#!/usr/bin/php
<?php
require_once('initialize.php');
require_once('GFConf.php');

/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Marcelo Mottalli <marcelo@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('initialize.php');
require_once('GFConf.php');
    

    if (GFConf::getMainConfigFile() || (isset($argv[1]) && $argv[1] == '-f')) {
        /**
        * Script that updates the configuration cache
        */
        // Call the appropiate method in the GFConf class
        GFConf::generateCache();

        echo "Clearing resource caches...\n";
        if (GFConf::varExists('system.cacheDir')) {
                $cacheDir = GFConf::get('system.cacheDir');
        }
        if (is_dir($cacheDir) && is_dir($cacheDir.'/resources')) {
                $resource_files = glob($cacheDir.'/resources/*');
                array_map( "unlink", $resource_files );
        }

        // Restart the daemon if necessary. Otherwise, it won't pick up the new variables.
        if (GFConf::varExists('system.useDaemon') && GFConf::get('system.useDaemon')) {
                include_once('SystemUtils.php');
                $output = array();
                echo "Restarting GForge daemon...\n";
                $handle = popen('/opt/gforge/bin/gforge restart','r');
                if($handle) {
                        echo (fread($handle, 2096));
                        pclose($handle);
                } else {
                        //Shouldn't happen unless file doesn't exists
                        echo "Daemon stop failed! Please check your system logs to determine the problem\n";
                }
        }
        echo "Cache created/updated successfully\n"; 
    } else {
        echo "GForge now stores all configuration settings in the database and use of this script has been deprecated.\n"
        ."To learn the new method for managing configuration settings in GForge please see https://gforge.com/gf/project/gforge5/wiki/?pagename=Site+Administration+-+Configuration\n"
        ."For reference the script you need to use is ".GFConf::get('system.libDir')."/bin/gf-config\n";
    }
    

?>