<?php

require_once('initialize.php');
require_once('core/Filesystem.php');
require_once('core/FilesystemPeer.php');

$c = new Criteria();
/** @var Filesystem[] $files  */
$files = FilesystemPeer::doSelect($c);

foreach($files as $file) {

	if(file_exists($file->getFilePath())) {
		$mime = get_mime_type($file->getFilePath());
		if ($mime) {
			$file->setFileType(get_mime_type($file->getFilePath()));
			$file->save();
		}
	}
}	


function get_mime_type($filename, $mimePath = '/etc') {
   $fileext = substr(strrchr($filename, '.'), 1);
   if (empty($fileext)) return (false);
   $regex = "/^([\w\+\-\.\/]+)\s+(\w+\s)*($fileext\s)/i";
   $lines = file("$mimePath/mime.types");
   foreach($lines as $line) {
      if (substr($line, 0, 1) == '#') continue; // skip comments
      $line = rtrim($line) . " ";
      if (!preg_match($regex, $line, $matches)) continue; // no match to the extension
      return ($matches[1]);
   }
   return ('application/octet-stream'); // no match at all
}
