#!/usr/bin/php
<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author 	Marcelo Mottalli <marcelo@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
 
/**
 * Creates a configuration for nss-pgsql
 */
require_once('initialize.php');
require_once('GFConf.php');
require_once('lib/external/propel/Propel.php');
require_once('lib/external/propel/util/Criteria.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/scm/lib/ProjectScm.php');
require_once('lib/core/UserUnixPeer.php');

$USER_UNIX_UID_ADD = UserUnixPeer::UNIX_UID_ADD;
$USER_UNIX_GID_ADD = UserUnixPeer::UNIX_GID_ADD;
$PROJECT_GID_ADD = ProjectScm::UNIX_GROUP_ADD;
$SYS_APACHE_USER = GFConf::get('system.apacheUser');

$DBCONF = include('/etc/gforge/gforge5-db-conf.php');
$DBNAME = $DBCONF['propel']['datasources']['gf5']['connection']['database'];
$DBUSER = $DBCONF['propel']['datasources']['gf5']['connection']['username'];
$DBPASSWD = $DBCONF['propel']['datasources']['gf5']['connection']['password'];

$CONFIG = <<<EOF
connectionstring        = dbname=$DBNAME user=$DBUSER password=$DBPASSWD connect_timeout=1

# List all the groups
allgroups				= SELECT groupname, passwd, gid FROM nss_group_vw
# List all the users
allusers				= SELECT username, passwd, gecos, homedir, shell, uid, gid FROM nss_passwd_vw
# Get the user information by username
getpwnam				= SELECT username, passwd, gecos, homedir, shell, uid, gid FROM nss_passwd_vw WHERE username=\$1
# Get the user information by uid
getpwuid				= SELECT username, passwd, gecos, homedir, shell, uid, gid FROM nss_passwd_vw WHERE uid=\$1
# Get the group information by group name
getgrnam				= SELECT groupname, passwd, gid FROM nss_group_vw WHERE groupname=\$1
# Get the group information by gid
getgrgid				= SELECT groupname, passwd, gid FROM nss_group_vw WHERE gid=\$1
# Get the list of groups a user belongs to
groups_dyn				= SELECT DISTINCT getAllUserProjectsIdsSCM+$PROJECT_GID_ADD FROM getAllUserProjectsIdsSCM( (SELECT uid-$USER_UNIX_UID_ADD FROM nss_passwd_vw WHERE username=\$1) ) WHERE getAllUserProjectsIdsSCM <> \$2-$USER_UNIX_GID_ADD UNION SELECT gid FROM nss_group_vw WHERE has_apache=true AND $1='$SYS_APACHE_USER' UNION SELECT gid FROM nss_group_vw WHERE has_anonymous=true AND $1='anonymous'
# Get the list of users in a group
getgroupmembersbygid	= SELECT username FROM nss_passwd_vw WHERE user_id IN (SELECT * FROM getAllProjectUsersIdsSCM( \$1-$PROJECT_GID_ADD )) UNION SELECT username FROM nss_passwd_vw WHERE gid=\$1 UNION SELECT '$SYS_APACHE_USER' FROM nss_group_vw WHERE gid=\$1 AND has_apache=true UNION SELECT 'anonymous' FROM nss_group_vw WHERE gid=\$1 AND has_anonymous=true

EOF;

echo $CONFIG;

exit(0);

?>
