<?php
require_once('system/Cronjob.php');
require_once('core/User.php');
require_once('system/GFDaemon.php');
require_once('GFConf.php');

class checkGFDaemonCronjob extends  Cronjob {

	private $daemonPid = '';
	private $libDir = '';

	public function __construct() {
		$this->daemonPid = GFDaemon::getDaemonPid();
		$this->libDir = GFConf::get('system.libDir');
	}

	public function isDaemonRunning() {
		return GFDaemon::isRunning();
	}

	private function notifySiteAdmin($subject, $msg) {
		$sql = "SELECT * from \"user\" WHERE user_id IN (SELECT user_id FROM site_admin)";
		$con = Propel::getConnection();
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);


		while($rs->next()) {
			if ($rs->getInt('status') == User::STATUS_ACTIVE) {
				SystemUtils::sendMail($subject, $msg, $rs->getString('email'));
			}

		}
	}

	public function run() {
		$isRunning = $this->isDaemonRunning();
		if (!$isRunning) {
			exec(GFConf::get('system.libDir').'/bin/gforge start > /dev/null 2>&1 &', $output, $error);
			if ($error) {
				$subject = "GFDamon stopped, site admin intervention required";
				$msg = "GFDaemon seems to have been stopped. The check-daemon cronjob tried to restart it but it failed with \n
				the following message: \n" . implode(PHP_EOL, $output);
				$this->notifySiteAdmin($subject, $msg);
			} else {

				$subject = "GFDaemon restarted automatically";
				$msg = "GFDaemon seems to have been stopped. The check-daemon cronjob was able to restart it successfully.\n
				Please check your system logs to determine the cause of the failure.\n";
			}

			$this->notifySiteAdmin($subject, $msg);
		}

	}
}

if(GFConf::get('system.useDaemon')) {
	$checkDaemon = new checkGFDaemonCronjob();
	$checkDaemon->run();
}
exit(0);
?>
