CREATE TABLE cruisecontrol (
    project_id integer NOT NULL CONSTRAINT projectid_fk REFERENCES project(project_id) ON DELETE CASCADE PRIMARY KEY,
    builder text NOT NULL,
    log_type text NOT NULL,
    developer integer NOT NULL CONSTRAINT userid_fk REFERENCES "user"(user_id) ON DELETE CASCADE,
    last_modified_date timestamptz default now()
);

CREATE TABLE cruisecontrol_publisher (
    project_id integer NOT NULL CONSTRAINT projectid_fk REFERENCES project(project_id) ON DELETE CASCADE,
    tracker_id integer NOT NULL CONSTRAINT trackerid_fk REFERENCES tracker(tracker_id) ON DELETE CASCADE,
    PRIMARY KEY (project_id, tracker_id)
);

CREATE INDEX cruisecontrolpublisher_projectidtrackerid ON cruisecontrol_publisher(project_id, tracker_id);

CREATE TABLE cruisecontrol_assignee (
    project_id integer NOT NULL CONSTRAINT projectid_fk REFERENCES project(project_id) ON DELETE CASCADE,
    assignee integer NOT NULL CONSTRAINT userid_fk REFERENCES "user"(user_id) ON DELETE CASCADE,
    PRIMARY KEY (project_id, assignee)
);

CREATE INDEX cruisecontrolassignee_projectidassignee ON cruisecontrol_assignee(project_id, assignee);


CREATE TABLE cruisecontrol_preference (
    project_id integer NOT NULL CONSTRAINT projectid_fk REFERENCES project(project_id) ON DELETE CASCADE,
    name text NOT NULL,
    value text NOT NULL,
    PRIMARY KEY (project_id, name)
);

CREATE TABLE cruisecontrol_module (
    project_id integer NOT NULL CONSTRAINT projectid_fk REFERENCES project(project_id) ON DELETE CASCADE,
    scm_module_id integer NOT NULL CONSTRAINT scmmoduleid_fk REFERENCES scm_module(scm_module_id) ON DELETE CASCADE,
    PRIMARY KEY (project_id, scm_module_id)
);

CREATE INDEX cruisecontrolmodule_projectidscmmoduleid ON cruisecontrol_module(project_id, scm_module_id);
