
CREATE TABLE wall_post (
    wall_post_id serial NOT NULL,
    posted_by	integer NOT NULL,
    section character varying(20) NOT NULL,
    ref_id integer NOT NULL,
    post_date timestamp,
    comment text
);

ALTER TABLE ONLY wall_post
    ADD CONSTRAINT wall_post_pkey PRIMARY KEY (wall_post_id);

CREATE INDEX wall_post_id_idx ON wall_post USING btree (wall_post_id);

CREATE INDEX wall_post_ref_id_idx ON wall_post USING btree (ref_id);


CREATE TABLE wall_post_comment (
    wall_post_comment_id serial NOT NULL,
    wall_post_id integer NOT NULL,
    posted_by integer NOT NULL,
    post_date timestamp,
    comment text
);


--

ALTER TABLE ONLY wall_post_comment
    ADD CONSTRAINT wall_post_comment_id_pkey PRIMARY KEY (wall_post_comment_id);

ALTER TABLE ONLY wall_post_comment
    ADD CONSTRAINT wall_post_id_fkey FOREIGN KEY (wall_post_id) REFERENCES wall_post(wall_post_id);
