CREATE OR REPLACE VIEW nss_passwd_vw AS
	SELECT
		u.user_id,
		COALESCE(uu.unix_uid, u.user_id+1000000) AS uid,		-- + UserUnixPeer::UNIX_UID_ADD
		COALESCE(uu.unix_gid, u.user_id+1000000) AS gid,		-- + UserUnixPeer::UNIX_GID_ADD 
		u.unix_name AS username,
		u.password_crypt AS passwd,
		u.firstname || ' ' || lastname AS gecos,
		'/home/' || u.unix_name AS homedir,
		COALESCE(us.path, '/bin/cvssh.pl') AS shell
	FROM "user" u
		LEFT OUTER JOIN user_unix uu ON u.user_id=uu.user_id
		LEFT OUTER JOIN unix_shell us ON uu.unix_shell_id=us.unix_shell_id
	WHERE u.status=1 AND u.is_group=false AND u.user_id != 100
;

CREATE OR REPLACE VIEW nss_group_vw AS
	SELECT
		p.unix_name AS groupname,
		'x'::VARCHAR AS passwd,
		p.project_id + 50000 AS gid,						-- + ProjectScm::UNIX_GROUP_ADD
		(p.is_public AND COALESCE(pscm.enable_anonread, false)) AS has_anonymous,
		(NOT p.is_public OR NOT COALESCE(pscm.enable_anonread, true)) AS has_apache
	FROM project p 
		LEFT OUTER JOIN project_scm pscm ON pscm.project_id=p.project_id
	WHERE p.status=1
	UNION
	SELECT
		u.unix_name AS groupname,
		'x'::VARCHAR as passwd,
		u.user_id + 1000000 AS gid,
		false AS has_anonymous,
		false AS has_apache
	FROM "user" u
	WHERE u.status=1 AND u.is_group=false AND u.user_id != 100
;
UPDATE user_unix SET unix_uid=unix_uid+980000, unix_gid=unix_gid+980000;

