-- From all the users in the project, retrieve only the ones that have at least SCM read permissions
CREATE OR REPLACE FUNCTION getAllProjectUsersIdsSCM(project_id INTEGER) RETURNS SETOF INTEGER AS E'
DECLARE
	user_ids RECORD;
	project_ids VARCHAR;
	root_path VARCHAR;
	sql VARCHAR;
	scm_settings_array RECORD;
BEGIN
	-- RAISE NOTICE ''getAllProjectUsersIdsSCM(%)'', project_id;
	IF project_id IS NULL THEN RETURN; END IF;

	-- Code copied from Permission::getPermission()
	SELECT p.root_path INTO root_path FROM project p WHERE p.project_id=project_id;
	
	IF root_path IS NOT NULL AND root_path <> '''' THEN
		project_ids := \' IN (\' || root_path || \')\';
	ELSE
		project_ids := \'=\' || project_id::TEXT;
	END IF;
	
	FOR user_ids IN SELECT * FROM getAllProjectUsersIds(project_id) LOOP
		sql := \'
			SELECT max(value) AS scm_setting FROM role_setting
			NATURAL JOIN user_project_role NATURAL JOIN user_project
			WHERE role_setting.section=\'\'scm\'\' AND role_setting.ref_id=0
			AND (user_project.user_id=\' || user_ids.getallprojectusersids::TEXT || \' OR user_project.user_id IN 
				(SELECT usergroup_id FROM usergroup_user WHERE member_user_id=\' || user_ids.getallprojectusersids::TEXT || \'))
			AND user_project.project_id \' || project_ids || \'
		\';
		FOR scm_settings_array IN EXECUTE(sql) LOOP
			IF scm_settings_array.scm_setting >= 0 THEN
				RETURN NEXT user_ids.getallprojectusersids;
			END IF;
		END LOOP;
	END LOOP;
END
'
LANGUAGE plpgsql
STABLE;

