<?php

require_once('initialize.php');
require_once('plugins/tracker/lib/TrackerQueryPeer.php');
require_once('plugin/PluginFactory.php');

// 2012-09-28 Bug 9312, make sure we don't fail the update
// Just because, e.g., hosting plugin isn't on the disk
PluginFactory::getFactory()->initializePlugins(FALSE);
$con = Propel::getConnection();

$sql = "select user_id from site_admin order by user_id limit 1";
$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);

if ($rs->next()) {
    $siteAdmin = UserPeer::retrieveByPK($rs->getInt(1));
}

if ($siteAdmin == null) {
    echo "ERROR: No site admin user exists in this database!\n";
    exit(1);
}

$session = Session::getSession();
$session->setUser($siteAdmin);

// If this is run multiple times for whatever reason, try to avoid adding duplicate queries
// System-generated queries should be the only ones with user_id = 100 (nobody)
$sql = "select tracker_id from tracker where tracker_id not in (select distinct tracker_id from tracker_query where user_id = 100)";
$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);

try {

    while ($rs->next()) {
        $tracker_id = $rs->getInt(1);
        if (TrackerQueryPeer::addStandardQueries($tracker_id) == FALSE) exit(1);
        echo '.';
    }
    exit(0);
} catch (Exception $ex) {
    exit(1);
}
