CREATE OR REPLACE VIEW nss_group_vw AS
	SELECT
		p.unix_name AS groupname,
		'x'::VARCHAR AS passwd,
		p.project_id + 50000 AS gid,						-- + ProjectScm::UNIX_GROUP_ADD
		(p.is_public AND COALESCE(pscm.enable_anonread, false)) AS has_anonymous,
		(NOT p.is_public OR NOT COALESCE(pscm.enable_anonread, true)) AS has_apache
	FROM project p
		LEFT OUTER JOIN project_scm pscm ON pscm.project_id=p.project_id
	WHERE p.status=1
	UNION
	SELECT
		'u_' || u.unix_name AS groupname,
		'x'::VARCHAR as passwd,
		u.user_id + 1000000 AS gid,
		false AS has_anonymous,
		false AS has_apache
	FROM "user" u
	WHERE u.status=1 AND u.is_group=false AND u.user_id != 100
;
