delete from audit_trail
where section = 'trackeritem'
and field_name = 'status_id';

insert into audit_trail (change_date, user_id, section, ref_id, field_name, old_value, new_value)
SELECT
  audit_trail.change_date,
  audit_trail.user_id,
  audit_trail.section,
  audit_trail.ref_id,
  'status_id',
  old_status.status_id::text AS old_status_id,
  new_status.status_id::text AS new_status_id
FROM
  public.audit_trail,
  public.tracker_item,
  public.tracker_extra_field,
  public.tracker_extra_field_element new_status,
  public.tracker,
  public.project,
  public.tracker_extra_field_element old_status
WHERE
  audit_trail.ref_id = tracker_item.tracker_item_id AND
  tracker_item.tracker_id = tracker.tracker_id AND
  tracker_extra_field.tracker_id = tracker_item.tracker_id AND
  tracker_extra_field.tracker_extra_field_id = new_status.tracker_extra_field_id AND
  new_status.element_name = audit_trail.new_value AND
  project.project_id = tracker.project_id AND
  old_status.tracker_extra_field_id = tracker_extra_field.tracker_extra_field_id AND
  old_status.element_name = audit_trail.old_value AND
  tracker_extra_field.field_type = 7 AND
  audit_trail.field_name = 'status' AND
  audit_trail.section = 'trackeritem' AND
  old_status.status_id != new_status.status_id
ORDER BY
  project.unix_name ASC,
  tracker.tracker_name ASC,
  audit_trail.ref_id ASC,
  audit_trail.change_date ASC;

-- Add status_id => 0 where close date is set
insert into audit_trail (change_date, user_id, section, ref_id, field_name, old_value, new_value)
SELECT
  audit_trail.change_date,
  audit_trail.user_id,
  audit_trail.section,
  audit_trail.ref_id,
  'status_id',
  '1',
  '0'
FROM
  public.audit_trail,
  public.tracker_item,
  public.tracker,
  public.project
WHERE
  audit_trail.ref_id = tracker_item.tracker_item_id AND
  tracker_item.tracker_id = tracker.tracker_id AND
  project.project_id = tracker.project_id AND
  audit_trail.field_name = 'close_date' AND
  audit_trail.section = 'trackeritem' AND
  COALESCE(audit_trail.new_value, '') != '' AND
  COALESCE(audit_trail.old_value, '') = '';

-- Add status_id => 1 where close date is nulled
insert into audit_trail (change_date, user_id, section, ref_id, field_name, old_value, new_value)
SELECT
  audit_trail.change_date,
  audit_trail.user_id,
  audit_trail.section,
  audit_trail.ref_id,
  'status_id',
  '0',
  '1'
FROM
  public.audit_trail,
  public.tracker_item,
  public.tracker,
  public.project
WHERE
  audit_trail.ref_id = tracker_item.tracker_item_id AND
  tracker_item.tracker_id = tracker.tracker_id AND
  project.project_id = tracker.project_id AND
  audit_trail.field_name = 'close_date' AND
  audit_trail.section = 'trackeritem' AND
  COALESCE(audit_trail.new_value, '') = '';