#!/bin/env php
<?php
require_once('initialize.php');
require_once('GFConf.php');
require_once("lib/SystemUtils.php");
$ret = SystemUtils::input_Y_N('This version of GForge includes a new Tracker template for User Stories.  Would you like to add this template as part of the upgrade process?  Answer y/yes or n/no');
if ($ret)
{
    require_once('lib/core/ProjectPeer.php');
    $templates = ProjectPeer::getTemplateProjects();

    $list = array();
    $first_project = '';
    foreach ($templates as $template)
    {
        $list[$template->getUnixName()] = $template->getUnixName() . ': ' . $template->getProjectName();
        if ($first_project == '')
            $first_project = $template->getUnixName();
    }
    $msg = 'Here are the template projects on your GForge site:';
    $msg .= "\n" . implode("\n", array_values($list));

    SystemUtils::showOnConsole($msg);

    while (true)
    {
        $project = SystemUtils::input_string('Enter the short name of the project to which you want the User Stories template added, or no name to skip:', '');
        if (strlen($project) == 0)
            break;
        if (array_key_exists($project, $list))
            break;
    }

    if (strlen($project) > 0)
    {
        require_once('plugins/tracker/lib/TrackerPeer.php');
        require_once('lib/core/SettingPeer.php');
        SystemUtils::useSiteAdmin();
        $result = TrackerPeer::addUserStoriesTracker($project);
        if ($result == true)
        {
            SystemUtils::showOnConsole('A User Stories Tracker was added to "' . $list[$project] . '".  You can clone it into other templates or existing projects as needed.');
            exit(0);
        } else
        {
            SystemUtils::showOnConsole(SystemUtils::COLOR_RED.'Sorry, could not add the User Stories Tracker to "' . $list[$project] . '". It may already exist, or there may have been an internal error.  Check the log for more details.');
            exit(1);
        }
    } else
    {
        SystemUtils::showOnConsole('Okay, not adding a User Stories Template.');
        exit(0);
    }
}
