<?php
require_once('initialize.php');
require_once('GFConf.php');
require_once('SystemUtils.php');
require_once('Validator.php');


$msg = "New configuration setting: system.expireOnLastLogin time.

This setting determines the parameter to be used for session time out
(system.sessionTimeOut). If true, session will have a fixed expiration range
starting from the last time the user logged into the system.  If false, the
range will be dynamical and the session start time will be modified anytime the
user access the system.

Default value is disabled. Do you want to enable this setting (If unsure, say N) ?";
$default = GFConf::get('system.expireOnLoginTime') ? 'Y': 'N';
$enable = Validator::sanitizeString(SystemUtils::input_Y_N($msg, $default));

if ($enable) {
	GFConf::set('system.expireOnLoginTime', true);
} else {
	GFConf::set('system.expireOnLoginTime', false);
}

exit(0);

