DROP VIEW IF EXISTS nss_passwd_vw;
ALTER TABLE "user" ALTER COLUMN password_crypt TYPE character VARYING (133);

CREATE VIEW nss_passwd_vw AS
SELECT u.user_id,
  COALESCE(uu.unix_uid, u.user_id + 1000000) AS uid,
  COALESCE(uu.unix_gid, u.user_id + 1000000) AS gid,
  u.unix_name AS username, u.password_crypt AS passwd,
  (u.firstname || ' '::text) || u.lastname AS gecos, '/home/'::text || u.unix_name AS homedir,
  COALESCE(us.path, '/bin/cvssh.pl'::text) AS shell
   FROM "user" u
   LEFT JOIN user_unix uu ON u.user_id = uu.user_id
   LEFT JOIN unix_shell us ON uu.unix_shell_id = us.unix_shell_id
  WHERE u.status = 1 AND u.is_group = false AND u.user_id <> 100;
