-- Add column to count links from projects to trove
ALTER TABLE trove_category ADD COLUMN project_links_count  integer DEFAULT 0;
-- Update counter on insert
CREATE OR REPLACE RULE trove_link_insert AS ON INSERT to trove_link
WHERE NEW.section = 'project'
DO ALSO
UPDATE trove_category SET project_links_count = project_links_count + 1 WHERE trove_category.trove_category_id = NEW.trove_category_id;
-- Update counter on delete
CREATE OR REPLACE RULE trove_link_delete AS ON DELETE to trove_link
WHERE OLD.section = 'project'
DO ALSO
UPDATE trove_category SET project_links_count = project_links_count - 1  WHERE trove_category.trove_category_id = OLD.trove_category_id;
-- Update counter on update
CREATE OR REPLACE RULE trove_link_update_00 AS ON update to trove_link
WHERE OLD.trove_category_id <> NEW.trove_category_id
AND OLD.section = 'project' AND NEW.section='project'
DO ALSO	UPDATE trove_category SET project_links_count = project_links_count +1 WHERE trove_category.trove_category_id = NEW.trove_category_id;

CREATE OR REPLACE RULE trove_link_update_01 AS ON update to trove_link
WHERE OLD.trove_category_id <> NEW.trove_category_id
AND OLD.section = 'project' AND NEW.section='project'
DO ALSO	UPDATE trove_category SET project_links_count = project_links_count -1 WHERE trove_category.trove_category_id = OLD.trove_category_id;
-- Init projects link count
UPDATE trove_category t set project_links_count =
COALESCE(
	(SELECT COUNT(ref_id) FROM trove_link tl WHERE section = 'project' AND tl.trove_category_id = t.trove_category_id GROUP BY tl.trove_category_id),
	0
);