<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2007-01-28
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'core/om/BaseAssociationPeer.php';

// The object class
include_once 'core/Association.php';

/** 
 * The skeleton for this class was autogenerated by Propel  *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package core 
 */
class AssociationPeer extends BaseAssociationPeer {
	private static $_pkCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	Association
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, AssociationPeer::$_pkCache)) {
			return AssociationPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			AssociationPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, AssociationPeer::$_pkCache)) {
			unset(AssociationPeer::$_pkCache[$pk]);
		}
	}


	public static function getAssociationCount($from_section,$from_ref_id) {
		$sql="SELECT * FROM association WHERE 
		(section='".Validator::sanitizeString($from_section)."' AND ref_id='".Validator::sanitizeInt($from_ref_id)."')
		UNION SELECT *
		FROM association WHERE
		(to_section='".Validator::sanitizeString($from_section)."' AND to_ref_id='".Validator::sanitizeInt($from_ref_id)."')";
		
		$rs=Propel::getConnection()->createStatement()->executeQuery($sql,ResultSet::FETCHMODE_ASSOC);
		
		return $rs->getRecordCount();
	}

}
?>