<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'core/om/BaseAuditTrailPeer.php';

// The object class
include_once 'core/AuditTrail.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Sun Nov 13 22:49:46 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package core 
 */
class AuditTrailPeer extends BaseAuditTrailPeer {
	private static $_pkCache = array();

	public static function writeAuditTrail($section, $ref_id, $field_name, $old_value, $new_value, $user = 100, $change_date = 0) {

		$at = new AuditTrail();

		if ($change_date < 1) $change_date = time();
		$at->setChangeDate($change_date);
		if ($user instanceof User) {
			$at->setUser($user);
		} else {
			$at->setUserId($user);
		}
		$at->setSection($section);
		$at->setRefId($ref_id);
		$at->setFieldName($field_name);
		$at->setOldValue($old_value);
		$at->setNewValue($new_value);

		$at->save();

		return $at;
	}

	public static function getAuditTrail($section, $ref_id) {

		$c = new Criteria();
		$c->add(self::SECTION, $section)
		  ->add(self::REF_ID, $ref_id)
		  ->addAscendingOrderByColumn(self::AUDIT_TRAIL_ID);

		return self::doSelect($c);
	}


	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	AuditTrail
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, AuditTrailPeer::$_pkCache)) {
			return AuditTrailPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			AuditTrailPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, AuditTrailPeer::$_pkCache)) {
			unset(AuditTrailPeer::$_pkCache[$pk]);
		}
	}

}
?>