<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once('core/om/BaseProjectPluginPeer.php');

// The object class
include_once('core/ProjectPlugin.php');

require_once('core/Plugin.php');

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Sun Nov 13 22:49:46 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package core 
 */
class ProjectPluginPeer extends BaseProjectPluginPeer {
	/**
	 * Return an array with the list of exclusive types for the project plugins
	 * @return array
	 */
	public function getExclusiveTypes() {
		$con = Propel::getConnection(PluginPeer::DATABASE_NAME);
		$rs = $con->createStatement()->executeQuery('SELECT DISTINCT exclusive_type FROM plugin WHERE exclusive_type IS NOT NULL AND plugin_type=\'project\' ORDER BY exclusive_type ASC');
		$exclusive_types = array();
		while ($rs->next()) {
			$exclusive_types[] = $rs->getString('exclusive_type');
		}
		
		return $exclusive_types;
	}
	
	public function getExclusiveTypePlugins($type) {
		$c = new Criteria();
		$c->add(PluginPeer::PLUGIN_TYPE, 'project');
		$c->add(PluginPeer::EXCLUSIVE_TYPE, $type);
		
		return PluginPeer::doSelect($c);
	}

}
?>