<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'core/om/BaseRoleSettingPeer.php';

// The object class
include_once 'core/RoleSetting.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Sun Nov 13 22:49:46 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package core 
 */
class RoleSettingPeer extends BaseRoleSettingPeer {
	private static $_pkCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	RoleSetting
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, RoleSettingPeer::$_pkCache)) {
			return RoleSettingPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			RoleSettingPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, RoleSettingPeer::$_pkCache)) {
			unset(RoleSettingPeer::$_pkCache[$pk]);
		}
	}

	public static function setRoleSetting($role_id, $section, $ref_id, $value) {

		$c = new Criteria();
		$c->add(self::ROLE_ID, $role_id)
		  ->add(self::SECTION, $section)
		  ->add(self::REF_ID, $ref_id);

		$existing = self::doSelectOne($c);

		if ($existing == null) {
			$existing = new RoleSetting();

			$existing->setRoleId($role_id);
			$existing->setSection($section);
			$existing->setRefId($ref_id);
		}
		$existing->setValue($value);

		$existing->save();

		return $existing->getValue();
	}

	public static function getRoleSetting($role_id, $section, $ref_id) {

		$c = new Criteria();
		$c->add(self::ROLE_ID, $role_id)
		  ->add(self::SECTION, $section)
		  ->add(self::REF_ID, $ref_id);

		$existing = self::doSelectOne($c);

		if ($existing == null) {
			return -1;
		}

		return $existing->getValue();
	}

}
?>