<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'core/om/BaseUserPluginPeer.php';

// The object class
include_once 'core/UserPlugin.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Sun Nov 13 22:49:46 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package core 
 */
class UserPluginPeer extends BaseUserPluginPeer {
	private static $_pkCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	UserPlugin
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, UserPluginPeer::$_pkCache)) {
			return UserPluginPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			UserPluginPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, UserPluginPeer::$_pkCache)) {
			unset(UserPluginPeer::$_pkCache[$pk]);
		}
	}


	public function getExclusiveTypes() {
		$con = Propel::getConnection(PluginPeer::DATABASE_NAME);
		$rs = $con->createStatement()->executeQuery('SELECT DISTINCT exclusive_type FROM plugin WHERE exclusive_type IS NOT NULL AND plugin_type=\'user\' ORDER BY exclusive_type ASC');
		$exclusive_types = array();
		while ($rs->next()) {
			$exclusive_types[] = $rs->getString('exclusive_type');
		}
		
		return $exclusive_types;
	}
	
	public function getExclusiveTypePlugins($type) {
		$c = new Criteria();
		$c->add(PluginPeer::PLUGIN_TYPE, 'user');
		$c->add(PluginPeer::EXCLUSIVE_TYPE, $type);
		
		return PluginPeer::doSelect($c);
	}


}
?>