<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'filesystem' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class FilesystemMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.FilesystemMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("filesystem");
		$tMap->setPhpName("Filesystem");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("filesystem_filesystem_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("FILESYSTEM_ID", "FilesystemId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("SECTION", "Section", "string", CreoleTypes::VARCHAR, false, 20);
		$tMap->addColumn("REF_ID", "RefId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("FILE_NAME", "FileName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("FILE_NAME_SAFE", "FileNameSafe", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("FILE_TYPE", "FileType", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("FILE_SIZE", "FileSize", "int", CreoleTypes::BIGINT, false, null);
		$tMap->addColumn("DELETED", "Deleted", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addForeignKey("POSTED_BY", "PostedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("DOWNLOAD_COUNT", "DownloadCount", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("STRINGS", "Strings", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("MD5_HASH", "Md5Hash", "string", CreoleTypes::VARCHAR, false, 32);
				
    }
}
