<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'pastebin' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class PastebinMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.PastebinMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("pastebin");
		$tMap->setPhpName("Pastebin");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("pastebin_pastebin_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("PASTEBIN_ID", "PastebinId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("TITLE", "Title", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("CONTENT", "Content", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("SECTION", "Section", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("REF_ID", "RefId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("EXPOSURE_TYPE", "ExposureType", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("LANGUAGE", "Language", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addForeignKey("POSTED_BY", "PostedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("POST_DATE", "PostDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("EXPIRATION", "Expiration", "int", CreoleTypes::INTEGER, true, null);
				
    }
}
