<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'pending_action' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class PendingActionMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.PendingActionMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("pending_action");
		$tMap->setPhpName("PendingAction");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("pending_action_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("PENDING_ACTION_ID", "PendingActionId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("ACTION_NAME", "ActionName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("PARAMETER", "Parameter", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("ACTION_DATE", "ActionDate", "int", CreoleTypes::TIMESTAMP, false, null);
				
    }
}
