<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'core/DeletedProjectPeer.php';

/**
 * Base class that represents a row from the 'deleted_project' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to DeletedProject class. 
 * 
 * @package core 
 */
abstract class BaseDeletedProject extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var DeletedProjectPeer
	 */
	protected static $peer;

	/**
	 * The value for the deleted_project_id field.
	 * @var int	  
	 */
	protected $deleted_project_id;	

	/**
	 * The value for the unix_group_name field.
	 * @var string	  
	 */
	protected $unix_group_name;	

	/**
	 * The value for the delete_date field.
	 * @var int	  
	 */
	protected $delete_date = -1;	

	/**
	 * The value for the isdeleted field.
	 * @var boolean	  
	 */
	protected $isdeleted = false;	
  
	/**
	 * Get the DeletedProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getDeletedProjectId()
	{
		return $this->deleted_project_id;
	}


	/**
	 * Set the value of `deleted_project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setDeletedProjectId($v)
	{
		if ($this->deleted_project_id !== $v) {
			$this->deleted_project_id = $v;
			$this->modifiedColumns[] = DeletedProjectPeer::DELETED_PROJECT_ID;
		}
				
	}

  
	/**
	 * Get the UnixGroupName column value.
	 *  
	 * @return string	  
	 */
	public function getUnixGroupName()
	{
		return $this->unix_group_name;
	}


	/**
	 * Set the value of `unix_group_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setUnixGroupName($v)
	{
		if ($this->unix_group_name !== $v) {
			$this->unix_group_name = $v;
			$this->modifiedColumns[] = DeletedProjectPeer::UNIX_GROUP_NAME;
		}
				
	}


	/**
	 * Get the [optionally formatted] `delete_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getDeleteDate($format = 'Y-m-d H:i:s')
	{
		if ($this->delete_date === null || $this->delete_date === '') {
			return null;
		} elseif (!is_int($this->delete_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->delete_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of delete_date as date/time value: " . var_export($this->delete_date, true));
			}
		} else {
			$ts = $this->delete_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `delete_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setDeleteDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for delete_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->delete_date !== $ts || $ts === -1) {
			$this->delete_date = $ts;
			$this->modifiedColumns[] = DeletedProjectPeer::DELETE_DATE;
		}
		
	}

  
	/**
	 * Get the Isdeleted column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsdeleted()
	{
		return $this->isdeleted;
	}


	/**
	 * Set the value of `isdeleted` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsdeleted($v)
	{
		if ($this->isdeleted !== $v || $v === false) {
			$this->isdeleted = $v;
			$this->modifiedColumns[] = DeletedProjectPeer::ISDELETED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->deleted_project_id = $rs->getInt($startcol + 0);					
			$this->unix_group_name = $rs->getString($startcol + 1);					
			$this->delete_date = $rs->getTimestamp($startcol + 2, null);
			$this->isdeleted = $rs->getBoolean($startcol + 3);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating DeletedProject object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(DeletedProjectPeer::DATABASE_NAME);
		$criteria->add(DeletedProjectPeer::DELETED_PROJECT_ID, $this->deleted_project_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(DeletedProjectPeer::DATABASE_NAME);
		if ($this->isColumnModified(DeletedProjectPeer::DELETED_PROJECT_ID)) $criteria->add(DeletedProjectPeer::DELETED_PROJECT_ID, $this->deleted_project_id);
		if ($this->isColumnModified(DeletedProjectPeer::UNIX_GROUP_NAME)) $criteria->add(DeletedProjectPeer::UNIX_GROUP_NAME, $this->unix_group_name);
		if ($this->isColumnModified(DeletedProjectPeer::DELETE_DATE)) $criteria->add(DeletedProjectPeer::DELETE_DATE, $this->delete_date);
		if ($this->isColumnModified(DeletedProjectPeer::ISDELETED)) $criteria->add(DeletedProjectPeer::ISDELETED, $this->isdeleted);
		return $criteria;			
	}
	
	

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("deleted_project_id", "unix_group_name", "delete_date", "isdeleted", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case DeletedProjectPeer::DELETED_PROJECT_ID:
				return $this->getDeletedProjectId();
				break;
		  
			case DeletedProjectPeer::UNIX_GROUP_NAME:
				return $this->getUnixGroupName();
				break;
		  
			case DeletedProjectPeer::DELETE_DATE:
				return $this->getDeleteDate();
				break;
		  
			case DeletedProjectPeer::ISDELETED:
				return $this->getIsdeleted();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getDeletedProjectId();
				break;
  
			case 1:
				return $this->getUnixGroupName();
				break;
  
			case 2:
				return $this->getDeleteDate();
				break;
  
			case 3:
				return $this->getIsdeleted();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(DeletedProjectPeer::DELETED_PROJECT_ID, $arr)) $this->setDeletedProjectId($arr[DeletedProjectPeer::DELETED_PROJECT_ID]);
  
		if (array_key_exists(DeletedProjectPeer::UNIX_GROUP_NAME, $arr)) $this->setUnixGroupName($arr[DeletedProjectPeer::UNIX_GROUP_NAME]);
  
		if (array_key_exists(DeletedProjectPeer::DELETE_DATE, $arr)) $this->setDeleteDate($arr[DeletedProjectPeer::DELETE_DATE]);
  
		if (array_key_exists(DeletedProjectPeer::ISDELETED, $arr)) $this->setIsdeleted($arr[DeletedProjectPeer::ISDELETED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case DeletedProjectPeer::DELETED_PROJECT_ID:
				$this->setDeletedProjectId($value);
				break;
	  
			case DeletedProjectPeer::UNIX_GROUP_NAME:
				$this->setUnixGroupName($value);
				break;
	  
			case DeletedProjectPeer::DELETE_DATE:
				$this->setDeleteDate($value);
				break;
	  
			case DeletedProjectPeer::ISDELETED:
				$this->setIsdeleted($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setDeletedProjectId($value);
				break;
  
			case 1:
				$this->setUnixGroupName($value);
				break;
  
			case 2:
				$this->setDeleteDate($value);
				break;
  
			case 3:
				$this->setIsdeleted($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(DeletedProjectPeer::DATABASE_NAME);

		try {
			$con->begin();
			DeletedProjectPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(DeletedProjectPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = DeletedProjectPeer::doInsert($this, $con);
					$this->setDeletedProjectId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					DeletedProjectPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return DeletedProjectPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = DeletedProjectPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed deleted_project_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setDeletedProjectId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getDeletedProjectId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return DeletedProject Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new DeletedProject();
		$copyObj->setUnixGroupName($this->unix_group_name);
		$copyObj->setDeleteDate($this->delete_date);
		$copyObj->setIsdeleted($this->isdeleted);
		
		$copyObj->setNew(true);
		
		$copyObj->setDeletedProjectId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return DeletedProjectPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new DeletedProjectPeer();
		}
		return self::$peer;
	}

}
