<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'core/FilesystemPeer.php';

/**
 * Base class that represents a row from the 'filesystem' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Filesystem class. 
 * 
 * @package core 
 */
abstract class BaseFilesystem extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var FilesystemPeer
	 */
	protected static $peer;

	/**
	 * The value for the filesystem_id field.
	 * @var int	  
	 */
	protected $filesystem_id;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the file_name field.
	 * @var string	  
	 */
	protected $file_name;	

	/**
	 * The value for the file_name_safe field.
	 * @var string	  
	 */
	protected $file_name_safe;	

	/**
	 * The value for the file_type field.
	 * @var string	  
	 */
	protected $file_type;	

	/**
	 * The value for the file_size field.
	 * @var int	  
	 */
	protected $file_size;	

	/**
	 * The value for the deleted field.
	 * @var boolean	  
	 */
	protected $deleted;	

	/**
	 * The value for the posted_by field.
	 * @var int	  
	 */
	protected $posted_by;	

	/**
	 * The value for the download_count field.
	 * @var int	  
	 */
	protected $download_count = 0;	

	/**
	 * The value for the strings field.
	 * @var string	  
	 */
	protected $strings;	

	/**
	 * The value for the md5_hash field.
	 * @var string	  
	 */
	protected $md5_hash;	
  
	/**
	 * Get the FilesystemId column value.
	 *  
	 * @return int	  
	 */
	public function getFilesystemId()
	{
		return $this->filesystem_id;
	}


	/**
	 * Set the value of `filesystem_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setFilesystemId($v)
	{
		if ($this->filesystem_id !== $v) {
			$this->filesystem_id = $v;
			$this->modifiedColumns[] = FilesystemPeer::FILESYSTEM_ID;
		}
			
		  // update associated FilesystemDownload		  
		  if ($this->collFilesystemDownloads !== null) {
			  for ($i=0,$size=count($this->collFilesystemDownloads); $i < $size; $i++) {
				  $this->collFilesystemDownloads[$i]->setFilesystemId($v);
			  }
		  }
			  	
		  // update associated TrackerTransitionScript		  
		  if ($this->collTrackerTransitionScripts !== null) {
			  for ($i=0,$size=count($this->collTrackerTransitionScripts); $i < $size; $i++) {
				  $this->collTrackerTransitionScripts[$i]->setScriptFilesystemId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = FilesystemPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = FilesystemPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the FileName column value.
	 *  
	 * @return string	  
	 */
	public function getFileName()
	{
		return $this->file_name;
	}


	/**
	 * Set the value of `file_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFileName($v)
	{
		if ($this->file_name !== $v) {
			$this->file_name = $v;
			$this->modifiedColumns[] = FilesystemPeer::FILE_NAME;
		}
				
	}

  
	/**
	 * Get the FileNameSafe column value.
	 *  
	 * @return string	  
	 */
	public function getFileNameSafe()
	{
		return $this->file_name_safe;
	}


	/**
	 * Set the value of `file_name_safe` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFileNameSafe($v)
	{
		if ($this->file_name_safe !== $v) {
			$this->file_name_safe = $v;
			$this->modifiedColumns[] = FilesystemPeer::FILE_NAME_SAFE;
		}
				
	}

  
	/**
	 * Get the FileType column value.
	 *  
	 * @return string	  
	 */
	public function getFileType()
	{
		return $this->file_type;
	}


	/**
	 * Set the value of `file_type` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFileType($v)
	{
		if ($this->file_type !== $v) {
			$this->file_type = $v;
			$this->modifiedColumns[] = FilesystemPeer::FILE_TYPE;
		}
				
	}

  
	/**
	 * Get the FileSize column value.
	 *  
	 * @return int	  
	 */
	public function getFileSize()
	{
		return $this->file_size;
	}


	/**
	 * Set the value of `file_size` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setFileSize($v)
	{
		if ($this->file_size !== $v) {
			$this->file_size = $v;
			$this->modifiedColumns[] = FilesystemPeer::FILE_SIZE;
		}
				
	}

  
	/**
	 * Get the Deleted column value.
	 *  
	 * @return boolean	  
	 */
	public function getDeleted()
	{
		return $this->deleted;
	}


	/**
	 * Set the value of `deleted` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setDeleted($v)
	{
		if ($this->deleted !== $v) {
			$this->deleted = $v;
			$this->modifiedColumns[] = FilesystemPeer::DELETED;
		}
				
	}

  
	/**
	 * Get the PostedBy column value.
	 *  
	 * @return int	  
	 */
	public function getPostedBy()
	{
		return $this->posted_by;
	}


	/**
	 * Set the value of `posted_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setPostedBy($v)
	{
		if ($this->posted_by !== $v) {
			$this->posted_by = $v;
			$this->modifiedColumns[] = FilesystemPeer::POSTED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the DownloadCount column value.
	 *  
	 * @return int	  
	 */
	public function getDownloadCount()
	{
		return $this->download_count;
	}


	/**
	 * Set the value of `download_count` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setDownloadCount($v)
	{
		if ($this->download_count !== $v || $v === 0) {
			$this->download_count = $v;
			$this->modifiedColumns[] = FilesystemPeer::DOWNLOAD_COUNT;
		}
				
	}

  
	/**
	 * Get the Strings column value.
	 *  
	 * @return string	  
	 */
	public function getStrings()
	{
		return $this->strings;
	}


	/**
	 * Set the value of `strings` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setStrings($v)
	{
		if ($this->strings !== $v) {
			$this->strings = $v;
			$this->modifiedColumns[] = FilesystemPeer::STRINGS;
		}
				
	}

  
	/**
	 * Get the Md5Hash column value.
	 *  
	 * @return string	  
	 */
	public function getMd5Hash()
	{
		return $this->md5_hash;
	}


	/**
	 * Set the value of `md5_hash` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setMd5Hash($v)
	{
		if ($this->md5_hash !== $v) {
			$this->md5_hash = $v;
			$this->modifiedColumns[] = FilesystemPeer::MD5_HASH;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->filesystem_id = $rs->getInt($startcol + 0);					
			$this->section = $rs->getString($startcol + 1);					
			$this->ref_id = $rs->getInt($startcol + 2);					
			$this->file_name = $rs->getString($startcol + 3);					
			$this->file_name_safe = $rs->getString($startcol + 4);					
			$this->file_type = $rs->getString($startcol + 5);					
			$this->file_size = $rs->getInt($startcol + 6);					
			$this->deleted = $rs->getBoolean($startcol + 7);					
			$this->posted_by = $rs->getInt($startcol + 8);					
			$this->download_count = $rs->getInt($startcol + 9);					
			$this->strings = $rs->getString($startcol + 10);					
			$this->md5_hash = $rs->getString($startcol + 11);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Filesystem object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(FilesystemPeer::DATABASE_NAME);
		$criteria->add(FilesystemPeer::FILESYSTEM_ID, $this->filesystem_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(FilesystemPeer::DATABASE_NAME);
		if ($this->isColumnModified(FilesystemPeer::FILESYSTEM_ID)) $criteria->add(FilesystemPeer::FILESYSTEM_ID, $this->filesystem_id);
		if ($this->isColumnModified(FilesystemPeer::SECTION)) $criteria->add(FilesystemPeer::SECTION, $this->section);
		if ($this->isColumnModified(FilesystemPeer::REF_ID)) $criteria->add(FilesystemPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(FilesystemPeer::FILE_NAME)) $criteria->add(FilesystemPeer::FILE_NAME, $this->file_name);
		if ($this->isColumnModified(FilesystemPeer::FILE_NAME_SAFE)) $criteria->add(FilesystemPeer::FILE_NAME_SAFE, $this->file_name_safe);
		if ($this->isColumnModified(FilesystemPeer::FILE_TYPE)) $criteria->add(FilesystemPeer::FILE_TYPE, $this->file_type);
		if ($this->isColumnModified(FilesystemPeer::FILE_SIZE)) $criteria->add(FilesystemPeer::FILE_SIZE, $this->file_size);
		if ($this->isColumnModified(FilesystemPeer::DELETED)) $criteria->add(FilesystemPeer::DELETED, $this->deleted);
		if ($this->isColumnModified(FilesystemPeer::POSTED_BY)) $criteria->add(FilesystemPeer::POSTED_BY, $this->posted_by);
		if ($this->isColumnModified(FilesystemPeer::DOWNLOAD_COUNT)) $criteria->add(FilesystemPeer::DOWNLOAD_COUNT, $this->download_count);
		if ($this->isColumnModified(FilesystemPeer::STRINGS)) $criteria->add(FilesystemPeer::STRINGS, $this->strings);
		if ($this->isColumnModified(FilesystemPeer::MD5_HASH)) $criteria->add(FilesystemPeer::MD5_HASH, $this->md5_hash);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setPostedBy(NULL);
		} else {
			$this->setPostedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->posted_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->posted_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->posted_by, $con);
			   $obj->addFilesystems($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setPostedBy( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collFilesystemDownloads	  
	 * @var array
	 */
	protected $collFilesystemDownloads; 

	/**
	 * Temporary storage of collFilesystemDownloads to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initFilesystemDownloads()
	{
		if ($this->collFilesystemDownloads === null) {
			$this->collFilesystemDownloads = array();
		}
	}

	/**
	 * Method called to associate a FilesystemDownload object to this object
	 * through the FilesystemDownload foreign key attribute
	 *
	 * @param FilesystemDownload $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addFilesystemDownload(FilesystemDownload $l)
	{
		$this->collFilesystemDownloads[] = $l;
		$l->setFilesystem($this);
	}

	/**
	 * The criteria used to select the current contents of collFilesystemDownloads.
	 * @var Criteria
	 */
	private $lastFilesystemDownloadsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Filesystem has previously
	 * been saved, it will retrieve related FilesystemDownloads from storage.
	 * If this Filesystem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getFilesystemDownloads($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/FilesystemDownloadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collFilesystemDownloads === null) {
			if ($this->isNew()) {
			   $this->collFilesystemDownloads = array();
			} else {
	
				$criteria->add(FilesystemDownloadPeer::FILESYSTEM_ID, $this->getFilesystemId() );

				$this->collFilesystemDownloads = FilesystemDownloadPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(FilesystemDownloadPeer::FILESYSTEM_ID, $this->getFilesystemId());

				if (!isset($this->lastFilesystemDownloadsCriteria) || !$this->lastFilesystemDownloadsCriteria->equals($criteria)) {
					$this->collFilesystemDownloads = FilesystemDownloadPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFilesystemDownloadsCriteria = $criteria;

		return $this->collFilesystemDownloads;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Filesystem is new, it will return
	 * an empty collection; or if this Filesystem has previously
	 * been saved, it will retrieve related FilesystemDownloads from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Filesystem.
	 */
	public function getFilesystemDownloadsJoinFilesystem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/FilesystemDownloadPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFilesystemDownloads === null) {
			if ($this->isNew()) {
			   $this->collFilesystemDownloads = array();
			} else {
	   
				$criteria->add(FilesystemDownloadPeer::FILESYSTEM_ID, $this->getFilesystemId());
				$this->collFilesystemDownloads = FilesystemDownloadPeer::doSelectJoinFilesystem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FilesystemDownloadPeer::FILESYSTEM_ID, $this->getFilesystemId());
			if (!isset($this->lastFilesystemDownloadsCriteria) || !$this->lastFilesystemDownloadsCriteria->equals($criteria)) {
				$this->collFilesystemDownloads = FilesystemDownloadPeer::doSelectJoinFilesystem($criteria, $con);
			}
		}
		$this->lastFilesystemDownloadsCriteria = $criteria;

		return $this->collFilesystemDownloads;
	}

	/**
	 * Collection to store aggregation of collTrackerTransitionScripts	  
	 * @var array
	 */
	protected $collTrackerTransitionScripts; 

	/**
	 * Temporary storage of collTrackerTransitionScripts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerTransitionScripts()
	{
		if ($this->collTrackerTransitionScripts === null) {
			$this->collTrackerTransitionScripts = array();
		}
	}

	/**
	 * Method called to associate a TrackerTransitionScript object to this object
	 * through the TrackerTransitionScript foreign key attribute
	 *
	 * @param TrackerTransitionScript $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerTransitionScript(TrackerTransitionScript $l)
	{
		$this->collTrackerTransitionScripts[] = $l;
		$l->setFilesystem($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerTransitionScripts.
	 * @var Criteria
	 */
	private $lastTrackerTransitionScriptsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Filesystem has previously
	 * been saved, it will retrieve related TrackerTransitionScripts from storage.
	 * If this Filesystem is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerTransitionScripts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerTransitionScriptPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerTransitionScripts === null) {
			if ($this->isNew()) {
			   $this->collTrackerTransitionScripts = array();
			} else {
	
				$criteria->add(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID, $this->getFilesystemId() );

				$this->collTrackerTransitionScripts = TrackerTransitionScriptPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID, $this->getFilesystemId());

				if (!isset($this->lastTrackerTransitionScriptsCriteria) || !$this->lastTrackerTransitionScriptsCriteria->equals($criteria)) {
					$this->collTrackerTransitionScripts = TrackerTransitionScriptPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerTransitionScriptsCriteria = $criteria;

		return $this->collTrackerTransitionScripts;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Filesystem is new, it will return
	 * an empty collection; or if this Filesystem has previously
	 * been saved, it will retrieve related TrackerTransitionScripts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Filesystem.
	 */
	public function getTrackerTransitionScriptsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerTransitionScriptPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerTransitionScripts === null) {
			if ($this->isNew()) {
			   $this->collTrackerTransitionScripts = array();
			} else {
	   
				$criteria->add(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID, $this->getFilesystemId());
				$this->collTrackerTransitionScripts = TrackerTransitionScriptPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID, $this->getFilesystemId());
			if (!isset($this->lastTrackerTransitionScriptsCriteria) || !$this->lastTrackerTransitionScriptsCriteria->equals($criteria)) {
				$this->collTrackerTransitionScripts = TrackerTransitionScriptPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastTrackerTransitionScriptsCriteria = $criteria;

		return $this->collTrackerTransitionScripts;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Filesystem is new, it will return
	 * an empty collection; or if this Filesystem has previously
	 * been saved, it will retrieve related TrackerTransitionScripts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Filesystem.
	 */
	public function getTrackerTransitionScriptsJoinFilesystem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerTransitionScriptPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerTransitionScripts === null) {
			if ($this->isNew()) {
			   $this->collTrackerTransitionScripts = array();
			} else {
	   
				$criteria->add(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID, $this->getFilesystemId());
				$this->collTrackerTransitionScripts = TrackerTransitionScriptPeer::doSelectJoinFilesystem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID, $this->getFilesystemId());
			if (!isset($this->lastTrackerTransitionScriptsCriteria) || !$this->lastTrackerTransitionScriptsCriteria->equals($criteria)) {
				$this->collTrackerTransitionScripts = TrackerTransitionScriptPeer::doSelectJoinFilesystem($criteria, $con);
			}
		}
		$this->lastTrackerTransitionScriptsCriteria = $criteria;

		return $this->collTrackerTransitionScripts;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("filesystem_id", "section", "ref_id", "file_name", "file_name_safe", "file_type", "file_size", "deleted", "posted_by", "download_count", "strings", "md5_hash", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case FilesystemPeer::FILESYSTEM_ID:
				return $this->getFilesystemId();
				break;
		  
			case FilesystemPeer::SECTION:
				return $this->getSection();
				break;
		  
			case FilesystemPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case FilesystemPeer::FILE_NAME:
				return $this->getFileName();
				break;
		  
			case FilesystemPeer::FILE_NAME_SAFE:
				return $this->getFileNameSafe();
				break;
		  
			case FilesystemPeer::FILE_TYPE:
				return $this->getFileType();
				break;
		  
			case FilesystemPeer::FILE_SIZE:
				return $this->getFileSize();
				break;
		  
			case FilesystemPeer::DELETED:
				return $this->getDeleted();
				break;
		  
			case FilesystemPeer::POSTED_BY:
				return $this->getPostedBy();
				break;
		  
			case FilesystemPeer::DOWNLOAD_COUNT:
				return $this->getDownloadCount();
				break;
		  
			case FilesystemPeer::STRINGS:
				return $this->getStrings();
				break;
		  
			case FilesystemPeer::MD5_HASH:
				return $this->getMd5Hash();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getFilesystemId();
				break;
  
			case 1:
				return $this->getSection();
				break;
  
			case 2:
				return $this->getRefId();
				break;
  
			case 3:
				return $this->getFileName();
				break;
  
			case 4:
				return $this->getFileNameSafe();
				break;
  
			case 5:
				return $this->getFileType();
				break;
  
			case 6:
				return $this->getFileSize();
				break;
  
			case 7:
				return $this->getDeleted();
				break;
  
			case 8:
				return $this->getPostedBy();
				break;
  
			case 9:
				return $this->getDownloadCount();
				break;
  
			case 10:
				return $this->getStrings();
				break;
  
			case 11:
				return $this->getMd5Hash();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(FilesystemPeer::FILESYSTEM_ID, $arr)) $this->setFilesystemId($arr[FilesystemPeer::FILESYSTEM_ID]);
  
		if (array_key_exists(FilesystemPeer::SECTION, $arr)) $this->setSection($arr[FilesystemPeer::SECTION]);
  
		if (array_key_exists(FilesystemPeer::REF_ID, $arr)) $this->setRefId($arr[FilesystemPeer::REF_ID]);
  
		if (array_key_exists(FilesystemPeer::FILE_NAME, $arr)) $this->setFileName($arr[FilesystemPeer::FILE_NAME]);
  
		if (array_key_exists(FilesystemPeer::FILE_NAME_SAFE, $arr)) $this->setFileNameSafe($arr[FilesystemPeer::FILE_NAME_SAFE]);
  
		if (array_key_exists(FilesystemPeer::FILE_TYPE, $arr)) $this->setFileType($arr[FilesystemPeer::FILE_TYPE]);
  
		if (array_key_exists(FilesystemPeer::FILE_SIZE, $arr)) $this->setFileSize($arr[FilesystemPeer::FILE_SIZE]);
  
		if (array_key_exists(FilesystemPeer::DELETED, $arr)) $this->setDeleted($arr[FilesystemPeer::DELETED]);
  
		if (array_key_exists(FilesystemPeer::POSTED_BY, $arr)) $this->setPostedBy($arr[FilesystemPeer::POSTED_BY]);
  
		if (array_key_exists(FilesystemPeer::DOWNLOAD_COUNT, $arr)) $this->setDownloadCount($arr[FilesystemPeer::DOWNLOAD_COUNT]);
  
		if (array_key_exists(FilesystemPeer::STRINGS, $arr)) $this->setStrings($arr[FilesystemPeer::STRINGS]);
  
		if (array_key_exists(FilesystemPeer::MD5_HASH, $arr)) $this->setMd5Hash($arr[FilesystemPeer::MD5_HASH]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case FilesystemPeer::FILESYSTEM_ID:
				$this->setFilesystemId($value);
				break;
	  
			case FilesystemPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case FilesystemPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case FilesystemPeer::FILE_NAME:
				$this->setFileName($value);
				break;
	  
			case FilesystemPeer::FILE_NAME_SAFE:
				$this->setFileNameSafe($value);
				break;
	  
			case FilesystemPeer::FILE_TYPE:
				$this->setFileType($value);
				break;
	  
			case FilesystemPeer::FILE_SIZE:
				$this->setFileSize($value);
				break;
	  
			case FilesystemPeer::DELETED:
				$this->setDeleted($value);
				break;
	  
			case FilesystemPeer::POSTED_BY:
				$this->setPostedBy($value);
				break;
	  
			case FilesystemPeer::DOWNLOAD_COUNT:
				$this->setDownloadCount($value);
				break;
	  
			case FilesystemPeer::STRINGS:
				$this->setStrings($value);
				break;
	  
			case FilesystemPeer::MD5_HASH:
				$this->setMd5Hash($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setFilesystemId($value);
				break;
  
			case 1:
				$this->setSection($value);
				break;
  
			case 2:
				$this->setRefId($value);
				break;
  
			case 3:
				$this->setFileName($value);
				break;
  
			case 4:
				$this->setFileNameSafe($value);
				break;
  
			case 5:
				$this->setFileType($value);
				break;
  
			case 6:
				$this->setFileSize($value);
				break;
  
			case 7:
				$this->setDeleted($value);
				break;
  
			case 8:
				$this->setPostedBy($value);
				break;
  
			case 9:
				$this->setDownloadCount($value);
				break;
  
			case 10:
				$this->setStrings($value);
				break;
  
			case 11:
				$this->setMd5Hash($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(FilesystemPeer::DATABASE_NAME);

		try {
			$con->begin();
			FilesystemPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(FilesystemPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FilesystemPeer::doInsert($this, $con);
					$this->setFilesystemId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					FilesystemPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collFilesystemDownloads !== null) {
				for ($i=0,$size=count($this->collFilesystemDownloads); $i < $size; $i++) {
					$this->collFilesystemDownloads[$i]->save($con);
				}
			  }
			if ($this->collTrackerTransitionScripts !== null) {
				for ($i=0,$size=count($this->collTrackerTransitionScripts); $i < $size; $i++) {
					$this->collTrackerTransitionScripts[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return FilesystemPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = FilesystemPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collFilesystemDownloads !== null) {
				for ($i=0,$size=count($this->collFilesystemDownloads); $i < $size; $i++) {
					if (($retval = $this->collFilesystemDownloads[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerTransitionScripts !== null) {
				for ($i=0,$size=count($this->collTrackerTransitionScripts); $i < $size; $i++) {
					if (($retval = $this->collTrackerTransitionScripts[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed filesystem_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setFilesystemId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getFilesystemId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Filesystem Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Filesystem();
		$copyObj->setSection($this->section);
		$copyObj->setRefId($this->ref_id);
		$copyObj->setFileName($this->file_name);
		$copyObj->setFileNameSafe($this->file_name_safe);
		$copyObj->setFileType($this->file_type);
		$copyObj->setFileSize($this->file_size);
		$copyObj->setDeleted($this->deleted);
		$copyObj->setPostedBy($this->posted_by);
		$copyObj->setDownloadCount($this->download_count);
		$copyObj->setStrings($this->strings);
		$copyObj->setMd5Hash($this->md5_hash);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getFilesystemDownloads() as $relObj) {
				$copyObj->addFilesystemDownload($relObj->copy());
			}

			foreach($this->getTrackerTransitionScripts() as $relObj) {
				$copyObj->addTrackerTransitionScript($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setFilesystemId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return FilesystemPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FilesystemPeer();
		}
		return self::$peer;
	}

}
