<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Filesystem.php';
// (on-demand) include_once 'core/FilesystemPeer.php';

include_once 'core/FilesystemDownloadPeer.php';

/**
 * Base class that represents a row from the 'filesystem_download' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to FilesystemDownload class. 
 * 
 * @package core 
 */
abstract class BaseFilesystemDownload extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var FilesystemDownloadPeer
	 */
	protected static $peer;

	/**
	 * The value for the filesystem_download_id field.
	 * @var int	  
	 */
	protected $filesystem_download_id;	

	/**
	 * The value for the ip_address field.
	 * @var string	  
	 */
	protected $ip_address;	

	/**
	 * The value for the filesystem_id field.
	 * @var int	  
	 */
	protected $filesystem_id;	

	/**
	 * The value for the download_date field.
	 * @var int	  
	 */
	protected $download_date = -1;	

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	
  
	/**
	 * Get the FilesystemDownloadId column value.
	 *  
	 * @return int	  
	 */
	public function getFilesystemDownloadId()
	{
		return $this->filesystem_download_id;
	}


	/**
	 * Set the value of `filesystem_download_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setFilesystemDownloadId($v)
	{
		if ($this->filesystem_download_id !== $v) {
			$this->filesystem_download_id = $v;
			$this->modifiedColumns[] = FilesystemDownloadPeer::FILESYSTEM_DOWNLOAD_ID;
		}
				
	}

  
	/**
	 * Get the IpAddress column value.
	 *  
	 * @return string	  
	 */
	public function getIpAddress()
	{
		return $this->ip_address;
	}


	/**
	 * Set the value of `ip_address` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setIpAddress($v)
	{
		if ($this->ip_address !== $v) {
			$this->ip_address = $v;
			$this->modifiedColumns[] = FilesystemDownloadPeer::IP_ADDRESS;
		}
				
	}

  
	/**
	 * Get the FilesystemId column value.
	 *  
	 * @return int	  
	 */
	public function getFilesystemId()
	{
		return $this->filesystem_id;
	}


	/**
	 * Set the value of `filesystem_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setFilesystemId($v)
	{
		if ($this->filesystem_id !== $v) {
			$this->filesystem_id = $v;
			$this->modifiedColumns[] = FilesystemDownloadPeer::FILESYSTEM_ID;
		}
			
		if ($this->aFilesystem !== null && $this->aFilesystem->getFilesystemId() !== $v) {
			$this->aFilesystem = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `download_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getDownloadDate($format = 'Y-m-d H:i:s')
	{
		if ($this->download_date === null || $this->download_date === '') {
			return null;
		} elseif (!is_int($this->download_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->download_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of download_date as date/time value: " . var_export($this->download_date, true));
			}
		} else {
			$ts = $this->download_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `download_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setDownloadDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for download_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->download_date !== $ts || $ts === -1) {
			$this->download_date = $ts;
			$this->modifiedColumns[] = FilesystemDownloadPeer::DOWNLOAD_DATE;
		}
		
	}

  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = FilesystemDownloadPeer::USER_ID;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->filesystem_download_id = $rs->getInt($startcol + 0);					
			$this->ip_address = $rs->getString($startcol + 1);					
			$this->filesystem_id = $rs->getInt($startcol + 2);					
			$this->download_date = $rs->getTimestamp($startcol + 3, null);
			$this->user_id = $rs->getInt($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating FilesystemDownload object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(FilesystemDownloadPeer::DATABASE_NAME);
		$criteria->add(FilesystemDownloadPeer::FILESYSTEM_DOWNLOAD_ID, $this->filesystem_download_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(FilesystemDownloadPeer::DATABASE_NAME);
		if ($this->isColumnModified(FilesystemDownloadPeer::FILESYSTEM_DOWNLOAD_ID)) $criteria->add(FilesystemDownloadPeer::FILESYSTEM_DOWNLOAD_ID, $this->filesystem_download_id);
		if ($this->isColumnModified(FilesystemDownloadPeer::IP_ADDRESS)) $criteria->add(FilesystemDownloadPeer::IP_ADDRESS, $this->ip_address);
		if ($this->isColumnModified(FilesystemDownloadPeer::FILESYSTEM_ID)) $criteria->add(FilesystemDownloadPeer::FILESYSTEM_ID, $this->filesystem_id);
		if ($this->isColumnModified(FilesystemDownloadPeer::DOWNLOAD_DATE)) $criteria->add(FilesystemDownloadPeer::DOWNLOAD_DATE, $this->download_date);
		if ($this->isColumnModified(FilesystemDownloadPeer::USER_ID)) $criteria->add(FilesystemDownloadPeer::USER_ID, $this->user_id);
		return $criteria;			
	}
	
	

	/**
	 * @var Filesystem	  
	 */
	protected $aFilesystem;

	/**
	 * Declares an association between this object and a Filesystem object
	 *
	 * @param Filesystem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setFilesystem($v)
	{
			
		if ($v === null) {
			$this->setFilesystemId(NULL);
		} else {
			$this->setFilesystemId($v->getFilesystemId());
		}
   
		$this->aFilesystem = $v;
	}


	/**
	 * Get the associated Filesystem object
	 *
	 * @param Connection Optional Connection object.
	 * @return Filesystem The associated Filesystem object.
	 * @throws PropelException
	 */
	public function getFilesystem($con = null)
	{
		// include the Peer class
		include_once 'core/FilesystemPeer.php';

		if ($this->aFilesystem === null && ($this->filesystem_id !== null)) {
	
			$this->aFilesystem = FilesystemPeer::retrieveByPK($this->filesystem_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = FilesystemPeer::retrieveByPK($this->filesystem_id, $con);
			   $obj->addFilesystemDownloads($this);
			 */
		}
		return $this->aFilesystem;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setFilesystemKey($key)
	{

		$this->setFilesystemId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("filesystem_download_id", "ip_address", "filesystem_id", "download_date", "user_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case FilesystemDownloadPeer::FILESYSTEM_DOWNLOAD_ID:
				return $this->getFilesystemDownloadId();
				break;
		  
			case FilesystemDownloadPeer::IP_ADDRESS:
				return $this->getIpAddress();
				break;
		  
			case FilesystemDownloadPeer::FILESYSTEM_ID:
				return $this->getFilesystemId();
				break;
		  
			case FilesystemDownloadPeer::DOWNLOAD_DATE:
				return $this->getDownloadDate();
				break;
		  
			case FilesystemDownloadPeer::USER_ID:
				return $this->getUserId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getFilesystemDownloadId();
				break;
  
			case 1:
				return $this->getIpAddress();
				break;
  
			case 2:
				return $this->getFilesystemId();
				break;
  
			case 3:
				return $this->getDownloadDate();
				break;
  
			case 4:
				return $this->getUserId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(FilesystemDownloadPeer::FILESYSTEM_DOWNLOAD_ID, $arr)) $this->setFilesystemDownloadId($arr[FilesystemDownloadPeer::FILESYSTEM_DOWNLOAD_ID]);
  
		if (array_key_exists(FilesystemDownloadPeer::IP_ADDRESS, $arr)) $this->setIpAddress($arr[FilesystemDownloadPeer::IP_ADDRESS]);
  
		if (array_key_exists(FilesystemDownloadPeer::FILESYSTEM_ID, $arr)) $this->setFilesystemId($arr[FilesystemDownloadPeer::FILESYSTEM_ID]);
  
		if (array_key_exists(FilesystemDownloadPeer::DOWNLOAD_DATE, $arr)) $this->setDownloadDate($arr[FilesystemDownloadPeer::DOWNLOAD_DATE]);
  
		if (array_key_exists(FilesystemDownloadPeer::USER_ID, $arr)) $this->setUserId($arr[FilesystemDownloadPeer::USER_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case FilesystemDownloadPeer::FILESYSTEM_DOWNLOAD_ID:
				$this->setFilesystemDownloadId($value);
				break;
	  
			case FilesystemDownloadPeer::IP_ADDRESS:
				$this->setIpAddress($value);
				break;
	  
			case FilesystemDownloadPeer::FILESYSTEM_ID:
				$this->setFilesystemId($value);
				break;
	  
			case FilesystemDownloadPeer::DOWNLOAD_DATE:
				$this->setDownloadDate($value);
				break;
	  
			case FilesystemDownloadPeer::USER_ID:
				$this->setUserId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setFilesystemDownloadId($value);
				break;
  
			case 1:
				$this->setIpAddress($value);
				break;
  
			case 2:
				$this->setFilesystemId($value);
				break;
  
			case 3:
				$this->setDownloadDate($value);
				break;
  
			case 4:
				$this->setUserId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(FilesystemDownloadPeer::DATABASE_NAME);

		try {
			$con->begin();
			FilesystemDownloadPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(FilesystemDownloadPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aFilesystem !== null) {
				if ($this->aFilesystem->isModified()) $this->aFilesystem->save($con);
				$this->setFilesystem($this->aFilesystem);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = FilesystemDownloadPeer::doInsert($this, $con);
					$this->setFilesystemDownloadId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					FilesystemDownloadPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return FilesystemDownloadPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aFilesystem !== null) {
				if (($retval = $this->aFilesystem->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = FilesystemDownloadPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed filesystem_download_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setFilesystemDownloadId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getFilesystemDownloadId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return FilesystemDownload Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new FilesystemDownload();
		$copyObj->setIpAddress($this->ip_address);
		$copyObj->setFilesystemId($this->filesystem_id);
		$copyObj->setDownloadDate($this->download_date);
		$copyObj->setUserId($this->user_id);
		
		$copyObj->setNew(true);
		
		$copyObj->setFilesystemDownloadId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return FilesystemDownloadPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new FilesystemDownloadPeer();
		}
		return self::$peer;
	}

}
