<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'core/NotificationPeer.php';

/**
 * Base class that represents a row from the 'notification' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Notification class. 
 * 
 * @package core 
 */
abstract class BaseNotification extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var NotificationPeer
	 */
	protected static $peer;

	/**
	 * The value for the notification_id field.
	 * @var int	  
	 */
	protected $notification_id;	

	/**
	 * The value for the send_date field.
	 * @var int	  
	 */
	protected $send_date = -1;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the subsection field.
	 * @var string	  
	 */
	protected $subsection = 'null';	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the subject field.
	 * @var string	  
	 */
	protected $subject;	

	/**
	 * The value for the body field.
	 * @var string	  
	 */
	protected $body;	

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	
  
	/**
	 * Get the NotificationId column value.
	 *  
	 * @return int	  
	 */
	public function getNotificationId()
	{
		return $this->notification_id;
	}


	/**
	 * Set the value of `notification_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setNotificationId($v)
	{
		if ($this->notification_id !== $v) {
			$this->notification_id = $v;
			$this->modifiedColumns[] = NotificationPeer::NOTIFICATION_ID;
		}
			
		  // update associated NotificationQueue		  
		  if ($this->collNotificationQueues !== null) {
			  for ($i=0,$size=count($this->collNotificationQueues); $i < $size; $i++) {
				  $this->collNotificationQueues[$i]->setNotificationId($v);
			  }
		  }
			  	
		  // update associated FailedNotification		  
		  if ($this->collFailedNotifications !== null) {
			  for ($i=0,$size=count($this->collFailedNotifications); $i < $size; $i++) {
				  $this->collFailedNotifications[$i]->setNotificationId($v);
			  }
		  }
			  		
	}


	/**
	 * Get the [optionally formatted] `send_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getSendDate($format = 'Y-m-d H:i:s')
	{
		if ($this->send_date === null || $this->send_date === '') {
			return null;
		} elseif (!is_int($this->send_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->send_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of send_date as date/time value: " . var_export($this->send_date, true));
			}
		} else {
			$ts = $this->send_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `send_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setSendDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for send_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->send_date !== $ts || $ts === -1) {
			$this->send_date = $ts;
			$this->modifiedColumns[] = NotificationPeer::SEND_DATE;
		}
		
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = NotificationPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the Subsection column value.
	 *  
	 * @return string	  
	 */
	public function getSubsection()
	{
		return $this->subsection;
	}


	/**
	 * Set the value of `subsection` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSubsection($v)
	{
		if ($this->subsection !== $v || $v === 'null') {
			$this->subsection = $v;
			$this->modifiedColumns[] = NotificationPeer::SUBSECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = NotificationPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the Subject column value.
	 *  
	 * @return string	  
	 */
	public function getSubject()
	{
		return $this->subject;
	}


	/**
	 * Set the value of `subject` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSubject($v)
	{
		if ($this->subject !== $v) {
			$this->subject = $v;
			$this->modifiedColumns[] = NotificationPeer::SUBJECT;
		}
				
	}

  
	/**
	 * Get the Body column value.
	 *  
	 * @return string	  
	 */
	public function getBody()
	{
		return $this->body;
	}


	/**
	 * Set the value of `body` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setBody($v)
	{
		if ($this->body !== $v) {
			$this->body = $v;
			$this->modifiedColumns[] = NotificationPeer::BODY;
		}
				
	}

  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = NotificationPeer::USER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->notification_id = $rs->getInt($startcol + 0);					
			$this->send_date = $rs->getTimestamp($startcol + 1, null);
			$this->section = $rs->getString($startcol + 2);					
			$this->subsection = $rs->getString($startcol + 3);					
			$this->ref_id = $rs->getInt($startcol + 4);					
			$this->subject = $rs->getString($startcol + 5);					
			$this->body = $rs->getString($startcol + 6);					
			$this->user_id = $rs->getInt($startcol + 7);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Notification object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(NotificationPeer::DATABASE_NAME);
		$criteria->add(NotificationPeer::NOTIFICATION_ID, $this->notification_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(NotificationPeer::DATABASE_NAME);
		if ($this->isColumnModified(NotificationPeer::NOTIFICATION_ID)) $criteria->add(NotificationPeer::NOTIFICATION_ID, $this->notification_id);
		if ($this->isColumnModified(NotificationPeer::SEND_DATE)) $criteria->add(NotificationPeer::SEND_DATE, $this->send_date);
		if ($this->isColumnModified(NotificationPeer::SECTION)) $criteria->add(NotificationPeer::SECTION, $this->section);
		if ($this->isColumnModified(NotificationPeer::SUBSECTION)) $criteria->add(NotificationPeer::SUBSECTION, $this->subsection);
		if ($this->isColumnModified(NotificationPeer::REF_ID)) $criteria->add(NotificationPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(NotificationPeer::SUBJECT)) $criteria->add(NotificationPeer::SUBJECT, $this->subject);
		if ($this->isColumnModified(NotificationPeer::BODY)) $criteria->add(NotificationPeer::BODY, $this->body);
		if ($this->isColumnModified(NotificationPeer::USER_ID)) $criteria->add(NotificationPeer::USER_ID, $this->user_id);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->user_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addNotifications($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collNotificationQueues	  
	 * @var array
	 */
	protected $collNotificationQueues; 

	/**
	 * Temporary storage of collNotificationQueues to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initNotificationQueues()
	{
		if ($this->collNotificationQueues === null) {
			$this->collNotificationQueues = array();
		}
	}

	/**
	 * Method called to associate a NotificationQueue object to this object
	 * through the NotificationQueue foreign key attribute
	 *
	 * @param NotificationQueue $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addNotificationQueue(NotificationQueue $l)
	{
		$this->collNotificationQueues[] = $l;
		$l->setNotification($this);
	}

	/**
	 * The criteria used to select the current contents of collNotificationQueues.
	 * @var Criteria
	 */
	private $lastNotificationQueuesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Notification has previously
	 * been saved, it will retrieve related NotificationQueues from storage.
	 * If this Notification is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getNotificationQueues($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/NotificationQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collNotificationQueues === null) {
			if ($this->isNew()) {
			   $this->collNotificationQueues = array();
			} else {
	
				$criteria->add(NotificationQueuePeer::NOTIFICATION_ID, $this->getNotificationId() );

				$this->collNotificationQueues = NotificationQueuePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(NotificationQueuePeer::NOTIFICATION_ID, $this->getNotificationId());

				if (!isset($this->lastNotificationQueuesCriteria) || !$this->lastNotificationQueuesCriteria->equals($criteria)) {
					$this->collNotificationQueues = NotificationQueuePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastNotificationQueuesCriteria = $criteria;

		return $this->collNotificationQueues;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Notification is new, it will return
	 * an empty collection; or if this Notification has previously
	 * been saved, it will retrieve related NotificationQueues from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Notification.
	 */
	public function getNotificationQueuesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/NotificationQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collNotificationQueues === null) {
			if ($this->isNew()) {
			   $this->collNotificationQueues = array();
			} else {
	   
				$criteria->add(NotificationQueuePeer::NOTIFICATION_ID, $this->getNotificationId());
				$this->collNotificationQueues = NotificationQueuePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(NotificationQueuePeer::NOTIFICATION_ID, $this->getNotificationId());
			if (!isset($this->lastNotificationQueuesCriteria) || !$this->lastNotificationQueuesCriteria->equals($criteria)) {
				$this->collNotificationQueues = NotificationQueuePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastNotificationQueuesCriteria = $criteria;

		return $this->collNotificationQueues;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Notification is new, it will return
	 * an empty collection; or if this Notification has previously
	 * been saved, it will retrieve related NotificationQueues from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Notification.
	 */
	public function getNotificationQueuesJoinNotification($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/NotificationQueuePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collNotificationQueues === null) {
			if ($this->isNew()) {
			   $this->collNotificationQueues = array();
			} else {
	   
				$criteria->add(NotificationQueuePeer::NOTIFICATION_ID, $this->getNotificationId());
				$this->collNotificationQueues = NotificationQueuePeer::doSelectJoinNotification($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(NotificationQueuePeer::NOTIFICATION_ID, $this->getNotificationId());
			if (!isset($this->lastNotificationQueuesCriteria) || !$this->lastNotificationQueuesCriteria->equals($criteria)) {
				$this->collNotificationQueues = NotificationQueuePeer::doSelectJoinNotification($criteria, $con);
			}
		}
		$this->lastNotificationQueuesCriteria = $criteria;

		return $this->collNotificationQueues;
	}

	/**
	 * Collection to store aggregation of collFailedNotifications	  
	 * @var array
	 */
	protected $collFailedNotifications; 

	/**
	 * Temporary storage of collFailedNotifications to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initFailedNotifications()
	{
		if ($this->collFailedNotifications === null) {
			$this->collFailedNotifications = array();
		}
	}

	/**
	 * Method called to associate a FailedNotification object to this object
	 * through the FailedNotification foreign key attribute
	 *
	 * @param FailedNotification $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addFailedNotification(FailedNotification $l)
	{
		$this->collFailedNotifications[] = $l;
		$l->setNotification($this);
	}

	/**
	 * The criteria used to select the current contents of collFailedNotifications.
	 * @var Criteria
	 */
	private $lastFailedNotificationsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Notification has previously
	 * been saved, it will retrieve related FailedNotifications from storage.
	 * If this Notification is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getFailedNotifications($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/FailedNotificationPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collFailedNotifications === null) {
			if ($this->isNew()) {
			   $this->collFailedNotifications = array();
			} else {
	
				$criteria->add(FailedNotificationPeer::NOTIFICATION_ID, $this->getNotificationId() );

				$this->collFailedNotifications = FailedNotificationPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(FailedNotificationPeer::NOTIFICATION_ID, $this->getNotificationId());

				if (!isset($this->lastFailedNotificationsCriteria) || !$this->lastFailedNotificationsCriteria->equals($criteria)) {
					$this->collFailedNotifications = FailedNotificationPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastFailedNotificationsCriteria = $criteria;

		return $this->collFailedNotifications;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Notification is new, it will return
	 * an empty collection; or if this Notification has previously
	 * been saved, it will retrieve related FailedNotifications from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Notification.
	 */
	public function getFailedNotificationsJoinNotification($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/FailedNotificationPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFailedNotifications === null) {
			if ($this->isNew()) {
			   $this->collFailedNotifications = array();
			} else {
	   
				$criteria->add(FailedNotificationPeer::NOTIFICATION_ID, $this->getNotificationId());
				$this->collFailedNotifications = FailedNotificationPeer::doSelectJoinNotification($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FailedNotificationPeer::NOTIFICATION_ID, $this->getNotificationId());
			if (!isset($this->lastFailedNotificationsCriteria) || !$this->lastFailedNotificationsCriteria->equals($criteria)) {
				$this->collFailedNotifications = FailedNotificationPeer::doSelectJoinNotification($criteria, $con);
			}
		}
		$this->lastFailedNotificationsCriteria = $criteria;

		return $this->collFailedNotifications;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Notification is new, it will return
	 * an empty collection; or if this Notification has previously
	 * been saved, it will retrieve related FailedNotifications from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Notification.
	 */
	public function getFailedNotificationsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/FailedNotificationPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collFailedNotifications === null) {
			if ($this->isNew()) {
			   $this->collFailedNotifications = array();
			} else {
	   
				$criteria->add(FailedNotificationPeer::NOTIFICATION_ID, $this->getNotificationId());
				$this->collFailedNotifications = FailedNotificationPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(FailedNotificationPeer::NOTIFICATION_ID, $this->getNotificationId());
			if (!isset($this->lastFailedNotificationsCriteria) || !$this->lastFailedNotificationsCriteria->equals($criteria)) {
				$this->collFailedNotifications = FailedNotificationPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastFailedNotificationsCriteria = $criteria;

		return $this->collFailedNotifications;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("notification_id", "send_date", "section", "subsection", "ref_id", "subject", "body", "user_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case NotificationPeer::NOTIFICATION_ID:
				return $this->getNotificationId();
				break;
		  
			case NotificationPeer::SEND_DATE:
				return $this->getSendDate();
				break;
		  
			case NotificationPeer::SECTION:
				return $this->getSection();
				break;
		  
			case NotificationPeer::SUBSECTION:
				return $this->getSubsection();
				break;
		  
			case NotificationPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case NotificationPeer::SUBJECT:
				return $this->getSubject();
				break;
		  
			case NotificationPeer::BODY:
				return $this->getBody();
				break;
		  
			case NotificationPeer::USER_ID:
				return $this->getUserId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getNotificationId();
				break;
  
			case 1:
				return $this->getSendDate();
				break;
  
			case 2:
				return $this->getSection();
				break;
  
			case 3:
				return $this->getSubsection();
				break;
  
			case 4:
				return $this->getRefId();
				break;
  
			case 5:
				return $this->getSubject();
				break;
  
			case 6:
				return $this->getBody();
				break;
  
			case 7:
				return $this->getUserId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(NotificationPeer::NOTIFICATION_ID, $arr)) $this->setNotificationId($arr[NotificationPeer::NOTIFICATION_ID]);
  
		if (array_key_exists(NotificationPeer::SEND_DATE, $arr)) $this->setSendDate($arr[NotificationPeer::SEND_DATE]);
  
		if (array_key_exists(NotificationPeer::SECTION, $arr)) $this->setSection($arr[NotificationPeer::SECTION]);
  
		if (array_key_exists(NotificationPeer::SUBSECTION, $arr)) $this->setSubsection($arr[NotificationPeer::SUBSECTION]);
  
		if (array_key_exists(NotificationPeer::REF_ID, $arr)) $this->setRefId($arr[NotificationPeer::REF_ID]);
  
		if (array_key_exists(NotificationPeer::SUBJECT, $arr)) $this->setSubject($arr[NotificationPeer::SUBJECT]);
  
		if (array_key_exists(NotificationPeer::BODY, $arr)) $this->setBody($arr[NotificationPeer::BODY]);
  
		if (array_key_exists(NotificationPeer::USER_ID, $arr)) $this->setUserId($arr[NotificationPeer::USER_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case NotificationPeer::NOTIFICATION_ID:
				$this->setNotificationId($value);
				break;
	  
			case NotificationPeer::SEND_DATE:
				$this->setSendDate($value);
				break;
	  
			case NotificationPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case NotificationPeer::SUBSECTION:
				$this->setSubsection($value);
				break;
	  
			case NotificationPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case NotificationPeer::SUBJECT:
				$this->setSubject($value);
				break;
	  
			case NotificationPeer::BODY:
				$this->setBody($value);
				break;
	  
			case NotificationPeer::USER_ID:
				$this->setUserId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setNotificationId($value);
				break;
  
			case 1:
				$this->setSendDate($value);
				break;
  
			case 2:
				$this->setSection($value);
				break;
  
			case 3:
				$this->setSubsection($value);
				break;
  
			case 4:
				$this->setRefId($value);
				break;
  
			case 5:
				$this->setSubject($value);
				break;
  
			case 6:
				$this->setBody($value);
				break;
  
			case 7:
				$this->setUserId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(NotificationPeer::DATABASE_NAME);

		try {
			$con->begin();
			NotificationPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(NotificationPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = NotificationPeer::doInsert($this, $con);
					$this->setNotificationId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					NotificationPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collNotificationQueues !== null) {
				for ($i=0,$size=count($this->collNotificationQueues); $i < $size; $i++) {
					$this->collNotificationQueues[$i]->save($con);
				}
			  }
			if ($this->collFailedNotifications !== null) {
				for ($i=0,$size=count($this->collFailedNotifications); $i < $size; $i++) {
					$this->collFailedNotifications[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return NotificationPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = NotificationPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collNotificationQueues !== null) {
				for ($i=0,$size=count($this->collNotificationQueues); $i < $size; $i++) {
					if (($retval = $this->collNotificationQueues[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collFailedNotifications !== null) {
				for ($i=0,$size=count($this->collFailedNotifications); $i < $size; $i++) {
					if (($retval = $this->collFailedNotifications[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed notification_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setNotificationId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getNotificationId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Notification Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Notification();
		$copyObj->setSendDate($this->send_date);
		$copyObj->setSection($this->section);
		$copyObj->setSubsection($this->subsection);
		$copyObj->setRefId($this->ref_id);
		$copyObj->setSubject($this->subject);
		$copyObj->setBody($this->body);
		$copyObj->setUserId($this->user_id);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getNotificationQueues() as $relObj) {
				$copyObj->addNotificationQueue($relObj->copy());
			}

			foreach($this->getFailedNotifications() as $relObj) {
				$copyObj->addFailedNotification($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setNotificationId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return NotificationPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new NotificationPeer();
		}
		return self::$peer;
	}

}
