<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'core/PastebinPeer.php';

/**
 * Base class that represents a row from the 'pastebin' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Pastebin class. 
 * 
 * @package core 
 */
abstract class BasePastebin extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var PastebinPeer
	 */
	protected static $peer;

	/**
	 * The value for the pastebin_id field.
	 * @var int	  
	 */
	protected $pastebin_id;	

	/**
	 * The value for the title field.
	 * @var string	  
	 */
	protected $title;	

	/**
	 * The value for the content field.
	 * @var string	  
	 */
	protected $content;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the exposure_type field.
	 * @var int	  
	 */
	protected $exposure_type;	

	/**
	 * The value for the language field.
	 * @var string	  
	 */
	protected $language;	

	/**
	 * The value for the posted_by field.
	 * @var int	  
	 */
	protected $posted_by;	

	/**
	 * The value for the post_date field.
	 * @var int	  
	 */
	protected $post_date = -1;	

	/**
	 * The value for the expiration field.
	 * @var int	  
	 */
	protected $expiration;	
  
	/**
	 * Get the PastebinId column value.
	 *  
	 * @return int	  
	 */
	public function getPastebinId()
	{
		return $this->pastebin_id;
	}


	/**
	 * Set the value of `pastebin_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setPastebinId($v)
	{
		if ($this->pastebin_id !== $v) {
			$this->pastebin_id = $v;
			$this->modifiedColumns[] = PastebinPeer::PASTEBIN_ID;
		}
				
	}

  
	/**
	 * Get the Title column value.
	 *  
	 * @return string	  
	 */
	public function getTitle()
	{
		return $this->title;
	}


	/**
	 * Set the value of `title` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setTitle($v)
	{
		if ($this->title !== $v) {
			$this->title = $v;
			$this->modifiedColumns[] = PastebinPeer::TITLE;
		}
				
	}

  
	/**
	 * Get the Content column value.
	 *  
	 * @return string	  
	 */
	public function getContent()
	{
		return $this->content;
	}


	/**
	 * Set the value of `content` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setContent($v)
	{
		if ($this->content !== $v) {
			$this->content = $v;
			$this->modifiedColumns[] = PastebinPeer::CONTENT;
		}
				
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = PastebinPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = PastebinPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the ExposureType column value.
	 *  
	 * @return int	  
	 */
	public function getExposureType()
	{
		return $this->exposure_type;
	}


	/**
	 * Set the value of `exposure_type` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setExposureType($v)
	{
		if ($this->exposure_type !== $v) {
			$this->exposure_type = $v;
			$this->modifiedColumns[] = PastebinPeer::EXPOSURE_TYPE;
		}
				
	}

  
	/**
	 * Get the Language column value.
	 *  
	 * @return string	  
	 */
	public function getLanguage()
	{
		return $this->language;
	}


	/**
	 * Set the value of `language` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setLanguage($v)
	{
		if ($this->language !== $v) {
			$this->language = $v;
			$this->modifiedColumns[] = PastebinPeer::LANGUAGE;
		}
				
	}

  
	/**
	 * Get the PostedBy column value.
	 *  
	 * @return int	  
	 */
	public function getPostedBy()
	{
		return $this->posted_by;
	}


	/**
	 * Set the value of `posted_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setPostedBy($v)
	{
		if ($this->posted_by !== $v) {
			$this->posted_by = $v;
			$this->modifiedColumns[] = PastebinPeer::POSTED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `post_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getPostDate($format = 'Y-m-d H:i:s')
	{
		if ($this->post_date === null || $this->post_date === '') {
			return null;
		} elseif (!is_int($this->post_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->post_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of post_date as date/time value: " . var_export($this->post_date, true));
			}
		} else {
			$ts = $this->post_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `post_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setPostDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for post_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->post_date !== $ts || $ts === -1) {
			$this->post_date = $ts;
			$this->modifiedColumns[] = PastebinPeer::POST_DATE;
		}
		
	}

  
	/**
	 * Get the Expiration column value.
	 *  
	 * @return int	  
	 */
	public function getExpiration()
	{
		return $this->expiration;
	}


	/**
	 * Set the value of `expiration` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setExpiration($v)
	{
		if ($this->expiration !== $v) {
			$this->expiration = $v;
			$this->modifiedColumns[] = PastebinPeer::EXPIRATION;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->pastebin_id = $rs->getInt($startcol + 0);					
			$this->title = $rs->getString($startcol + 1);					
			$this->content = $rs->getString($startcol + 2);					
			$this->section = $rs->getString($startcol + 3);					
			$this->ref_id = $rs->getInt($startcol + 4);					
			$this->exposure_type = $rs->getInt($startcol + 5);					
			$this->language = $rs->getString($startcol + 6);					
			$this->posted_by = $rs->getInt($startcol + 7);					
			$this->post_date = $rs->getTimestamp($startcol + 8, null);
			$this->expiration = $rs->getInt($startcol + 9);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Pastebin object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(PastebinPeer::DATABASE_NAME);
		$criteria->add(PastebinPeer::PASTEBIN_ID, $this->pastebin_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(PastebinPeer::DATABASE_NAME);
		if ($this->isColumnModified(PastebinPeer::PASTEBIN_ID)) $criteria->add(PastebinPeer::PASTEBIN_ID, $this->pastebin_id);
		if ($this->isColumnModified(PastebinPeer::TITLE)) $criteria->add(PastebinPeer::TITLE, $this->title);
		if ($this->isColumnModified(PastebinPeer::CONTENT)) $criteria->add(PastebinPeer::CONTENT, $this->content);
		if ($this->isColumnModified(PastebinPeer::SECTION)) $criteria->add(PastebinPeer::SECTION, $this->section);
		if ($this->isColumnModified(PastebinPeer::REF_ID)) $criteria->add(PastebinPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(PastebinPeer::EXPOSURE_TYPE)) $criteria->add(PastebinPeer::EXPOSURE_TYPE, $this->exposure_type);
		if ($this->isColumnModified(PastebinPeer::LANGUAGE)) $criteria->add(PastebinPeer::LANGUAGE, $this->language);
		if ($this->isColumnModified(PastebinPeer::POSTED_BY)) $criteria->add(PastebinPeer::POSTED_BY, $this->posted_by);
		if ($this->isColumnModified(PastebinPeer::POST_DATE)) $criteria->add(PastebinPeer::POST_DATE, $this->post_date);
		if ($this->isColumnModified(PastebinPeer::EXPIRATION)) $criteria->add(PastebinPeer::EXPIRATION, $this->expiration);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setPostedBy(NULL);
		} else {
			$this->setPostedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->posted_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->posted_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->posted_by, $con);
			   $obj->addPastebins($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setPostedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("pastebin_id", "title", "content", "section", "ref_id", "exposure_type", "language", "posted_by", "post_date", "expiration", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case PastebinPeer::PASTEBIN_ID:
				return $this->getPastebinId();
				break;
		  
			case PastebinPeer::TITLE:
				return $this->getTitle();
				break;
		  
			case PastebinPeer::CONTENT:
				return $this->getContent();
				break;
		  
			case PastebinPeer::SECTION:
				return $this->getSection();
				break;
		  
			case PastebinPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case PastebinPeer::EXPOSURE_TYPE:
				return $this->getExposureType();
				break;
		  
			case PastebinPeer::LANGUAGE:
				return $this->getLanguage();
				break;
		  
			case PastebinPeer::POSTED_BY:
				return $this->getPostedBy();
				break;
		  
			case PastebinPeer::POST_DATE:
				return $this->getPostDate();
				break;
		  
			case PastebinPeer::EXPIRATION:
				return $this->getExpiration();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getPastebinId();
				break;
  
			case 1:
				return $this->getTitle();
				break;
  
			case 2:
				return $this->getContent();
				break;
  
			case 3:
				return $this->getSection();
				break;
  
			case 4:
				return $this->getRefId();
				break;
  
			case 5:
				return $this->getExposureType();
				break;
  
			case 6:
				return $this->getLanguage();
				break;
  
			case 7:
				return $this->getPostedBy();
				break;
  
			case 8:
				return $this->getPostDate();
				break;
  
			case 9:
				return $this->getExpiration();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(PastebinPeer::PASTEBIN_ID, $arr)) $this->setPastebinId($arr[PastebinPeer::PASTEBIN_ID]);
  
		if (array_key_exists(PastebinPeer::TITLE, $arr)) $this->setTitle($arr[PastebinPeer::TITLE]);
  
		if (array_key_exists(PastebinPeer::CONTENT, $arr)) $this->setContent($arr[PastebinPeer::CONTENT]);
  
		if (array_key_exists(PastebinPeer::SECTION, $arr)) $this->setSection($arr[PastebinPeer::SECTION]);
  
		if (array_key_exists(PastebinPeer::REF_ID, $arr)) $this->setRefId($arr[PastebinPeer::REF_ID]);
  
		if (array_key_exists(PastebinPeer::EXPOSURE_TYPE, $arr)) $this->setExposureType($arr[PastebinPeer::EXPOSURE_TYPE]);
  
		if (array_key_exists(PastebinPeer::LANGUAGE, $arr)) $this->setLanguage($arr[PastebinPeer::LANGUAGE]);
  
		if (array_key_exists(PastebinPeer::POSTED_BY, $arr)) $this->setPostedBy($arr[PastebinPeer::POSTED_BY]);
  
		if (array_key_exists(PastebinPeer::POST_DATE, $arr)) $this->setPostDate($arr[PastebinPeer::POST_DATE]);
  
		if (array_key_exists(PastebinPeer::EXPIRATION, $arr)) $this->setExpiration($arr[PastebinPeer::EXPIRATION]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case PastebinPeer::PASTEBIN_ID:
				$this->setPastebinId($value);
				break;
	  
			case PastebinPeer::TITLE:
				$this->setTitle($value);
				break;
	  
			case PastebinPeer::CONTENT:
				$this->setContent($value);
				break;
	  
			case PastebinPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case PastebinPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case PastebinPeer::EXPOSURE_TYPE:
				$this->setExposureType($value);
				break;
	  
			case PastebinPeer::LANGUAGE:
				$this->setLanguage($value);
				break;
	  
			case PastebinPeer::POSTED_BY:
				$this->setPostedBy($value);
				break;
	  
			case PastebinPeer::POST_DATE:
				$this->setPostDate($value);
				break;
	  
			case PastebinPeer::EXPIRATION:
				$this->setExpiration($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setPastebinId($value);
				break;
  
			case 1:
				$this->setTitle($value);
				break;
  
			case 2:
				$this->setContent($value);
				break;
  
			case 3:
				$this->setSection($value);
				break;
  
			case 4:
				$this->setRefId($value);
				break;
  
			case 5:
				$this->setExposureType($value);
				break;
  
			case 6:
				$this->setLanguage($value);
				break;
  
			case 7:
				$this->setPostedBy($value);
				break;
  
			case 8:
				$this->setPostDate($value);
				break;
  
			case 9:
				$this->setExpiration($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(PastebinPeer::DATABASE_NAME);

		try {
			$con->begin();
			PastebinPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(PastebinPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PastebinPeer::doInsert($this, $con);
					$this->setPastebinId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					PastebinPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return PastebinPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = PastebinPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed pastebin_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setPastebinId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getPastebinId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Pastebin Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Pastebin();
		$copyObj->setTitle($this->title);
		$copyObj->setContent($this->content);
		$copyObj->setSection($this->section);
		$copyObj->setRefId($this->ref_id);
		$copyObj->setExposureType($this->exposure_type);
		$copyObj->setLanguage($this->language);
		$copyObj->setPostedBy($this->posted_by);
		$copyObj->setPostDate($this->post_date);
		$copyObj->setExpiration($this->expiration);
		
		$copyObj->setNew(true);
		
		$copyObj->setPastebinId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return PastebinPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PastebinPeer();
		}
		return self::$peer;
	}

}
