<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';

include_once 'core/RolePeer.php';

/**
 * Base class that represents a row from the 'role' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Role class. 
 * 
 * @package core 
 */
abstract class BaseRole extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var RolePeer
	 */
	protected static $peer;

	/**
	 * The value for the role_id field.
	 * @var int	  
	 */
	protected $role_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the role_name field.
	 * @var string	  
	 */
	protected $role_name;	
  
	/**
	 * Get the RoleId column value.
	 *  
	 * @return int	  
	 */
	public function getRoleId()
	{
		return $this->role_id;
	}


	/**
	 * Set the value of `role_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setRoleId($v)
	{
		if ($this->role_id !== $v) {
			$this->role_id = $v;
			$this->modifiedColumns[] = RolePeer::ROLE_ID;
		}
			
		  // update associated RoleSetting		  
		  if ($this->collRoleSettings !== null) {
			  for ($i=0,$size=count($this->collRoleSettings); $i < $size; $i++) {
				  $this->collRoleSettings[$i]->setRoleId($v);
			  }
		  }
			  	
		  // update associated TrackerEfeTransitionReassign		  
		  if ($this->collTrackerEfeTransitionReassigns !== null) {
			  for ($i=0,$size=count($this->collTrackerEfeTransitionReassigns); $i < $size; $i++) {
				  $this->collTrackerEfeTransitionReassigns[$i]->setAssignToRoleId($v);
			  }
		  }
			  	
		  // update associated TrackerCommitReassignTrigger		  
		  if ($this->collTrackerCommitReassignTriggers !== null) {
			  for ($i=0,$size=count($this->collTrackerCommitReassignTriggers); $i < $size; $i++) {
				  $this->collTrackerCommitReassignTriggers[$i]->setAssignToRoleId($v);
			  }
		  }
			  	
		  // update associated TrackerExtraFieldElementTransitionRole		  
		  if ($this->collTrackerExtraFieldElementTransitionRoles !== null) {
			  for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionRoles); $i < $size; $i++) {
				  $this->collTrackerExtraFieldElementTransitionRoles[$i]->setRoleId($v);
			  }
		  }
			  	
		  // update associated UserProjectRole		  
		  if ($this->collUserProjectRoles !== null) {
			  for ($i=0,$size=count($this->collUserProjectRoles); $i < $size; $i++) {
				  $this->collUserProjectRoles[$i]->setRoleId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = RolePeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the RoleName column value.
	 *  
	 * @return string	  
	 */
	public function getRoleName()
	{
		return $this->role_name;
	}


	/**
	 * Set the value of `role_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setRoleName($v)
	{
		if ($this->role_name !== $v) {
			$this->role_name = $v;
			$this->modifiedColumns[] = RolePeer::ROLE_NAME;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->role_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->role_name = $rs->getString($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Role object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(RolePeer::DATABASE_NAME);
		$criteria->add(RolePeer::ROLE_ID, $this->role_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(RolePeer::DATABASE_NAME);
		if ($this->isColumnModified(RolePeer::ROLE_ID)) $criteria->add(RolePeer::ROLE_ID, $this->role_id);
		if ($this->isColumnModified(RolePeer::PROJECT_ID)) $criteria->add(RolePeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(RolePeer::ROLE_NAME)) $criteria->add(RolePeer::ROLE_NAME, $this->role_name);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addRoles($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collRoleSettings	  
	 * @var array
	 */
	protected $collRoleSettings; 

	/**
	 * Temporary storage of collRoleSettings to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initRoleSettings()
	{
		if ($this->collRoleSettings === null) {
			$this->collRoleSettings = array();
		}
	}

	/**
	 * Method called to associate a RoleSetting object to this object
	 * through the RoleSetting foreign key attribute
	 *
	 * @param RoleSetting $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addRoleSetting(RoleSetting $l)
	{
		$this->collRoleSettings[] = $l;
		$l->setRole($this);
	}

	/**
	 * The criteria used to select the current contents of collRoleSettings.
	 * @var Criteria
	 */
	private $lastRoleSettingsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role has previously
	 * been saved, it will retrieve related RoleSettings from storage.
	 * If this Role is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getRoleSettings($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/RoleSettingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collRoleSettings === null) {
			if ($this->isNew()) {
			   $this->collRoleSettings = array();
			} else {
	
				$criteria->add(RoleSettingPeer::ROLE_ID, $this->getRoleId() );

				$this->collRoleSettings = RoleSettingPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(RoleSettingPeer::ROLE_ID, $this->getRoleId());

				if (!isset($this->lastRoleSettingsCriteria) || !$this->lastRoleSettingsCriteria->equals($criteria)) {
					$this->collRoleSettings = RoleSettingPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRoleSettingsCriteria = $criteria;

		return $this->collRoleSettings;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related RoleSettings from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getRoleSettingsJoinRole($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/RoleSettingPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collRoleSettings === null) {
			if ($this->isNew()) {
			   $this->collRoleSettings = array();
			} else {
	   
				$criteria->add(RoleSettingPeer::ROLE_ID, $this->getRoleId());
				$this->collRoleSettings = RoleSettingPeer::doSelectJoinRole($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(RoleSettingPeer::ROLE_ID, $this->getRoleId());
			if (!isset($this->lastRoleSettingsCriteria) || !$this->lastRoleSettingsCriteria->equals($criteria)) {
				$this->collRoleSettings = RoleSettingPeer::doSelectJoinRole($criteria, $con);
			}
		}
		$this->lastRoleSettingsCriteria = $criteria;

		return $this->collRoleSettings;
	}

	/**
	 * Collection to store aggregation of collTrackerEfeTransitionReassigns	  
	 * @var array
	 */
	protected $collTrackerEfeTransitionReassigns; 

	/**
	 * Temporary storage of collTrackerEfeTransitionReassigns to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerEfeTransitionReassigns()
	{
		if ($this->collTrackerEfeTransitionReassigns === null) {
			$this->collTrackerEfeTransitionReassigns = array();
		}
	}

	/**
	 * Method called to associate a TrackerEfeTransitionReassign object to this object
	 * through the TrackerEfeTransitionReassign foreign key attribute
	 *
	 * @param TrackerEfeTransitionReassign $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerEfeTransitionReassign(TrackerEfeTransitionReassign $l)
	{
		$this->collTrackerEfeTransitionReassigns[] = $l;
		$l->setRole($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerEfeTransitionReassigns.
	 * @var Criteria
	 */
	private $lastTrackerEfeTransitionReassignsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role has previously
	 * been saved, it will retrieve related TrackerEfeTransitionReassigns from storage.
	 * If this Role is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerEfeTransitionReassigns($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionReassignPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerEfeTransitionReassigns === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionReassigns = array();
			} else {
	
				$criteria->add(TrackerEfeTransitionReassignPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId() );

				$this->collTrackerEfeTransitionReassigns = TrackerEfeTransitionReassignPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerEfeTransitionReassignPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());

				if (!isset($this->lastTrackerEfeTransitionReassignsCriteria) || !$this->lastTrackerEfeTransitionReassignsCriteria->equals($criteria)) {
					$this->collTrackerEfeTransitionReassigns = TrackerEfeTransitionReassignPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerEfeTransitionReassignsCriteria = $criteria;

		return $this->collTrackerEfeTransitionReassigns;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related TrackerEfeTransitionReassigns from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getTrackerEfeTransitionReassignsJoinTrackerExtraFieldElementTransition($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionReassignPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionReassigns === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionReassigns = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionReassignPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());
				$this->collTrackerEfeTransitionReassigns = TrackerEfeTransitionReassignPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionReassignPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());
			if (!isset($this->lastTrackerEfeTransitionReassignsCriteria) || !$this->lastTrackerEfeTransitionReassignsCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionReassigns = TrackerEfeTransitionReassignPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionReassignsCriteria = $criteria;

		return $this->collTrackerEfeTransitionReassigns;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related TrackerEfeTransitionReassigns from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getTrackerEfeTransitionReassignsJoinRole($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionReassignPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionReassigns === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionReassigns = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionReassignPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());
				$this->collTrackerEfeTransitionReassigns = TrackerEfeTransitionReassignPeer::doSelectJoinRole($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionReassignPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());
			if (!isset($this->lastTrackerEfeTransitionReassignsCriteria) || !$this->lastTrackerEfeTransitionReassignsCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionReassigns = TrackerEfeTransitionReassignPeer::doSelectJoinRole($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionReassignsCriteria = $criteria;

		return $this->collTrackerEfeTransitionReassigns;
	}

	/**
	 * Collection to store aggregation of collTrackerCommitReassignTriggers	  
	 * @var array
	 */
	protected $collTrackerCommitReassignTriggers; 

	/**
	 * Temporary storage of collTrackerCommitReassignTriggers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerCommitReassignTriggers()
	{
		if ($this->collTrackerCommitReassignTriggers === null) {
			$this->collTrackerCommitReassignTriggers = array();
		}
	}

	/**
	 * Method called to associate a TrackerCommitReassignTrigger object to this object
	 * through the TrackerCommitReassignTrigger foreign key attribute
	 *
	 * @param TrackerCommitReassignTrigger $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerCommitReassignTrigger(TrackerCommitReassignTrigger $l)
	{
		$this->collTrackerCommitReassignTriggers[] = $l;
		$l->setRole($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerCommitReassignTriggers.
	 * @var Criteria
	 */
	private $lastTrackerCommitReassignTriggersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role has previously
	 * been saved, it will retrieve related TrackerCommitReassignTriggers from storage.
	 * If this Role is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerCommitReassignTriggers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitReassignTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerCommitReassignTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitReassignTriggers = array();
			} else {
	
				$criteria->add(TrackerCommitReassignTriggerPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId() );

				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerCommitReassignTriggerPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());

				if (!isset($this->lastTrackerCommitReassignTriggersCriteria) || !$this->lastTrackerCommitReassignTriggersCriteria->equals($criteria)) {
					$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerCommitReassignTriggersCriteria = $criteria;

		return $this->collTrackerCommitReassignTriggers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related TrackerCommitReassignTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getTrackerCommitReassignTriggersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitReassignTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitReassignTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitReassignTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitReassignTriggerPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());
				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitReassignTriggerPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());
			if (!isset($this->lastTrackerCommitReassignTriggersCriteria) || !$this->lastTrackerCommitReassignTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerCommitReassignTriggersCriteria = $criteria;

		return $this->collTrackerCommitReassignTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related TrackerCommitReassignTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getTrackerCommitReassignTriggersJoinRole($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitReassignTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitReassignTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitReassignTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitReassignTriggerPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());
				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelectJoinRole($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitReassignTriggerPeer::ASSIGN_TO_ROLE_ID, $this->getRoleId());
			if (!isset($this->lastTrackerCommitReassignTriggersCriteria) || !$this->lastTrackerCommitReassignTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitReassignTriggers = TrackerCommitReassignTriggerPeer::doSelectJoinRole($criteria, $con);
			}
		}
		$this->lastTrackerCommitReassignTriggersCriteria = $criteria;

		return $this->collTrackerCommitReassignTriggers;
	}

	/**
	 * Collection to store aggregation of collTrackerExtraFieldElementTransitionRoles	  
	 * @var array
	 */
	protected $collTrackerExtraFieldElementTransitionRoles; 

	/**
	 * Temporary storage of collTrackerExtraFieldElementTransitionRoles to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerExtraFieldElementTransitionRoles()
	{
		if ($this->collTrackerExtraFieldElementTransitionRoles === null) {
			$this->collTrackerExtraFieldElementTransitionRoles = array();
		}
	}

	/**
	 * Method called to associate a TrackerExtraFieldElementTransitionRole object to this object
	 * through the TrackerExtraFieldElementTransitionRole foreign key attribute
	 *
	 * @param TrackerExtraFieldElementTransitionRole $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerExtraFieldElementTransitionRole(TrackerExtraFieldElementTransitionRole $l)
	{
		$this->collTrackerExtraFieldElementTransitionRoles[] = $l;
		$l->setRole($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerExtraFieldElementTransitionRoles.
	 * @var Criteria
	 */
	private $lastTrackerExtraFieldElementTransitionRolesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionRoles from storage.
	 * If this Role is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerExtraFieldElementTransitionRoles($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerExtraFieldElementTransitionRoles === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionRoles = array();
			} else {
	
				$criteria->add(TrackerExtraFieldElementTransitionRolePeer::ROLE_ID, $this->getRoleId() );

				$this->collTrackerExtraFieldElementTransitionRoles = TrackerExtraFieldElementTransitionRolePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerExtraFieldElementTransitionRolePeer::ROLE_ID, $this->getRoleId());

				if (!isset($this->lastTrackerExtraFieldElementTransitionRolesCriteria) || !$this->lastTrackerExtraFieldElementTransitionRolesCriteria->equals($criteria)) {
					$this->collTrackerExtraFieldElementTransitionRoles = TrackerExtraFieldElementTransitionRolePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerExtraFieldElementTransitionRolesCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionRoles;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionRoles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getTrackerExtraFieldElementTransitionRolesJoinTrackerExtraFieldElementTransition($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldElementTransitionRoles === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionRoles = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldElementTransitionRolePeer::ROLE_ID, $this->getRoleId());
				$this->collTrackerExtraFieldElementTransitionRoles = TrackerExtraFieldElementTransitionRolePeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldElementTransitionRolePeer::ROLE_ID, $this->getRoleId());
			if (!isset($this->lastTrackerExtraFieldElementTransitionRolesCriteria) || !$this->lastTrackerExtraFieldElementTransitionRolesCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldElementTransitionRoles = TrackerExtraFieldElementTransitionRolePeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldElementTransitionRolesCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionRoles;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionRoles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getTrackerExtraFieldElementTransitionRolesJoinRole($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldElementTransitionRoles === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionRoles = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldElementTransitionRolePeer::ROLE_ID, $this->getRoleId());
				$this->collTrackerExtraFieldElementTransitionRoles = TrackerExtraFieldElementTransitionRolePeer::doSelectJoinRole($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldElementTransitionRolePeer::ROLE_ID, $this->getRoleId());
			if (!isset($this->lastTrackerExtraFieldElementTransitionRolesCriteria) || !$this->lastTrackerExtraFieldElementTransitionRolesCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldElementTransitionRoles = TrackerExtraFieldElementTransitionRolePeer::doSelectJoinRole($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldElementTransitionRolesCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionRoles;
	}

	/**
	 * Collection to store aggregation of collUserProjectRoles	  
	 * @var array
	 */
	protected $collUserProjectRoles; 

	/**
	 * Temporary storage of collUserProjectRoles to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserProjectRoles()
	{
		if ($this->collUserProjectRoles === null) {
			$this->collUserProjectRoles = array();
		}
	}

	/**
	 * Method called to associate a UserProjectRole object to this object
	 * through the UserProjectRole foreign key attribute
	 *
	 * @param UserProjectRole $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserProjectRole(UserProjectRole $l)
	{
		$this->collUserProjectRoles[] = $l;
		$l->setRole($this);
	}

	/**
	 * The criteria used to select the current contents of collUserProjectRoles.
	 * @var Criteria
	 */
	private $lastUserProjectRolesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role has previously
	 * been saved, it will retrieve related UserProjectRoles from storage.
	 * If this Role is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserProjectRoles($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserProjectRoles === null) {
			if ($this->isNew()) {
			   $this->collUserProjectRoles = array();
			} else {
	
				$criteria->add(UserProjectRolePeer::ROLE_ID, $this->getRoleId() );

				$this->collUserProjectRoles = UserProjectRolePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserProjectRolePeer::ROLE_ID, $this->getRoleId());

				if (!isset($this->lastUserProjectRolesCriteria) || !$this->lastUserProjectRolesCriteria->equals($criteria)) {
					$this->collUserProjectRoles = UserProjectRolePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserProjectRolesCriteria = $criteria;

		return $this->collUserProjectRoles;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related UserProjectRoles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getUserProjectRolesJoinRole($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserProjectRoles === null) {
			if ($this->isNew()) {
			   $this->collUserProjectRoles = array();
			} else {
	   
				$criteria->add(UserProjectRolePeer::ROLE_ID, $this->getRoleId());
				$this->collUserProjectRoles = UserProjectRolePeer::doSelectJoinRole($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserProjectRolePeer::ROLE_ID, $this->getRoleId());
			if (!isset($this->lastUserProjectRolesCriteria) || !$this->lastUserProjectRolesCriteria->equals($criteria)) {
				$this->collUserProjectRoles = UserProjectRolePeer::doSelectJoinRole($criteria, $con);
			}
		}
		$this->lastUserProjectRolesCriteria = $criteria;

		return $this->collUserProjectRoles;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Role is new, it will return
	 * an empty collection; or if this Role has previously
	 * been saved, it will retrieve related UserProjectRoles from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Role.
	 */
	public function getUserProjectRolesJoinUserProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserProjectRolePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserProjectRoles === null) {
			if ($this->isNew()) {
			   $this->collUserProjectRoles = array();
			} else {
	   
				$criteria->add(UserProjectRolePeer::ROLE_ID, $this->getRoleId());
				$this->collUserProjectRoles = UserProjectRolePeer::doSelectJoinUserProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserProjectRolePeer::ROLE_ID, $this->getRoleId());
			if (!isset($this->lastUserProjectRolesCriteria) || !$this->lastUserProjectRolesCriteria->equals($criteria)) {
				$this->collUserProjectRoles = UserProjectRolePeer::doSelectJoinUserProject($criteria, $con);
			}
		}
		$this->lastUserProjectRolesCriteria = $criteria;

		return $this->collUserProjectRoles;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("role_id", "project_id", "role_name", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case RolePeer::ROLE_ID:
				return $this->getRoleId();
				break;
		  
			case RolePeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case RolePeer::ROLE_NAME:
				return $this->getRoleName();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getRoleId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getRoleName();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(RolePeer::ROLE_ID, $arr)) $this->setRoleId($arr[RolePeer::ROLE_ID]);
  
		if (array_key_exists(RolePeer::PROJECT_ID, $arr)) $this->setProjectId($arr[RolePeer::PROJECT_ID]);
  
		if (array_key_exists(RolePeer::ROLE_NAME, $arr)) $this->setRoleName($arr[RolePeer::ROLE_NAME]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case RolePeer::ROLE_ID:
				$this->setRoleId($value);
				break;
	  
			case RolePeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case RolePeer::ROLE_NAME:
				$this->setRoleName($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setRoleId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setRoleName($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(RolePeer::DATABASE_NAME);

		try {
			$con->begin();
			RolePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(RolePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = RolePeer::doInsert($this, $con);
					$this->setRoleId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					RolePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collRoleSettings !== null) {
				for ($i=0,$size=count($this->collRoleSettings); $i < $size; $i++) {
					$this->collRoleSettings[$i]->save($con);
				}
			  }
			if ($this->collTrackerEfeTransitionReassigns !== null) {
				for ($i=0,$size=count($this->collTrackerEfeTransitionReassigns); $i < $size; $i++) {
					$this->collTrackerEfeTransitionReassigns[$i]->save($con);
				}
			  }
			if ($this->collTrackerCommitReassignTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitReassignTriggers); $i < $size; $i++) {
					$this->collTrackerCommitReassignTriggers[$i]->save($con);
				}
			  }
			if ($this->collTrackerExtraFieldElementTransitionRoles !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionRoles); $i < $size; $i++) {
					$this->collTrackerExtraFieldElementTransitionRoles[$i]->save($con);
				}
			  }
			if ($this->collUserProjectRoles !== null) {
				for ($i=0,$size=count($this->collUserProjectRoles); $i < $size; $i++) {
					$this->collUserProjectRoles[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return RolePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = RolePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collRoleSettings !== null) {
				for ($i=0,$size=count($this->collRoleSettings); $i < $size; $i++) {
					if (($retval = $this->collRoleSettings[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerEfeTransitionReassigns !== null) {
				for ($i=0,$size=count($this->collTrackerEfeTransitionReassigns); $i < $size; $i++) {
					if (($retval = $this->collTrackerEfeTransitionReassigns[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerCommitReassignTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitReassignTriggers); $i < $size; $i++) {
					if (($retval = $this->collTrackerCommitReassignTriggers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerExtraFieldElementTransitionRoles !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionRoles); $i < $size; $i++) {
					if (($retval = $this->collTrackerExtraFieldElementTransitionRoles[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserProjectRoles !== null) {
				for ($i=0,$size=count($this->collUserProjectRoles); $i < $size; $i++) {
					if (($retval = $this->collUserProjectRoles[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed role_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setRoleId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getRoleId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Role Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Role();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setRoleName($this->role_name);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getRoleSettings() as $relObj) {
				$copyObj->addRoleSetting($relObj->copy());
			}

			foreach($this->getTrackerEfeTransitionReassigns() as $relObj) {
				$copyObj->addTrackerEfeTransitionReassign($relObj->copy());
			}

			foreach($this->getTrackerCommitReassignTriggers() as $relObj) {
				$copyObj->addTrackerCommitReassignTrigger($relObj->copy());
			}

			foreach($this->getTrackerExtraFieldElementTransitionRoles() as $relObj) {
				$copyObj->addTrackerExtraFieldElementTransitionRole($relObj->copy());
			}

			foreach($this->getUserProjectRoles() as $relObj) {
				$copyObj->addUserProjectRole($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setRoleId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return RolePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new RolePeer();
		}
		return self::$peer;
	}

}
