<?php

require_once('lib/core/TagEntry.php');
require_once('lib/core/TagEntryPeer.php');


class TagsRenderer{

	static function getTagsInput($section){
		$Lang = Session::getSession()->getLanguage();
		echo '<strong>' . $Lang->getText('Tag.CommaSepListOfTags') . '</strong><br />';
		echo '<input type="text" name="tags" size="60" maxlenght="120" />&nbsp;&nbsp;';
	}


	static function getTagsCount($ref_id, $section) {
		$c = new Criteria();
		$c->add(TagEntryPeer::REF_ID, $ref_id);
		$c->add(TagEntryPeer::SECTION,$section);
		$tags_count = TagEntryPeer::doCount($c);
		return $tags_count;
	}

	static function getTagsTable($ref_id, $section, $theme, $subsection_id=null){
		$Lang = Session::getSession()->getLanguage();
		
		if ($section == "userblog") {
			$user = GFUrl::getUrl()->getUser();
			$usr_unix_name = $user->getUnixName();
	
			$c = new Criteria();
			$c->add(TagEntryPeer::REF_ID, $ref_id);
			$c->add(TagEntryPeer::SECTION,$section);
			$tags = TagEntryPeer::doSelect($c);
			$theader = array();
			$theader[] = $Lang->getText('Tag.TabHeader');

			//$canUpdate = TagEntryPeer::userCanUpdate($section, $ref_id);
			$UserBlog = UserBlogPeer::retrieveByPk($ref_id);
			 
			if ($user->getUserId() == $UserBlog->getUserId()) {
				$canUpdate = true;
			} else {
				$canUpdate = false;
			}
			
			if ($canUpdate) {
				$theader[] = $Lang->getText('Delete');
			}
	
			$html = $theme->tableTop($theader);
			
			if(count($tags) < 1){
				$html .= $theme->TableFullRow($Lang->getText('Tag.NoneFound'));
			} else {
				foreach ($tags as $tag){
					$trow = array();
					$trow[] = '<a href="'. GFUrl::getUrl()->userUrl($user,
					'TagSearch', 'tag', '',
					array(
						'ref_id'=>$ref_id,
						'section'=>$section,
						'tag_name'=>$tag->getTagName(),
						'subsection_id'=>$subsection_id)) .'">'. $tag->getTagName() .'</a>';
					if($canUpdate){
						$trow[] = '<a href="'.GFUrl::getUrl()->userUrl($user,'TagDeleteAction','tag','',array('ref_id'=>$ref_id, 'section'=>$section,'tagname'=>$tag->getTagName(), 'return_to'=>$_SERVER['REQUEST_URI']))  . '" >' . $Lang->getText('Delete') . '</a>';
						$trow[] = '';
					}
	
				$html .= $theme->TableRow($trow);
				}
			}
			if($canUpdate){
				$params = array('ref_id'=>$ref_id, 'section'=>$section, 'return_to'=>$_SERVER['REQUEST_URI']);
				$html .= $theme->tableBottom(array(
					GFUrl::getUrl()->userURL($user, 'TagAdd', 'tag', '', $params)=>$Lang->getText('Tag.Add')
				));
				$html .= $theme->tableBottom();
			} else {
				$html .= $theme->tableBottom();
			}
		} elseif ($section == pastebin::SECTION) {
			$user = Session::getSession()->getUser();

			$c = new Criteria();
			$c->add(TagEntryPeer::REF_ID, $ref_id);
			$c->add(TagEntryPeer::SECTION,$section);
			$tags = TagEntryPeer::doSelect($c);
			$theader = array();
			$theader[] = $Lang->getText('Tag.TabHeader');

			$pastebin = PastebinPeer::retrieveByPK($ref_id);
			if (!is_object($pastebin)) {
				return '';
			}

			$canUpdate = false;
			if (is_object($user)) {
				$canUpdate = $pastebin->userCanUpdate();
			}

			if ($canUpdate) {
				$theader[] = $Lang->getText('Delete');
			}

			$html = $theme->tableTop($theader);

			if(count($tags) < 1){
				$html .= $theme->TableFullRow($Lang->getText('Tag.NoneFound'));
			} else {
				foreach ($tags as $tag){
					$trow = array();
					$trow[] = $tag->getTagName();
					if($canUpdate){
						$trow[] = '<a href="'.GFUrl::getUrl()->userUrl($user,'TagDeleteAction','tag','',array('ref_id'=>$ref_id, 'section'=>$section,'tagname'=>$tag->getTagName(), 'return_to'=>$_SERVER['REQUEST_URI']))  . '" >' . $Lang->getText('Delete') . '</a>';
					}

					$html .= $theme->TableRow($trow);
				}
			}
			if($canUpdate){
				$params = array('ref_id'=>$ref_id, 'section'=>$section, 'return_to'=>$_SERVER['REQUEST_URI']);
				$html .= $theme->tableBottom(array(
					GFUrl::getUrl()->userURL($user, 'TagAdd', 'tag', '', $params)=>$Lang->getText('Tag.Add')
				));
			} else {
				$html .= $theme->tableBottom();
			}
		} else {
			$project = GFUrl::getUrl()->getProject();
			$prj_unix_name = $project->getUnixName();
	
			$c = new Criteria();
			$c->add(TagEntryPeer::REF_ID, $ref_id);
			$c->add(TagEntryPeer::SECTION,$section);
			$tags = TagEntryPeer::doSelect($c);
			$theader = array();
			$theader[] = $Lang->getText('Tag.TabHeader');
			
			$canUpdate = TagEntryPeer::userCanUpdate($section, $ref_id);
			
			if ($canUpdate) {
				$theader[] = $Lang->getText('Delete');
			}
	
			$html = $theme->tableTop($theader);
			
			if(count($tags) < 1){
				$html .= $theme->TableFullRow($Lang->getText('Tag.NoneFound'));
			} else {
				foreach ($tags as $tag){
					$trow = array();
					$trow[] = '<a href="'. GFUrl::getUrl()->projectUrl($prj_unix_name, 
					'TagSearch', 'tag', '', 
					array(
						'ref_id'=>$ref_id, 
						'section'=>$section, 
						'tag_name'=>$tag->getTagName(),
						'subsection_id'=>$subsection_id)) .'">'. $tag->getTagName() .'</a>';
					if(TagEntryPeer::userCanUpdate($section, $ref_id)){
						$trow[] = '<a href="'.GFUrl::getUrl()->projectUrl($prj_unix_name,'TagDeleteAction','tag','',array('ref_id'=>$ref_id, 'section'=>$section,'tagname'=>$tag->getTagName(), 'return_to'=>$_SERVER['REQUEST_URI']))  . '" >' . $Lang->getText('Delete') . '</a>';
					}
	
				$html .= $theme->TableRow($trow);
				}
			}
			if(TagEntryPeer::userCanUpdate($section, $ref_id)){
				$params = array('ref_id'=>$ref_id, 'section'=>$section, 'return_to'=>$_SERVER['REQUEST_URI']);
				$html .= $theme->tableBottom(array(
					GFUrl::getUrl()->projectURL($prj_unix_name, 'TagAdd','','tag',$params)=>$Lang->getText('Tag.Add')
				));
			} else {
				$html .= $theme->tableBottom();
			}
		}
		return $html;

	}

}

?>
