<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. P�rez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/Association.php');
require_once('lib/core/AssociationPeer.php');

function renderAssociationList($from_section,$from_ref_id,$canmod,$theme,$project,$dialog=false, $dialog_add_action="") {
	$sql="SELECT to_section AS section,to_ref_id AS ref_id, 
		section || '|'::char || ref_id::varchar(10) || '|'::char || to_section || '|'::char || to_ref_id::varchar(10) AS key, comment
		FROM association WHERE 
		(section='".Validator::sanitizeString($from_section)."' AND ref_id='".Validator::sanitizeInt($from_ref_id)."')
		UNION SELECT section AS section,ref_id AS ref_id, 
		section || '|'::char || ref_id::varchar(10) || '|'::char || to_section || '|'::char || to_ref_id::varchar(10) AS key, comment
		FROM association WHERE
		(to_section='".Validator::sanitizeString($from_section)."' AND to_ref_id='".Validator::sanitizeInt($from_ref_id)."')";

	$rs=Propel::getConnection()->createStatement()->executeQuery($sql,ResultSet::FETCHMODE_ASSOC);

	$sql = "SELECT tracker_item_id, message_log FROM tracker_item_scm_commit NATURAL JOIN scm_commit WHERE scm_commit_id =  " . Validator::sanitizeInt($from_ref_id) ;
	
	$theader=array();
	$Lang=Session::getSession()->getLanguage();
	$theader[] = $Lang->getText('Association.ItemId');
	$theader[] = $Lang->getText('Association.Item');
	$theader[] = $Lang->getText('Association.CommentName');
	if ($canmod) {
		$theader[] = $Lang->getText('Delete');
	}
	$return = $theme->tableTop($theader);
	$arr=array();
	if ($rs->getRecordCount() < 1) {
		$return .= $theme->tableFullRow($Lang->getText('Association.NoneFound'));
	} else {
		while($rs->next()) {
			$arr[]=array($rs->getString('section'),$rs->getInt('ref_id'),$rs->getString('key'),$rs->getString('comment'));
		}

	}		
	$prs=ActionManager::notify('RENDER_ASSOCIATION_LINK',$arr);
	foreach ($prs as $result) {
		$urls = $result->getResult();
		foreach ($urls as $url) {
			$trow=array();

			list($id, $description, $key, $comment) = $url;

			$trow[]=$id;
			$trow[]=$description;
			$trow[]=$comment;
			if ($canmod) {
				if ($key != '') {
					if ($dialog) {
						$trow[]='<a href="javascript:;" onclick="docmanFile.deleteAssociation(\'' . $key . '\', \''. rawurlencode($description) . '\')">'.$Lang->getText('Delete').'</a>';
					} else {
						$trow[]='<a href="'.GFUrl::getUrl()->projectURL($project,'AssociationDelete','','association',array('key'=>$key,'return_to'=>$_SERVER['REQUEST_URI'])).'">'.$Lang->getText('Delete').'</a>';
					}
				} else {
					$trow[]= '-';
				}
			}
			$return .= $theme->tableRow($trow);
		}
	}
	if ($canmod) {
		if ($dialog) {
			$return .= $theme->tableBottom(array($dialog_add_action=>$Lang->getText('Association.AddNew')),array(true),"", true);
		} else {
			$return .= $theme->tableBottom(array(GFUrl::getUrl()->projectURL($project,'AssociationAdd','','association',array('from_section'=>$from_section,'from_ref_id'=>$from_ref_id,'return_to'=>$_SERVER['REQUEST_URI']))=>$Lang->getText('Association.AddNew')));
		}
	} else {
		$return .= $theme->tableBottom(array(GFUrl::getUrl()->projectURL($project,'AssociationAdd','','association',array('from_section'=>$from_section,'from_ref_id'=>$from_ref_id,'return_to'=>$_SERVER['REQUEST_URI']))=>$Lang->getText('Association.AddNew')),array(false));
	}
	return $return;
}

?>
