<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Group.class,v 1.94 2005/09/06 18:13:29 danper Exp $
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-10
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/User.php');
require_once('notification/NotificationManager.php');

interface GFNotification {

	const NOTIFICATION_QUEUE_TABLE_NAME = 'notification_queue';
	const NOTIFICATION_ACTION_NAME = 'Notify';
	
	/**
	 *	getNotificationMessage - construct a string of this message content
	 *	@param User
	 *	@return string
	 */
	function getNotificationMessage(User $User);

	/**
	 *	getNotificationSubject - construct a string of this message content
	 *	@param User
	 *	@return string
	 */
	function getNotificationSubject(User $User);

	/**
	 *	getUsers - get an array of user objects
	 *	@return array
	 */
	public function getUsers();

	/**
	 *	getSection - retrieves the section name of the item that the notification belongs to
	 *	@return string
	 */	
	function getSection();
	
	/**
	 *	getRefId - retrieves the id of the item that the notification belongs to
	 *	@return int
	 */	
	function getRefId();
}

?>