<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-10
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

class PluginResult {

	private $Plugin;
	private $errormsg;
	private $result;

	function __construct($Plugin) {
		$this->Plugin = $Plugin;
	}

	/**
	 *  setError   set the error message.
	 *  @param  string
	 */
	function setError($errormsg) {
		$this->errormsg=$errormsg;
	}

	/**
	 *  isError - whether any errors are in any of
	 *  the PluginResult objects
	 *  @return boolean
	 */
	function isError() {
		if ($this->errormsg) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 *	getError - get the error message.
	 *	@return	string
	 */
	function getError() {
		return $this->errormsg;
	}

	/**
	 *  setResult   set the result, whatever that may be for the plugin.
	 *  @param  mixed
	 */
	function setResult($result) {
		$this->result=$result;
	}

	/**
	 *  getResult get the mixed result.
	 *  @return	mixed
	 */
	function getResult() {
		return $this->result;
	}
	
	/**
	 * Returns the plugin that handled the action
	 */
	function getPlugin() {
		return $this->Plugin;
	}

}

?>