<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'cruisecontrol_build' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.build.lib.map
 */
class CruisecontrolBuildMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.build.lib.map.CruisecontrolBuildMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("cruisecontrol_build");
		$tMap->setPhpName("CruisecontrolBuild");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("cruisecontrol_build_cruisecontrol_build_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("CRUISECONTROL_BUILD_ID", "CruisecontrolBuildId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("CRUISECONTROL_ID", "CruisecontrolId", "int", CreoleTypes::INTEGER, "cruisecontrol" , "CRUISECONTROL_ID", true);
		$tMap->addForeignKey("CRUISECONTROL_DEFECT_ID", "CruisecontrolDefectId", "int", CreoleTypes::INTEGER, "cruisecontrol_defect" , "CRUISECONTROL_DEFECT_ID", false);
		$tMap->addColumn("BUILD_DATE", "BuildDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("WAS_SUCCESSFUL", "WasSuccessful", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("WAS_FIX", "WasFix", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("WAS_NECESSARY", "WasNecessary", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("EVENT_TYPE", "EventType", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
