<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/build/lib/CruisecontrolPeer.php';

/**
 * Base class that represents a row from the 'cruisecontrol' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Cruisecontrol class. 
 * 
 * @package plugins.build.lib 
 */
abstract class BaseCruisecontrol extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CruisecontrolPeer
	 */
	protected static $peer;

	/**
	 * The value for the cruisecontrol_id field.
	 * @var int	  
	 */
	protected $cruisecontrol_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the build_name field.
	 * @var string	  
	 */
	protected $build_name;	

	/**
	 * The value for the build_description field.
	 * @var string	  
	 */
	protected $build_description;	

	/**
	 * The value for the submitter_id field.
	 * @var int	  
	 */
	protected $submitter_id;	
  
	/**
	 * Get the CruisecontrolId column value.
	 *  
	 * @return int	  
	 */
	public function getCruisecontrolId()
	{
		return $this->cruisecontrol_id;
	}


	/**
	 * Set the value of `cruisecontrol_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCruisecontrolId($v)
	{
		if ($this->cruisecontrol_id !== $v) {
			$this->cruisecontrol_id = $v;
			$this->modifiedColumns[] = CruisecontrolPeer::CRUISECONTROL_ID;
		}
			
		  // update associated CruisecontrolDefect		  
		  if ($this->collCruisecontrolDefects !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolDefects); $i < $size; $i++) {
				  $this->collCruisecontrolDefects[$i]->setCruisecontrolId($v);
			  }
		  }
			  	
		  // update associated CruisecontrolPublisher		  
		  if ($this->collCruisecontrolPublishers !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolPublishers); $i < $size; $i++) {
				  $this->collCruisecontrolPublishers[$i]->setCruisecontrolId($v);
			  }
		  }
			  	
		  // update associated CruisecontrolAssignee		  
		  if ($this->collCruisecontrolAssignees !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolAssignees); $i < $size; $i++) {
				  $this->collCruisecontrolAssignees[$i]->setCruisecontrolId($v);
			  }
		  }
			  	
		  // update associated CruisecontrolBuild		  
		  if ($this->collCruisecontrolBuilds !== null) {
			  for ($i=0,$size=count($this->collCruisecontrolBuilds); $i < $size; $i++) {
				  $this->collCruisecontrolBuilds[$i]->setCruisecontrolId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = CruisecontrolPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the BuildName column value.
	 *  
	 * @return string	  
	 */
	public function getBuildName()
	{
		return $this->build_name;
	}


	/**
	 * Set the value of `build_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setBuildName($v)
	{
		if ($this->build_name !== $v) {
			$this->build_name = $v;
			$this->modifiedColumns[] = CruisecontrolPeer::BUILD_NAME;
		}
				
	}

  
	/**
	 * Get the BuildDescription column value.
	 *  
	 * @return string	  
	 */
	public function getBuildDescription()
	{
		return $this->build_description;
	}


	/**
	 * Set the value of `build_description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setBuildDescription($v)
	{
		if ($this->build_description !== $v) {
			$this->build_description = $v;
			$this->modifiedColumns[] = CruisecontrolPeer::BUILD_DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the SubmitterId column value.
	 *  
	 * @return int	  
	 */
	public function getSubmitterId()
	{
		return $this->submitter_id;
	}


	/**
	 * Set the value of `submitter_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setSubmitterId($v)
	{
		if ($this->submitter_id !== $v) {
			$this->submitter_id = $v;
			$this->modifiedColumns[] = CruisecontrolPeer::SUBMITTER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->cruisecontrol_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->build_name = $rs->getString($startcol + 2);					
			$this->build_description = $rs->getString($startcol + 3);					
			$this->submitter_id = $rs->getInt($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Cruisecontrol object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(CruisecontrolPeer::DATABASE_NAME);
		$criteria->add(CruisecontrolPeer::CRUISECONTROL_ID, $this->cruisecontrol_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(CruisecontrolPeer::DATABASE_NAME);
		if ($this->isColumnModified(CruisecontrolPeer::CRUISECONTROL_ID)) $criteria->add(CruisecontrolPeer::CRUISECONTROL_ID, $this->cruisecontrol_id);
		if ($this->isColumnModified(CruisecontrolPeer::PROJECT_ID)) $criteria->add(CruisecontrolPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(CruisecontrolPeer::BUILD_NAME)) $criteria->add(CruisecontrolPeer::BUILD_NAME, $this->build_name);
		if ($this->isColumnModified(CruisecontrolPeer::BUILD_DESCRIPTION)) $criteria->add(CruisecontrolPeer::BUILD_DESCRIPTION, $this->build_description);
		if ($this->isColumnModified(CruisecontrolPeer::SUBMITTER_ID)) $criteria->add(CruisecontrolPeer::SUBMITTER_ID, $this->submitter_id);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addCruisecontrols($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setSubmitterId(NULL);
		} else {
			$this->setSubmitterId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->submitter_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->submitter_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->submitter_id, $con);
			   $obj->addCruisecontrols($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setSubmitterId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collCruisecontrolDefects	  
	 * @var array
	 */
	protected $collCruisecontrolDefects; 

	/**
	 * Temporary storage of collCruisecontrolDefects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolDefects()
	{
		if ($this->collCruisecontrolDefects === null) {
			$this->collCruisecontrolDefects = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolDefect object to this object
	 * through the CruisecontrolDefect foreign key attribute
	 *
	 * @param CruisecontrolDefect $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolDefect(CruisecontrolDefect $l)
	{
		$this->collCruisecontrolDefects[] = $l;
		$l->setCruisecontrol($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolDefects.
	 * @var Criteria
	 */
	private $lastCruisecontrolDefectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolDefects from storage.
	 * If this Cruisecontrol is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolDefects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolDefectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolDefects === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolDefects = array();
			} else {
	
				$criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_ID, $this->getCruisecontrolId() );

				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());

				if (!isset($this->lastCruisecontrolDefectsCriteria) || !$this->lastCruisecontrolDefectsCriteria->equals($criteria)) {
					$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolDefectsCriteria = $criteria;

		return $this->collCruisecontrolDefects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol is new, it will return
	 * an empty collection; or if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolDefects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Cruisecontrol.
	 */
	public function getCruisecontrolDefectsJoinCruisecontrol($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolDefectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolDefects === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolDefects = array();
			} else {
	   
				$criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
			if (!isset($this->lastCruisecontrolDefectsCriteria) || !$this->lastCruisecontrolDefectsCriteria->equals($criteria)) {
				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		}
		$this->lastCruisecontrolDefectsCriteria = $criteria;

		return $this->collCruisecontrolDefects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol is new, it will return
	 * an empty collection; or if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolDefects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Cruisecontrol.
	 */
	public function getCruisecontrolDefectsJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolDefectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolDefects === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolDefects = array();
			} else {
	   
				$criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolDefectPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
			if (!isset($this->lastCruisecontrolDefectsCriteria) || !$this->lastCruisecontrolDefectsCriteria->equals($criteria)) {
				$this->collCruisecontrolDefects = CruisecontrolDefectPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastCruisecontrolDefectsCriteria = $criteria;

		return $this->collCruisecontrolDefects;
	}

	/**
	 * Collection to store aggregation of collCruisecontrolPublishers	  
	 * @var array
	 */
	protected $collCruisecontrolPublishers; 

	/**
	 * Temporary storage of collCruisecontrolPublishers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolPublishers()
	{
		if ($this->collCruisecontrolPublishers === null) {
			$this->collCruisecontrolPublishers = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolPublisher object to this object
	 * through the CruisecontrolPublisher foreign key attribute
	 *
	 * @param CruisecontrolPublisher $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolPublisher(CruisecontrolPublisher $l)
	{
		$this->collCruisecontrolPublishers[] = $l;
		$l->setCruisecontrol($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolPublishers.
	 * @var Criteria
	 */
	private $lastCruisecontrolPublishersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolPublishers from storage.
	 * If this Cruisecontrol is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolPublishers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolPublisherPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolPublishers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolPublishers = array();
			} else {
	
				$criteria->add(CruisecontrolPublisherPeer::CRUISECONTROL_ID, $this->getCruisecontrolId() );

				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolPublisherPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());

				if (!isset($this->lastCruisecontrolPublishersCriteria) || !$this->lastCruisecontrolPublishersCriteria->equals($criteria)) {
					$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolPublishersCriteria = $criteria;

		return $this->collCruisecontrolPublishers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol is new, it will return
	 * an empty collection; or if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolPublishers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Cruisecontrol.
	 */
	public function getCruisecontrolPublishersJoinCruisecontrol($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolPublisherPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolPublishers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolPublishers = array();
			} else {
	   
				$criteria->add(CruisecontrolPublisherPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolPublisherPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
			if (!isset($this->lastCruisecontrolPublishersCriteria) || !$this->lastCruisecontrolPublishersCriteria->equals($criteria)) {
				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		}
		$this->lastCruisecontrolPublishersCriteria = $criteria;

		return $this->collCruisecontrolPublishers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol is new, it will return
	 * an empty collection; or if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolPublishers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Cruisecontrol.
	 */
	public function getCruisecontrolPublishersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolPublisherPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolPublishers === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolPublishers = array();
			} else {
	   
				$criteria->add(CruisecontrolPublisherPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolPublisherPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
			if (!isset($this->lastCruisecontrolPublishersCriteria) || !$this->lastCruisecontrolPublishersCriteria->equals($criteria)) {
				$this->collCruisecontrolPublishers = CruisecontrolPublisherPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastCruisecontrolPublishersCriteria = $criteria;

		return $this->collCruisecontrolPublishers;
	}

	/**
	 * Collection to store aggregation of collCruisecontrolAssignees	  
	 * @var array
	 */
	protected $collCruisecontrolAssignees; 

	/**
	 * Temporary storage of collCruisecontrolAssignees to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolAssignees()
	{
		if ($this->collCruisecontrolAssignees === null) {
			$this->collCruisecontrolAssignees = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolAssignee object to this object
	 * through the CruisecontrolAssignee foreign key attribute
	 *
	 * @param CruisecontrolAssignee $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolAssignee(CruisecontrolAssignee $l)
	{
		$this->collCruisecontrolAssignees[] = $l;
		$l->setCruisecontrol($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolAssignees.
	 * @var Criteria
	 */
	private $lastCruisecontrolAssigneesCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolAssignees from storage.
	 * If this Cruisecontrol is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolAssignees($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolAssignees === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolAssignees = array();
			} else {
	
				$criteria->add(CruisecontrolAssigneePeer::CRUISECONTROL_ID, $this->getCruisecontrolId() );

				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolAssigneePeer::CRUISECONTROL_ID, $this->getCruisecontrolId());

				if (!isset($this->lastCruisecontrolAssigneesCriteria) || !$this->lastCruisecontrolAssigneesCriteria->equals($criteria)) {
					$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolAssigneesCriteria = $criteria;

		return $this->collCruisecontrolAssignees;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol is new, it will return
	 * an empty collection; or if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolAssignees from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Cruisecontrol.
	 */
	public function getCruisecontrolAssigneesJoinCruisecontrol($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolAssignees === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolAssignees = array();
			} else {
	   
				$criteria->add(CruisecontrolAssigneePeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolAssigneePeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
			if (!isset($this->lastCruisecontrolAssigneesCriteria) || !$this->lastCruisecontrolAssigneesCriteria->equals($criteria)) {
				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		}
		$this->lastCruisecontrolAssigneesCriteria = $criteria;

		return $this->collCruisecontrolAssignees;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol is new, it will return
	 * an empty collection; or if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolAssignees from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Cruisecontrol.
	 */
	public function getCruisecontrolAssigneesJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolAssigneePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolAssignees === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolAssignees = array();
			} else {
	   
				$criteria->add(CruisecontrolAssigneePeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolAssigneePeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
			if (!isset($this->lastCruisecontrolAssigneesCriteria) || !$this->lastCruisecontrolAssigneesCriteria->equals($criteria)) {
				$this->collCruisecontrolAssignees = CruisecontrolAssigneePeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastCruisecontrolAssigneesCriteria = $criteria;

		return $this->collCruisecontrolAssignees;
	}

	/**
	 * Collection to store aggregation of collCruisecontrolBuilds	  
	 * @var array
	 */
	protected $collCruisecontrolBuilds; 

	/**
	 * Temporary storage of collCruisecontrolBuilds to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCruisecontrolBuilds()
	{
		if ($this->collCruisecontrolBuilds === null) {
			$this->collCruisecontrolBuilds = array();
		}
	}

	/**
	 * Method called to associate a CruisecontrolBuild object to this object
	 * through the CruisecontrolBuild foreign key attribute
	 *
	 * @param CruisecontrolBuild $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCruisecontrolBuild(CruisecontrolBuild $l)
	{
		$this->collCruisecontrolBuilds[] = $l;
		$l->setCruisecontrol($this);
	}

	/**
	 * The criteria used to select the current contents of collCruisecontrolBuilds.
	 * @var Criteria
	 */
	private $lastCruisecontrolBuildsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolBuilds from storage.
	 * If this Cruisecontrol is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCruisecontrolBuilds($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCruisecontrolBuilds === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuilds = array();
			} else {
	
				$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $this->getCruisecontrolId() );

				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());

				if (!isset($this->lastCruisecontrolBuildsCriteria) || !$this->lastCruisecontrolBuildsCriteria->equals($criteria)) {
					$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCruisecontrolBuildsCriteria = $criteria;

		return $this->collCruisecontrolBuilds;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol is new, it will return
	 * an empty collection; or if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolBuilds from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Cruisecontrol.
	 */
	public function getCruisecontrolBuildsJoinCruisecontrol($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolBuilds === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuilds = array();
			} else {
	   
				$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
			if (!isset($this->lastCruisecontrolBuildsCriteria) || !$this->lastCruisecontrolBuildsCriteria->equals($criteria)) {
				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelectJoinCruisecontrol($criteria, $con);
			}
		}
		$this->lastCruisecontrolBuildsCriteria = $criteria;

		return $this->collCruisecontrolBuilds;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Cruisecontrol is new, it will return
	 * an empty collection; or if this Cruisecontrol has previously
	 * been saved, it will retrieve related CruisecontrolBuilds from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Cruisecontrol.
	 */
	public function getCruisecontrolBuildsJoinCruisecontrolDefect($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/build/lib/CruisecontrolBuildPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCruisecontrolBuilds === null) {
			if ($this->isNew()) {
			   $this->collCruisecontrolBuilds = array();
			} else {
	   
				$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelectJoinCruisecontrolDefect($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $this->getCruisecontrolId());
			if (!isset($this->lastCruisecontrolBuildsCriteria) || !$this->lastCruisecontrolBuildsCriteria->equals($criteria)) {
				$this->collCruisecontrolBuilds = CruisecontrolBuildPeer::doSelectJoinCruisecontrolDefect($criteria, $con);
			}
		}
		$this->lastCruisecontrolBuildsCriteria = $criteria;

		return $this->collCruisecontrolBuilds;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("cruisecontrol_id", "project_id", "build_name", "build_description", "submitter_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case CruisecontrolPeer::CRUISECONTROL_ID:
				return $this->getCruisecontrolId();
				break;
		  
			case CruisecontrolPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case CruisecontrolPeer::BUILD_NAME:
				return $this->getBuildName();
				break;
		  
			case CruisecontrolPeer::BUILD_DESCRIPTION:
				return $this->getBuildDescription();
				break;
		  
			case CruisecontrolPeer::SUBMITTER_ID:
				return $this->getSubmitterId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getCruisecontrolId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getBuildName();
				break;
  
			case 3:
				return $this->getBuildDescription();
				break;
  
			case 4:
				return $this->getSubmitterId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(CruisecontrolPeer::CRUISECONTROL_ID, $arr)) $this->setCruisecontrolId($arr[CruisecontrolPeer::CRUISECONTROL_ID]);
  
		if (array_key_exists(CruisecontrolPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[CruisecontrolPeer::PROJECT_ID]);
  
		if (array_key_exists(CruisecontrolPeer::BUILD_NAME, $arr)) $this->setBuildName($arr[CruisecontrolPeer::BUILD_NAME]);
  
		if (array_key_exists(CruisecontrolPeer::BUILD_DESCRIPTION, $arr)) $this->setBuildDescription($arr[CruisecontrolPeer::BUILD_DESCRIPTION]);
  
		if (array_key_exists(CruisecontrolPeer::SUBMITTER_ID, $arr)) $this->setSubmitterId($arr[CruisecontrolPeer::SUBMITTER_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case CruisecontrolPeer::CRUISECONTROL_ID:
				$this->setCruisecontrolId($value);
				break;
	  
			case CruisecontrolPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case CruisecontrolPeer::BUILD_NAME:
				$this->setBuildName($value);
				break;
	  
			case CruisecontrolPeer::BUILD_DESCRIPTION:
				$this->setBuildDescription($value);
				break;
	  
			case CruisecontrolPeer::SUBMITTER_ID:
				$this->setSubmitterId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setCruisecontrolId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setBuildName($value);
				break;
  
			case 3:
				$this->setBuildDescription($value);
				break;
  
			case 4:
				$this->setSubmitterId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(CruisecontrolPeer::DATABASE_NAME);

		try {
			$con->begin();
			CruisecontrolPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(CruisecontrolPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CruisecontrolPeer::doInsert($this, $con);
					$this->setCruisecontrolId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					CruisecontrolPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCruisecontrolDefects !== null) {
				for ($i=0,$size=count($this->collCruisecontrolDefects); $i < $size; $i++) {
					$this->collCruisecontrolDefects[$i]->save($con);
				}
			  }
			if ($this->collCruisecontrolPublishers !== null) {
				for ($i=0,$size=count($this->collCruisecontrolPublishers); $i < $size; $i++) {
					$this->collCruisecontrolPublishers[$i]->save($con);
				}
			  }
			if ($this->collCruisecontrolAssignees !== null) {
				for ($i=0,$size=count($this->collCruisecontrolAssignees); $i < $size; $i++) {
					$this->collCruisecontrolAssignees[$i]->save($con);
				}
			  }
			if ($this->collCruisecontrolBuilds !== null) {
				for ($i=0,$size=count($this->collCruisecontrolBuilds); $i < $size; $i++) {
					$this->collCruisecontrolBuilds[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return CruisecontrolPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = CruisecontrolPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCruisecontrolDefects !== null) {
				for ($i=0,$size=count($this->collCruisecontrolDefects); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolDefects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collCruisecontrolPublishers !== null) {
				for ($i=0,$size=count($this->collCruisecontrolPublishers); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolPublishers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collCruisecontrolAssignees !== null) {
				for ($i=0,$size=count($this->collCruisecontrolAssignees); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolAssignees[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collCruisecontrolBuilds !== null) {
				for ($i=0,$size=count($this->collCruisecontrolBuilds); $i < $size; $i++) {
					if (($retval = $this->collCruisecontrolBuilds[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed cruisecontrol_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setCruisecontrolId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getCruisecontrolId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Cruisecontrol Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Cruisecontrol();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setBuildName($this->build_name);
		$copyObj->setBuildDescription($this->build_description);
		$copyObj->setSubmitterId($this->submitter_id);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCruisecontrolDefects() as $relObj) {
				$copyObj->addCruisecontrolDefect($relObj->copy());
			}

			foreach($this->getCruisecontrolPublishers() as $relObj) {
				$copyObj->addCruisecontrolPublisher($relObj->copy());
			}

			foreach($this->getCruisecontrolAssignees() as $relObj) {
				$copyObj->addCruisecontrolAssignee($relObj->copy());
			}

			foreach($this->getCruisecontrolBuilds() as $relObj) {
				$copyObj->addCruisecontrolBuild($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setCruisecontrolId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return CruisecontrolPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CruisecontrolPeer();
		}
		return self::$peer;
	}

}
