<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for Cruisecontrol
//
require_once('plugins/build/lib/CruisecontrolPeer.php');
require_once('plugins/build/lib/Cruisecontrol.php');
require_once('plugins/build/lib/CCHelper.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/build/lib/html/BuildAdminTemplate.php');
$theme = new BuildAdminTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Build.AddNewPageTitle')
		);
$theme->header($params);

$build_name=((isset($_POST['build_name'])) ? htmlspecialchars($_POST['build_name']) : '' );
$build_description=((isset($_POST['build_desc'])) ? htmlspecialchars($_POST['build_desc']) : '' );
$user_id=((isset($_POST['user_id'])) ? Validator::sanitizeInt($_POST['user_id']) : 0);
$assignees = (isset($_POST['assigned_to']) ? $_POST['assigned_to'] : array());
$tracker_id=((isset($_POST['tracker'])) ? Validator::sanitizeInt($_POST['tracker']) : 0);

// Get Project Members
$users = array();
foreach ($Project->getMembers() as $member) {
        $users[$member->getUserId()] = $member->getFullName();
}

// Arrays for tracker and asignees
$arrTrackers = $Project->getTrackers();

$trackers = array(100=>$Lang->getText('Options.None'));
$techs = array(100 => array(100 => 'Nobody'));
foreach($arrTrackers as $tracker) {
	$trackers[$tracker->getTrackerID()] = $tracker->getTrackerName();
	$tech = $tracker->getTechnicians();
	$arrTech = array(100=>'Nobody');
	foreach($tech as $value){
		$arrTech[$value->getId()] = $value->getName();
	}
	$techs[$tracker->getTrackerID()] = $arrTech;
}

// This will only be used if the page is being reloaded because of a validation error
$sel_assignees = array();
foreach ($assignees as $ass_id) {
	$sel_assignees[$tracker_id][$ass_id] = true;
}

include('forms/BuildAdd-tpl.php');

$theme->footer($params);
?>
