<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez ruben@gforgegroup.com
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/build/lib/Cruisecontrol.php');
require_once('plugins/build/lib/CruisecontrolPeer.php');
require_once('plugins/build/lib/html/BuildAdminTemplate.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/build/lib/html/BuildAdminTemplate.php');
$theme = new BuildAdminTemplate();

$Project = GFUrl::getUrl()->getProject();

$cruisecontrol_id = Validator::sanitizeInt((isset($_REQUEST['id']) ? $_REQUEST['id'] : 0));
$isNET = (isset($_REQUEST['net']) && Validator::sanitizeInt($_REQUEST['net']) == 1) ? true : false;

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => ($isNET) ? $Lang->getText('Build.GetNETConfig') : $Lang->getText('Build.GetConfig')
		);


$CControl = CruisecontrolPeer::retrieveByPK($cruisecontrol_id);

if (!$CControl || !is_object($CControl)) {
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''));
} else {
	$theme->header($params);
	$build_name = $CControl->getBuildName();
	$seed = GFConf::get('build.hash');
	$project_id = $Project->getProjectId();
	$dev_id = $CControl->getSubmitterId();
	$unique_id = ($project_id+$dev_id+$cruisecontrol_id);
	$host = GFConf::get('system.hostName').'/';
	$ssl = (GFConf::get('system.use_ssl') == false) ? 'false' : 'true';
	$hash = base64_encode(sha1($seed.$project_id.$seed.$dev_id.$seed.$cruisecontrol_id.$seed.$unique_id.$seed, true));

	echo '<h3>'.$Lang->getText('Build.BuildNameName').': '.$build_name.'</h3>';

	switch ($_GET['type']) {
	default:
	case 'ccjava':
		$plugin  = "<plugin name=\"gforge\"\n\tclassname=\"org.gforge.cruisecontrol.publishers.GForgeSOAPExternalPublisher\"\n\t";
		$plugin .= "host=\"$host\" ssl=\"$ssl\"\n/>";
	
		$config  = "<publishers>\n\t<gforge projectId=\"$project_id\"\n\t\t";
		$config .= "cruisecontrolId=\"$cruisecontrol_id\"\n\t\t";
		$config .= "hash=\"$hash\"\n\t/>\n</publishers>";

		echo '<p><b>config.xml</b></p>';
		echo '<p><strong>&lt;cruisecontrol&gt;</strong><br />&nbsp; &nbsp; &nbsp; ';
		echo '<textarea cols="87" rows="3" style="font-family: Verdana,Arial,Helvetica; font-size: 11px;">'.$plugin.'</textarea><br />';
		echo '<strong>&nbsp; &nbsp; &nbsp; &lt;project...&gt;<br />';
		echo '&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ...<br /></strong>';
		echo '&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ';
		echo '<textarea cols="85" rows="7" style="font-family: Verdana,Arial,Helvetica; font-size: 11px;">'.$config.'</textarea><br />';
		echo '<strong>&nbsp; &nbsp; &nbsp; &lt;/project&gt;<br />';
		echo '&lt;/cruisecontrol&gt;</strong></p>';
		break;
	case 'ccnet':
		$config  = "<publishers>\n";
		$config .= "\t<gforge host=\"$host\" hash=\"$hash\"\n";
		$config .= "\t\tprojectId=\"$project_id\" cruisecontrolId=\"$cruisecontrol_id\" ssl=\"$ssl\">\n";
		$config .= "\t</gforge>\n";
		$config .= "</publishers>\n";

		echo '<p><b>ccnet.config</b></p>';
		echo '<p><strong>&lt;cruisecontrol&gt;</strong><br />&nbsp; &nbsp; &nbsp; ';
		echo '<strong>&nbsp; &nbsp; &nbsp; &lt;project...&gt;<br />';
		echo '&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ...<br /></strong>';
		echo '&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; ';
		echo '<textarea cols="85" rows="5" style="font-family: Verdana,Arial,Helvetica; font-size: 11px;">'.$config.'</textarea><br />';
		echo '<strong>&nbsp; &nbsp; &nbsp; &lt;/project&gt;<br />';
		echo '&lt;/cruisecontrol&gt;</strong></p>';
		break;
	case 'jenkins':
		$useSSLText = GFConf::get('system.use_ssl') ? $Lang->getText('Hudson.UseSSLChecked') : $Lang->getText('Hudson.UseSSLUnchecked');
?>
<br />
<p>
	<b><?php echo $Lang->getText('Hudson.ConfigurationTitle') ?></b><br />
	<?php echo $Lang->getText('Hudson.SiteConfigurationDescription', array(GFConf::get('system.hostName'), $useSSLText)) ?>
</p>
<p>
	<b><?php echo $Lang->getText('Hudson.ProjectConfigurationTitle') ?></b><br />
	<?php echo $Lang->getText('Hudson.ProjectConfigurationDescription', array($Project->getProjectId(), $cruisecontrol_id, $hash)) ?>
</p>

<?php
		break;
	}
}

$theme->footer($params);
?>
