<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Cruisecontrol
//
require_once('plugins/build/lib/CruisecontrolPeer.php');
require_once('plugins/build/lib/Cruisecontrol.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/build/lib/html/BuildAdminTemplate.php');
$theme = new BuildAdminTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Build.BrowsePageTitle')
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->add(CruisecontrolPeer::PROJECT_ID, $Project->getProjectId());
$arr = CruisecontrolPeer::doSelect($crit);


$theader = array();

$theader[] = $Lang->getText('Build.CruisecontrolIdName');
$theader[] = $Lang->getText('Build.BuildNameName');
$theader[] = $Lang->getText('Build.BuildDescriptionName');
$theader[] = $Lang->getText('Build.Config');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');

echo '<p><div class="infobox">'.$Lang->getText('Build.DefineBuilds').'</div></p>';

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Build.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getCruisecontrolId();
		$trow[]=$item->getBuildName();
		$trow[]=$item->getBuildDescription();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('BuildGetConfig', array('id' => $item->getCruisecontrolId(), 'type' => 'ccjava')).'">'. $Lang->getText('Build.GetConfig') .'</a> &nbsp; &nbsp; 
				<a href="'. GFUrl::getUrl()->currentBaseUrl('BuildGetConfig', array('id' => $item->getCruisecontrolId(), 'type' => 'ccnet')).'">'. $Lang->getText('Build.GetNETConfig') .'</a> &nbsp; &nbsp;'.
				'<a href="'. GFUrl::getUrl()->currentBaseUrl('BuildGetConfig', array('id' => $item->getCruisecontrolId(), 'type' => 'jenkins')) .'">'. $Lang->getText('Build.GetHudsonConfig') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('BuildEdit').'&amp;id='.$item->getCruisecontrolId() .'">'. $Lang->getText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('BuildDelete').'&amp;id='.$item->getCruisecontrolId() .'">'. $Lang->getText('Delete') .'</a>';

		echo $theme->tableRow($trow);
	}
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('BuildAdd').'">'.$Lang->getText('Build.AddNew').'</a>'));

$theme->footer($params);

?>
