<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Cruisecontrol
//
require_once('plugins/build/lib/CruisecontrolPeer.php');
require_once('plugins/build/lib/CruisecontrolBuildPeer.php');
require_once('plugins/build/lib/Cruisecontrol.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/build/lib/html/BuildTemplate.php');
$theme = new BuildTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Build.BrowsePageTitle')
		);
$theme->header($params);

$theader = array();
$theader[] = $Lang->getText('Build.BuildNameName');
$theader[] = $Lang->getText('Build.EventType');
$theader[] = $Lang->getText('Build.LastBuildDate');
$theader[] = $Lang->getText('Build.LastBuildStatus');
$theader[] = $Lang->getText('Build.WasBuildNecessary');
$theader[] = $Lang->getText('Build.WasBuildFix');
$theader[] = $Lang->getText('Build.TicketLink');

// Retrieve the objects array
$crit = new Criteria();
$crit->add(CruisecontrolPeer::PROJECT_ID, $Project->getProjectId());
$CControls = CruisecontrolPeer::doSelect($crit);

echo $theme->tableTop($theader);
if (count($CControls) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Build.NoneFound').'</span>');
} else {
	foreach ($CControls as $CControl) {
		$crit = new Criteria();
		$crit->add(CruisecontrolBuildPeer::CRUISECONTROL_ID, $CControl->getCruisecontrolId());
		$crit->addDescendingOrderByColumn(CruisecontrolBuildPeer::BUILD_DATE);
		$CCBuild = CruisecontrolBuildPeer::doSelectOne($crit);
		$unknown = '<i>'.$Lang->getText('Build.Unknown').'</i>';
		$trow = array();
		$trow[]=$CControl->getBuildName();
		if (!$CCBuild || !is_object($CCBuild)) {
			$trow[]=$unknown;
			$trow[]=$unknown;
			$trow[]=$unknown;
			$trow[]=$unknown;
			$trow[]=$unknown;
			$trow[]='&nbsp;';
		} else {
			$trow[]='<font color=\'#009900\'><b>'.CruiseControlBuildPeer::getEventTypeDescription($CCBuild->getEventType()).'</b></font>';
			$trow[]=$CCBuild->getBuildDate();
			$trow[]=$CCBuild->getWasSuccessful() ? 
						'<font color=\'#009900\'><b>'.$Lang->getText('Build.BuildSucceed').'</b></font>' : 
						'<font color=\'#FF0000\'><b>'.$Lang->getText('Build.BuildFailed').'</b></font>';
			$trow[]=$CCBuild->getWasNecessary() ? 
						$Lang->getText('Common.Yes') : $Lang->getText('Common.No');
			$trow[]=$CCBuild->getWasFix() ? 
						$Lang->getText('Common.Yes') : $Lang->getText('Common.No');
			$CCDefect = $CCBuild->getCruisecontrolDefect();
			if (!is_null($CCDefect) && is_object($CCDefect) && !$CCBuild->getWasSuccessful()) {
				$tracker_item_id = $CCDefect->getTrackerItemId();
				$ti = TrackerItemPeer::retrieveByPK($tracker_item_id);
				$trow[]='<a href="'. GFUrl::getUrl()->projectUrl($params['project'],'TrackerItemEdit','tracker').
				'&tracker_id='.$ti->getTrackerId().'&amp;tracker_item_id='.$ti->getTrackerItemID() .'">[#'.$ti->getTrackerItemID().'] '.$ti->getSummary().'</a>';
			} else {
				$trow[]='&nbsp;';
			}
		}
		echo $theme->tableRow($trow);
	}
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('BuildHistory').'">'.$Lang->getText('Build.ViewHistory').'</a>'));

$theme->footer($params);

?>
