<?php

require_once('notification/GFNotification.php');
require_once('StringUtils.php');
require_once('GFUrl.php');


class CalendarEventNotification implements GFNotification {
	private $CalendarEvent;
	private $Calendar;
	
	function __construct(CalendarEvent $Event){
		$this->CalendarEvent = $Event;
		$this->Calendar = $Event->getCalendar();
	}


	function getNotificationMessage(User $User) {
		return $this->getGenericMessage();
	}

	private function getGenericMessage(){
		$url = GFUrl::getUrl();
	
		if($this->Calendar->getSection() == 'user'){
			$user = UserPeer::retrieveByPk($this->Calendar->getRefId());
		}

		$body  = "This is a reminder for event #" . $this->CalendarEvent->getCalendarEventId(). "\n\n";
		$body .= "Subject: ".$this->CalendarEvent->getSubject() . "\n\n";
		$body .= "From :   " . $this->CalendarEvent->getFromDate("%c %z") . "\n";
		$body .= "To:      " . $this->CalendarEvent->getToDate("%c %z") . "\n\n";
		$body .= "Description: " . $this->CalendarEvent->getDescription() . "\n\n";
		$body .= $url->getFullUrl($url->userUrl($user, 'UsercalendarEventView', 'usercalendar','my',array('event_id'=>$this->CalendarEvent->getCalendarEventId())) . "\n\n", true);
		$body .= "You're receiving this email at the account " . $user->getEmail() . " because you set a reminder for this event.\n";

		return $body;
	}

	function getNotificationSubject(User $User) {
		return $this->getGenericSubject();
	}

	private function getGenericSubject(){
		$subject = "Reminder " . $this->CalendarEvent->getSubject() . " @ " . $this->CalendarEvent->getFromDate("%c");
		return $subject;
	}

	public function getUsers(){
		if($this->Calendar->getSection() == 'user'){
			return array(UserPeer::retrieveByPk($this->Calendar->getRefId()));
		}
	}

	function getSection(){
		if($this->Calendar->getSection() == 'user'){
			return 'usercalendar';
		}else {
			return 'calendar';
		}
	}

	function getRefId(){
		return $this->CalendarEvent->getCalendarEventId();
	}

}
?>

