<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'calendar_event' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.calendar.lib.map
 */
class CalendarEventMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.calendar.lib.map.CalendarEventMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("calendar_event");
		$tMap->setPhpName("CalendarEvent");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("calendar_event_calendar_event_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("CALENDAR_EVENT_ID", "CalendarEventId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("CALENDAR_ID", "CalendarId", "int", CreoleTypes::INTEGER, "calendar" , "CALENDAR_ID", true);
		$tMap->addColumn("SUBJECT", "Subject", "string", CreoleTypes::VARCHAR, true, 255);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("FROM_DATE", "FromDate", "int", CreoleTypes::TIMESTAMP, true, null);
		$tMap->addColumn("TO_DATE", "ToDate", "int", CreoleTypes::TIMESTAMP, true, null);
		$tMap->addColumn("FROM_HOUR", "FromHour", "int", CreoleTypes::TIME, false, null);
		$tMap->addColumn("TO_HOUR", "ToHour", "int", CreoleTypes::TIME, false, null);
		$tMap->addColumn("OCCURRENCE", "Occurrence", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("OCCURRENCE_TO", "OccurrenceTo", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("IS_PUBLIC", "IsPublic", "boolean", CreoleTypes::BOOLEAN, false, null);
				
    }
}
