<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'calendar' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.calendar.lib.map
 */
class CalendarMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.calendar.lib.map.CalendarMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("calendar");
		$tMap->setPhpName("Calendar");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("calendar_calendar_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("CALENDAR_ID", "CalendarId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("REF_ID", "RefId", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("SECTION", "Section", "string", CreoleTypes::VARCHAR, true, 20);
		$tMap->addColumn("CALENDAR_NAME", "CalendarName", "string", CreoleTypes::VARCHAR, true, 255);
		$tMap->addColumn("IS_PUBLIC", "IsPublic", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("TIMEZONE", "Timezone", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("WORKING_HOUR_START", "WorkingHourStart", "int", CreoleTypes::TIME, false, null);
		$tMap->addColumn("WORKING_HOUR_END", "WorkingHourEnd", "int", CreoleTypes::TIME, false, null);
		$tMap->addColumn("FIRST_DAY_OF_WEEK", "FirstDayOfWeek", "int", CreoleTypes::INTEGER, false, null);
				
    }
}
