<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'plugins/calendar/lib/CalendarPeer.php';

/**
 * Base class that represents a row from the 'calendar' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Calendar class. 
 * 
 * @package plugins.calendar.lib 
 */
abstract class BaseCalendar extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CalendarPeer
	 */
	protected static $peer;

	/**
	 * The value for the calendar_id field.
	 * @var int	  
	 */
	protected $calendar_id;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the calendar_name field.
	 * @var string	  
	 */
	protected $calendar_name;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = false;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	

	/**
	 * The value for the timezone field.
	 * @var string	  
	 */
	protected $timezone;	

	/**
	 * The value for the working_hour_start field.
	 * @var int	  
	 */
	protected $working_hour_start;	

	/**
	 * The value for the working_hour_end field.
	 * @var int	  
	 */
	protected $working_hour_end;	

	/**
	 * The value for the first_day_of_week field.
	 * @var int	  
	 */
	protected $first_day_of_week = 1;	
  
	/**
	 * Get the CalendarId column value.
	 *  
	 * @return int	  
	 */
	public function getCalendarId()
	{
		return $this->calendar_id;
	}


	/**
	 * Set the value of `calendar_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCalendarId($v)
	{
		if ($this->calendar_id !== $v) {
			$this->calendar_id = $v;
			$this->modifiedColumns[] = CalendarPeer::CALENDAR_ID;
		}
			
		  // update associated CalendarEvent		  
		  if ($this->collCalendarEvents !== null) {
			  for ($i=0,$size=count($this->collCalendarEvents); $i < $size; $i++) {
				  $this->collCalendarEvents[$i]->setCalendarId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = CalendarPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = CalendarPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the CalendarName column value.
	 *  
	 * @return string	  
	 */
	public function getCalendarName()
	{
		return $this->calendar_name;
	}


	/**
	 * Set the value of `calendar_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setCalendarName($v)
	{
		if ($this->calendar_name !== $v) {
			$this->calendar_name = $v;
			$this->modifiedColumns[] = CalendarPeer::CALENDAR_NAME;
		}
				
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === false) {
			$this->is_public = $v;
			$this->modifiedColumns[] = CalendarPeer::IS_PUBLIC;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = CalendarPeer::DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the Timezone column value.
	 *  
	 * @return string	  
	 */
	public function getTimezone()
	{
		return $this->timezone;
	}


	/**
	 * Set the value of `timezone` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setTimezone($v)
	{
		if ($this->timezone !== $v) {
			$this->timezone = $v;
			$this->modifiedColumns[] = CalendarPeer::TIMEZONE;
		}
				
	}


	/**
	 * Get the [optionally formatted] `working_hour_start` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getWorkingHourStart($format = '%X')
	{
		if ($this->working_hour_start === null || $this->working_hour_start === '') {
			return null;
		} elseif (!is_int($this->working_hour_start)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->working_hour_start);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of working_hour_start as date/time value: " . var_export($this->working_hour_start, true));
			}
		} else {
			$ts = $this->working_hour_start;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `working_hour_start` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setWorkingHourStart($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for working_hour_start from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->working_hour_start !== $ts || $ts === -1) {
			$this->working_hour_start = $ts;
			$this->modifiedColumns[] = CalendarPeer::WORKING_HOUR_START;
		}
		
	}


	/**
	 * Get the [optionally formatted] `working_hour_end` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getWorkingHourEnd($format = '%X')
	{
		if ($this->working_hour_end === null || $this->working_hour_end === '') {
			return null;
		} elseif (!is_int($this->working_hour_end)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->working_hour_end);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of working_hour_end as date/time value: " . var_export($this->working_hour_end, true));
			}
		} else {
			$ts = $this->working_hour_end;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `working_hour_end` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setWorkingHourEnd($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for working_hour_end from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->working_hour_end !== $ts || $ts === -1) {
			$this->working_hour_end = $ts;
			$this->modifiedColumns[] = CalendarPeer::WORKING_HOUR_END;
		}
		
	}

  
	/**
	 * Get the FirstDayOfWeek column value.
	 *  
	 * @return int	  
	 */
	public function getFirstDayOfWeek()
	{
		return $this->first_day_of_week;
	}


	/**
	 * Set the value of `first_day_of_week` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setFirstDayOfWeek($v)
	{
		if ($this->first_day_of_week !== $v || $v === 1) {
			$this->first_day_of_week = $v;
			$this->modifiedColumns[] = CalendarPeer::FIRST_DAY_OF_WEEK;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->calendar_id = $rs->getInt($startcol + 0);					
			$this->ref_id = $rs->getInt($startcol + 1);					
			$this->section = $rs->getString($startcol + 2);					
			$this->calendar_name = $rs->getString($startcol + 3);					
			$this->is_public = $rs->getBoolean($startcol + 4);					
			$this->description = $rs->getString($startcol + 5);					
			$this->timezone = $rs->getString($startcol + 6);					
			$this->working_hour_start = $rs->getTime($startcol + 7, null);
			$this->working_hour_end = $rs->getTime($startcol + 8, null);
			$this->first_day_of_week = $rs->getInt($startcol + 9);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Calendar object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(CalendarPeer::DATABASE_NAME);
		$criteria->add(CalendarPeer::CALENDAR_ID, $this->calendar_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(CalendarPeer::DATABASE_NAME);
		if ($this->isColumnModified(CalendarPeer::CALENDAR_ID)) $criteria->add(CalendarPeer::CALENDAR_ID, $this->calendar_id);
		if ($this->isColumnModified(CalendarPeer::REF_ID)) $criteria->add(CalendarPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(CalendarPeer::SECTION)) $criteria->add(CalendarPeer::SECTION, $this->section);
		if ($this->isColumnModified(CalendarPeer::CALENDAR_NAME)) $criteria->add(CalendarPeer::CALENDAR_NAME, $this->calendar_name);
		if ($this->isColumnModified(CalendarPeer::IS_PUBLIC)) $criteria->add(CalendarPeer::IS_PUBLIC, $this->is_public);
		if ($this->isColumnModified(CalendarPeer::DESCRIPTION)) $criteria->add(CalendarPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(CalendarPeer::TIMEZONE)) $criteria->add(CalendarPeer::TIMEZONE, $this->timezone);
		if ($this->isColumnModified(CalendarPeer::WORKING_HOUR_START)) $criteria->add(CalendarPeer::WORKING_HOUR_START, $this->working_hour_start);
		if ($this->isColumnModified(CalendarPeer::WORKING_HOUR_END)) $criteria->add(CalendarPeer::WORKING_HOUR_END, $this->working_hour_end);
		if ($this->isColumnModified(CalendarPeer::FIRST_DAY_OF_WEEK)) $criteria->add(CalendarPeer::FIRST_DAY_OF_WEEK, $this->first_day_of_week);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collCalendarEvents	  
	 * @var array
	 */
	protected $collCalendarEvents; 

	/**
	 * Temporary storage of collCalendarEvents to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCalendarEvents()
	{
		if ($this->collCalendarEvents === null) {
			$this->collCalendarEvents = array();
		}
	}

	/**
	 * Method called to associate a CalendarEvent object to this object
	 * through the CalendarEvent foreign key attribute
	 *
	 * @param CalendarEvent $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCalendarEvent(CalendarEvent $l)
	{
		$this->collCalendarEvents[] = $l;
		$l->setCalendar($this);
	}

	/**
	 * The criteria used to select the current contents of collCalendarEvents.
	 * @var Criteria
	 */
	private $lastCalendarEventsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Calendar has previously
	 * been saved, it will retrieve related CalendarEvents from storage.
	 * If this Calendar is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCalendarEvents($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/calendar/lib/CalendarEventPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCalendarEvents === null) {
			if ($this->isNew()) {
			   $this->collCalendarEvents = array();
			} else {
	
				$criteria->add(CalendarEventPeer::CALENDAR_ID, $this->getCalendarId() );

				$this->collCalendarEvents = CalendarEventPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CalendarEventPeer::CALENDAR_ID, $this->getCalendarId());

				if (!isset($this->lastCalendarEventsCriteria) || !$this->lastCalendarEventsCriteria->equals($criteria)) {
					$this->collCalendarEvents = CalendarEventPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCalendarEventsCriteria = $criteria;

		return $this->collCalendarEvents;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Calendar is new, it will return
	 * an empty collection; or if this Calendar has previously
	 * been saved, it will retrieve related CalendarEvents from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Calendar.
	 */
	public function getCalendarEventsJoinCalendar($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/calendar/lib/CalendarEventPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCalendarEvents === null) {
			if ($this->isNew()) {
			   $this->collCalendarEvents = array();
			} else {
	   
				$criteria->add(CalendarEventPeer::CALENDAR_ID, $this->getCalendarId());
				$this->collCalendarEvents = CalendarEventPeer::doSelectJoinCalendar($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CalendarEventPeer::CALENDAR_ID, $this->getCalendarId());
			if (!isset($this->lastCalendarEventsCriteria) || !$this->lastCalendarEventsCriteria->equals($criteria)) {
				$this->collCalendarEvents = CalendarEventPeer::doSelectJoinCalendar($criteria, $con);
			}
		}
		$this->lastCalendarEventsCriteria = $criteria;

		return $this->collCalendarEvents;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("calendar_id", "ref_id", "section", "calendar_name", "is_public", "description", "timezone", "working_hour_start", "working_hour_end", "first_day_of_week", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case CalendarPeer::CALENDAR_ID:
				return $this->getCalendarId();
				break;
		  
			case CalendarPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case CalendarPeer::SECTION:
				return $this->getSection();
				break;
		  
			case CalendarPeer::CALENDAR_NAME:
				return $this->getCalendarName();
				break;
		  
			case CalendarPeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
		  
			case CalendarPeer::DESCRIPTION:
				return $this->getDescription();
				break;
		  
			case CalendarPeer::TIMEZONE:
				return $this->getTimezone();
				break;
		  
			case CalendarPeer::WORKING_HOUR_START:
				return $this->getWorkingHourStart();
				break;
		  
			case CalendarPeer::WORKING_HOUR_END:
				return $this->getWorkingHourEnd();
				break;
		  
			case CalendarPeer::FIRST_DAY_OF_WEEK:
				return $this->getFirstDayOfWeek();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getCalendarId();
				break;
  
			case 1:
				return $this->getRefId();
				break;
  
			case 2:
				return $this->getSection();
				break;
  
			case 3:
				return $this->getCalendarName();
				break;
  
			case 4:
				return $this->getIsPublic();
				break;
  
			case 5:
				return $this->getDescription();
				break;
  
			case 6:
				return $this->getTimezone();
				break;
  
			case 7:
				return $this->getWorkingHourStart();
				break;
  
			case 8:
				return $this->getWorkingHourEnd();
				break;
  
			case 9:
				return $this->getFirstDayOfWeek();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(CalendarPeer::CALENDAR_ID, $arr)) $this->setCalendarId($arr[CalendarPeer::CALENDAR_ID]);
  
		if (array_key_exists(CalendarPeer::REF_ID, $arr)) $this->setRefId($arr[CalendarPeer::REF_ID]);
  
		if (array_key_exists(CalendarPeer::SECTION, $arr)) $this->setSection($arr[CalendarPeer::SECTION]);
  
		if (array_key_exists(CalendarPeer::CALENDAR_NAME, $arr)) $this->setCalendarName($arr[CalendarPeer::CALENDAR_NAME]);
  
		if (array_key_exists(CalendarPeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[CalendarPeer::IS_PUBLIC]);
  
		if (array_key_exists(CalendarPeer::DESCRIPTION, $arr)) $this->setDescription($arr[CalendarPeer::DESCRIPTION]);
  
		if (array_key_exists(CalendarPeer::TIMEZONE, $arr)) $this->setTimezone($arr[CalendarPeer::TIMEZONE]);
  
		if (array_key_exists(CalendarPeer::WORKING_HOUR_START, $arr)) $this->setWorkingHourStart($arr[CalendarPeer::WORKING_HOUR_START]);
  
		if (array_key_exists(CalendarPeer::WORKING_HOUR_END, $arr)) $this->setWorkingHourEnd($arr[CalendarPeer::WORKING_HOUR_END]);
  
		if (array_key_exists(CalendarPeer::FIRST_DAY_OF_WEEK, $arr)) $this->setFirstDayOfWeek($arr[CalendarPeer::FIRST_DAY_OF_WEEK]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case CalendarPeer::CALENDAR_ID:
				$this->setCalendarId($value);
				break;
	  
			case CalendarPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case CalendarPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case CalendarPeer::CALENDAR_NAME:
				$this->setCalendarName($value);
				break;
	  
			case CalendarPeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
	  
			case CalendarPeer::DESCRIPTION:
				$this->setDescription($value);
				break;
	  
			case CalendarPeer::TIMEZONE:
				$this->setTimezone($value);
				break;
	  
			case CalendarPeer::WORKING_HOUR_START:
				$this->setWorkingHourStart($value);
				break;
	  
			case CalendarPeer::WORKING_HOUR_END:
				$this->setWorkingHourEnd($value);
				break;
	  
			case CalendarPeer::FIRST_DAY_OF_WEEK:
				$this->setFirstDayOfWeek($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setCalendarId($value);
				break;
  
			case 1:
				$this->setRefId($value);
				break;
  
			case 2:
				$this->setSection($value);
				break;
  
			case 3:
				$this->setCalendarName($value);
				break;
  
			case 4:
				$this->setIsPublic($value);
				break;
  
			case 5:
				$this->setDescription($value);
				break;
  
			case 6:
				$this->setTimezone($value);
				break;
  
			case 7:
				$this->setWorkingHourStart($value);
				break;
  
			case 8:
				$this->setWorkingHourEnd($value);
				break;
  
			case 9:
				$this->setFirstDayOfWeek($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(CalendarPeer::DATABASE_NAME);

		try {
			$con->begin();
			CalendarPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(CalendarPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CalendarPeer::doInsert($this, $con);
					$this->setCalendarId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					CalendarPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCalendarEvents !== null) {
				for ($i=0,$size=count($this->collCalendarEvents); $i < $size; $i++) {
					$this->collCalendarEvents[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return CalendarPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = CalendarPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCalendarEvents !== null) {
				for ($i=0,$size=count($this->collCalendarEvents); $i < $size; $i++) {
					if (($retval = $this->collCalendarEvents[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed calendar_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setCalendarId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getCalendarId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Calendar Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Calendar();
		$copyObj->setRefId($this->ref_id);
		$copyObj->setSection($this->section);
		$copyObj->setCalendarName($this->calendar_name);
		$copyObj->setIsPublic($this->is_public);
		$copyObj->setDescription($this->description);
		$copyObj->setTimezone($this->timezone);
		$copyObj->setWorkingHourStart($this->working_hour_start);
		$copyObj->setWorkingHourEnd($this->working_hour_end);
		$copyObj->setFirstDayOfWeek($this->first_day_of_week);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCalendarEvents() as $relObj) {
				$copyObj->addCalendarEvent($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setCalendarId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return CalendarPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CalendarPeer();
		}
		return self::$peer;
	}

}
