<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/calendar/lib/Calendar.php';
// (on-demand) include_once 'plugins/calendar/lib/CalendarPeer.php';

include_once 'plugins/calendar/lib/CalendarEventPeer.php';

/**
 * Base class that represents a row from the 'calendar_event' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CalendarEvent class. 
 * 
 * @package plugins.calendar.lib 
 */
abstract class BaseCalendarEvent extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CalendarEventPeer
	 */
	protected static $peer;

	/**
	 * The value for the calendar_event_id field.
	 * @var int	  
	 */
	protected $calendar_event_id;	

	/**
	 * The value for the calendar_id field.
	 * @var int	  
	 */
	protected $calendar_id;	

	/**
	 * The value for the subject field.
	 * @var string	  
	 */
	protected $subject;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	

	/**
	 * The value for the from_date field.
	 * @var int	  
	 */
	protected $from_date;	

	/**
	 * The value for the to_date field.
	 * @var int	  
	 */
	protected $to_date;	

	/**
	 * The value for the from_hour field.
	 * @var int	  
	 */
	protected $from_hour;	

	/**
	 * The value for the to_hour field.
	 * @var int	  
	 */
	protected $to_hour;	

	/**
	 * The value for the occurrence field.
	 * @var int	  
	 */
	protected $occurrence = 0;	

	/**
	 * The value for the occurrence_to field.
	 * @var int	  
	 */
	protected $occurrence_to;	

	/**
	 * The value for the is_public field.
	 * @var boolean	  
	 */
	protected $is_public = false;	
  
	/**
	 * Get the CalendarEventId column value.
	 *  
	 * @return int	  
	 */
	public function getCalendarEventId()
	{
		return $this->calendar_event_id;
	}


	/**
	 * Set the value of `calendar_event_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCalendarEventId($v)
	{
		if ($this->calendar_event_id !== $v) {
			$this->calendar_event_id = $v;
			$this->modifiedColumns[] = CalendarEventPeer::CALENDAR_EVENT_ID;
		}
			
		  // update associated CalendarEventReminder		  
		  if ($this->collCalendarEventReminders !== null) {
			  for ($i=0,$size=count($this->collCalendarEventReminders); $i < $size; $i++) {
				  $this->collCalendarEventReminders[$i]->setCalendarEventId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the CalendarId column value.
	 *  
	 * @return int	  
	 */
	public function getCalendarId()
	{
		return $this->calendar_id;
	}


	/**
	 * Set the value of `calendar_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCalendarId($v)
	{
		if ($this->calendar_id !== $v) {
			$this->calendar_id = $v;
			$this->modifiedColumns[] = CalendarEventPeer::CALENDAR_ID;
		}
			
		if ($this->aCalendar !== null && $this->aCalendar->getCalendarId() !== $v) {
			$this->aCalendar = null;
		}
			
	}

  
	/**
	 * Get the Subject column value.
	 *  
	 * @return string	  
	 */
	public function getSubject()
	{
		return $this->subject;
	}


	/**
	 * Set the value of `subject` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSubject($v)
	{
		if ($this->subject !== $v) {
			$this->subject = $v;
			$this->modifiedColumns[] = CalendarEventPeer::SUBJECT;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = CalendarEventPeer::DESCRIPTION;
		}
				
	}


	/**
	 * Get the [optionally formatted] `from_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getFromDate($format = 'Y-m-d H:i:s')
	{
		if ($this->from_date === null || $this->from_date === '') {
			return null;
		} elseif (!is_int($this->from_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->from_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of from_date as date/time value: " . var_export($this->from_date, true));
			}
		} else {
			$ts = $this->from_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `from_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setFromDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for from_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->from_date !== $ts || $ts === -1) {
			$this->from_date = $ts;
			$this->modifiedColumns[] = CalendarEventPeer::FROM_DATE;
		}
		
	}


	/**
	 * Get the [optionally formatted] `to_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getToDate($format = 'Y-m-d H:i:s')
	{
		if ($this->to_date === null || $this->to_date === '') {
			return null;
		} elseif (!is_int($this->to_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->to_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of to_date as date/time value: " . var_export($this->to_date, true));
			}
		} else {
			$ts = $this->to_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `to_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setToDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for to_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->to_date !== $ts || $ts === -1) {
			$this->to_date = $ts;
			$this->modifiedColumns[] = CalendarEventPeer::TO_DATE;
		}
		
	}


	/**
	 * Get the [optionally formatted] `from_hour` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getFromHour($format = '%X')
	{
		if ($this->from_hour === null || $this->from_hour === '') {
			return null;
		} elseif (!is_int($this->from_hour)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->from_hour);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of from_hour as date/time value: " . var_export($this->from_hour, true));
			}
		} else {
			$ts = $this->from_hour;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `from_hour` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setFromHour($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for from_hour from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->from_hour !== $ts || $ts === -1) {
			$this->from_hour = $ts;
			$this->modifiedColumns[] = CalendarEventPeer::FROM_HOUR;
		}
		
	}


	/**
	 * Get the [optionally formatted] `to_hour` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getToHour($format = '%X')
	{
		if ($this->to_hour === null || $this->to_hour === '') {
			return null;
		} elseif (!is_int($this->to_hour)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->to_hour);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of to_hour as date/time value: " . var_export($this->to_hour, true));
			}
		} else {
			$ts = $this->to_hour;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `to_hour` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setToHour($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for to_hour from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->to_hour !== $ts || $ts === -1) {
			$this->to_hour = $ts;
			$this->modifiedColumns[] = CalendarEventPeer::TO_HOUR;
		}
		
	}

  
	/**
	 * Get the Occurrence column value.
	 *  
	 * @return int	  
	 */
	public function getOccurrence()
	{
		return $this->occurrence;
	}


	/**
	 * Set the value of `occurrence` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setOccurrence($v)
	{
		if ($this->occurrence !== $v || $v === 0) {
			$this->occurrence = $v;
			$this->modifiedColumns[] = CalendarEventPeer::OCCURRENCE;
		}
				
	}


	/**
	 * Get the [optionally formatted] `occurrence_to` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getOccurrenceTo($format = 'Y-m-d H:i:s')
	{
		if ($this->occurrence_to === null || $this->occurrence_to === '') {
			return null;
		} elseif (!is_int($this->occurrence_to)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->occurrence_to);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of occurrence_to as date/time value: " . var_export($this->occurrence_to, true));
			}
		} else {
			$ts = $this->occurrence_to;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `occurrence_to` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setOccurrenceTo($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for occurrence_to from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->occurrence_to !== $ts || $ts === -1) {
			$this->occurrence_to = $ts;
			$this->modifiedColumns[] = CalendarEventPeer::OCCURRENCE_TO;
		}
		
	}

  
	/**
	 * Get the IsPublic column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsPublic()
	{
		return $this->is_public;
	}


	/**
	 * Set the value of `is_public` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsPublic($v)
	{
		if ($this->is_public !== $v || $v === false) {
			$this->is_public = $v;
			$this->modifiedColumns[] = CalendarEventPeer::IS_PUBLIC;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->calendar_event_id = $rs->getInt($startcol + 0);					
			$this->calendar_id = $rs->getInt($startcol + 1);					
			$this->subject = $rs->getString($startcol + 2);					
			$this->description = $rs->getString($startcol + 3);					
			$this->from_date = $rs->getTimestamp($startcol + 4, null);
			$this->to_date = $rs->getTimestamp($startcol + 5, null);
			$this->from_hour = $rs->getTime($startcol + 6, null);
			$this->to_hour = $rs->getTime($startcol + 7, null);
			$this->occurrence = $rs->getInt($startcol + 8);					
			$this->occurrence_to = $rs->getTimestamp($startcol + 9, null);
			$this->is_public = $rs->getBoolean($startcol + 10);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating CalendarEvent object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(CalendarEventPeer::DATABASE_NAME);
		$criteria->add(CalendarEventPeer::CALENDAR_EVENT_ID, $this->calendar_event_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(CalendarEventPeer::DATABASE_NAME);
		if ($this->isColumnModified(CalendarEventPeer::CALENDAR_EVENT_ID)) $criteria->add(CalendarEventPeer::CALENDAR_EVENT_ID, $this->calendar_event_id);
		if ($this->isColumnModified(CalendarEventPeer::CALENDAR_ID)) $criteria->add(CalendarEventPeer::CALENDAR_ID, $this->calendar_id);
		if ($this->isColumnModified(CalendarEventPeer::SUBJECT)) $criteria->add(CalendarEventPeer::SUBJECT, $this->subject);
		if ($this->isColumnModified(CalendarEventPeer::DESCRIPTION)) $criteria->add(CalendarEventPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(CalendarEventPeer::FROM_DATE)) $criteria->add(CalendarEventPeer::FROM_DATE, $this->from_date);
		if ($this->isColumnModified(CalendarEventPeer::TO_DATE)) $criteria->add(CalendarEventPeer::TO_DATE, $this->to_date);
		if ($this->isColumnModified(CalendarEventPeer::FROM_HOUR)) $criteria->add(CalendarEventPeer::FROM_HOUR, $this->from_hour);
		if ($this->isColumnModified(CalendarEventPeer::TO_HOUR)) $criteria->add(CalendarEventPeer::TO_HOUR, $this->to_hour);
		if ($this->isColumnModified(CalendarEventPeer::OCCURRENCE)) $criteria->add(CalendarEventPeer::OCCURRENCE, $this->occurrence);
		if ($this->isColumnModified(CalendarEventPeer::OCCURRENCE_TO)) $criteria->add(CalendarEventPeer::OCCURRENCE_TO, $this->occurrence_to);
		if ($this->isColumnModified(CalendarEventPeer::IS_PUBLIC)) $criteria->add(CalendarEventPeer::IS_PUBLIC, $this->is_public);
		return $criteria;			
	}
	
	

	/**
	 * @var Calendar	  
	 */
	protected $aCalendar;

	/**
	 * Declares an association between this object and a Calendar object
	 *
	 * @param Calendar $v
	 * @return void
	 * @throws PropelException
	 */
	public function setCalendar($v)
	{
			
		if ($v === null) {
			$this->setCalendarId(NULL);
		} else {
			$this->setCalendarId($v->getCalendarId());
		}
   
		$this->aCalendar = $v;
	}


	/**
	 * Get the associated Calendar object
	 *
	 * @param Connection Optional Connection object.
	 * @return Calendar The associated Calendar object.
	 * @throws PropelException
	 */
	public function getCalendar($con = null)
	{
		// include the Peer class
		include_once 'plugins/calendar/lib/CalendarPeer.php';

		if ($this->aCalendar === null && ($this->calendar_id !== null)) {
	
			$this->aCalendar = CalendarPeer::retrieveByPK($this->calendar_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = CalendarPeer::retrieveByPK($this->calendar_id, $con);
			   $obj->addCalendarEvents($this);
			 */
		}
		return $this->aCalendar;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setCalendarKey($key)
	{

		$this->setCalendarId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collCalendarEventReminders	  
	 * @var array
	 */
	protected $collCalendarEventReminders; 

	/**
	 * Temporary storage of collCalendarEventReminders to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initCalendarEventReminders()
	{
		if ($this->collCalendarEventReminders === null) {
			$this->collCalendarEventReminders = array();
		}
	}

	/**
	 * Method called to associate a CalendarEventReminder object to this object
	 * through the CalendarEventReminder foreign key attribute
	 *
	 * @param CalendarEventReminder $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addCalendarEventReminder(CalendarEventReminder $l)
	{
		$this->collCalendarEventReminders[] = $l;
		$l->setCalendarEvent($this);
	}

	/**
	 * The criteria used to select the current contents of collCalendarEventReminders.
	 * @var Criteria
	 */
	private $lastCalendarEventRemindersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CalendarEvent has previously
	 * been saved, it will retrieve related CalendarEventReminders from storage.
	 * If this CalendarEvent is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getCalendarEventReminders($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/calendar/lib/CalendarEventReminderPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collCalendarEventReminders === null) {
			if ($this->isNew()) {
			   $this->collCalendarEventReminders = array();
			} else {
	
				$criteria->add(CalendarEventReminderPeer::CALENDAR_EVENT_ID, $this->getCalendarEventId() );

				$this->collCalendarEventReminders = CalendarEventReminderPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(CalendarEventReminderPeer::CALENDAR_EVENT_ID, $this->getCalendarEventId());

				if (!isset($this->lastCalendarEventRemindersCriteria) || !$this->lastCalendarEventRemindersCriteria->equals($criteria)) {
					$this->collCalendarEventReminders = CalendarEventReminderPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastCalendarEventRemindersCriteria = $criteria;

		return $this->collCalendarEventReminders;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this CalendarEvent is new, it will return
	 * an empty collection; or if this CalendarEvent has previously
	 * been saved, it will retrieve related CalendarEventReminders from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in CalendarEvent.
	 */
	public function getCalendarEventRemindersJoinCalendarEvent($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/calendar/lib/CalendarEventReminderPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collCalendarEventReminders === null) {
			if ($this->isNew()) {
			   $this->collCalendarEventReminders = array();
			} else {
	   
				$criteria->add(CalendarEventReminderPeer::CALENDAR_EVENT_ID, $this->getCalendarEventId());
				$this->collCalendarEventReminders = CalendarEventReminderPeer::doSelectJoinCalendarEvent($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(CalendarEventReminderPeer::CALENDAR_EVENT_ID, $this->getCalendarEventId());
			if (!isset($this->lastCalendarEventRemindersCriteria) || !$this->lastCalendarEventRemindersCriteria->equals($criteria)) {
				$this->collCalendarEventReminders = CalendarEventReminderPeer::doSelectJoinCalendarEvent($criteria, $con);
			}
		}
		$this->lastCalendarEventRemindersCriteria = $criteria;

		return $this->collCalendarEventReminders;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("calendar_event_id", "calendar_id", "subject", "description", "from_date", "to_date", "from_hour", "to_hour", "occurrence", "occurrence_to", "is_public", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case CalendarEventPeer::CALENDAR_EVENT_ID:
				return $this->getCalendarEventId();
				break;
		  
			case CalendarEventPeer::CALENDAR_ID:
				return $this->getCalendarId();
				break;
		  
			case CalendarEventPeer::SUBJECT:
				return $this->getSubject();
				break;
		  
			case CalendarEventPeer::DESCRIPTION:
				return $this->getDescription();
				break;
		  
			case CalendarEventPeer::FROM_DATE:
				return $this->getFromDate();
				break;
		  
			case CalendarEventPeer::TO_DATE:
				return $this->getToDate();
				break;
		  
			case CalendarEventPeer::FROM_HOUR:
				return $this->getFromHour();
				break;
		  
			case CalendarEventPeer::TO_HOUR:
				return $this->getToHour();
				break;
		  
			case CalendarEventPeer::OCCURRENCE:
				return $this->getOccurrence();
				break;
		  
			case CalendarEventPeer::OCCURRENCE_TO:
				return $this->getOccurrenceTo();
				break;
		  
			case CalendarEventPeer::IS_PUBLIC:
				return $this->getIsPublic();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getCalendarEventId();
				break;
  
			case 1:
				return $this->getCalendarId();
				break;
  
			case 2:
				return $this->getSubject();
				break;
  
			case 3:
				return $this->getDescription();
				break;
  
			case 4:
				return $this->getFromDate();
				break;
  
			case 5:
				return $this->getToDate();
				break;
  
			case 6:
				return $this->getFromHour();
				break;
  
			case 7:
				return $this->getToHour();
				break;
  
			case 8:
				return $this->getOccurrence();
				break;
  
			case 9:
				return $this->getOccurrenceTo();
				break;
  
			case 10:
				return $this->getIsPublic();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(CalendarEventPeer::CALENDAR_EVENT_ID, $arr)) $this->setCalendarEventId($arr[CalendarEventPeer::CALENDAR_EVENT_ID]);
  
		if (array_key_exists(CalendarEventPeer::CALENDAR_ID, $arr)) $this->setCalendarId($arr[CalendarEventPeer::CALENDAR_ID]);
  
		if (array_key_exists(CalendarEventPeer::SUBJECT, $arr)) $this->setSubject($arr[CalendarEventPeer::SUBJECT]);
  
		if (array_key_exists(CalendarEventPeer::DESCRIPTION, $arr)) $this->setDescription($arr[CalendarEventPeer::DESCRIPTION]);
  
		if (array_key_exists(CalendarEventPeer::FROM_DATE, $arr)) $this->setFromDate($arr[CalendarEventPeer::FROM_DATE]);
  
		if (array_key_exists(CalendarEventPeer::TO_DATE, $arr)) $this->setToDate($arr[CalendarEventPeer::TO_DATE]);
  
		if (array_key_exists(CalendarEventPeer::FROM_HOUR, $arr)) $this->setFromHour($arr[CalendarEventPeer::FROM_HOUR]);
  
		if (array_key_exists(CalendarEventPeer::TO_HOUR, $arr)) $this->setToHour($arr[CalendarEventPeer::TO_HOUR]);
  
		if (array_key_exists(CalendarEventPeer::OCCURRENCE, $arr)) $this->setOccurrence($arr[CalendarEventPeer::OCCURRENCE]);
  
		if (array_key_exists(CalendarEventPeer::OCCURRENCE_TO, $arr)) $this->setOccurrenceTo($arr[CalendarEventPeer::OCCURRENCE_TO]);
  
		if (array_key_exists(CalendarEventPeer::IS_PUBLIC, $arr)) $this->setIsPublic($arr[CalendarEventPeer::IS_PUBLIC]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case CalendarEventPeer::CALENDAR_EVENT_ID:
				$this->setCalendarEventId($value);
				break;
	  
			case CalendarEventPeer::CALENDAR_ID:
				$this->setCalendarId($value);
				break;
	  
			case CalendarEventPeer::SUBJECT:
				$this->setSubject($value);
				break;
	  
			case CalendarEventPeer::DESCRIPTION:
				$this->setDescription($value);
				break;
	  
			case CalendarEventPeer::FROM_DATE:
				$this->setFromDate($value);
				break;
	  
			case CalendarEventPeer::TO_DATE:
				$this->setToDate($value);
				break;
	  
			case CalendarEventPeer::FROM_HOUR:
				$this->setFromHour($value);
				break;
	  
			case CalendarEventPeer::TO_HOUR:
				$this->setToHour($value);
				break;
	  
			case CalendarEventPeer::OCCURRENCE:
				$this->setOccurrence($value);
				break;
	  
			case CalendarEventPeer::OCCURRENCE_TO:
				$this->setOccurrenceTo($value);
				break;
	  
			case CalendarEventPeer::IS_PUBLIC:
				$this->setIsPublic($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setCalendarEventId($value);
				break;
  
			case 1:
				$this->setCalendarId($value);
				break;
  
			case 2:
				$this->setSubject($value);
				break;
  
			case 3:
				$this->setDescription($value);
				break;
  
			case 4:
				$this->setFromDate($value);
				break;
  
			case 5:
				$this->setToDate($value);
				break;
  
			case 6:
				$this->setFromHour($value);
				break;
  
			case 7:
				$this->setToHour($value);
				break;
  
			case 8:
				$this->setOccurrence($value);
				break;
  
			case 9:
				$this->setOccurrenceTo($value);
				break;
  
			case 10:
				$this->setIsPublic($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(CalendarEventPeer::DATABASE_NAME);

		try {
			$con->begin();
			CalendarEventPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(CalendarEventPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aCalendar !== null) {
				if ($this->aCalendar->isModified()) $this->aCalendar->save($con);
				$this->setCalendar($this->aCalendar);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CalendarEventPeer::doInsert($this, $con);
					$this->setCalendarEventId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					CalendarEventPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collCalendarEventReminders !== null) {
				for ($i=0,$size=count($this->collCalendarEventReminders); $i < $size; $i++) {
					$this->collCalendarEventReminders[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return CalendarEventPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aCalendar !== null) {
				if (($retval = $this->aCalendar->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = CalendarEventPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collCalendarEventReminders !== null) {
				for ($i=0,$size=count($this->collCalendarEventReminders); $i < $size; $i++) {
					if (($retval = $this->collCalendarEventReminders[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed calendar_event_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setCalendarEventId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getCalendarEventId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return CalendarEvent Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new CalendarEvent();
		$copyObj->setCalendarId($this->calendar_id);
		$copyObj->setSubject($this->subject);
		$copyObj->setDescription($this->description);
		$copyObj->setFromDate($this->from_date);
		$copyObj->setToDate($this->to_date);
		$copyObj->setFromHour($this->from_hour);
		$copyObj->setToHour($this->to_hour);
		$copyObj->setOccurrence($this->occurrence);
		$copyObj->setOccurrenceTo($this->occurrence_to);
		$copyObj->setIsPublic($this->is_public);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getCalendarEventReminders() as $relObj) {
				$copyObj->addCalendarEventReminder($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setCalendarEventId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return CalendarEventPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CalendarEventPeer();
		}
		return self::$peer;
	}

}
