<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/calendar/lib/CalendarEvent.php';
// (on-demand) include_once 'plugins/calendar/lib/CalendarEventPeer.php';

include_once 'plugins/calendar/lib/CalendarEventReminderPeer.php';

/**
 * Base class that represents a row from the 'calendar_event_reminder' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CalendarEventReminder class. 
 * 
 * @package plugins.calendar.lib 
 */
abstract class BaseCalendarEventReminder extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CalendarEventReminderPeer
	 */
	protected static $peer;

	/**
	 * The value for the calendar_event_id field.
	 * @var int	  
	 */
	protected $calendar_event_id;	

	/**
	 * The value for the send_time field.
	 * @var int	  
	 */
	protected $send_time;	

	/**
	 * The value for the time_unit field.
	 * @var int	  
	 */
	protected $time_unit;	
  
	/**
	 * Get the CalendarEventId column value.
	 *  
	 * @return int	  
	 */
	public function getCalendarEventId()
	{
		return $this->calendar_event_id;
	}


	/**
	 * Set the value of `calendar_event_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCalendarEventId($v)
	{
		if ($this->calendar_event_id !== $v) {
			$this->calendar_event_id = $v;
			$this->modifiedColumns[] = CalendarEventReminderPeer::CALENDAR_EVENT_ID;
		}
			
		if ($this->aCalendarEvent !== null && $this->aCalendarEvent->getCalendarEventId() !== $v) {
			$this->aCalendarEvent = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `send_time` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getSendTime($format = 'Y-m-d H:i:s')
	{
		if ($this->send_time === null || $this->send_time === '') {
			return null;
		} elseif (!is_int($this->send_time)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->send_time);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of send_time as date/time value: " . var_export($this->send_time, true));
			}
		} else {
			$ts = $this->send_time;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `send_time` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setSendTime($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for send_time from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->send_time !== $ts || $ts === -1) {
			$this->send_time = $ts;
			$this->modifiedColumns[] = CalendarEventReminderPeer::SEND_TIME;
		}
		
	}

  
	/**
	 * Get the TimeUnit column value.
	 *  
	 * @return int	  
	 */
	public function getTimeUnit()
	{
		return $this->time_unit;
	}


	/**
	 * Set the value of `time_unit` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setTimeUnit($v)
	{
		if ($this->time_unit !== $v) {
			$this->time_unit = $v;
			$this->modifiedColumns[] = CalendarEventReminderPeer::TIME_UNIT;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->calendar_event_id = $rs->getInt($startcol + 0);					
			$this->send_time = $rs->getTimestamp($startcol + 1, null);
			$this->time_unit = $rs->getInt($startcol + 2);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating CalendarEventReminder object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(CalendarEventReminderPeer::DATABASE_NAME);
		$criteria->add(CalendarEventReminderPeer::CALENDAR_EVENT_ID, $this->calendar_event_id);
		$criteria->add(CalendarEventReminderPeer::TIME_UNIT, $this->time_unit);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(CalendarEventReminderPeer::DATABASE_NAME);
		if ($this->isColumnModified(CalendarEventReminderPeer::CALENDAR_EVENT_ID)) $criteria->add(CalendarEventReminderPeer::CALENDAR_EVENT_ID, $this->calendar_event_id);
		if ($this->isColumnModified(CalendarEventReminderPeer::SEND_TIME)) $criteria->add(CalendarEventReminderPeer::SEND_TIME, $this->send_time);
		if ($this->isColumnModified(CalendarEventReminderPeer::TIME_UNIT)) $criteria->add(CalendarEventReminderPeer::TIME_UNIT, $this->time_unit);
		return $criteria;			
	}
	
	

	/**
	 * @var CalendarEvent	  
	 */
	protected $aCalendarEvent;

	/**
	 * Declares an association between this object and a CalendarEvent object
	 *
	 * @param CalendarEvent $v
	 * @return void
	 * @throws PropelException
	 */
	public function setCalendarEvent($v)
	{
			
		if ($v === null) {
			$this->setCalendarEventId(NULL);
		} else {
			$this->setCalendarEventId($v->getCalendarEventId());
		}
   
		$this->aCalendarEvent = $v;
	}


	/**
	 * Get the associated CalendarEvent object
	 *
	 * @param Connection Optional Connection object.
	 * @return CalendarEvent The associated CalendarEvent object.
	 * @throws PropelException
	 */
	public function getCalendarEvent($con = null)
	{
		// include the Peer class
		include_once 'plugins/calendar/lib/CalendarEventPeer.php';

		if ($this->aCalendarEvent === null && ($this->calendar_event_id !== null)) {
	
			$this->aCalendarEvent = CalendarEventPeer::retrieveByPK($this->calendar_event_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = CalendarEventPeer::retrieveByPK($this->calendar_event_id, $con);
			   $obj->addCalendarEventReminders($this);
			 */
		}
		return $this->aCalendarEvent;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setCalendarEventKey($key)
	{

		$this->setCalendarEventId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("calendar_event_id", "send_time", "time_unit", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case CalendarEventReminderPeer::CALENDAR_EVENT_ID:
				return $this->getCalendarEventId();
				break;
		  
			case CalendarEventReminderPeer::SEND_TIME:
				return $this->getSendTime();
				break;
		  
			case CalendarEventReminderPeer::TIME_UNIT:
				return $this->getTimeUnit();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getCalendarEventId();
				break;
  
			case 1:
				return $this->getSendTime();
				break;
  
			case 2:
				return $this->getTimeUnit();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(CalendarEventReminderPeer::CALENDAR_EVENT_ID, $arr)) $this->setCalendarEventId($arr[CalendarEventReminderPeer::CALENDAR_EVENT_ID]);
  
		if (array_key_exists(CalendarEventReminderPeer::SEND_TIME, $arr)) $this->setSendTime($arr[CalendarEventReminderPeer::SEND_TIME]);
  
		if (array_key_exists(CalendarEventReminderPeer::TIME_UNIT, $arr)) $this->setTimeUnit($arr[CalendarEventReminderPeer::TIME_UNIT]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case CalendarEventReminderPeer::CALENDAR_EVENT_ID:
				$this->setCalendarEventId($value);
				break;
	  
			case CalendarEventReminderPeer::SEND_TIME:
				$this->setSendTime($value);
				break;
	  
			case CalendarEventReminderPeer::TIME_UNIT:
				$this->setTimeUnit($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setCalendarEventId($value);
				break;
  
			case 1:
				$this->setSendTime($value);
				break;
  
			case 2:
				$this->setTimeUnit($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(CalendarEventReminderPeer::DATABASE_NAME);

		try {
			$con->begin();
			CalendarEventReminderPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(CalendarEventReminderPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aCalendarEvent !== null) {
				if ($this->aCalendarEvent->isModified()) $this->aCalendarEvent->save($con);
				$this->setCalendarEvent($this->aCalendarEvent);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CalendarEventReminderPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					CalendarEventReminderPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return CalendarEventReminderPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aCalendarEvent !== null) {
				if (($retval = $this->aCalendarEvent->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = CalendarEventReminderPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setCalendarEventId($keys[0]);

		$this->setTimeUnit($keys[1]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getCalendarEventId();
		$this->pks[1] = $this->getTimeUnit();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return CalendarEventReminder Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new CalendarEventReminder();
		$copyObj->setSendTime($this->send_time);
		
		$copyObj->setNew(true);
		
		$copyObj->setCalendarEventId(NULL); // this is a pkey column, so set to default value
		$copyObj->setTimeUnit(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return CalendarEventReminderPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CalendarEventReminderPeer();
		}
		return self::$peer;
	}

}
