<?php
require_once('core/ProjectPeer.php');
require_once('lib/core/SettingPeer.php');

class SaveDiskUsageCronjob extends Cronjob {
    
    public function __construct() {
        $this->jobname = basename(__FILE__);
        parent::__construct();
    }
    
    public function run() {
        $c = new Criteria();
        $crtTpl = $c->getNewCriterion(ProjectPeer::IS_TEMPLATE, false);
        $c->add($crtTpl);
        $projectsArray = ProjectPeer::doSelect($c);
        foreach($projectsArray as $project) {
            $params = array(
                'project_id' => $project->getId(),
                'project_unix_name' => $project->getUnixName()
            );
            $prs = ActionManager::notify('GET_DISK_QUOTA_USAGE', $params);
            $project_usage = 0;
            foreach ($prs as $diskUsageResult) {
                $resArray = $diskUsageResult->getResult();
                //We can know the plugin name: $resArray['plugin_name']
                foreach ($resArray['usage'] as $section_name => $section_usage) {
                    $project_usage += $section_usage;
                }
            }
            //Last parameter instructs the method to update the timestamp.
            SettingPeer::SaveSetting('project', $params['project_id'], 'disk-used', $project_usage, $params['project_id'], true);
        }
    }
}

$cronjob = new SaveDiskUsageCronjob();
$cronjob->run();