<?php
require_once('exceptions/PermissionDeniedException.php');
require_once('lib/core/SettingPeer.php');
require_once('core/Language.php');

$lang = Language::getSessLang();

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
    throw new PermissionDeniedException();
}

//Store the quota in bytes:
$quotaValue = (float)$_POST['disk_quota'] * 1024 * 1024;

if ($quotaValue != GFConf::get('diskquota.projectMaxQuota')) {
    //Only store the quota value if it is different than the default quota:
    SettingPeer::SaveSetting('project', (int)$_POST['project_id'], 'project-quota', $quotaValue, (string)$_POST['project_id']);
    $feedback = $lang->getText('Diskquota.QuotaSaved');
} else {
    $setting = SettingPeer::findSetting('project', (int)$_POST['project_id'], 'project-quota');
    if (is_object($setting)) {
        $setting->delete();
    }
    $feedback = $lang->getText('Diskquota.DefaultUsed');
}

GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('ManageDiskQuota'), array('feedback' => $feedback));
