<?php
require_once('plugin/ActionManager.php');
require_once('core/ProjectPeer.php');
require_once('lib/core/SettingPeer.php');
require_once('core/Language.php');

$lang = Language::getSessLang();

$Project = ProjectPeer::retrieveByPk((int)$_GET['id']);
if (!is_object($Project)) {
    throw new PermissionDeniedException();
}
$params = array(
        'project_id' => $Project->getId(),
        'project_unix_name' => $Project->getUnixName()
    );
$prs = ActionManager::notify('GET_DISK_QUOTA_USAGE', $params);
$project_usage = 0;
foreach ($prs as $diskUsageResult) {
    $resArray = $diskUsageResult->getResult();
    //We can know the plugin name: $resArray['plugin_name']
    foreach ($resArray['usage'] as $section_name => $section_usage) {
        //Right now we only need the total usage, anyway we can know how much disk each section of the project is using
        //(Pie chart FTW!)
        $project_usage += $section_usage;
    }
}
//Last parameter instructs the method to update the timestamp.
SettingPeer::SaveSetting('project', $params['project_id'], 'disk-used', $project_usage, $params['project_id'], true);
if (isset($_GET['return_to_list']) && $_GET['return_to_list'] == '1') {
    $feedback = $lang->getText('Diskquota.DiskUsedSaved');
    GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('ManageDiskQuota'), array('feedback' => $feedback));
}
