<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/html/ProjectTemplate.php');
require_once('lib/plugin/PluginResult.php');

class DocmanTemplate extends ProjectTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array	array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab']='docman';
		$Lang = Session::getSession()->getLanguage();
		if (isset($params['title'])) {
			$params['title']=' '.$Lang->getText('Docman.TabString').' > '.$params['title'];
		} else {
			Throw new exception('Missing title in docman template');
		}
		
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','docman').'">'.$Lang->getText('Docman.TabString').'</a>');
		
		return parent::header($params);
	}

	/**
	 *      getPluginNavElements - this overrides parent class and adds its own
	 *      plugin listener
	 *      @return PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
		$tprs = ActionManager::Notify('GET_DOCMAN_NAV_ELEMENTS',null);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}

	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 */
	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		$ret = array();
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		if (!isset($params['project'])) {
			echo 'missing project param';
			return $ret;
		}
		$url = GFurl::getUrl();
		$lang = Session::getSession()->getLanguage();
		$user = Session::getSession()->getUser();
		$loggedin = Session::getSession()->isLoggedIn();
		$project = $params['project'];
		
		$elements = array(
				);
		
/*		if (isset($params['docman_file']) && is_object($params['docman_file'])) {
			if (!is_null($user)) {
				if ($file->userIsMonitoring($user)) {
					$elements[] = array('link' => $url->getMonitorUrl(DocmanFile::SECTION, $file->getPrimaryKey(), null, false),
						'description' => $lang->getText('DocmanFile.StopMonitor'), true);
				} else {
					$elements[] = array('link' => $url->getMonitorUrl(DocmanFile::SECTION, $file->getPrimaryKey(), null, true),
						'description' => $lang->getText('DocmanFile.Monitor'));
				}
			}
		}*/
		
		
		// Monitoring
		if (!is_null($user)) {
			if (isset($params['docman_file']) && is_object($params['docman_file'])) {
				// Docman file monitoring
				$file = $params['docman_file'];
				if ($file->userIsMonitoring($user)) {
					$elements[] = array(
						'link' => $url->getMonitorUrl(DocmanFile::SECTION, $file->getDocmanFileId(), $_SERVER['REQUEST_URI'], false),
						'description' => $lang->getText('DocmanFile.StopMonitoring'),
						true);
				} else {
					$elements[] = array(
						'link' => $url->getMonitorUrl(DocmanFile::SECTION, $file->getDocmanFileId(),  $_SERVER['REQUEST_URI'], true),
						'description' => $lang->getText('DocmanFile.Monitor'), true);
				}

				$elements[] = array('link' => GFUrl::getUrl()->projectURL($project,'UsersMonitoringBrowse','','usersmonitoring',array('section'=>'docmanfile','ref_id'=>$file->getDocmanFileId(),'description'=>$file->getDescription(),'type'=>'section','return_to'=>$_SERVER['REQUEST_URI'])),
					'description' => $lang->getText('Monitor.UsersMonitoringItem'));
			} 
				// Whole docman monitoring
				if (DocmanPlugin::userIsMonitoring($user, $project)) {
					$elements[] = array('link' => $url->getMonitorUrl(DocmanPlugin::SECTION, $project->getProjectId(), $url->currentUrl(), false),
						'description' => $lang->getText('Docman.StopMonitoring'), true);
				} else {
					$elements[] = array('link' => $url->getMonitorUrl(DocmanPlugin::SECTION, $project->getProjectId(), $url->currentUrl(), true),
						'description' => $lang->getText('Docman.Monitor'), true);
				}
		}

		if (!is_null($user)) {
			$elements[] = array('link' => GFUrl::getUrl()->projectURL($project,'UsersMonitoringBrowse','','usersmonitoring',array('section'=>'docman','ref_id'=>$project->getProjectId(),'description'=>'Docman','type'=>'plugin','return_to'=>$_SERVER['REQUEST_URI'])),
					'description' => $lang->getText('Monitor.UsersMonitoringPlugin'));
		}
		/*
		if ($loggedin) {
			if ($project->getPermission()->check('docman', 0, DocmanPlugin::ADMIN)) {
				$elements[] = array('link' => $url->projectURL($project,'','docman','admin', ''),
				'description' => $lang->getText('Tabs.Admin'));
			}			
				
		}		
		*/
		$ret[] = array(
			'title'=> $lang->getText('Docman.Docman'),
			'elements'=> $elements
			);
			

			
		return $ret;
	}
}

?>
