<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/docman/lib/DocmanFolder.php';
// (on-demand) include_once 'plugins/docman/lib/DocmanFolderPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/docman/lib/DocmanFilePeer.php';

/**
 * Base class that represents a row from the 'docman_file' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to DocmanFile class. 
 * 
 * @package plugins.docman.lib 
 */
abstract class BaseDocmanFile extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var DocmanFilePeer
	 */
	protected static $peer;

	/**
	 * The value for the docman_file_id field.
	 * @var int	  
	 */
	protected $docman_file_id;	

	/**
	 * The value for the docman_folder_id field.
	 * @var int	  
	 */
	protected $docman_folder_id;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	

	/**
	 * The value for the is_locked field.
	 * @var boolean	  
	 */
	protected $is_locked = true;	

	/**
	 * The value for the locked_by field.
	 * @var int	  
	 */
	protected $locked_by;	
  
	/**
	 * Get the DocmanFileId column value.
	 *  
	 * @return int	  
	 */
	public function getDocmanFileId()
	{
		return $this->docman_file_id;
	}


	/**
	 * Set the value of `docman_file_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setDocmanFileId($v)
	{
		if ($this->docman_file_id !== $v) {
			$this->docman_file_id = $v;
			$this->modifiedColumns[] = DocmanFilePeer::DOCMAN_FILE_ID;
		}
			
		  // update associated DocmanFileFolder		  
		  if ($this->collDocmanFileFolders !== null) {
			  for ($i=0,$size=count($this->collDocmanFileFolders); $i < $size; $i++) {
				  $this->collDocmanFileFolders[$i]->setDocmanFileId($v);
			  }
		  }
			  	
		  // update associated DocmanFileVersion		  
		  if ($this->collDocmanFileVersions !== null) {
			  for ($i=0,$size=count($this->collDocmanFileVersions); $i < $size; $i++) {
				  $this->collDocmanFileVersions[$i]->setDocmanFileId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the DocmanFolderId column value.
	 *  
	 * @return int	  
	 */
	public function getDocmanFolderId()
	{
		return $this->docman_folder_id;
	}


	/**
	 * Set the value of `docman_folder_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setDocmanFolderId($v)
	{
		if ($this->docman_folder_id !== $v) {
			$this->docman_folder_id = $v;
			$this->modifiedColumns[] = DocmanFilePeer::DOCMAN_FOLDER_ID;
		}
			
		if ($this->aDocmanFolder !== null && $this->aDocmanFolder->getDocmanFolderId() !== $v) {
			$this->aDocmanFolder = null;
		}
			
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = DocmanFilePeer::DESCRIPTION;
		}
				
	}

  
	/**
	 * Get the IsLocked column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsLocked()
	{
		return $this->is_locked;
	}


	/**
	 * Set the value of `is_locked` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsLocked($v)
	{
		if ($this->is_locked !== $v || $v === true) {
			$this->is_locked = $v;
			$this->modifiedColumns[] = DocmanFilePeer::IS_LOCKED;
		}
				
	}

  
	/**
	 * Get the LockedBy column value.
	 *  
	 * @return int	  
	 */
	public function getLockedBy()
	{
		return $this->locked_by;
	}


	/**
	 * Set the value of `locked_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setLockedBy($v)
	{
		if ($this->locked_by !== $v) {
			$this->locked_by = $v;
			$this->modifiedColumns[] = DocmanFilePeer::LOCKED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->docman_file_id = $rs->getInt($startcol + 0);					
			$this->docman_folder_id = $rs->getInt($startcol + 1);					
			$this->description = $rs->getString($startcol + 2);					
			$this->is_locked = $rs->getBoolean($startcol + 3);					
			$this->locked_by = $rs->getInt($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating DocmanFile object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(DocmanFilePeer::DATABASE_NAME);
		$criteria->add(DocmanFilePeer::DOCMAN_FILE_ID, $this->docman_file_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(DocmanFilePeer::DATABASE_NAME);
		if ($this->isColumnModified(DocmanFilePeer::DOCMAN_FILE_ID)) $criteria->add(DocmanFilePeer::DOCMAN_FILE_ID, $this->docman_file_id);
		if ($this->isColumnModified(DocmanFilePeer::DOCMAN_FOLDER_ID)) $criteria->add(DocmanFilePeer::DOCMAN_FOLDER_ID, $this->docman_folder_id);
		if ($this->isColumnModified(DocmanFilePeer::DESCRIPTION)) $criteria->add(DocmanFilePeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(DocmanFilePeer::IS_LOCKED)) $criteria->add(DocmanFilePeer::IS_LOCKED, $this->is_locked);
		if ($this->isColumnModified(DocmanFilePeer::LOCKED_BY)) $criteria->add(DocmanFilePeer::LOCKED_BY, $this->locked_by);
		return $criteria;			
	}
	
	

	/**
	 * @var DocmanFolder	  
	 */
	protected $aDocmanFolder;

	/**
	 * Declares an association between this object and a DocmanFolder object
	 *
	 * @param DocmanFolder $v
	 * @return void
	 * @throws PropelException
	 */
	public function setDocmanFolder($v)
	{
			
		if ($v === null) {
			$this->setDocmanFolderId(NULL);
		} else {
			$this->setDocmanFolderId($v->getDocmanFolderId());
		}
   
		$this->aDocmanFolder = $v;
	}


	/**
	 * Get the associated DocmanFolder object
	 *
	 * @param Connection Optional Connection object.
	 * @return DocmanFolder The associated DocmanFolder object.
	 * @throws PropelException
	 */
	public function getDocmanFolder($con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFolderPeer.php';

		if ($this->aDocmanFolder === null && ($this->docman_folder_id !== null)) {
	
			$this->aDocmanFolder = DocmanFolderPeer::retrieveByPK($this->docman_folder_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = DocmanFolderPeer::retrieveByPK($this->docman_folder_id, $con);
			   $obj->addDocmanFiles($this);
			 */
		}
		return $this->aDocmanFolder;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setDocmanFolderKey($key)
	{

		$this->setDocmanFolderId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setLockedBy(NULL);
		} else {
			$this->setLockedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->locked_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->locked_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->locked_by, $con);
			   $obj->addDocmanFiles($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setLockedBy( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collDocmanFileFolders	  
	 * @var array
	 */
	protected $collDocmanFileFolders; 

	/**
	 * Temporary storage of collDocmanFileFolders to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initDocmanFileFolders()
	{
		if ($this->collDocmanFileFolders === null) {
			$this->collDocmanFileFolders = array();
		}
	}

	/**
	 * Method called to associate a DocmanFileFolder object to this object
	 * through the DocmanFileFolder foreign key attribute
	 *
	 * @param DocmanFileFolder $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addDocmanFileFolder(DocmanFileFolder $l)
	{
		$this->collDocmanFileFolders[] = $l;
		$l->setDocmanFile($this);
	}

	/**
	 * The criteria used to select the current contents of collDocmanFileFolders.
	 * @var Criteria
	 */
	private $lastDocmanFileFoldersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this DocmanFile has previously
	 * been saved, it will retrieve related DocmanFileFolders from storage.
	 * If this DocmanFile is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getDocmanFileFolders($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileFolderPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collDocmanFileFolders === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileFolders = array();
			} else {
	
				$criteria->add(DocmanFileFolderPeer::DOCMAN_FILE_ID, $this->getDocmanFileId() );

				$this->collDocmanFileFolders = DocmanFileFolderPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(DocmanFileFolderPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());

				if (!isset($this->lastDocmanFileFoldersCriteria) || !$this->lastDocmanFileFoldersCriteria->equals($criteria)) {
					$this->collDocmanFileFolders = DocmanFileFolderPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDocmanFileFoldersCriteria = $criteria;

		return $this->collDocmanFileFolders;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this DocmanFile is new, it will return
	 * an empty collection; or if this DocmanFile has previously
	 * been saved, it will retrieve related DocmanFileFolders from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in DocmanFile.
	 */
	public function getDocmanFileFoldersJoinDocmanFolder($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileFolderPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanFileFolders === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileFolders = array();
			} else {
	   
				$criteria->add(DocmanFileFolderPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());
				$this->collDocmanFileFolders = DocmanFileFolderPeer::doSelectJoinDocmanFolder($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanFileFolderPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());
			if (!isset($this->lastDocmanFileFoldersCriteria) || !$this->lastDocmanFileFoldersCriteria->equals($criteria)) {
				$this->collDocmanFileFolders = DocmanFileFolderPeer::doSelectJoinDocmanFolder($criteria, $con);
			}
		}
		$this->lastDocmanFileFoldersCriteria = $criteria;

		return $this->collDocmanFileFolders;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this DocmanFile is new, it will return
	 * an empty collection; or if this DocmanFile has previously
	 * been saved, it will retrieve related DocmanFileFolders from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in DocmanFile.
	 */
	public function getDocmanFileFoldersJoinDocmanFile($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileFolderPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanFileFolders === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileFolders = array();
			} else {
	   
				$criteria->add(DocmanFileFolderPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());
				$this->collDocmanFileFolders = DocmanFileFolderPeer::doSelectJoinDocmanFile($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanFileFolderPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());
			if (!isset($this->lastDocmanFileFoldersCriteria) || !$this->lastDocmanFileFoldersCriteria->equals($criteria)) {
				$this->collDocmanFileFolders = DocmanFileFolderPeer::doSelectJoinDocmanFile($criteria, $con);
			}
		}
		$this->lastDocmanFileFoldersCriteria = $criteria;

		return $this->collDocmanFileFolders;
	}

	/**
	 * Collection to store aggregation of collDocmanFileVersions	  
	 * @var array
	 */
	protected $collDocmanFileVersions; 

	/**
	 * Temporary storage of collDocmanFileVersions to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initDocmanFileVersions()
	{
		if ($this->collDocmanFileVersions === null) {
			$this->collDocmanFileVersions = array();
		}
	}

	/**
	 * Method called to associate a DocmanFileVersion object to this object
	 * through the DocmanFileVersion foreign key attribute
	 *
	 * @param DocmanFileVersion $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addDocmanFileVersion(DocmanFileVersion $l)
	{
		$this->collDocmanFileVersions[] = $l;
		$l->setDocmanFile($this);
	}

	/**
	 * The criteria used to select the current contents of collDocmanFileVersions.
	 * @var Criteria
	 */
	private $lastDocmanFileVersionsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this DocmanFile has previously
	 * been saved, it will retrieve related DocmanFileVersions from storage.
	 * If this DocmanFile is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getDocmanFileVersions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collDocmanFileVersions === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileVersions = array();
			} else {
	
				$criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_ID, $this->getDocmanFileId() );

				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());

				if (!isset($this->lastDocmanFileVersionsCriteria) || !$this->lastDocmanFileVersionsCriteria->equals($criteria)) {
					$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastDocmanFileVersionsCriteria = $criteria;

		return $this->collDocmanFileVersions;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this DocmanFile is new, it will return
	 * an empty collection; or if this DocmanFile has previously
	 * been saved, it will retrieve related DocmanFileVersions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in DocmanFile.
	 */
	public function getDocmanFileVersionsJoinDocmanFile($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanFileVersions === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileVersions = array();
			} else {
	   
				$criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());
				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelectJoinDocmanFile($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());
			if (!isset($this->lastDocmanFileVersionsCriteria) || !$this->lastDocmanFileVersionsCriteria->equals($criteria)) {
				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelectJoinDocmanFile($criteria, $con);
			}
		}
		$this->lastDocmanFileVersionsCriteria = $criteria;

		return $this->collDocmanFileVersions;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this DocmanFile is new, it will return
	 * an empty collection; or if this DocmanFile has previously
	 * been saved, it will retrieve related DocmanFileVersions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in DocmanFile.
	 */
	public function getDocmanFileVersionsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFileVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collDocmanFileVersions === null) {
			if ($this->isNew()) {
			   $this->collDocmanFileVersions = array();
			} else {
	   
				$criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());
				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_ID, $this->getDocmanFileId());
			if (!isset($this->lastDocmanFileVersionsCriteria) || !$this->lastDocmanFileVersionsCriteria->equals($criteria)) {
				$this->collDocmanFileVersions = DocmanFileVersionPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastDocmanFileVersionsCriteria = $criteria;

		return $this->collDocmanFileVersions;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("docman_file_id", "docman_folder_id", "description", "is_locked", "locked_by", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case DocmanFilePeer::DOCMAN_FILE_ID:
				return $this->getDocmanFileId();
				break;
		  
			case DocmanFilePeer::DOCMAN_FOLDER_ID:
				return $this->getDocmanFolderId();
				break;
		  
			case DocmanFilePeer::DESCRIPTION:
				return $this->getDescription();
				break;
		  
			case DocmanFilePeer::IS_LOCKED:
				return $this->getIsLocked();
				break;
		  
			case DocmanFilePeer::LOCKED_BY:
				return $this->getLockedBy();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getDocmanFileId();
				break;
  
			case 1:
				return $this->getDocmanFolderId();
				break;
  
			case 2:
				return $this->getDescription();
				break;
  
			case 3:
				return $this->getIsLocked();
				break;
  
			case 4:
				return $this->getLockedBy();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(DocmanFilePeer::DOCMAN_FILE_ID, $arr)) $this->setDocmanFileId($arr[DocmanFilePeer::DOCMAN_FILE_ID]);
  
		if (array_key_exists(DocmanFilePeer::DOCMAN_FOLDER_ID, $arr)) $this->setDocmanFolderId($arr[DocmanFilePeer::DOCMAN_FOLDER_ID]);
  
		if (array_key_exists(DocmanFilePeer::DESCRIPTION, $arr)) $this->setDescription($arr[DocmanFilePeer::DESCRIPTION]);
  
		if (array_key_exists(DocmanFilePeer::IS_LOCKED, $arr)) $this->setIsLocked($arr[DocmanFilePeer::IS_LOCKED]);
  
		if (array_key_exists(DocmanFilePeer::LOCKED_BY, $arr)) $this->setLockedBy($arr[DocmanFilePeer::LOCKED_BY]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case DocmanFilePeer::DOCMAN_FILE_ID:
				$this->setDocmanFileId($value);
				break;
	  
			case DocmanFilePeer::DOCMAN_FOLDER_ID:
				$this->setDocmanFolderId($value);
				break;
	  
			case DocmanFilePeer::DESCRIPTION:
				$this->setDescription($value);
				break;
	  
			case DocmanFilePeer::IS_LOCKED:
				$this->setIsLocked($value);
				break;
	  
			case DocmanFilePeer::LOCKED_BY:
				$this->setLockedBy($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setDocmanFileId($value);
				break;
  
			case 1:
				$this->setDocmanFolderId($value);
				break;
  
			case 2:
				$this->setDescription($value);
				break;
  
			case 3:
				$this->setIsLocked($value);
				break;
  
			case 4:
				$this->setLockedBy($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(DocmanFilePeer::DATABASE_NAME);

		try {
			$con->begin();
			DocmanFilePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(DocmanFilePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aDocmanFolder !== null) {
				if ($this->aDocmanFolder->isModified()) $this->aDocmanFolder->save($con);
				$this->setDocmanFolder($this->aDocmanFolder);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = DocmanFilePeer::doInsert($this, $con);
					$this->setDocmanFileId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					DocmanFilePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collDocmanFileFolders !== null) {
				for ($i=0,$size=count($this->collDocmanFileFolders); $i < $size; $i++) {
					$this->collDocmanFileFolders[$i]->save($con);
				}
			  }
			if ($this->collDocmanFileVersions !== null) {
				for ($i=0,$size=count($this->collDocmanFileVersions); $i < $size; $i++) {
					$this->collDocmanFileVersions[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return DocmanFilePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aDocmanFolder !== null) {
				if (($retval = $this->aDocmanFolder->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = DocmanFilePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collDocmanFileFolders !== null) {
				for ($i=0,$size=count($this->collDocmanFileFolders); $i < $size; $i++) {
					if (($retval = $this->collDocmanFileFolders[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collDocmanFileVersions !== null) {
				for ($i=0,$size=count($this->collDocmanFileVersions); $i < $size; $i++) {
					if (($retval = $this->collDocmanFileVersions[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed docman_file_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setDocmanFileId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getDocmanFileId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return DocmanFile Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new DocmanFile();
		$copyObj->setDocmanFolderId($this->docman_folder_id);
		$copyObj->setDescription($this->description);
		$copyObj->setIsLocked($this->is_locked);
		$copyObj->setLockedBy($this->locked_by);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getDocmanFileFolders() as $relObj) {
				$copyObj->addDocmanFileFolder($relObj->copy());
			}

			foreach($this->getDocmanFileVersions() as $relObj) {
				$copyObj->addDocmanFileVersion($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setDocmanFileId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return DocmanFilePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new DocmanFilePeer();
		}
		return self::$peer;
	}

}
