<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFileVersionPeer.php');
require_once('lib/core/FilesystemPeer.php');
require_once('exceptions/PermissionDeniedException.php');
//require_once('plugins/docman/lib/InfoParser.php');
require_once('plugins/docman/lib/DocmanTreeRenderer.php');
require_once('external/Browser.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$project=GFUrl::getUrl()->getProject();

require_once('plugins/docman/lib/html/DocmanTemplate.php');
$theme = new DocmanTemplate();

$id = Validator::sanitizeInt($_REQUEST['file_id']);
$file_name = Validator::sanitizeString($_REQUEST['file_name']);

$file = DocmanFilePeer::retrieveByPK($id);
if (!is_object($file) || $file->getDocmanFolder()->getProjectId() != $project->getProjectId()) {
	throw new PermissionDeniedException();
}

$subdir = $file->getDocmanFolderId();

$params = array(
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'title' => $Lang->getText('Docman.EditPageTitle'),
	'project' => $project,
	'docman_file' => $file
			);

$folder_id = ( isset($_POST['folder_id']) ? htmlspecialchars($_POST['folder_id']) : $file->getDocmanFolderId() );
$description = ( isset($_POST['description']) ? htmlspecialchars($_POST['description']) : $file->getDescription() );
$is_locked = ( isset($_POST['is_locked']) ? $_POST['is_locked'] : $file->getIsLocked() );
$changes = ( isset($_POST['changes']) ? htmlspecialchars($_POST['changes']) : '' );

//Determine browser version
$browser = new Browser();
$browser_name = strtolower($browser->getBrowser());
$browser_version = floatval($browser->getVersion());

//Verify if drag and drop is enabled
$can_drag_drop = false;

//Determine if it's an HTML5 compliant browser and allow drag'n drop
if (($browser_name == 'firefox' && $browser_version >= 4) || ($browser_name == 'chrome')) {
	$can_drag_drop = true;
}

include('forms/DocmanFileDetails-tpl.php');
?>
