<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//
// This code lists Docman
//
require_once('plugins/docman/lib/html/DocmanTemplate.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('plugins/docman/lib/DocmanTreeRenderer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFileFolder.php');
require_once('plugins/docman/lib/DocmanFileFolderPeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('html/ProjectTemplate.php');
require_once('plugins/docman/lib/FastJSON.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$template = new ProjectTemplate();

$theme = new DocmanTemplate();
$project = GFUrl::getUrl()->getProject();

if (!$project->isPublic() && !$session->isLoggedIn()) {
	header('HTTP/1.1 401');
	exit;
}

$file_id = isset($_REQUEST['file_id']) ? $_REQUEST['file_id'] : 0;

//Get folder ids for which this file belongs to
$c = new Criteria();
$c->add(DocmanFileFolderPeer::DOCMAN_FILE_ID, $file_id);
$file_folders = DocmanFileFolderPeer::doSelect($c);

$arr_folder_ids = array();
foreach ($file_folders as $file_folder) {
	$arr_folder_ids[] = $file_folder->getDocmanFolderId();
}

$parser = new InfoParser($project);
$nested_folders = $parser->getNestedFolders();

$folders = $nested_folders;
$docmanRenderer = new DocmanTreeCheckboxRender($nested_folders, $parser, $arr_folder_ids, $file_id);
$str_tree = $docmanRenderer->renderTree();

$status = '200';
header('HTTP/1.1 ' . $status);
echo $str_tree;
?>