<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

$Lang = Language::getSessLang();
$status = '';

if (!$session->isLoggedIn()) {
	header('HTTP/1.1 401');
}

$url = ''; 
if (isset($_GET['file_id'])) {
	$file = DocmanFilePeer::retrieveByPk($_GET['file_id']);

	if (is_object($file)) {
		$latestfile = $file->getLatestVersion()->getFile();
		$file_id = $latestfile->getFilesystemId();
		$file_versions = $file->getDocmanFileVersions();	
		$file_version = $file_versions[sizeof($file_versions)-1];

		if (is_object($latestfile)) {		
			$url = GFUrl::getURL()->getFullURL(GFUrl::getURL()->downloadURL(DocmanFileVersion::SECTION,$file_version->getDocmanFileVersionId(),$latestfile->getFilesystemId(),$latestfile->getFileNameSafe()));
			$status = '200';
		} else {
			$status = '401';
		}

	} else {
		$status = '401';

	}
} else {
	$status = '201';

}

$arr_return['url'] = $url;
header('HTTP/1.1 ' . $status);
echo FastJSON::encode($arr_return);
?>