<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Prez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/FastJSON.php');
require_once('external/fckeditor/fckeditor.php');

$project=GFUrl::getUrl()->getProject();
$df = DocmanFilePeer::retrieveByPk($_POST['id']);
if (!is_object($df) 
	|| $df->getDocmanFolder()->getProjectId() != $project->getProjectId() 
	|| !$df->userCanCreate()) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied 1";
	echo FastJSON::encode($arr_feedback);
	exit;
}

try {
	$latestfile=$df->getLatestVersion()->getFile();
	$file_id = $latestfile->getFilesystemId();
	$file_name = $latestfile->getFilename();
	$file_type = $latestfile->getFileType();

	header('HTTP/1.1 200');
	$file_content = $latestfile->getFileData();
	$arr_feedback = array();
	$arr_feedback["file_content"] = $latestfile->getFileData();
	$arr_feedback["description"] = $df->getDescription();
	$arr_feedback["changes"] = $df->getLatestVersion()->getChanges();
	echo FastJSON::encode($arr_feedback);
	exit;
} catch (InvalidDataException $ex) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied 2";
	echo FastJSON::encode($arr_feedback);
	exit;
}
?>
