<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

$Lang = Language::getSessLang();
$status = '';

if (!$session->isLoggedIn()) {
	header('HTTP/1.1 401');
}
 
$str_json = '';
if (isset($_GET['file_id'])) {
	$file_id = Validator::sanitizeInt($_GET['file_id']);
	
	$c = new Criteria();
	$c->add(MonitorPeer::SECTION, 'docmanfile');
	$c->add(MonitorPeer::REF_ID, $file_id);
	$monitors = MonitorPeer::doSelect($c);
	
	$arr_monitors = array();
	$i=0;
	foreach($monitors as $monitor) {
		$user_id = $monitor->getUserId();
		$user = UserPeer::retrieveByPk($user_id);
		
		if (is_object($user)) {
			$arr_monitors[$i]['user_id'] = $user_id;
			$arr_monitors[$i]['username'] = $user->getFullname();
			$arr_monitors[$i]['unixname'] = $user->getUnixName();
		}
		$i=0;	
	}
	
	$str_json = FastJSON::encode($arr_monitors);
	$status = 200;
		
} else {
	$status = '401';
}

header('HTTP/1.1 ' . $status);
echo $str_json;
?>