<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

$file_id = isset($_GET['file_id']) ? intval($_GET['file_id']) : 0;

if ($file_id != 0) {
	$folder = DocmanFolderPeer::retrieveByPk($file_id);
	
	$con = Propel::getConnection(UserPeer::DATABASE_NAME);
	
	$sql = "SELECT max(fd.download_date) as max_download_date, u.unix_name as unix_name, u.firstname, u.lastname
			  FROM filesystem_download fd, filesystem fs, docman_file_version dfv, \"user\" u
				WHERE
				fd.filesystem_id = fs.filesystem_id
				AND
				fd.user_id = u.user_id
				AND
				fs.section = 'docmanfileversion'
				AND
				fs.ref_id = dfv.docman_file_version_id
				AND
				dfv.docman_file_id = " . $file_id . "
				GROUP BY u.unix_name, u.firstname, u.lastname
				ORDER BY max_download_date DESC";

	$stmt = $con->createStatement();
	$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

	$arr_download_data = array();
	
	while ($rs->next()) {
		$arr_download_item = array();
		$arr_download_item['download_date'] = date('d-m-Y h:i:s a', strtotime($rs->getString('max_download_date')));
		$arr_download_item['unix_name'] = $rs->getString('unix_name');
		$arr_download_item['firstname'] = $rs->getString('firstname');
		$arr_download_item['lastname'] = $rs->getString('lastname');
		
		$arr_download_data[] = $arr_download_item;
	}	
			
	header('HTTP/1.1 200');
	echo FastJSON::encode($arr_download_data);

} else {
	header('HTTP/1.1 401');
}
?>