<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//
// This code lists Docman
//
require_once('plugins/docman/lib/html/DocmanTemplate.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('plugins/docman/lib/DocmanTreeRenderer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFileFolder.php');
require_once('plugins/docman/lib/DocmanFileFolderPeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('html/ProjectTemplate.php');
require_once('plugins/docman/lib/FastJSON.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$template = new ProjectTemplate();

$theme = new DocmanTemplate();
$project = GFUrl::getUrl()->getProject();

if (!$project->isPublic() && !$session->isLoggedIn()) {
	header('HTTP/1.1 401');
	exit;
}

$words = isset($_REQUEST['words']) ? $_REQUEST['words'] : '';
$search_contents_only = isset($_REQUEST['search_contents_only']) ? $_REQUEST['search_contents_only'] : 'false';

if ($search_contents_only == 'true') {
	$search_contents_only = true;
} else {
	$search_contents_only = false;
}
	

if ($words != '') {
	$search_params['project'] = $project;
	$search_params['template'] = new ProjectTemplate();
	$search_params['search']= array('docman');
	$search_params['words'] = $words;
	$search_params['startdate'] = '';
	$search_params['enddate'] = '';
	$search_params['search_attach'] = true;
	$search_params['search_contents_only'] = $search_contents_only;

	$searchAction  = 'DO_SEARCH';
	$searcher = new GFSearch($search_params);
	$docmanPlugin = new DocmanPlugin();
		
	$search_results = $docmanPlugin->search($searcher);	
		
	$file_ids = $search_results['files'];
}


$docmanRenderer = new DocmanFolderSearchRenderer($file_ids);
$arr_data = $docmanRenderer->renderSearchResults();

$status = '200';
header('HTTP/1.1 ' . $status);
echo FastJSON::encode($arr_data);
?> 