<?php

/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/Filesystem.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFileVersion.php');
require_once('plugins/docman/lib/DocmanFileVersionPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('Validator.php');
require_once('plugins/docman/lib/FastJSON.php');

$project = GFUrl::getUrl()->getProject();

if (!Session::getSession()->isLoggedIn()) {
	header('HTTP/1.1 401');
	exit;
}

$docman_file_version_id = isset($_REQUEST['file_id']) ?  intval($_REQUEST['file_id']) : 0;
$DocmanFileVersion = DocmanFileVersionPeer::retrieveByPk($docman_file_version_id);

if (!is_object($DocmanFileVersion)
	|| $DocmanFileVersion->getDocmanFile()->getDocmanFolder()->getProjectId() != $project->getProjectId()
	|| !$DocmanFileVersion->userCanUpdate()) {
	header('HTTP/1.1 401');
	exit;
}

try {
	$DocmanFileVersion->setIsApproved(true);
	$DocmanFileVersion->save();
	header('HTTP/1.1 200');
	exit;
} catch (Exception $e) {
	header('HTTP/1.1 401');
	exit;
}

?>
