<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a DocmanFolder and saves it to the 
// database
//
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/docman/lib/FastJSON.php');

if ($_SERVER['REQUEST_METHOD'] != 'GET') {
	throw new PermissionDeniedException();
}

$project = GFUrl::getUrl()->getProject();
$folder_id = $_GET['folder_id'];
$DocmanFolder = DocmanFolderPeer::retrieveByPk($folder_id);
if (!is_object($DocmanFolder) || !$DocmanFolder->userCanUpdate()) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}
if ($DocmanFolder->getProject()->getProjectId() != $project->getProjectId()) {
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "Permission denied";
	echo FastJSON::encode($arr_feedback);
	exit;
}

$Lang = Language::getSessLang();

$is_public = isset($_GET['is_public']) ? true : false;

try {
	$DocmanFolder->setFolderName( Validator::sanitizeString($_GET['folder_name']) );
	$DocmanFolder->setIsPublic( Validator::sanitizeBool($is_public) );
	//The folder_parent_id select in form does not exclude the current folder, so a check is needed
	/*
	if($_GET['folder_parent_id'] != $DocmanFolder->getId()){
		$DocmanFolder->setParentFolderId(Validator::sanitizeInt($_POST['folder_parent_id']));
	}
	*/
	$DocmanFolder->save();

	header('HTTP/1.1 200');
	$arr_feedback = array();
	$arr_feedback["error_message"] = "";
	echo FastJSON::encode($arr_feedback);

} catch (InvalidDataException $ex) {
	$errors=$ex->getErrors();
	$feedback = implode('<br />', $errors);
	
	header('HTTP/1.1 401');
	$arr_feedback = array();
	$arr_feedback["error_message"] = $feedback;
	echo FastJSON::encode($arr_feedback);
	
}

?>
