<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 * @date 2006-03-08
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('lib/core/Filesystem.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/html/association.php');
require_once('lib/html/TagsRenderer.php');
require_once('plugins/docman/lib/DocmanProjectSettingPeer.php');

if ($file->userCanUpdate()) {
	$url_edit_desc = '&nbsp;<a href="javascript:;" onclick="docmanFile.editFileDescription(' .  $file->getDocmanFileId() . ');">(Edit)</a>';
} else {
	$url_edit_desc = '';
}

?>
<div id="view_files">
	<div>
		<p style="margin-top: 10px"><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;[#<?php echo $id ;?>] <?php echo $file->getLatestVersion()->getFile()->getFileName(); ?></p></td>
	</div>
	<br>
	<div>
		<strong><p><?php echo $Lang->getText('Docman.Locked'); ?>:</strong><br /><?php echo (( $is_locked ) ? '&nbsp;<img alt="(locked)" src="/images/locked.png">' : '('.$Lang->getText('Docman.Unlocked').')' );?></p>
	</div>
	<br>
	<div>
			<p><strong><?php echo $Lang->getText('Docman.DescriptionName'); ?>:</strong><?php echo $url_edit_desc; ?>
			<?php echo $description; ?>
			</p>
	</div>
	<br>
	<br>
<?php

/*
	Get the versions of docs
*/
$rs = DocmanFilePeer::doSelectDocumentVersionsRS($id);

$theader = array();
//$theader[]= $Lang->getText('Docman.Navigation');
$theader[] = $Lang->getText('Docman.FileName');
$theader[] = '';
$theader[] = '';
$theader[] = $Lang->getText('Docman.Version');
$theader[] = $Lang->getText('Docman.ChangesName');
$theader[] = $Lang->getText('Docman.DateName');
$theader[] = $Lang->getText('Docman.Author');

$association_count = AssociationPeer::getAssociationCount(DocmanFile::SECTION, $file->getDocmanFileId());
?>
<script>
	$(function() {
		$( "#tabs" ).tabs();
	});
</script>
<div id="tabs">

<ul>
	<li><a href="#tabs-1"><?php echo $Lang->getText('Docman.Versions').'&nbsp('.$rs->getRecordCount().')'; ?></a></li>
	<li><a href="#tabs-2"><?php echo $Lang->getText('Associations').'&nbsp('.$association_count.')'; ?></a></li>
</ul>

<div id="tabs-1" title="<?php echo $Lang->getText('Docman.Versions'); ?>">
<?php
echo $theme->tableTop($theader);
$count=0;
while ($rs->next()) {
	$c = new Criteria();
	$c->add(FilesystemPeer::REF_ID, $rs->getInt('docman_file_version_id'));
	$c->add(FilesystemPeer::SECTION, 'docmanfileversion');
	$filesystem = FilesystemPeer::doSelectOne($c);
	
	$url = GFUrl::downloadURLFromFS($filesystem, false);
	$url_open_file =  GFUrl::openURLFromFS($filesystem);
	$open_document_class = 'other';

	$trow = array();
	$mods=array();	
	$trow[] = '<a class="' . $open_document_class . '" href="' . $url . '" title="' . $filesystem->getFileName() . '"><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;'.$rs->getString('file_name_safe'). '</a>';	
	$trow[] = ($url_open_file != '') ? '<a href="' . $url_open_file . '" target="_blank">view</a>' : '-';	
	if ($file->userCanUpdate()) {
		$url_delete = '<a href="javascript:;" onclick="docmanFile.deleteFileVersion(' . $rs->getInt('docman_file_id') . ',' . $rs->getInt('docman_file_version_id') . ')">' . $Lang->getText('DocmanFileVersion.Delete') . '</a>';
	} else {
		$url_delete = '';
	}
	$trow[] = $url_delete;
	$trow[] = $rs->getInt('version_number');
	if ($file->userCanUpdate()) {
		$url_edit = '&nbsp;<a href="javascript:;" onclick="docmanFile.editVersionChanges(' .  $file->getDocmanFileId() . ',\'' . $file_name . '\', ' . $rs->getInt('docman_file_version_id') . ', ' . $rs->getInt('version_number') . ',\'' . $rs->getDate('create_date') . '\',\'' . $rs->getString('changes') . '\');">(Edit)</a>';
	} else {
		$url_edit = '';
	}
	$trow[] = $rs->getString('changes') . $url_edit;
	$trow[] = date('d-m-Y h:i:s a', strtotime($rs->getString('create_date')));
	$trow[] = UserPeer::retrieveByPk($rs->getInt('created_by'))->getUserLink();
	echo $theme->tableRow($trow, $mods, true);
	$count++;
}

if ($is_locked) {
	$button_enabled = false;
} else {
	$setting = DocmanProjectSettingPeer::retrieveByPk($file->getDocmanFolder()->getProject()->getProjectId());	
	if (!$setting) {
		$allow_unprivileged_upload = false;
	} else {
		$allow_unprivileged_upload = $setting->getAllowUnprivilegedUpload();
	}

	if ($file->userCanUpdate() || $allow_unprivileged_upload) {
		$button_enabled = true;
	} else {
		$button_enabled = false;
	}
}	
echo $theme->tableBottom(array("showUpload()" => Language::getSessText('Docman.AddVersionPageTitle')), array(true),"", true);


if ($can_drag_drop) {
	$str_hint = $Lang->getText('Docman.DragDropNewVersionSupported');
} else {
	$str_hint = $Lang->getText('Docman.DragDropNewVersionNotSupported');
}
$str_hint .= $Lang->getText('Docman.Rightclick');
?>
<br />
<div class="infobox" style="margin-left: 0px;"><?php echo $str_hint; ?></div>
</div>
<?php
$settings = DocmanProjectSettingPeer::retrieveByPk(GFUrl::getUrl()->getProject()->getProjectId());
if(!$settings || $settings->getShowAssociationsTab()) { ?>
<div id="tabs-2" title="<?php echo $Lang->getText('Associations') ?>">
<?php
	echo renderAssociationList(DocmanFile::SECTION,$file->getDocmanFileId(),$file->userCanUpdate(),$theme,$project,true, "docmanFile.addAssociation(" . $id . "  , '" . $file_name . "')");
?>
</div>
<?php

}
?>
</div>
