<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/forum/lib/ForumThread.php';
// (on-demand) include_once 'plugins/forum/lib/ForumThreadPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/forum/lib/ForumMessagePeer.php';

/**
 * Base class that represents a row from the 'forum_message' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ForumMessage class. 
 * 
 * @package plugins.forum.lib 
 */
abstract class BaseForumMessage extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ForumMessagePeer
	 */
	protected static $peer;

	/**
	 * The value for the forum_message_id field.
	 * @var int	  
	 */
	protected $forum_message_id;	

	/**
	 * The value for the forum_thread_id field.
	 * @var int	  
	 */
	protected $forum_thread_id;	

	/**
	 * The value for the created_by field.
	 * @var int	  
	 */
	protected $created_by;	

	/**
	 * The value for the subject field.
	 * @var string	  
	 */
	protected $subject;	

	/**
	 * The value for the body field.
	 * @var string	  
	 */
	protected $body;	

	/**
	 * The value for the post_date field.
	 * @var int	  
	 */
	protected $post_date = -1;	

	/**
	 * The value for the parent_forum_message_id field.
	 * @var int	  
	 */
	protected $parent_forum_message_id = 0;	

	/**
	 * The value for the mail_msg_id field.
	 * @var string	  
	 */
	protected $mail_msg_id;	

	/**
	 * The value for the mail_sender field.
	 * @var string	  
	 */
	protected $mail_sender;	

	/**
	 * The value for the is_approved field.
	 * @var boolean	  
	 */
	protected $is_approved = true;	
  
	/**
	 * Get the ForumMessageId column value.
	 *  
	 * @return int	  
	 */
	public function getForumMessageId()
	{
		return $this->forum_message_id;
	}


	/**
	 * Set the value of `forum_message_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setForumMessageId($v)
	{
		if ($this->forum_message_id !== $v) {
			$this->forum_message_id = $v;
			$this->modifiedColumns[] = ForumMessagePeer::FORUM_MESSAGE_ID;
		}
				
	}

  
	/**
	 * Get the ForumThreadId column value.
	 *  
	 * @return int	  
	 */
	public function getForumThreadId()
	{
		return $this->forum_thread_id;
	}


	/**
	 * Set the value of `forum_thread_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setForumThreadId($v)
	{
		if ($this->forum_thread_id !== $v) {
			$this->forum_thread_id = $v;
			$this->modifiedColumns[] = ForumMessagePeer::FORUM_THREAD_ID;
		}
			
		if ($this->aForumThread !== null && $this->aForumThread->getForumThreadId() !== $v) {
			$this->aForumThread = null;
		}
			
	}

  
	/**
	 * Get the CreatedBy column value.
	 *  
	 * @return int	  
	 */
	public function getCreatedBy()
	{
		return $this->created_by;
	}


	/**
	 * Set the value of `created_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCreatedBy($v)
	{
		if ($this->created_by !== $v) {
			$this->created_by = $v;
			$this->modifiedColumns[] = ForumMessagePeer::CREATED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the Subject column value.
	 *  
	 * @return string	  
	 */
	public function getSubject()
	{
		return $this->subject;
	}


	/**
	 * Set the value of `subject` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSubject($v)
	{
		if ($this->subject !== $v) {
			$this->subject = $v;
			$this->modifiedColumns[] = ForumMessagePeer::SUBJECT;
		}
				
	}

  
	/**
	 * Get the Body column value.
	 *  
	 * @return string	  
	 */
	public function getBody()
	{
		return $this->body;
	}


	/**
	 * Set the value of `body` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setBody($v)
	{
		if ($this->body !== $v) {
			$this->body = $v;
			$this->modifiedColumns[] = ForumMessagePeer::BODY;
		}
				
	}


	/**
	 * Get the [optionally formatted] `post_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getPostDate($format = 'Y-m-d H:i:s')
	{
		if ($this->post_date === null || $this->post_date === '') {
			return null;
		} elseif (!is_int($this->post_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->post_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of post_date as date/time value: " . var_export($this->post_date, true));
			}
		} else {
			$ts = $this->post_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `post_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setPostDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for post_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->post_date !== $ts || $ts === -1) {
			$this->post_date = $ts;
			$this->modifiedColumns[] = ForumMessagePeer::POST_DATE;
		}
		
	}

  
	/**
	 * Get the ParentForumMessageId column value.
	 *  
	 * @return int	  
	 */
	public function getParentForumMessageId()
	{
		return $this->parent_forum_message_id;
	}


	/**
	 * Set the value of `parent_forum_message_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setParentForumMessageId($v)
	{
		if ($this->parent_forum_message_id !== $v || $v === 0) {
			$this->parent_forum_message_id = $v;
			$this->modifiedColumns[] = ForumMessagePeer::PARENT_FORUM_MESSAGE_ID;
		}
				
	}

  
	/**
	 * Get the MailMsgId column value.
	 *  
	 * @return string	  
	 */
	public function getMailMsgId()
	{
		return $this->mail_msg_id;
	}


	/**
	 * Set the value of `mail_msg_id` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setMailMsgId($v)
	{
		if ($this->mail_msg_id !== $v) {
			$this->mail_msg_id = $v;
			$this->modifiedColumns[] = ForumMessagePeer::MAIL_MSG_ID;
		}
				
	}

  
	/**
	 * Get the MailSender column value.
	 *  
	 * @return string	  
	 */
	public function getMailSender()
	{
		return $this->mail_sender;
	}


	/**
	 * Set the value of `mail_sender` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setMailSender($v)
	{
		if ($this->mail_sender !== $v) {
			$this->mail_sender = $v;
			$this->modifiedColumns[] = ForumMessagePeer::MAIL_SENDER;
		}
				
	}

  
	/**
	 * Get the IsApproved column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsApproved()
	{
		return $this->is_approved;
	}


	/**
	 * Set the value of `is_approved` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsApproved($v)
	{
		if ($this->is_approved !== $v || $v === true) {
			$this->is_approved = $v;
			$this->modifiedColumns[] = ForumMessagePeer::IS_APPROVED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->forum_message_id = $rs->getInt($startcol + 0);					
			$this->forum_thread_id = $rs->getInt($startcol + 1);					
			$this->created_by = $rs->getInt($startcol + 2);					
			$this->subject = $rs->getString($startcol + 3);					
			$this->body = $rs->getString($startcol + 4);					
			$this->post_date = $rs->getTimestamp($startcol + 5, null);
			$this->parent_forum_message_id = $rs->getInt($startcol + 6);					
			$this->mail_msg_id = $rs->getString($startcol + 7);					
			$this->mail_sender = $rs->getString($startcol + 8);					
			$this->is_approved = $rs->getBoolean($startcol + 9);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ForumMessage object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ForumMessagePeer::DATABASE_NAME);
		$criteria->add(ForumMessagePeer::FORUM_MESSAGE_ID, $this->forum_message_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ForumMessagePeer::DATABASE_NAME);
		if ($this->isColumnModified(ForumMessagePeer::FORUM_MESSAGE_ID)) $criteria->add(ForumMessagePeer::FORUM_MESSAGE_ID, $this->forum_message_id);
		if ($this->isColumnModified(ForumMessagePeer::FORUM_THREAD_ID)) $criteria->add(ForumMessagePeer::FORUM_THREAD_ID, $this->forum_thread_id);
		if ($this->isColumnModified(ForumMessagePeer::CREATED_BY)) $criteria->add(ForumMessagePeer::CREATED_BY, $this->created_by);
		if ($this->isColumnModified(ForumMessagePeer::SUBJECT)) $criteria->add(ForumMessagePeer::SUBJECT, $this->subject);
		if ($this->isColumnModified(ForumMessagePeer::BODY)) $criteria->add(ForumMessagePeer::BODY, $this->body);
		if ($this->isColumnModified(ForumMessagePeer::POST_DATE)) $criteria->add(ForumMessagePeer::POST_DATE, $this->post_date);
		if ($this->isColumnModified(ForumMessagePeer::PARENT_FORUM_MESSAGE_ID)) $criteria->add(ForumMessagePeer::PARENT_FORUM_MESSAGE_ID, $this->parent_forum_message_id);
		if ($this->isColumnModified(ForumMessagePeer::MAIL_MSG_ID)) $criteria->add(ForumMessagePeer::MAIL_MSG_ID, $this->mail_msg_id);
		if ($this->isColumnModified(ForumMessagePeer::MAIL_SENDER)) $criteria->add(ForumMessagePeer::MAIL_SENDER, $this->mail_sender);
		if ($this->isColumnModified(ForumMessagePeer::IS_APPROVED)) $criteria->add(ForumMessagePeer::IS_APPROVED, $this->is_approved);
		return $criteria;			
	}
	
	

	/**
	 * @var ForumThread	  
	 */
	protected $aForumThread;

	/**
	 * Declares an association between this object and a ForumThread object
	 *
	 * @param ForumThread $v
	 * @return void
	 * @throws PropelException
	 */
	public function setForumThread($v)
	{
			
		if ($v === null) {
			$this->setForumThreadId(NULL);
		} else {
			$this->setForumThreadId($v->getForumThreadId());
		}
   
		$this->aForumThread = $v;
	}


	/**
	 * Get the associated ForumThread object
	 *
	 * @param Connection Optional Connection object.
	 * @return ForumThread The associated ForumThread object.
	 * @throws PropelException
	 */
	public function getForumThread($con = null)
	{
		// include the Peer class
		include_once 'plugins/forum/lib/ForumThreadPeer.php';

		if ($this->aForumThread === null && ($this->forum_thread_id !== null)) {
	
			$this->aForumThread = ForumThreadPeer::retrieveByPK($this->forum_thread_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ForumThreadPeer::retrieveByPK($this->forum_thread_id, $con);
			   $obj->addForumMessages($this);
			 */
		}
		return $this->aForumThread;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setForumThreadKey($key)
	{

		$this->setForumThreadId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setCreatedBy(NULL);
		} else {
			$this->setCreatedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->created_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->created_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->created_by, $con);
			   $obj->addForumMessages($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setCreatedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("forum_message_id", "forum_thread_id", "created_by", "subject", "body", "post_date", "parent_forum_message_id", "mail_msg_id", "mail_sender", "is_approved", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ForumMessagePeer::FORUM_MESSAGE_ID:
				return $this->getForumMessageId();
				break;
		  
			case ForumMessagePeer::FORUM_THREAD_ID:
				return $this->getForumThreadId();
				break;
		  
			case ForumMessagePeer::CREATED_BY:
				return $this->getCreatedBy();
				break;
		  
			case ForumMessagePeer::SUBJECT:
				return $this->getSubject();
				break;
		  
			case ForumMessagePeer::BODY:
				return $this->getBody();
				break;
		  
			case ForumMessagePeer::POST_DATE:
				return $this->getPostDate();
				break;
		  
			case ForumMessagePeer::PARENT_FORUM_MESSAGE_ID:
				return $this->getParentForumMessageId();
				break;
		  
			case ForumMessagePeer::MAIL_MSG_ID:
				return $this->getMailMsgId();
				break;
		  
			case ForumMessagePeer::MAIL_SENDER:
				return $this->getMailSender();
				break;
		  
			case ForumMessagePeer::IS_APPROVED:
				return $this->getIsApproved();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getForumMessageId();
				break;
  
			case 1:
				return $this->getForumThreadId();
				break;
  
			case 2:
				return $this->getCreatedBy();
				break;
  
			case 3:
				return $this->getSubject();
				break;
  
			case 4:
				return $this->getBody();
				break;
  
			case 5:
				return $this->getPostDate();
				break;
  
			case 6:
				return $this->getParentForumMessageId();
				break;
  
			case 7:
				return $this->getMailMsgId();
				break;
  
			case 8:
				return $this->getMailSender();
				break;
  
			case 9:
				return $this->getIsApproved();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ForumMessagePeer::FORUM_MESSAGE_ID, $arr)) $this->setForumMessageId($arr[ForumMessagePeer::FORUM_MESSAGE_ID]);
  
		if (array_key_exists(ForumMessagePeer::FORUM_THREAD_ID, $arr)) $this->setForumThreadId($arr[ForumMessagePeer::FORUM_THREAD_ID]);
  
		if (array_key_exists(ForumMessagePeer::CREATED_BY, $arr)) $this->setCreatedBy($arr[ForumMessagePeer::CREATED_BY]);
  
		if (array_key_exists(ForumMessagePeer::SUBJECT, $arr)) $this->setSubject($arr[ForumMessagePeer::SUBJECT]);
  
		if (array_key_exists(ForumMessagePeer::BODY, $arr)) $this->setBody($arr[ForumMessagePeer::BODY]);
  
		if (array_key_exists(ForumMessagePeer::POST_DATE, $arr)) $this->setPostDate($arr[ForumMessagePeer::POST_DATE]);
  
		if (array_key_exists(ForumMessagePeer::PARENT_FORUM_MESSAGE_ID, $arr)) $this->setParentForumMessageId($arr[ForumMessagePeer::PARENT_FORUM_MESSAGE_ID]);
  
		if (array_key_exists(ForumMessagePeer::MAIL_MSG_ID, $arr)) $this->setMailMsgId($arr[ForumMessagePeer::MAIL_MSG_ID]);
  
		if (array_key_exists(ForumMessagePeer::MAIL_SENDER, $arr)) $this->setMailSender($arr[ForumMessagePeer::MAIL_SENDER]);
  
		if (array_key_exists(ForumMessagePeer::IS_APPROVED, $arr)) $this->setIsApproved($arr[ForumMessagePeer::IS_APPROVED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ForumMessagePeer::FORUM_MESSAGE_ID:
				$this->setForumMessageId($value);
				break;
	  
			case ForumMessagePeer::FORUM_THREAD_ID:
				$this->setForumThreadId($value);
				break;
	  
			case ForumMessagePeer::CREATED_BY:
				$this->setCreatedBy($value);
				break;
	  
			case ForumMessagePeer::SUBJECT:
				$this->setSubject($value);
				break;
	  
			case ForumMessagePeer::BODY:
				$this->setBody($value);
				break;
	  
			case ForumMessagePeer::POST_DATE:
				$this->setPostDate($value);
				break;
	  
			case ForumMessagePeer::PARENT_FORUM_MESSAGE_ID:
				$this->setParentForumMessageId($value);
				break;
	  
			case ForumMessagePeer::MAIL_MSG_ID:
				$this->setMailMsgId($value);
				break;
	  
			case ForumMessagePeer::MAIL_SENDER:
				$this->setMailSender($value);
				break;
	  
			case ForumMessagePeer::IS_APPROVED:
				$this->setIsApproved($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setForumMessageId($value);
				break;
  
			case 1:
				$this->setForumThreadId($value);
				break;
  
			case 2:
				$this->setCreatedBy($value);
				break;
  
			case 3:
				$this->setSubject($value);
				break;
  
			case 4:
				$this->setBody($value);
				break;
  
			case 5:
				$this->setPostDate($value);
				break;
  
			case 6:
				$this->setParentForumMessageId($value);
				break;
  
			case 7:
				$this->setMailMsgId($value);
				break;
  
			case 8:
				$this->setMailSender($value);
				break;
  
			case 9:
				$this->setIsApproved($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ForumMessagePeer::DATABASE_NAME);

		try {
			$con->begin();
			ForumMessagePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ForumMessagePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aForumThread !== null) {
				if ($this->aForumThread->isModified()) $this->aForumThread->save($con);
				$this->setForumThread($this->aForumThread);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ForumMessagePeer::doInsert($this, $con);
					$this->setForumMessageId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					ForumMessagePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ForumMessagePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aForumThread !== null) {
				if (($retval = $this->aForumThread->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = ForumMessagePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed forum_message_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setForumMessageId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getForumMessageId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ForumMessage Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ForumMessage();
		$copyObj->setForumThreadId($this->forum_thread_id);
		$copyObj->setCreatedBy($this->created_by);
		$copyObj->setSubject($this->subject);
		$copyObj->setBody($this->body);
		$copyObj->setPostDate($this->post_date);
		$copyObj->setParentForumMessageId($this->parent_forum_message_id);
		$copyObj->setMailMsgId($this->mail_msg_id);
		$copyObj->setMailSender($this->mail_sender);
		$copyObj->setIsApproved($this->is_approved);
		
		$copyObj->setNew(true);
		
		$copyObj->setForumMessageId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ForumMessagePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ForumMessagePeer();
		}
		return self::$peer;
	}

}
