<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists ForumThread
//
require_once('plugins/forum/lib/ForumThreadPeer.php');
require_once('plugins/forum/lib/ForumThread.php');
require_once('plugins/forum/lib/Forum.php');
require_once('plugins/forum/lib/html/ForumFormRenderer.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/forum/lib/html/ForumTemplate.php');
$theme = new ForumTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('ForumThread.BrowsePageTitle')
		);

if (!isset($_GET['forum_id'])) {
	$theme->header($params);
	echo $Lang->getText('Forum.ForumIdNotSpecified');
} elseif ( is_null($Forum = ForumPeer::retrieveByPk($_GET['forum_id']))) {
	$theme->header($params);
	echo $Lang->getText('Forum.InvalidForumID');
} else {	
	$params['forum'] = $Forum;

	$theme->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'ForumViewArchive','forum','',array('forum_id' => $Forum->getForumId())).'">'.$Lang->getText('Forum.History', array($Forum->getForumName())).'</a>');
	$theme->header($params);
	
	$renderer = new ForumFormRenderer('project', $Project->getProjectId(), $theme, $Lang);
	$renderer->showHistory($_GET['forum_id']);

}

$theme->footer($params);
?>