<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//
// This code shows all posts ordered by post_date desc
//

require_once('plugins/forum/lib/ForumMessagePeer.php');
require_once('html/Paginator.php');
require_once('core/UserPeer.php');
require_once('lib/GFUrl.php');
require_once('html/HTMLWidget.php');


$session= Session::getSession();
$Lang= $session->getLanguage();


require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();
$params = array(
		'action'=> isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title'=>$Lang->getText('SiteAdmin.ForumLastPosts'),
	);
$theme->header($params);

//Columns to be used in pagination sort
$columns = array(
	'forum_message_id'=>$Lang->getText('ForumMessage.Id'),
	//'post_date'=>'Post date',
	'created_by'=>$Lang->getText('ForumMessage.CreatedByName'),
	'subject'=>$Lang->getText('ForumMessage.SubjectName'),
	'body'=>$Lang->getText('ForumMessage.BodyName'),
);
	
	

$sqltmp= 'SELECT forum_message_id,post_date,created_by,subject, body from forum_message';

//Get the amount of messages
$total = 0; 
$sqlCount = "SELECT COUNT(*) AS count FROM ($sqltmp) foo";
$con = Propel::getConnection(ForumMessagePeer::DATABASE_NAME);
$stmtCount = $con->createStatement();
$rsCount = $stmtCount->executeQuery($sqlCount, ResultSet::FETCHMODE_ASSOC);
$rsCount->next();
$total = $rsCount->getInt('count');

$paginator = new Paginator('lastposts', -1, $total, 'post_date', $columns);
$sqlAux = $paginator->getSql();

//Get messages
$sql = "$sqltmp $sqlAux";
$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);


//Print headers
$theader = $paginator->getSortableTableHeaders($theme);

echo $theme->tableTop($theader);


if($total < 1){
	echo $theme->tableFullRow('<span class="none found">'.$Lang->getText('ForumMessage.None').'</span>');
} else {
	echo '<form name="delete" method="POST" action="'.GFUrl::getUrl()->baseUrl('LastPostsBrowseAction','forum','admin').'">';
	while ($rs->next()){
		$trow = array();
		//Message id
		$trow[] = '<input type="checkbox" name="message_id[]" value="'.$rs->getInt('forum_message_id').'"/><br />'.$rs->getInt('forum_message_id');
		//$trow[] = $rs->getDate('post_date');
		
		//User
		$userEditUrl = GFUrl::getUrl()->baseUrl('UserEdit','admin','',array('user_id'=>$rs->getInt('created_by')));
		$user = UserPeer::retrieveByPk($rs->getInt('created_by'));
		$trow[] = '<a href="'.$userEditUrl.'">'. $user->getFullName() .'</a>';

		//Subject
		$trow[] = $rs->getString('subject');
		
		//Message body
		$trow[] = $rs->getString('body');
		echo $theme->tableRow($trow);
	}
}

echo $theme->tableBottom();
if(isset($paginator) && is_object($paginator)) {
   echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}
echo '<div align="right">';
echo HTMLWidget::button("submit", "Delete", "submit");
echo '</div>';
echo "</form>";




$theme->footer($params);
?>




