<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/frs/lib/FrsRelease.php');

header("Content-Type: text/plain");

$session = Session::getSession();
$lang = $session->getLanguage();
$project = GFUrl::getUrl()->getProject();

if (!isset($_REQUEST['release_id'])) {
	throw new PermissionDeniedException();
}

$release = FrsReleasePeer::retrieveByPk(Validator::sanitizeInt($_REQUEST['release_id']));
if (!$release || !$release->userCanRead()) {
	throw new PermissionDeniedException();
}

$title = $lang->getText('FrsRelease.ChangelogFor', array($release->getReleaseName()));
echo $title."\n";
echo str_repeat("-", strlen($title))."\n\n";

$closed_items = $release->getChangeLog();
foreach ($closed_items as $item) {
	printf("[#%s] %s\n", $item->getTrackerItemId(), $item->getSummary());
}


?>
