<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists FrsRelease
//
require_once('plugins/frs/lib/FrsReleasePeer.php');
require_once('plugins/frs/lib/FrsRelease.php');
require_once('lib/core/FilesystemPeer.php');
require_once('lib/html/association.php');
require_once('lib/html/TagsRenderer.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/frs/lib/html/FrsTemplate.php');
$theme = new FrsTemplate();

$Project = GFUrl::getUrl()->getProject();
$FrsRelease = FrsReleasePeer::retrieveByPk($_REQUEST['release_id']);
$Package = $FrsRelease->getFrsPackage();
if ($Package->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}
if (!$FrsRelease->userCanRead()) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('FrsRelease.BrowsePageTitle'),
		'frspackage' => $Package
		);
$theme->header($params);

$formatbegin=(( $FrsRelease->getPreformatted() ) ? '<pre>' : '' );
$formatend=(( $FrsRelease->getPreformatted() ) ? '</pre>' : '' );

?>
<table>
	<tr>
		<td><strong><?php echo $Lang->getText('FrsRelease.FrsReleaseIdName'); ?></strong>:<br />
		<?php echo $FrsRelease->getFrsReleaseId(); ?>
		</td>
	</tr>
	<tr>
		<td><strong><?php echo $Lang->getText('FrsRelease.ReleaseNameName'); ?></strong>:<br />
		<?php echo $FrsRelease->getReleaseName(); ?>
		</td>
	</tr>
	<tr>
		<td><strong><?php echo $Lang->getText('FrsRelease.ReleaseDateName'); ?></strong>:<br />
		<?php echo $FrsRelease->getReleaseDate(); ?>
		</td>
	</tr>
	<tr>
		<td><strong><?php echo $Lang->getText('FrsRelease.ReleasedByName'); ?></strong>:<br />
		<?php echo $FrsRelease->getUser()->getUserLink(); ?>
		</td>
	</tr>
</table>
<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","back","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'FrsReleaseBrowse','frs','',array('frs_package_id' => $Package->getFrsPackageId())) . "'; ")?>
<?php	
	if ($FrsRelease->userIsAdmin()) {
?>
<?php echo HTMLWidget::button("button","" .   $Lang->getText('FrsRelease.Edit') . " ","edit","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'FrsReleaseEdit','frs','admin',array('frs_release_id' => $FrsRelease->getFrsReleaseId())) . "'; ")?>
<?php
	} else {
?>
<?php echo HTMLWidget::button("button","" .   $Lang->getText('FrsRelease.Edit') . " ","edit","","",false)?>
<?php
	}
?>
<div id="mainTabSet" class="tabber">
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='notes') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('FrsRelease.NotesName') ?>" id="notestab">
<p><?php echo (( strlen($FrsRelease->getReleaseNotes()) > 1 ) ? $formatbegin.$FrsRelease->getReleaseNotes().$formatend : $Lang->getText('FrsRelease.NoReleaseNotesProvided') ); ?>
</p>
</div>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='changes') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('FrsRelease.ChangesName') ?>" id="changestab">
<p><?php echo (( strlen($FrsRelease->getChanges()) > 1 ) ? $formatbegin.$FrsRelease->getChanges().$formatend : $Lang->getText('FrsRelease.NoChangesProvided') ); ?>
</p>
</div>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='files') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('FrsRelease.Files') ?>" id="filestab">
<?php
//get the fso for the release
$c = new Criteria();
$c->add(FilesystemPeer::SECTION,FrsRelease::SECTION);
$c->add(FilesystemPeer::REF_ID,$FrsRelease->getPrimaryKey());
$fsos = FilesystemPeer::doSelect($c);

$theader[] = Language::getSessText('FrsRelease.Files');
$theader[] = Language::getSessText('FrsRelease.FileSize');
$theader[] = Language::getSessText('FrsRelease.Downloads');
$theader[] = Language::getSessText('FrsRelease.Md5');

echo $theme->tableTop($theader);

if (count($fsos) < 1) {
	echo $theme->tableFullRow($Lang->getText('FrsRelease.NoFiles'));
} else {
	foreach ($fsos as $fso) {
		$trow=array();
		// user must be logged in
		if (($Package->getRequireLogin() || !$Package->isPublic()) && !$session->isLoggedIn()) {
			$url = GFUrl::getURL()->baseURL('Login', '', 'account', array('redirect' => $_SERVER['REQUEST_URI']));
		} else {
			$url = GFUrl::downloadUrlFromFS($fso);
		}
		// download link. 
		$trow[]= '<a href="'.$url.'">'.$fso->getFileName().'</a>';
		$trow[]=$fso->getFileSize();
		$trow[]=$fso->getDownloadCount();
		$trow[]=$fso->getMd5Hash();
		
		echo $theme->tableRow($trow);
		unset($trow);
	}
}
echo $theme->tableBottom();

?>
</div>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='associatedtrackeritems') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('FrsRelease.TrackerItems') ?>" id="trackeritemstab">
<?php
// here we get all the related tracker items
$sql = "SELECT t.tracker_id, t.tracker_name, tef.tracker_extra_field_id,
tef.field_name, ti.tracker_item_id, ti.summary, ti.open_date
FROM tracker t, tracker_item ti, tracker_extra_field tef, tracker_extra_field_data tefd
WHERE t.tracker_id = ti.tracker_id
AND tef.tracker_id=t.tracker_id
AND t.project_id=".$Project->getProjectId()."
AND tef.field_type=".TrackerExtraField::TYPE_RELEASE."
AND tef.tracker_extra_field_id=tefd.tracker_extra_field_id
AND tefd.tracker_item_id = ti.tracker_item_id
AND tefd.field_data = '".$FrsRelease->getPrimaryKey()."'
ORDER BY tef.tracker_extra_field_id ASC";

$theader = array($Lang->getText('Tracker.TrackerNameName'),
			$Lang->getText('TrackerExtraField.FieldNameName'),
			$Lang->getText('TrackerItemRelation.TrackerItemIdName'),
			$Lang->getText('TrackerItem.SummaryName'),
			$Lang->getText('TrackerItem.OpenDateName'));

echo $theme->tableTop($theader);

$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);
$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$data = array();
$fields = array();
while($rs != null && $rs->getRecordCount() > 0 && $rs->next()) {
	$tid = $rs->getInt('tracker_id');
	$data[$tid][] = array('tracker_id'=>$rs->getInt('tracker_id'),
										'tracker_name'=>$rs->getString('tracker_name'),
										'field_id'=>$rs->getString('tracker_extra_field_id'),
										'field_name'=>$rs->getString('field_name'),
										'tracker_item_id'=>$rs->getString('tracker_item_id'),
										'summary'=>$rs->getString('summary'),
										'open_date'=>$rs->getString('open_date'));

	$fid = $rs->getString('tracker_extra_field_id');
	if (!isset($fields[$tid][$fid])) {
		$fields[$tid][$fid] = 0;
	}
	$fields[$tid][$fid]++;
}

$lastTracker = 0;
$lastField = 0;
$itemscount = 0;
foreach ($data as $tracker) {
	foreach ($tracker as $item) {
		if ($lastTracker != $item['tracker_id']) {
			$trow[]=$item['tracker_name'];
			$tmod[]='rowspan="'.count($tracker).'" bgcolor="#FFFFFF"';
			$lastField = 0;
			$lastTracker=$item['tracker_id'];
		}
		if ($lastField != $item['field_id']) {
			$trow[]=$item['field_name'];
			$tmod[]='rowspan="'.$fields[$item['tracker_id']][$item['field_id']].'" bgcolor="#FFFFFF"';
			$lastField=$item['field_id'];
		}

		$trow[]='#'.$item['tracker_item_id'];
		$tmod[]='';
		$trow[]='<a href="'.GFUrl::getURL()->projectURL($Project, 'TrackerItemEdit', 'tracker', '', array('tracker_item_id'=>$item['tracker_item_id'])).'">'.$item['summary'].'</a>';
		$tmod[]='';
		$date = explode('.', $item['open_date']);
		$trow[]=$date[0];
		$tmod[]='';
		echo $theme->tableRow($trow,$tmod);
		unset($tmod);
		unset($trow);
		$itemscount++;
	}
}
if ($itemscount == 0) {
	echo $theme->tableFullRow($Lang->getText('TrackerReporting.NoneFound'));
	$export = array();
} else {
	$export  = '<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsReleaseExport').'&amp;release_id='.$FrsRelease->getPrimaryKey().'&amp;type=csv">'. $Lang->getText('TrackerQuery.ExportCSV').'</a>  ';
	$export .= '<a href="'. GFUrl::getUrl()->currentBaseUrl('FrsReleaseExport').'&amp;release_id='.$FrsRelease->getPrimaryKey().'&amp;type=xls">'. $Lang->getText('TrackerQuery.ExportExcel').'</a>  ';
	$export  = array($export);
}


echo $theme->tableBottom($export);

?>
</div>
<?php
$settings = FrsProjectSettingPeer::retrieveByPk($Project->getProjectId());
if(!$settings || $settings->getShowAssociationsTab()){?>
	<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='associations') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Associations') ?>" id="associationstab">
<?php echo renderAssociationList(FrsRelease::SECTION,$FrsRelease->getPrimaryKey(),$FrsRelease->userCanUpdate(),$theme,$Project); ?>
	</div>
<?php
} 
if(!$settings || $settings->getShowTagsTab()){ ?>
	<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab'] =='associations') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Tag.TabHeader') ?>" id="tagstab">
<?php echo TagsRenderer::getTagsTable($FrsRelease->getFrsReleaseId(), FrsRelease::SECTION,$theme, $FrsRelease->getFrsPackageId()); ?>
	</div>
<?php } ?>
</div>
<?php
$theme->footer($params);	

?>
