<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for $OBJECT deletion
//
require_once('plugins/frs/lib/FrsPackagePeer.php');
require_once('plugins/frs/lib/FrsPackage.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/frs/lib/html/FrsAdminTemplate.php');
$theme = new FrsAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$FrsPackage = FrsPackagePeer::retrieveByPk($_GET['frs_package_id']);
if (!is_object($FrsPackage) || !$FrsPackage->userCanDelete()
	|| $FrsPackage->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('FrsPackage.DeletePageTitle'),
		'frspackage' => $FrsPackage
		);

include('forms/FrsPackageDelete-tpl.php');

?>