<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new FrsPackage and saves it to the 
// database
//
require_once('plugins/frs/lib/FrsPackage.php');
require_once('plugins/frs/lib/FrsPackagePeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();

$Project = GFUrl::getUrl()->getProject();
$perm = $Project->getPermission(); 
if (array_key_exists('sure',$_POST)) {
	$FrsPackage = FrsPackagePeer::retrieveByPk($_POST['frs_package_id']);
	if (!is_object($FrsPackage) || !$FrsPackage->userCanDelete()
		|| $FrsPackage->getProject()->getProjectId() != $Project->getProjectId()) {
		throw new PermissionDeniedException();
	}
	$FrsPackage->delete();
	
	if ($perm->check(FrsPlugin::SECTION, 0, FrsPlugin::WRITE)) {
		GFUrl::redirect($url->currentBaseURL('FrsPackageBrowse'), array('feedback' => $Lang->getText('FrsPackage.DeleteFeedback')));
	} else {
		GFUrl::redirect($url->projectURL($Project, '','','frs',array('feedback'=>$Lang->getText('FrsPackage.DeleteFeedback'))));
	}
} else {
	if ($perm->check(FrsPlugin::SECTION, 0, FrsPlugin::WRITE)) {
		GFUrl::redirect($url->currentBaseURL('FrsPackageBrowse'), array('feedback' => $Lang->getText('FrsPackageDeleteForm.DidntConfirm')));
	} else {
		GFUrl::redirect($url->projectURL($Project, '','','frs',array('feedback'=>$Lang->getText('FrsPackageDeleteForm.DidntConfirm'))));
	}
}

?>