<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for FrsRelease
//
require_once('plugins/frs/lib/FrsReleasePeer.php');
require_once('plugins/frs/lib/FrsRelease.php');
require_once('GFUrl.php');
require_once('lib/core/TroveLink.php');
require_once('html/HTMLWidget.php');
require_once('lib/html/UploadHandler.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/frs/lib/html/FrsAdminTemplate.php');
$theme = new FrsAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$FrsPackage = FrsPackagePeer::retrieveByPK($_REQUEST['frs_package_id']);
if (!is_object($FrsPackage) || !$FrsPackage->userIsAdmin()
	|| $FrsPackage->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('FrsRelease.AddNewPageTitle'),
		'frspackage' => $FrsPackage,
		'enableUploads' => true,
		);

$frs_package_id=((isset($_REQUEST['frs_package_id'])) ? htmlspecialchars($_REQUEST['frs_package_id']) : '' );
$release_name=((isset($_POST['release_name'])) ? htmlspecialchars($_POST['release_name']) : '' );
$release_notes=((isset($_POST['release_notes'])) ? htmlspecialchars($_POST['release_notes']) : '' );
$changes=((isset($_POST['changes'])) ? htmlspecialchars($_POST['changes']) : '' );
$status_id=((isset($_POST['status_id'])) ? htmlspecialchars($_POST['status_id']) : '' );
$preformatted=((isset($_POST['preformatted'])) ? htmlspecialchars($_POST['preformatted']) : '' );
$release_date=((isset($_POST['release_date'])) ? htmlspecialchars($_POST['release_date']) : '' );
$is_released=((isset($_POST['is_released'])) ? htmlspecialchars($_POST['is_released']) : '' );

// This will let us upload files even if we don't have the ID
$uploadHandler = new UploadHandler();
$file_upload_form_hash = $uploadHandler->getUploadHash();

include('forms/FrsReleaseAdd-tpl.php');

?>
