<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/mailman/lib/Mailman.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$kept_variables = array('action', 'mailman_id');

require_once('plugins/mailman/lib/html/MailmanTemplate.php');
$theme = new MailmanTemplate();

$Project = GFUrl::getUrl()->getProject();
$list = MailmanPeer::retrieveByPk($_GET['mailman_id']);
if (!is_object($list) || !$list->userCanRead()) {
	throw new PermissionDeniedException();
}

/*
 * Generate the forum page. This is done BEFORE outputting any text before 
 * this code could redirect.
 */
include_once('plugins/forum/lib/html/ForumFormRenderer.php');
$renderer = new ForumFormRenderer(Mailman::SECTION, $list->getPrimaryKey(), $theme, $Lang, $kept_variables);

// Try to create a forum for this object on the fly
$c = new Criteria();
$c->add(ForumPeer::SECTION, Mailman::SECTION);
$c->add(ForumPeer::REF_ID, $list->getPrimaryKey());
$forum = ForumPeer::doSelectOne($c);
if (is_null($forum)) {
	$forum = new Forum();
	$forum->setSection(Mailman::SECTION);
	$forum->setRefId($list->getPrimaryKey());
	$forum->setForumName($list->getListName());
	$forum->setIsPublic($list->getIsPublic());
	$forum->setDescription($list->getListDescription());

	// We do this because we may be logged in as any user, so we must skip
	// permission checks
	$forum->forceSave();
	$forum->save();
}

$renderer->setReadonly();		// do not allow posting
$forum_page = $renderer->handleBrowse($forum);



$params = array(
		'project' => $Project,
		'list' => $list,
		'forum' => $forum,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Mailman.Archives', array($list->getListName()))
		);

$theme->header($params);

echo $forum_page;

$theme->footer();
?>
