<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing News
//
require_once('plugins/news/lib/NewsPeer.php');
require_once('plugins/news/lib/News.php');
require_once('exceptions/PermissionDeniedException.php');
//require_once('plugins/forum/lib/html/ForumFormRenderer.php');

$kept_vars = array('action', 'id');

$session = Session::getSession();
$Lang = $session->getLanguage();

$forum_action = $_REQUEST['_forum_action'];

require_once('plugins/news/lib/html/NewsTemplate.php');
$theme = new NewsTemplate();

$Project = GFUrl::getUrl()->getProject();

$thread_id = isset($_REQUEST['thread_id']) ? Validator::sanitizeInt($_REQUEST['thread_id']) : 0;
$message_id = isset($_REQUEST['message_id']) ? Validator::sanitizeInt($_REQUEST['message_id']) : 0;
$news_id = isset($_REQUEST['id']) ? Validator::sanitizeInt($_REQUEST['id']) : 0;

if ($thread_id == 0) {
	if($message_id != 0) {
		$ForumMessage = ForumMessagePeer::retrieveByPk($message_id);
		if (is_object($ForumMessage)) {
			$Forum = $ForumMessage->getForumThread()->getForum();
			$news_id = $Forum->getRefId();
		}
	}
} else {
	$ForumThread = ForumThreadPeer::retrieveByPk($thread_id);
	if (is_object($ForumThread)) {
		$Forum = $ForumThread->getForum();
		$news_id = $Forum->getRefId();
	}
}


$News = NewsPeer::retrieveByPk($news_id);
if (!is_object($News) || !$News->userCanRead()) {
	throw new PermissionDeniedException();
}
$obj = $News;

/*
 * Generate the forum page. This is done BEFORE outputting any text before 
 * this code could redirect.
 */
include_once('plugins/news/lib/html/NewsCommentsRenderer.php');
$renderer = new NewsCommentsRenderer(News::SECTION, NewsPlugin::getFormPaths(), $News->getPrimaryKey(), $theme, $Lang, $kept_vars);

$forum_page = $renderer->handleBrowse($Forum, $News->getSummary(), $thread_id, $message_id, $forum_action);

if ($renderer->hasErrors()) {
	$feedback = "*".implode('<br />*', $renderer->getErrors());
	echo $feedback;
} else {
	echo $forum_page;
}
?>
