<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists News
//
$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/news/lib/html/NewsTemplate.php');
$theme = new NewsTemplate();

$id = Validator::sanitizeInt($_REQUEST['id']);

$Project = GFUrl::getUrl()->getProject();

$News = NewsPeer::retrieveByPk($_GET['id']);
if (!is_object($News)) {
	throw new PermissionDeniedException();
}

$forum_action = isset($_REQUEST['_forum_action']) ? Validator::sanitizeString($_REQUEST['_forum_action']) : "";

/*
 * Generate the forum page. This is done BEFORE outputting any text before 
 * this code could redirect.
 */
// Try to create a forum for this news on the fly
$c = new Criteria();
$c->add(ForumPeer::SECTION, News::SECTION);
$c->add(ForumPeer::REF_ID, $News->getPrimaryKey());
$forum = ForumPeer::doSelectOne($c);
if (is_null($forum)) {
	$forum = new Forum();
	$forum->setSection(News::SECTION);
	$forum->setRefId($News->getPrimaryKey());
	$forum->setForumName($News->getSummary());
	// We do this because we may be logged in as any user, so we must skip
	// permission checks
	$forum->forceSave();
	$forum->save();
}

include_once('plugins/news/lib/html/NewsCommentsRenderer.php');
$kept_vars = array();
$renderer = new NewsCommentsRenderer(News::SECTION, NewsPlugin::getFormPaths(), $News->getPrimaryKey(), $theme, $Lang, $kept_vars, $forum_action);

$form = $renderer->handleBrowse($forum, $News->getSummary(), 0, 0, 'ForumThreadAdd');
echo $form;
//require_once("forms/NewsThreadAdd-tpl.php");
?>