<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing News
//
require_once('plugins/news/lib/NewsPeer.php');
require_once('plugins/news/lib/News.php');
require_once('exceptions/PermissionDeniedException.php');
//require_once('plugins/forum/lib/html/ForumFormRenderer.php');

$kept_vars = array('action', 'id');

$session = Session::getSession();
$Lang = $session->getLanguage();

$forum_action = $_REQUEST['_forum_action'];

require_once('plugins/news/lib/html/NewsTemplate.php');
$theme = new NewsTemplate();

$Project = GFUrl::getUrl()->getProject();
$News = NewsPeer::retrieveByPk($_GET['id']);
if (!is_object($News) || !$News->userCanRead()) {
	throw new PermissionDeniedException();
}
$obj = $News;

/*
 * Generate the forum page. This is done BEFORE outputting any text before 
 * this code could redirect.
 */
include_once('plugins/news/lib/html/NewsCommentsRenderer.php');
$renderer = new NewsCommentsRenderer(News::SECTION, $News->getPrimaryKey(), $theme, $Lang, $kept_vars);

// Try to create a forum for this news on the fly
$c = new Criteria();
$c->add(ForumPeer::SECTION, News::SECTION);
$c->add(ForumPeer::REF_ID, $News->getPrimaryKey());
$forum = ForumPeer::doSelectOne($c);
if (is_null($forum)) {
	$forum = new Forum();
	$forum->setSection(News::SECTION);
	$forum->setRefId($News->getPrimaryKey());
	$forum->setForumName($News->getSummary());
	// We do this because we may be logged in as any user, so we must skip
	// permission checks
	$forum->forceSave();
	$forum->save();
}

$forum_page = $renderer->handleBrowse($forum, $News);

if ($renderer->hasErrors()) {
	$feedback = "*".implode('<br />*', $renderer->getErrors());
}

$params = array(
		'project' => $Project,
		'news' => $News,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('News.EditPageTitle')
		);
$theme->header($params);

$theader = array($obj->getSummary());
$value = $theme->tableTop($theader);
$trow = array();
$trow[0]=$obj->getUser()->getUserLink().'<br />'.
	'<p>'.nl2br(StringUtils::addHtmlLinks($obj->getDetails())).'</p>';
$trow[0] .= '<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'NewsThreadView','news','',array('id'=>$News->getNewsId())).'"><img src="/images/forum_icon.gif" alt="2" border="0" height="16" width="16">&nbsp;'.Language::getSessText('News.Discussions').'</a>';

//echo $theme->tableRow($trow);

//echo $theme->tableBottom();


if ($forum_action == "ForumThreadAdd") {
	//GFUrl::getUrl()->redirect( GFUrl::getUrl()->projectURL($Project,'NewsThreadView','news','',array('_forum_action'=>'ForumThreadAdd', 'forum_id'=>$forum->getForumId(), 'id'=>$id)) );
	GFUrl::getUrl()->redirect( GFUrl::getUrl()->projectURL($Project,'','news','',array('forum_id'=>$forum->getForumId(), 'id'=>$id)));
} else {
	echo $forum_page;
}

$theme->footer();
?>
