<?php
/**
 * Copyright (c) 2005-2013 GForge, LLC
 *
 * @version   $Id$
 * @author Mario A. Papayannis	<mpapayannis@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/pastebin/lib/PastebinPeer.php');
require_once('plugins/pastebin/lib/Pastebin.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$url = GFUrl::getUrl();

if (isset($_REQUEST['check_login']) && !$session->isLoggedIn()) {
	throw new NotLoggedInException();
}

if (!is_object($pastebin)) {
	//there is no object, so we check if there's a parameter for a pase, otherwise
	$show_paste = true;
	$pastebin_hash = $url->getSubdir();
	$pastebin_hash = str_replace("/", "", $pastebin_hash);
	$pos = strpos($pastebin_hash, "&");
	if ($pos > 0) {
		$pastebin_hash = substr($pastebin_hash, 0, $pos);
	}

	if ($pastebin_hash != "") {
		$pastebin_id = PastebinPeer::convertPasteHash($pastebin_hash);
		$pastebin = PastebinPeer::retrieveByPK($pastebin_id);
		if (is_object($pastebin)) {
			if (!$pastebin->userCanRead()) {
				throw new PermissionDeniedException();
			}

			if ($pastebin->isExpired()) {
				$pastebin->delete();
				throw new PermissionDeniedException();
			}

			$post_user = UserPeer::retrieveByPk($pastebin->getPostedBy());
		}
	}
} else {
	//if object exists, then it's a result of a previous paste submit attempt, enter edit mode
	$show_paste = false;
	$post_user = UserPeer::retrieveByPk($pastebin->getPostedBy());
}

//Gets option arrays
$languages = PastebinPeer::getLanguages();
$expirations = PastebinPeer::getExpirations();
$exposures = PastebinPeer::getExposures();
$snippet_themes = PastebinPeer::getThemes();

$user = null;
if ($session->isLoggedIn()) {
	//Get user projects
	$user = $session->getUser();
	if (is_object($user)) {
		$user_projects = $user->getAllAccessibleProjectsAssoc();
	}
}

require_once('plugins/pastebin/lib/html/PastebinTemplate.php');
$theme = new PastebinTemplate();

$params = array(
	'action' => isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'title' => $Lang->getText('Pastebin.TabString'),
	'extra_head' => array('<META NAME="ROBOTS" CONTENT="NOINDEX,NOFOLLOW" />')
);

$pastebins = PastebinPeer::getLatestPastes($user);

$theme->header($params);

include("forms/Pastebin-tpl.php");

$theme->footer($params);

?>
