<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Marcelo Mottalli <marcelo@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

class RatingWidget 
{
	/**
	 * Returns the list of extra headers to show (used to include the javascript for the widget)
	 */
	public static function getExtraHeaders() {
		return array(
			'<script language="javascript" src="/jquery.rating.js"></script>'
		);
	}
	
	public static function getWidget($widgetName, $defaultValue=3, $readOnly=false, $title='', $numberStars=5) {
		$ret = '';
		
		if ($title) {
			$ret .= '<table border="0" cellspacing="0" cellpadding="0"><tr><td>'.$title.'</td><td>';
		}
		
		for ($i = 1; $i <= $numberStars; $i++) {
			$ret .= '<input type="radio" name="'.$widgetName.'" value="'.$i.'" class="star"';
			
			if ($i == $defaultValue) {
				$ret .= 'checked="checked" ';
			}
			
			if ($readOnly) {
				$ret .= 'disabled="disabled" ';
			}
			
			$ret .= ' />';
		}
		
		if ($title) {
			$ret .= '</td></tr></table>';
		}
		
		return $ret;
	}
}
?>
