<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Marcelo Mottalli <marcelo@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/ProjectTemplate.php');
require_once('html/HTMLWidget.php');
require_once('plugins/projectrating/lib/UserProjectRating.php');
require_once('plugins/projectrating/lib/html/RatingWidget.php');

$project = GFUrl::getUrl()->getProject();
$project_url = GFUrl::getUrl()->projectUrl($project);

if (! Session::getSession()->isLoggedIn()) {
	GFUrl::redirect($project_url);
	return;
}

$lang = Session::getSession()->getLanguage();
$template = new ProjectTemplate();
$user = Session::getSession()->getUser();

$userRating = UserProjectRatingPeer::retrieveByPk($user->getUserId(), $project->getProjectId());

$params = array(
	'project' => $project,
	'title'=> $lang->getText('ProjectRating.RateProject'),
	'feedback'=> isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'extra_head' => RatingWidget::getExtraHeaders(),
);
$template->header($params);

$comment = (isset($_REQUEST['comment']) ? $_REQUEST['comment'] : (is_object($userRating) ? $userRating->getComment() : ''));
// 3 stars by default
$rating = (isset($_REQUEST['rating']) ? $_REQUEST['rating'] : (is_object($userRating) ? $userRating->getRating() : 3));

?>
<h3><?php echo $lang->getText('ProjectRating.RateProject') ?></h3>

<p>&nbsp;</p>

<form method="post" action="<?php echo GFUrl::getUrl()->currentBaseUrl('UserProjectRatingAction'); ?>">
<table border="0">
	<tr>
		<td><strong><?php echo $lang->getText('ProjectRating.YourRating') ?>:</strong></td>
		<td><?php echo RatingWidget::getWidget('rating', $rating); ?></td>
	</tr>
	<tr>
		<td><strong><?php echo $lang->getText('ProjectRating.CommentsTitle') ?></strong></td>
		<td>
			<textarea name="comment" rows="5" cols="40" /><?php echo $comment ?></textarea>
		</td>
	</tr>
</table>

<?php echo HtmlWidget::button('submit', $lang->getText('Common.Submit')) ?>
<?php echo HTMLWidget::button('button', $lang->getText('Common.Back'), "cancel", "", "window.location='$project_url'; ") ?>
</form>

<?php
$template->footer();
?>
