<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Marcelo Mottalli <marcelo@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
 
require_once('Validator.php');
 
$project = GFUrl::getUrl()->getProject();

if (! Session::getSession()->isLoggedIn()) {
	GFUrl::redirect(GFUrl::getUrl()->projectUrl($project));
	return;
}

if ($_SERVER['REQUEST_METHOD'] != 'POST' || !isset($_POST['rating'])) {
	throw new PermissionDeniedException();
}

$rating = Validator::sanitizeInt($_POST['rating']);
$comments = Validator::sanitizeString($_POST['comment']);
$user = Session::getSession()->getUser();

try {
	$project->setProjectRating($rating, $comments, $user);
	$feedback = Language::getSessText('ProjectRating.SavedRating');
	
	GFUrl::redirect(GFUrl::getUrl()->projectUrl($project, '', '', '', array('feedback' => $feedback)));
} catch (PermissionDeniedException $ex) {
	$feedback = $ex->getMessage();
} catch (InvalidDataException $ex) {
	$errors = $ex->getErrors();		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
}

include("UserProjectRating.php");

?>
