<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-01-03
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'plugins/scm/lib/om/BaseScmProjectStatsPeer.php';

// The object class
include_once 'plugins/scm/lib/ScmProjectStats.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Wed Jan  4 05:51:25 2006]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package plugins.scm.lib 
 */
class ScmProjectStatsPeer extends BaseScmProjectStatsPeer {
	private static $_pkCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	ScmProjectStats
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, ScmProjectStatsPeer::$_pkCache)) {
			return ScmProjectStatsPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			ScmProjectStatsPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, ScmProjectStatsPeer::$_pkCache)) {
			unset(ScmProjectStatsPeer::$_pkCache[$pk]);
		}
	}
	
	public static function getProjectStats($project_id) {
		
		$project_id = Validator::sanitizeInt($project_id);
		
		$sql = 'SELECT SUM(checkouts) AS total_checkouts, SUM(commits) AS total_commits, 
				SUM(adds) AS total_adds FROM scm_project_stats WHERE project_id=\''.$project_id.'\'
				GROUP BY project_id
				';
		
		$con = Propel::getConnection(self::DATABASE_NAME);
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql);
		
		if (!$rs->next()) return null;
		
		return array(
				'checkouts'	=> $rs->getInt('total_checkouts'),
				'commits'	=> $rs->getInt('total_commits'),
				'adds'		=> $rs->getInt('total_adds')
			);

	}

}
?>
