<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/scm/lib/CodeSearchModule.php';
// (on-demand) include_once 'plugins/scm/lib/CodeSearchModulePeer.php';

include_once 'plugins/scm/lib/CodeSearchIndexPeer.php';

/**
 * Base class that represents a row from the 'code_search_index' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to CodeSearchIndex class. 
 * 
 * @package plugins.scm.lib 
 */
abstract class BaseCodeSearchIndex extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CodeSearchIndexPeer
	 */
	protected static $peer;

	/**
	 * The value for the code_search_index_id field.
	 * @var int	  
	 */
	protected $code_search_index_id;	

	/**
	 * The value for the code_search_module_id field.
	 * @var int	  
	 */
	protected $code_search_module_id;	

	/**
	 * The value for the filename field.
	 * @var string	  
	 */
	protected $filename;	

	/**
	 * The value for the line field.
	 * @var int	  
	 */
	protected $line;	

	/**
	 * The value for the revision field.
	 * @var string	  
	 */
	protected $revision;	

	/**
	 * The value for the class_name field.
	 * @var string	  
	 */
	protected $class_name;	

	/**
	 * The value for the method_name field.
	 * @var string	  
	 */
	protected $method_name;	

	/**
	 * The value for the variable_name field.
	 * @var string	  
	 */
	protected $variable_name;	

	/**
	 * The value for the comment field.
	 * @var string	  
	 */
	protected $comment;	
  
	/**
	 * Get the CodeSearchIndexId column value.
	 *  
	 * @return int	  
	 */
	public function getCodeSearchIndexId()
	{
		return $this->code_search_index_id;
	}


	/**
	 * Set the value of `code_search_index_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setCodeSearchIndexId($v)
	{
		if ($this->code_search_index_id !== $v) {
			$this->code_search_index_id = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::CODE_SEARCH_INDEX_ID;
		}
				
	}

  
	/**
	 * Get the CodeSearchModuleId column value.
	 *  
	 * @return int	  
	 */
	public function getCodeSearchModuleId()
	{
		return $this->code_search_module_id;
	}


	/**
	 * Set the value of `code_search_module_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCodeSearchModuleId($v)
	{
		if ($this->code_search_module_id !== $v) {
			$this->code_search_module_id = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID;
		}
			
		if ($this->aCodeSearchModule !== null && $this->aCodeSearchModule->getCodeSearchModuleId() !== $v) {
			$this->aCodeSearchModule = null;
		}
			
	}

  
	/**
	 * Get the Filename column value.
	 *  
	 * @return string	  
	 */
	public function getFilename()
	{
		return $this->filename;
	}


	/**
	 * Set the value of `filename` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFilename($v)
	{
		if ($this->filename !== $v) {
			$this->filename = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::FILENAME;
		}
				
	}

  
	/**
	 * Get the Line column value.
	 *  
	 * @return int	  
	 */
	public function getLine()
	{
		return $this->line;
	}


	/**
	 * Set the value of `line` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setLine($v)
	{
		if ($this->line !== $v) {
			$this->line = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::LINE;
		}
				
	}

  
	/**
	 * Get the Revision column value.
	 *  
	 * @return string	  
	 */
	public function getRevision()
	{
		return $this->revision;
	}


	/**
	 * Set the value of `revision` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setRevision($v)
	{
		if ($this->revision !== $v) {
			$this->revision = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::REVISION;
		}
				
	}

  
	/**
	 * Get the ClassName column value.
	 *  
	 * @return string	  
	 */
	public function getClassName()
	{
		return $this->class_name;
	}


	/**
	 * Set the value of `class_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setClassName($v)
	{
		if ($this->class_name !== $v) {
			$this->class_name = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::CLASS_NAME;
		}
				
	}

  
	/**
	 * Get the MethodName column value.
	 *  
	 * @return string	  
	 */
	public function getMethodName()
	{
		return $this->method_name;
	}


	/**
	 * Set the value of `method_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setMethodName($v)
	{
		if ($this->method_name !== $v) {
			$this->method_name = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::METHOD_NAME;
		}
				
	}

  
	/**
	 * Get the VariableName column value.
	 *  
	 * @return string	  
	 */
	public function getVariableName()
	{
		return $this->variable_name;
	}


	/**
	 * Set the value of `variable_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setVariableName($v)
	{
		if ($this->variable_name !== $v) {
			$this->variable_name = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::VARIABLE_NAME;
		}
				
	}

  
	/**
	 * Get the Comment column value.
	 *  
	 * @return string	  
	 */
	public function getComment()
	{
		return $this->comment;
	}


	/**
	 * Set the value of `comment` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setComment($v)
	{
		if ($this->comment !== $v) {
			$this->comment = $v;
			$this->modifiedColumns[] = CodeSearchIndexPeer::COMMENT;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->code_search_index_id = $rs->getInt($startcol + 0);					
			$this->code_search_module_id = $rs->getInt($startcol + 1);					
			$this->filename = $rs->getString($startcol + 2);					
			$this->line = $rs->getInt($startcol + 3);					
			$this->revision = $rs->getString($startcol + 4);					
			$this->class_name = $rs->getString($startcol + 5);					
			$this->method_name = $rs->getString($startcol + 6);					
			$this->variable_name = $rs->getString($startcol + 7);					
			$this->comment = $rs->getString($startcol + 8);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating CodeSearchIndex object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(CodeSearchIndexPeer::DATABASE_NAME);
		$criteria->add(CodeSearchIndexPeer::CODE_SEARCH_INDEX_ID, $this->code_search_index_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(CodeSearchIndexPeer::DATABASE_NAME);
		if ($this->isColumnModified(CodeSearchIndexPeer::CODE_SEARCH_INDEX_ID)) $criteria->add(CodeSearchIndexPeer::CODE_SEARCH_INDEX_ID, $this->code_search_index_id);
		if ($this->isColumnModified(CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID)) $criteria->add(CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID, $this->code_search_module_id);
		if ($this->isColumnModified(CodeSearchIndexPeer::FILENAME)) $criteria->add(CodeSearchIndexPeer::FILENAME, $this->filename);
		if ($this->isColumnModified(CodeSearchIndexPeer::LINE)) $criteria->add(CodeSearchIndexPeer::LINE, $this->line);
		if ($this->isColumnModified(CodeSearchIndexPeer::REVISION)) $criteria->add(CodeSearchIndexPeer::REVISION, $this->revision);
		if ($this->isColumnModified(CodeSearchIndexPeer::CLASS_NAME)) $criteria->add(CodeSearchIndexPeer::CLASS_NAME, $this->class_name);
		if ($this->isColumnModified(CodeSearchIndexPeer::METHOD_NAME)) $criteria->add(CodeSearchIndexPeer::METHOD_NAME, $this->method_name);
		if ($this->isColumnModified(CodeSearchIndexPeer::VARIABLE_NAME)) $criteria->add(CodeSearchIndexPeer::VARIABLE_NAME, $this->variable_name);
		if ($this->isColumnModified(CodeSearchIndexPeer::COMMENT)) $criteria->add(CodeSearchIndexPeer::COMMENT, $this->comment);
		return $criteria;			
	}
	
	

	/**
	 * @var CodeSearchModule	  
	 */
	protected $aCodeSearchModule;

	/**
	 * Declares an association between this object and a CodeSearchModule object
	 *
	 * @param CodeSearchModule $v
	 * @return void
	 * @throws PropelException
	 */
	public function setCodeSearchModule($v)
	{
			
		if ($v === null) {
			$this->setCodeSearchModuleId(NULL);
		} else {
			$this->setCodeSearchModuleId($v->getCodeSearchModuleId());
		}
   
		$this->aCodeSearchModule = $v;
	}


	/**
	 * Get the associated CodeSearchModule object
	 *
	 * @param Connection Optional Connection object.
	 * @return CodeSearchModule The associated CodeSearchModule object.
	 * @throws PropelException
	 */
	public function getCodeSearchModule($con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/CodeSearchModulePeer.php';

		if ($this->aCodeSearchModule === null && ($this->code_search_module_id !== null)) {
	
			$this->aCodeSearchModule = CodeSearchModulePeer::retrieveByPK($this->code_search_module_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = CodeSearchModulePeer::retrieveByPK($this->code_search_module_id, $con);
			   $obj->addCodeSearchIndexs($this);
			 */
		}
		return $this->aCodeSearchModule;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setCodeSearchModuleKey($key)
	{

		$this->setCodeSearchModuleId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("code_search_index_id", "code_search_module_id", "filename", "line", "revision", "class_name", "method_name", "variable_name", "comment", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case CodeSearchIndexPeer::CODE_SEARCH_INDEX_ID:
				return $this->getCodeSearchIndexId();
				break;
		  
			case CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID:
				return $this->getCodeSearchModuleId();
				break;
		  
			case CodeSearchIndexPeer::FILENAME:
				return $this->getFilename();
				break;
		  
			case CodeSearchIndexPeer::LINE:
				return $this->getLine();
				break;
		  
			case CodeSearchIndexPeer::REVISION:
				return $this->getRevision();
				break;
		  
			case CodeSearchIndexPeer::CLASS_NAME:
				return $this->getClassName();
				break;
		  
			case CodeSearchIndexPeer::METHOD_NAME:
				return $this->getMethodName();
				break;
		  
			case CodeSearchIndexPeer::VARIABLE_NAME:
				return $this->getVariableName();
				break;
		  
			case CodeSearchIndexPeer::COMMENT:
				return $this->getComment();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getCodeSearchIndexId();
				break;
  
			case 1:
				return $this->getCodeSearchModuleId();
				break;
  
			case 2:
				return $this->getFilename();
				break;
  
			case 3:
				return $this->getLine();
				break;
  
			case 4:
				return $this->getRevision();
				break;
  
			case 5:
				return $this->getClassName();
				break;
  
			case 6:
				return $this->getMethodName();
				break;
  
			case 7:
				return $this->getVariableName();
				break;
  
			case 8:
				return $this->getComment();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(CodeSearchIndexPeer::CODE_SEARCH_INDEX_ID, $arr)) $this->setCodeSearchIndexId($arr[CodeSearchIndexPeer::CODE_SEARCH_INDEX_ID]);
  
		if (array_key_exists(CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID, $arr)) $this->setCodeSearchModuleId($arr[CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID]);
  
		if (array_key_exists(CodeSearchIndexPeer::FILENAME, $arr)) $this->setFilename($arr[CodeSearchIndexPeer::FILENAME]);
  
		if (array_key_exists(CodeSearchIndexPeer::LINE, $arr)) $this->setLine($arr[CodeSearchIndexPeer::LINE]);
  
		if (array_key_exists(CodeSearchIndexPeer::REVISION, $arr)) $this->setRevision($arr[CodeSearchIndexPeer::REVISION]);
  
		if (array_key_exists(CodeSearchIndexPeer::CLASS_NAME, $arr)) $this->setClassName($arr[CodeSearchIndexPeer::CLASS_NAME]);
  
		if (array_key_exists(CodeSearchIndexPeer::METHOD_NAME, $arr)) $this->setMethodName($arr[CodeSearchIndexPeer::METHOD_NAME]);
  
		if (array_key_exists(CodeSearchIndexPeer::VARIABLE_NAME, $arr)) $this->setVariableName($arr[CodeSearchIndexPeer::VARIABLE_NAME]);
  
		if (array_key_exists(CodeSearchIndexPeer::COMMENT, $arr)) $this->setComment($arr[CodeSearchIndexPeer::COMMENT]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case CodeSearchIndexPeer::CODE_SEARCH_INDEX_ID:
				$this->setCodeSearchIndexId($value);
				break;
	  
			case CodeSearchIndexPeer::CODE_SEARCH_MODULE_ID:
				$this->setCodeSearchModuleId($value);
				break;
	  
			case CodeSearchIndexPeer::FILENAME:
				$this->setFilename($value);
				break;
	  
			case CodeSearchIndexPeer::LINE:
				$this->setLine($value);
				break;
	  
			case CodeSearchIndexPeer::REVISION:
				$this->setRevision($value);
				break;
	  
			case CodeSearchIndexPeer::CLASS_NAME:
				$this->setClassName($value);
				break;
	  
			case CodeSearchIndexPeer::METHOD_NAME:
				$this->setMethodName($value);
				break;
	  
			case CodeSearchIndexPeer::VARIABLE_NAME:
				$this->setVariableName($value);
				break;
	  
			case CodeSearchIndexPeer::COMMENT:
				$this->setComment($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setCodeSearchIndexId($value);
				break;
  
			case 1:
				$this->setCodeSearchModuleId($value);
				break;
  
			case 2:
				$this->setFilename($value);
				break;
  
			case 3:
				$this->setLine($value);
				break;
  
			case 4:
				$this->setRevision($value);
				break;
  
			case 5:
				$this->setClassName($value);
				break;
  
			case 6:
				$this->setMethodName($value);
				break;
  
			case 7:
				$this->setVariableName($value);
				break;
  
			case 8:
				$this->setComment($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(CodeSearchIndexPeer::DATABASE_NAME);

		try {
			$con->begin();
			CodeSearchIndexPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(CodeSearchIndexPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aCodeSearchModule !== null) {
				if ($this->aCodeSearchModule->isModified()) $this->aCodeSearchModule->save($con);
				$this->setCodeSearchModule($this->aCodeSearchModule);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CodeSearchIndexPeer::doInsert($this, $con);
					$this->setCodeSearchIndexId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					CodeSearchIndexPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return CodeSearchIndexPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aCodeSearchModule !== null) {
				if (($retval = $this->aCodeSearchModule->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = CodeSearchIndexPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed code_search_index_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setCodeSearchIndexId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getCodeSearchIndexId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return CodeSearchIndex Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new CodeSearchIndex();
		$copyObj->setCodeSearchModuleId($this->code_search_module_id);
		$copyObj->setFilename($this->filename);
		$copyObj->setLine($this->line);
		$copyObj->setRevision($this->revision);
		$copyObj->setClassName($this->class_name);
		$copyObj->setMethodName($this->method_name);
		$copyObj->setVariableName($this->variable_name);
		$copyObj->setComment($this->comment);
		
		$copyObj->setNew(true);
		
		$copyObj->setCodeSearchIndexId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return CodeSearchIndexPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CodeSearchIndexPeer();
		}
		return self::$peer;
	}

}
