<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists ScmModule
//

require_once('plugins/scm/lib/ScmModule.php');

$project = GFUrl::getUrl()->getProject();

// Retrieve the objects array
$crit = new Criteria();
$crit->add(ScmModulePeer::PROJECT_ID, $project->getProjectId());
$crit->addAscendingOrderByColumn(ScmModulePeer::PATH);
$arr = ScmModulePeer::doSelect($crit);

$support_www_publish = (isset($support_www_publish)) ? $support_www_publish : false;

$www_publish_none = true;

$theader = array();

$theader[] = $Lang->getText('ScmModule.ScmModuleIdName');
$theader[] = $Lang->getText('ScmModule.PathName');
if ($support_www_publish) {
	$theader[] = $Lang->getText('ScmModule.UseForWebPublishing');
}
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');
$theader[] = $Lang->getText('ScmModule.Permissions');

?>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('ScmModulesUpdateAction') ?>" method="post" name="ScmForm" id="ScmForm">
<?php
echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('ScmModule.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		if ($item->getPublishToWww()) $www_publish_none = false;
		$trow = array();
		$trow[]=$item->getScmModuleId();
		$trow[]=$item->getPath();
		if ($support_www_publish) {
			$trow[]='<input type="radio" name="publish_to_www" value="'.$item->getScmModuleId().'" '.(( $item->getPublishToWww()) ? 'checked="checked"' : '').'/>';
		}
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmModuleEdit', array('id' => $item->getScmModuleId())).'">'. $Lang->getText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmModuleDelete', array('id' => $item->getScmModuleId())).'">'. $Lang->getText('Delete') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmModuleUserEdit', array('id' => $item->getScmModuleId())).'">'. $Lang->getText('ScmModule.EditPermissions') .'</a>';;

		echo $theme->tableRow($trow);
	}
}

// Add one more row for disabling www publishing
if ($support_www_publish) {
	$trow = array($Lang->getText('ScmModule.DontUseWebPublishing'),
				'<input type="radio" name="publish_to_www" value="0" '.($www_publish_none ? 'checked="checked"' : '').' />','&nbsp;','&nbsp;','&nbsp;');
	$tmod = array('colspan="2"','','','','');

	echo $theme->tableRow($trow, $tmod);
	echo $theme->tableBottom(array('<a href="javascript:document.ScmForm.submit();">Update</a>',
								'<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmModuleAdd').'">'. $Lang->getText('ScmModule.AddNew') .'</a>'));
} else {
	echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmModuleAdd').'">'. $Lang->getText('ScmModule.AddNew') .'</a>'));
}

?>
</form>
