<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('GFUrl.php');

$project = GFUrl::getUrl()->getProject();
$scmplugin = $project->getPluginByName('scm');
if (is_null($scmplugin)) {
	throw new InvalidPluginException('scm');
}

// this retrieves the handler for the selected SCM (CVS, SVN, etc)
$selectedPlugin = $scmplugin->getScmHandler();

if (!is_null($selectedPlugin)) {
	// If the plugin exists, redirect to the plugin page.
	// Otherwise, it means the plugin is not selected, so display selection page
	
	//@todo	We'll have to change the way this URL is generated once we program
	//support for sub-plugins
	Webutils::redirect(GFUrl::getUrl()->projectURL($project, '', $selectedPlugin->getName()));
}

require_once('html/ScmAdminTemplate.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$lang = $session->getLanguage();

$template = new ScmAdminTemplate();
$params = array(
		'selectedbottomtab'	=> 'scm',
		'project' => $project
	);
$template->header($params);

$scmplugin = $project->getPluginByName('scm');
?>

<a href="<?php echo GFUrl::getUrl()->projectURL($project, '', 'scm', 'admin'); ?>"><?php echo $lang->getText('Scm.Admin'); ?></a>

<form method="post" action="<?php echo GFUrl::getUrl()->currentBaseUrl('SelectScmAction') ?>">
<p>
<?php
	// SCM has not been configured for this project
	echo $lang->getText('ScmAdmin.SelectHandler');
	echo "<br />\n";
	
	// get a list of SCM plugins
	$availableSCM = $scmplugin->getAvailableHandlers();
	echo HTMLWidget::radioSet('scmplugin', $availableSCM);
?>
</p>
<?php echo HTMLWidget::button("submit","" .   $lang->getText('Common.Submit')  . " ","submit","","")?>
</form>

<?php
$template->footer($params);
?>
