<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: ScmTemplate.php 434 2006-02-13 15:16:13Z marcelo $
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/scmsvn/lib/html/ScmSVNTemplate.php');
require_once('lib/plugin/PluginResult.php');

class ScmSVNAdminTemplate extends ScmSVNTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab']='svn';
		$Lang = Session::getSession()->getLanguage();
		
		if(!isset($params['project']) || !is_object($params['project'])) {
			Throw new exception('Missing project object in scmsvn template');
		} 
		if(!$params['project']->getPermission()->isAdmin()) {
			Throw new PermissionDeniedException();
		}
		if (!isset($params['title'])) {
			Throw new exception('Missing title in scmsvn template');
		}
		$params['title']=' '.$Lang->getText('Scmsvn.Admin').' > '.$params['title'];
		
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','scmsvn','admin').'">'.$Lang->getText('Tabs.Admin').'</a>');
		
		return parent::header($params);
	}

	/**
	 *      getPluginNavElements - this overrides parent class and adds its own
	 *      plugin listener
	 *      @return PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
		$tprs = ActionManager::Notify('GET_SCMSVNADMIN_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		
		return $prs;
	}
	
}

?>
