<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Snippet and saves it to the 
// database
//
require_once('plugins/snippet/lib/Snippet.php');
require_once('plugins/snippet/lib/SnippetPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();

Validator::validatePOSTAction();

if (isset($_REQUEST['_trove_category_id'])) {
	$cat = Validator::sanitizeInt($_REQUEST['_trove_category_id']);
} else {
	unset($cat);
}

if (array_key_exists('sure',$_POST)) {
	$c = new Criteria();
	$c->add(SnippetPeer::SNIPPET_ID, $_REQUEST['snippet_id']);
	$Snippet = SnippetPeer::doSelectOne($c);
	if (is_object($Snippet) && $Snippet->userCanDelete()) {	
		$Snippet->delete();
		if (isset($cat)) {
			GFUrl::redirect($url->currentBaseURL(''), array('_trove_category_id' => $cat, 'feedback' => $Lang->getText('Snippet.DeleteFeedback')));
		} else {
			GFUrl::redirect($url->currentBaseURL(''), array('feedback' => $Lang->getText('Snippet.DeleteFeedback')));
		}
	} else {
		throw new PermissionDeniedException();
	}
} else {
	GFUrl::redirect($url->currentBaseURL(''), array('_trove_category_id' => $cat, 'feedback' => $Lang->getText('SnippetDeleteForm.DidntConfirm')));
}

?>