<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Snippet
//
require_once('plugins/snippet/lib/SnippetPeer.php');
require_once('plugins/snippet/lib/Snippet.php');
require_once('plugins/snippet/lib/html/SnippetTroveFilterRenderer.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/snippet/lib/html/SnippetTemplate.php');
$theme = new SnippetTemplate();

$params = array(
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Snippet.BrowsePageTitle'),
		'extra_head' => array('<META NAME="ROBOTS" CONTENT="NOINDEX,NOFOLLOW" />')
		);
$theme->header($params);
$words = (isset($_REQUEST['words']) && !empty($_REQUEST['words'])) ? $_REQUEST['words'] : '';

echo '<h3>'.$Lang->getText('Snippet.TroveSearch').'</h3>';

// Trove search
$r = new SnippetTroveFilterRenderer('snippet', 0);
echo $r->getFilterForm();

// Retrieve the objects array
$crit = new Criteria();
$arr = SnippetPeer::doSelect($crit);

echo '<br />';
echo '<h3>'.$Lang->getText('Snippet.SearchAllCategories').'</h3>';
echo '<center><form style="display: inline;" action="/gf/snippet/search/" method="get">';
echo '<input type="hidden" name="search" value="snippet_0">';
echo '<input type="hidden" name="type" value="snippet">';
echo '<input type="text" size="12" name="words" value="'.stripslashes(htmlspecialchars($words)).'" />&nbsp;';
echo HTMLWidget::button("submit",$language->getSessText('SearchBox.search'),"Search","","") ;
echo '</form></center><br />';
echo Language::getSessText('Snippet.SearchMessage');
echo '<br /><br />';

/*
$isAdmin = Session::getSession()->isSiteAdmin();

$theader = array();

$theader[] = $Lang->getText('Snippet.NameName');
$theader[] = $Lang->getText('Snippet.CreatedByName');
//$theader[] = $Lang->getText('Snippet.DescriptionName');
if ($isAdmin) {
	$theader[] = $Lang->getText('Edit');
	$theader[] = $Lang->getText('Delete');
}

echo $theme->tableTop($theader);


if (count($arr) < 1) {
	echo $theme->tableFullRow($Lang->getText('Snippet.NoneFound'));
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseURL('SnippetBrowse',array('id'=>$item->getSnippetID())) . '">'.$item->getSnippetName().'</a>';
		$trow[]=$item->getUser()->getUserLink();
//		$trow[]=$item->getDescription();
		if ($isAdmin) {
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('SnippetEdit').'&amp;snippet_id='.$item->getSnippetID() .'">'. $Lang->getText('Edit') .'</a>';
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('SnippetDelete').'&amp;snippet_id='.$item->getSnippetID() .'">'. $Lang->getText('Delete') .'</a>';
		}

		echo $theme->tableRow($trow);
	}
}

echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('SnippetAdd') => $Lang->getText('Snippet.AddNew')));
*/

$theme->footer($params);

?>
