<?php
// The parent class
require_once 'plugins/tracker/lib/om/BaseTrackerEfeTransitionEnabledScriptPeer.php';

// The object class
include_once 'plugins/tracker/lib/TrackerEfeTransitionEnabledScript.php';

/** 
 * The skeleton for this class was autogenerated by Propel  *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package plugins.tracker.lib 
 */
class TrackerEfeTransitionEnabledScriptPeer extends BaseTrackerEfeTransitionEnabledScriptPeer {
	/**
	 * Returns the list of enabled and available but disabled scripts for the transition
	 */
	public static function getEnabledAndDisabledScripts(TrackerExtraFieldElementTransition $trans) {
		$c = new Criteria();
		
		// Phew!
		$project_id = $trans->getTrackerExtraFieldElementRelatedByElementId()->getTrackerExtraField()->getTracker()->getProjectId();
		$transition_id = $trans->getPrimaryKey();
		
		$sql = "SELECT 
					tts.*, tefetes.*
				FROM tracker_transition_script tts
					LEFT OUTER JOIN (SELECT * FROM tracker_efe_transition_enabled_script WHERE tracker_extra_field_element_transition_id = $transition_id) tefetes ON tts.tracker_transition_script_id=tefetes.tracker_transition_script_id 
				WHERE
					tts.project_id IS NULL OR tts.project_id = $project_id		-- Select project and global scripts
				ORDER BY
					tefetes.exec_order ASC
			";
		
		$result = array("enabled" => array(), "disabled" => array());
		
		$rs = Propel::getConnection(self::DATABASE_NAME)->createStatement()->executeQuery($sql, ResultSet::FETCHMODE_NUM);
		while ($rs->next()) {
			$script = new TrackerTransitionScript();
			$script->hydrate($rs);
			
			$transition_id = $rs->getInt(TrackerTransitionScriptPeer::$numColumns+1);
			if (!$transition_id) {		// Null here means the script is not enabled in this transition
				$result['disabled'][] = $script;
			} else {
				$result['enabled'][] = $script;
			}
		}
		
		return $result;
	}
}
