<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'plugins/tracker/lib/om/BaseTrackerExtraFieldElementPeer.php';

// The object class
include_once 'plugins/tracker/lib/TrackerExtraFieldElement.php';

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Wed Nov 16 20:42:33 2005]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package plugins.tracker.lib 
 */
class TrackerExtraFieldElementPeer extends BaseTrackerExtraFieldElementPeer {
	private static $_pkCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	TrackerExtraFieldElement
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, TrackerExtraFieldElementPeer::$_pkCache)) {
			return TrackerExtraFieldElementPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			TrackerExtraFieldElementPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, TrackerExtraFieldElementPeer::$_pkCache)) {
			unset(TrackerExtraFieldElementPeer::$_pkCache[$pk]);
		}
	}


	/**
	 * Deletes data elements for a particular tracker extra field, given a TI
	 *
	 * @param	object $ti	The tracker item to which the extra field belongs
	 * @param	object $tef	The tracker extra field to which the data elements to delete belong
	 */
	public static function deleteElements($tefd) {
		if (!is_object($tefd)) {
			return;
		}

		try {
			$con=Propel::getConnection();

			$sql = "DELETE FROM tracker_extra_field_data WHERE tracker_extra_field_data_id IN (
				SELECT tracker_extra_field_data_id
				FROM tracker_extra_field_data
				WHERE ";

			if (!$tefd->isNew()) {
				$sql .= "
						tracker_extra_field_data_id <> " . $tefd->getTrackerExtraFieldDataId() . "
						AND ";
			}

			$sql .= "
					tracker_item_id = " . $tefd->getTrackerItem()->getTrackerItemId() . "
					AND
					tracker_extra_field_id = " . $tefd->getTrackerExtraField()->getTrackerExtraFieldId() . "
			)";

			$con->createStatement()->executeQuery($sql);
		} catch(Exception $e) {}
	}
}
?>