<?php
require_once 'propel/util/BasePeer.php';

// The object class -- needed for instanceof checks in this class.
// actual class may be a subclass -- as returned by TrackerPeer::getOMClass()
include_once 'plugins/tracker/lib/TrackerSprint.php';

include_once 'plugins/tracker/lib/om/BaseTrackerSprintPeer.php';
	
include_once 'core/Project.php';
include_once 'core/ProjectPeer.php';

/**
 * Base static class for performing query and update operations on the 'tracker' table.
 *
 *  
 *
 * @package plugins.tracker.lib 
 */
class TrackerSprintPeer extends BaseTrackerSprintPeer {
	private static $_pkCache = array();
	private static $sprintCount = array();

  /**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
     * @param   integer $projectId
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	TrackerSprint
	 */
	public static function retrieveByPk($pk, $projectId, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, TrackerSprintPeer::$_pkCache)) {
			return TrackerSprintPeer::$_pkCache[$pk];
		}

		$c = new Criteria();
		$c->add(TrackerPeer::PROJECT_ID, $projectId);
		$c->add(TrackerSprintPeer::SPRINT_ID, $pk);
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			TrackerSprintPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}

  /**
   * Removes an object from the cache. This is usually done after saving.
   * This method was added by propel_customizer.php.
   *
   * @param	mixed $pk	The primary key of the object to remove
   */
  public static function invalidate($pk) {
    if (array_key_exists($pk, TrackerSprintPeer::$_pkCache)) {
      unset(TrackerSprintPeer::$_pkCache[$pk]);
    }
  }

	public static function getTrackerSprintCount($project_id) {

		if(!array_key_exists($project_id, self::$sprintCount)) {
			$c = new Criteria();
			$c->add(TrackerSprintPeer::PROJECT_ID, $project_id);
			$total = TrackerSprintPeer::doCount($c);

			self::$sprintCount[$project_id] = $total;

		} else {
			$total = self::$sprintCount[$project_id];
		}

		return $total;
	}

  public static function getMaxTrackerSprintNumber($project_id) {

    $sql = "SELECT COALESCE(MAX(sprint_progression), 0) 
            AS max_value FROM tracker_sprint
            WHERE project_id = {$project_id}";

    $con = Propel::getConnection();
    $stmt = $con->createStatement();
    $rs = $stmt->executeQuery($sql);
    if ($rs->next()) {
        $row = $rs->getRow();
        if (count($row)) {
          return $row['max_value'];
        }
    }

    return 0;
  }
  
  /**
    * If this user is an admin for this object
    * @param	int $project_id	
    * @return boolean
  */
  public static function userIsAdmin($project_id) {     
        $proyect = ProjectPeer::retrieveByPk($project_id);
        if ($proyect->userIsAdmin()) {
            return true;
        }
	    $user = Session::getSession()->getUser();
        if (is_object($user) && $user->isSiteAdmin()) {
            return true;
        }
        $perm = $proyect->getPermission();
        if ( ($perm->check(Tracker::SECTION, 0, Tracker::PERMLEVEL_ADMIN))) {
            return true;
        }
        if ( ($perm->check(TrackerSprint::SECTION, $project_id, TrackerSprint::PERMLEVEL_ADMIN))) {
            return true;
        }
        return false;
  }

}?>
