<?php

class TrackerItemBrowseList {
	protected $tracker;
	protected $project;
	protected $isTaskTracker;
	protected $show;
	protected $start;
	protected $lang;
	protected $isTrackerAdmin;
	protected $efcache;
	protected $session;
	protected $theme;
	protected $show_query;	
	protected $str_message;
	protected $arr_node_icons;
	protected $parent_tracker_item_id;
	protected $arr_parent_node_icons;
	protected $arr_parent_nodes_path;
	protected $arr_nodes_path;
	protected $bol_has_open_nodes;
	protected $show_all;

	function __construct($theme, $show_query=true, $str_message="", $parent_tracker_item_id=0, $arr_parent_node_icons=array(), $arr_parent_nodes_path=array(), $bol_has_open_nodes=false, $show_all=false) {
		$this->project = GFUrl::getUrl()->getProject();
		$this->tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
		$this->isTaskTracker = ($this->tracker->getDatatype() == Tracker::DATATYPE_TASK);
		$this->isTrackerAdmin = $this->tracker->userIsAdmin();
		$this->session = Session::getSession();
		$this->lang = $this->session->getLanguage();
		$this->theme = $theme;
		$this->show_query = $show_query;
		$this->str_message = $str_message;
		$this->parent_tracker_item_id = $parent_tracker_item_id;
		$this->arr_parent_node_icons = $arr_parent_node_icons;
		$this->arr_parent_nodes_path = $arr_parent_nodes_path;
		$this->arr_nodes_path = array();
		$this->bol_has_open_nodes = $bol_has_open_nodes;
		$this->show_all = $show_all;

		$this->loadPreferences();
	}
	
	function showList() {
		// Build the query
		$this->show = (isset($_REQUEST['show']) ? Validator::sanitizeInt($_REQUEST['show']) : 25 );
		$this->start = (isset($_REQUEST['start']) ? Validator::sanitizeInt($_REQUEST['start']) : 0 );

		$tq = $this->getQueryObject();
		if ($this->parent_tracker_item_id != 0) {
			$TrackerItem = TrackerItemPeer::retrieveByPk($this->parent_tracker_item_id);
			$tq = $tq->getSubitemsQuery($TrackerItem);
		}
		
		if ($this->show_query &&  $this->parent_tracker_item_id == 0) {
			$this->showQuickBrowse($tq);
			$this->showQueryList();
			$this->showBrowseInstructions();
		}

		if ($this->parent_tracker_item_id == 0) {
			if ($this->show_query) {
				//echo '<div id="tracker_items">';
			}
			if ($this->str_message != "") {
				echo '<span class="feedback">' . $this->str_message . '</span><br />';
			}
		
		}
		
		$this->arr_node_icons = array();
		
		if ($tq->showTree()) {			// Whether to show the items as a tree or as a flat list
		
			// Show the "Expand" and "Collapse" buttons
			if ($this->parent_tracker_item_id == 0) {
				echo "<br />" . HTMLWidget::button("button", Session::getSession()->getLanguage()->getText('Common.CollapseAll') ,"expand_button","","doCollapseAll()");
			}

			if ($this->parent_tracker_item_id == 0) {
				echo '<div id="tracker_items">';
				$this->showTableHeader($tq, 'thierarchical','jsTrackerItemsTop');
			}
			$str_draggables_js = $this->showTrackerItemsTree($tq, 0, $this->parent_tracker_item_id);
			//$str_draggables_js = $this->showTrackerItemsTreeOLD($tq, 0);
		} else {
			$this->showTableHeader($tq);
			$str_draggables_js = $this->showTrackerItemsFlat($tq);
		}
		
		//Generate the node icons JS array
		$str_node_icons = "var arr_node_icons = new Array(); ";
		foreach($this->arr_node_icons as $node_icon_tid => $node_icon_value) {
			$str_node_icons .= 'arr_node_icons[' . $node_icon_tid . '] = "' . $node_icon_value . '"; ';
		}


		if ($this->parent_tracker_item_id == 0) {
			if ($this->show_query) {
				//echo '<script type="text/javascript"> function setDraggables() { ' . $str_draggables_js . ' } </script>';
			}
			$this->showTableFooter();
			//echo "</div>";
			//echo '<div id="tracker_items">';
			echo "<br/><p><strong>".$this->lang->getText('Tracker.DragHints1').":</strong></p>";
			echo "<ul>";
			echo "<li>".$this->lang->getText('Tracker.DragHints2')." <img src=\"/images/drag_arrow.png\" alt=\"icon\" />  ".$this->lang->getText('Tracker.DragHints3')." .</li>";
			echo "<li>".$this->lang->getText('Tracker.DragHints4').".</li>";
			//echo "</div>";
			
			if ($this->show_query) {
				//echo '</div>';
			}
	
			if ($this->show_query) {
				$this->showMassUpdate();
				//echo '</div>';
			}
			echo "</div>";
		}
		
		
		if ($this->parent_tracker_item_id == 0) {
			$str_draggables_js .= " Droppables.add(
		     	'jsTrackerItemsTop',
		   			{
		        	onDrop: function() {
		        		parentTrackerItemId = \"0\";
		        		parentTrackerItemSummary = \"No parent\";
		        		addToParent();		
		        	}
		     		}
		  		);";

			$str_draggables_js .= "new Draggable('jsTrackerItemsTop', {revert:true,
						onStart: function() {
						dropTrackerItemId = 0;
						dropTrackerItemSummary = \"No parent\";			
					}
					});";
		
			$str_nodes_path = "var arr_nodes_path = new Array(); ";
			foreach ($this->arr_nodes_path as $node_id => $node_path) {
				$str_nodes_path .= "arr_nodes_path[" . $node_id . "] = \"" . $node_path . "\"; ";
			}
			echo '<script type="text/javascript"> ' . $str_node_icons .  '; ' . $str_nodes_path . ' </script>';
		} else {
			$str_nodes_path = "";
			$str_parent_nodes_path = implode(",", $this->arr_parent_nodes_path);
			foreach($this->arr_nodes_path as $key => $value) {
				$str_nodes_path .= 'arr_nodes_path["' . $key . '"] = "' . $str_parent_nodes_path . $value . '";';
			}
			$str_node_icons = "";
			$str_parent_node_icons = implode(",", $this->arr_parent_node_icons);
			if ($str_parent_node_icons == "undefined") {
				$str_parent_node_icons = "";
			}
			foreach($this->arr_node_icons as $key => $value) {
				if ($key != $this->parent_tracker_item_id) {
					$str_node_icons .= 'arr_node_icons["' . $key . '"] = "' . $str_parent_node_icons . $value . '";';
				}
			}

		}

		if ($this->parent_tracker_item_id == 0) {
			echo '<script type="text/javascript"> function setDraggables() { ' . $str_draggables_js . ' } </script>';
		} else {
			$str_draggables = '<script type="text/javascript">' . $str_draggables_js . ' '. $str_nodes_path . ' ' . $str_node_icons . ' </script>';
			echo $str_draggables;
		}
	}
	
	/* There are 3 ways of retrieving the tracker items:
	 * 1) Running a query
	 * 2) "Remembering" the last query used,
	 * 3) Using the "Quick query" menu.
	 * 
	 * The logic goes like this: if a query is run, rememer the query_id and the current page so the
	 * user can come back to the same page if he, for example, adds a new tracker item.
	 * If a quick query is run, forget the query_id and remember the parameters of the quick query instead.
	 */
	private function loadPreferences() {
		// Saved query logic
		$preference_name = 'trkquery'.$this->tracker->getTrackerId();
		if ($this->session->isLoggedIn()) {
			$user = $this->session->getUser();
			if (!isset($_POST['quickquery']) && !isset($_GET['tracker_query_id']) && !isset($_GET['forget_query'])) {
				$saved_query = $user->getPreference($preference_name);
				if ($saved_query) {
					// Emulate a query using the saved query information
					$saved_query = unserialize($saved_query);
					$_REQUEST['tracker_query_id'] = $_GET['tracker_query_id'] = $saved_query['tracker_query_id'];
					$_REQUEST['show'] = $_GET['show'] = $saved_query['show'];
					$_REQUEST['start'] = $_GET['start'] = $saved_query['start'];
				}
			} else {
				// If using quick query, delete the saved query ID
				$user->deletePreference($preference_name);
			}
		}

		// Save the tracker_query info, if any
		if (isset($_GET['tracker_query_id']) && $this->session->isLoggedIn()) {
			$saved_query = array('tracker_query_id' => $_GET['tracker_query_id'], 'show' => $this->show, 'start' => $this->start);
			$this->session->getUser()->setPreference($preference_name, serialize($saved_query));
		}
	}
	
	private function getQueryObject() {
		if (isset($_GET['tracker_query_id'])) {
			if (!$this->session->isLoggedIn()) {
				throw new PermissionDeniedException();
			}
			$tracker_query_id = Validator::sanitizeInt($_GET['tracker_query_id']);
			$tsq = TrackerQueryPeer::retrieveByPk($tracker_query_id);
			if (!$tsq) {
				// The query got deleted for some reason
				$tq = new TrackerItemQuickQuery($this->tracker);
			} elseif (!$tsq->getIsShared() && $tsq->getUserId() != $this->session->getUser()->getUserId()) {
				throw new PermissionDeniedException();
			} else {
				$tq = new TrackerItemSavedQuery($this->tracker, $tsq);
			}
		} else {
			$tq = new TrackerItemQuickQuery($this->tracker);
		}
		return $tq;
	}
	
	private function showQuickBrowse($tq) {
		echo '<form action="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemBrowse').'&amp;tracker_id='.$this->tracker->getTrackerId().'" method="post">
		<input type="hidden" name="quickquery" value="1" /><table width="50%"><tr>';
		echo '<td><strong>'.$this->lang->getText('TrackerItem.TrackerItemIdName').'</strong><br /><input type="text" name="tracker_item_id" value="'.$tq->getTrackerItemId().'" size="4" maxlength="8" /></td>';
		echo '<td><strong>'.$this->lang->getText('TrackerItem.SummaryName').'</strong><br /><input type="text" name="summary" value="'.$tq->getSummary().'" size="10" maxlength="40" /></td>';
		echo '<td><strong>'.$this->lang->getText('TrackerItem.SubmittedByName').'</strong><br /><input type="text" name="submitted_by" value="'.$tq->getSubmittedBy().'" size="10" maxlength="40" /></td>';
		$tefr = new TrackerExtraFieldRenderer($this->tracker);
		echo $tefr->renderFields('QUICKBROWSE',null,$tq);
		echo '<td><strong>'.$this->lang->getText('Tracker.SortCol').'</strong><br />'.HTMLWidget::selectBoxFromAssoc($tq->getAvailableSortColumns(),'sortcol',$tq->getSortCol(),false,false).'</td>';
		echo '<td><strong>'.$this->lang->getText('Tracker.SortOrd').'</strong><br />'.HTMLWidget::selectBoxFromAssoc($tq->getAvailableSortOrd(),'sortord',$tq->getSortOrd(),false,false).'</td>';
		//echo '<td width="200px">'.HTMLWidget::button("submit",$this->lang->getText('Common.Browse'),"browse","","", true, "button", "position: absolute").'</td></tr></table></form>';
	}
        
        private function sortQueries(TrackerQuery $a, TrackerQuery $b) {
            $aname = $a->getQueryName();
            $bname = $b->getQueryName();
            if ($aname == $bname) {
                return 0;
            }
            return ($aname < $bname) ? -1 : 1;
        }
	
	private function showQueryList() {
		//show a list of saved queries
		if ($this->session->isLoggedIn()) {
			// Retrieve the objects array
			$crit = new Criteria();
			$cton1=$crit->getNewCriterion(TrackerQueryPeer::USER_ID, $this->session->getUser()->getID());
			$cton2=$crit->getNewCriterion(TrackerQueryPeer::IS_SHARED, true);
			$cton1->addOr($cton2);
			$crit->add($cton1);
			$queries = $this->tracker->getTrackerQuerys($crit);
                        usort($queries, 'sortQueries');

			echo '<br /><form name="querynavform" action="">
			<select name="querynav" onchange="location.href=document.querynavform.querynav.value">
			<option value="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemBrowse', array('tracker_id' => $this->tracker->getTrackerId(), 'forget_query' => 1)).'">'.$this->lang->getText('Tracker.Filter').'</option>
			<option value="'.GFUrl::getUrl()->currentBaseUrl('TrackerQueryAdd').'&amp;tracker_id='.$this->tracker->getTrackerId().'">'.$this->lang->getText('Tracker.FilterAdd').'</option>'."\n";
			$url=GFUrl::getUrl()->currentBaseUrl('TrackerItemBrowse').'&amp;tracker_id='.$this->tracker->getTrackerId().'&amp;tracker_query_id=';
			
			foreach ($queries as $query) {
				echo '	<option value="'.$url.$query->getTrackerQueryId().'" '.((isset($_REQUEST['tracker_query_id']) && $_REQUEST['tracker_query_id']==$query->getTrackerQueryId()) ? 'selected="selected"': '').'>'.$query->getQueryName().'</option>'."\n";
			}
			
			echo '	</select>
				</form><br />
			';

		}
	}
	
	private function showBrowseInstructions() {
		$browseInstructions = trim($this->tracker->getBrowseInstructions());
		if ($browseInstructions) {
			echo "<br><strong>".$browseInstructions."</strong><br>";
		}
	}
	
	private function showTableHeader($tq, $tclass='tabular', $row_id="") {
		$theader = array();

		$theader[] = $this->lang->getText('TrackerItem.TrackerItemIdName');
		$theader[] = $this->lang->getText('TrackerItem.SummaryName');
		
		if ($this->isTrackerAdmin) {
			$theader[] = $this->lang->getText('Delete');
		//	$theader[] = $this->lang->getText('TrackerItem.StatusIdName');
		}
		if ($tq->showColumn('priority')) {
			$theader[] = $this->lang->getText('TrackerItem.PriorityName');
		}
		if ($tq->showColumn('assigned_to')) {
			$theader[] = $this->lang->getText('TrackerItem.AssignedTo');
		}
		if ($tq->showColumn('submitted_by')) {
			$theader[] = $this->lang->getText('TrackerItem.SubmittedByName');
		}
		
				

		// Show the extra fields
		$efs = $this->tracker->getTrackerExtraFields();
		if($tq instanceof TrackerItemSavedQuery){
			usort($efs,array($tq,'sortByDisplayOrder'));
		}
		foreach ($efs as $ef) {
			$this->efcache[$ef->getTrackerExtraFieldId()]=$ef;
			if ($tq->showColumn($ef->getTrackerExtraFieldId())) {
				$theader[] = $ef->getFieldName();
			}
		}

		// Open, close and last modified dates
		if ($tq->showColumn('open_date')) {
			$theader[] = $this->lang->getText('TrackerItem.OpenDateName');
		}
		if ($tq->showColumn('close_date')) {
			$theader[] = $this->lang->getText('TrackerItem.CloseDateName');
		}
		if ($tq->showColumn('last_modified_date')) {
			$theader[] = $this->lang->getText('TrackerItem.LastModifiedDateName');
		}

		if ($this->parent_tracker_item_id == 0) {
			$str_expand_list = (isset($_COOKIE['expand_' . $this->tracker->getTrackerId()]) ? $_COOKIE['expand_' . $this->tracker->getTrackerId()] : "");
		} else {
			$str_expand_list = (isset($_REQUEST['expand_' . $this->tracker->getTrackerId()]) ? $_REQUEST['expand_' . $this->tracker->getTrackerId()] : "");	
		}
			
		if ($str_expand_list == "") {
				$expand_list = array();
		} else {
				$expand_list = explode(",", $str_expand_list);
		}

		echo '<form id="formmassupdate" action="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemMassUpdateAction', array('tracker_id' => $this->tracker->getTrackerId(), 'start' => $this->start, 'expand' => $str_expand_list)).'" method="post">';
		echo $this->theme->tableTop($theader, false, 'id="trackeritems"', $tclass, $row_id);
	}
	
	private function showTableFooter() {
		$button_enabled = ($this->tracker->userCanRead() && Session::getSession()->isLoggedIn());
		echo $this->theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('TrackerItemAdd').'&amp;tracker_id='.$this->tracker->getTrackerId()=>$this->lang->getText('TrackerItem.AddNew')),array($button_enabled),'jsTrackerItemsBottom');
	}
	
	/**
	 * Show the tracker items as a flat list
	 */
	function showTrackerItemsFlat(TrackerItemQuery $tq)
	{
		$tq->setGetOnlyParents(false);
		$totalcount = $tq->getTrackerItemCount();
		$arr = $tq->getTrackerItems($this->show, $this->start);

		$efs = $this->tracker->getTrackerExtraFields();
		if($tq instanceof TrackerItemSavedQuery){
			usort($efs, array($tq,'sortByDisplayOrder'));
		}
		foreach ($efs as $ef) {
			$efcache[$ef->getTrackerExtraFieldId()] = $ef;
		}

		if (count($arr) == 0 ) {
			echo $this->theme->tableFullRow($this->lang->getText('TrackerItem.NoneFound'));
		} else {
			$editurl=GFUrl::getUrl()->currentBaseUrl('TrackerItemEdit');
			$deleteurl=GFUrl::getUrl()->currentBaseUrl('TrackerItemDelete');
			for ($i=0; $i<count($arr); $i++) {
				$trow = array();
				$tmod = array();
				$trow[]=(($this->isTrackerAdmin) ? '<input type="checkbox" name="tid[]" value="'.$arr[$i]->getTrackerItemId().'" />' : '' ).''.$arr[$i]->getTrackerItemId();
				$tmod[]='';
				
				// Text that will be used on the tooltip
				$tooltip = StringUtils::trimString($arr[$i]->getDetails(), 500);
				$tooltip = StringUtils::generateTooltip($tooltip);
				
				$trow[]='<a href="'. $editurl .'&amp;tracker_item_id='.$arr[$i]->getTrackerItemID() .'&amp;start='. $this->start .'" onmouseover="tooltip(\''.$tooltip.'\');" onmouseout="tooltipexit()">'. $arr[$i]->getSummary().'</a>';
				$tmod[]='';
				if ($this->isTrackerAdmin) {
					$trow[]='<a href="'. $deleteurl .'&amp;tracker_item_id='.$arr[$i]->getTrackerItemID() .'">'. $this->lang->getText('Delete').'</a>';
					$tmod[]='';
				}
		//		$trow[]=$arr[$i]->getStatusId();;
				if ($tq->showColumn('priority')) {
					$trow[]=$arr[$i]->getPriority();
					$tmod[]='bgcolor="'.$this->theme->getPriorityColor($arr[$i]->getPriority()).'"';
				}
				if ($tq->showColumn('assigned_to')) {
					$asses = $arr[$i]->getTrackerItemAssignees();
					$assignees = '';
					foreach ($asses as $ass) {
						$assignees .= $ass->getUser()->getUserLink().'<br />';
					}
					$trow[]=$assignees;
					$tmod[]='';
					unset($assignees);
				}
				if ($tq->showColumn('submitted_by')) {
					$trow[]=UserPeer::retrieveByPk($arr[$i]->getSubmittedBy())->getUserLink();
					$tmod[]='';
				}
				$colarray=array();
				$efdatas=$arr[$i]->getTrackerExtraFieldDatas();

				foreach($efdatas as $efdata) {
					if (is_object($efcache[$efdata->getTrackerExtraFieldId()])) {
						$colarray[$efdata->getTrackerExtraFieldId()][]=$efcache[$efdata->getTrackerExtraFieldId()]->translateFieldDataToName($efdata->getFieldData());
					}
				}
				reset($efs);
					
				foreach ($efs as $ef) {
					if ($tq->showColumn($ef->getId())) {
						if (isset($colarray[$ef->getTrackerExtraFieldId()]) && count($colarray[$ef->getTrackerExtraFieldId()]) > 1) {
							$trow[] = implode('<br />',$colarray[$ef->getTrackerExtraFieldId()]);
							$tmod[]='';
						} else {
							if (isset($colarray[$ef->getTrackerExtraFieldId()])) {
								if($ef->getFieldType() == TrackerExtraField::TYPE_DATE){
									if ($colarray[$ef->getTrackerExtraFieldId()][0] != "") {
										$dt = date('Y-m-d',  strtotime($colarray[$ef->getTrackerExtraFieldId()][0]));
										$trow[] = $dt;
									} else {
										$trow[] = '--';
									}
								} else {
									$trow[] =  $colarray[$ef->getTrackerExtraFieldId()][0];
								}
									$tmod[]='';
							} else {
								$trow[] = '--';
								$tmod[]='';
							}
						}
					}
				}
				if ($tq->showColumn('open_date')) {
					$trow[]=$arr[$i]->getOpenDate('Y-m-d');
					$tmod[]='';
				}
				if ($tq->showColumn('close_date')) {
					$trow[]=(($arr[$i]->getStatusId()==Tracker::STATUS_CLOSED || $this->isTaskTracker) ? $arr[$i]->getCloseDate('Y-m-d') : '&nbsp;');
					$tmod[]='';
				}
				if ($tq->showColumn('last_modified_date')) {
					$trow[]=$arr[$i]->getLastModifiedDate('Y-m-d');
					$tmod[]='';
				}

		//echo "trow count: ".count($trow);
				echo $this->theme->tableRow($trow,$tmod,false);
				unset($trow);
				unset($tmod);
			}
		}
		
		echo $this->theme->tableBottom();
		
		//
		//	Pagination code
		//
		$pages = $totalcount / $this->show;
		$currentpage = intval($this->start / $this->show);
		$skipped_pages=false;
		for ($j=0; $j<$pages; $j++) {
			if ($pages > 20) {
				if ((($j > 4) && ($j < ($currentpage-5))) || (($j > ($currentpage+5)) && ($j < ($pages-5)))) {
					if (!$skipped_pages) {
						$skipped_pages=true;
						echo "....&nbsp;";
					}
					continue;
				} else {
					$skipped_pages=false;
				}
			}
			if ($j == $currentpage) {
				echo '<strong>'.($j+1).'</strong>&nbsp;';
			} else {
				if (isset($_GET['tracker_query_id'])) {
					$tracker_query_id = $_GET['tracker_query_id'];
					echo '<a href="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemBrowse').'&amp;tracker_id='.$this->tracker->getTrackerId().'&amp;tracker_query_id='.$tracker_query_id.'&amp;start='.($j*$this->show).'">'.($j+1).'</a>&nbsp;';
				} else {
					echo '<a href="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemBrowse').'&amp;tracker_id='.$this->tracker->getTrackerId().'&amp;start='.($j*$this->show).'">'.($j+1).'</a>&nbsp;';
				}
			}
		}
	}
	
	
	/**
	 * Recursively show the tracker items (may have subitems)
	 */
	function showTrackerItemsTree(TrackerItemQuery $tq, $level=0, $root_id=0, $special_attributes='', $arr_levels=array(), $arr_nodes_path_aux=array()) {
		if ($this->parent_tracker_item_id == 0) {
			if ($level != 0) {
				$tq->setGetOnlyParents(true);
			}
		} else {
			$tq->setGetOnlyParents(false);
		}

		$totalcount = $tq->getTrackerItemCount();

		if ($this->parent_tracker_item_id == 0 && $level == 0) {
			$arr = $tq->getTrackerItems($this->show, $this->start);
		} else {
			$arr = $tq->getTrackerItems();
		}

		$url = GFUrl::getUrl();

		if ($this->parent_tracker_item_id == 0) {
			$str_expand_list = (isset($_COOKIE['expand_' . $this->tracker->getTrackerId()]) ? $_COOKIE['expand_' . $this->tracker->getTrackerId()] : "");
		} else {
			$str_expand_list = (isset($_REQUEST['expand_' . $this->tracker->getTrackerId()]) ? $_REQUEST['expand_' . $this->tracker->getTrackerId()] : "");	
		}

		if ($str_expand_list == "") {
			$expand_list = array();
		} else {
			$expand_list = explode(",", $str_expand_list);
		}

		$str_draggables_js = '';	
		$trmod = '';

		if (count($arr) == 0 && $level == 0) {
			echo $this->theme->tableFullRow($this->lang->getText('TrackerItem.NoneFound'));
		}

		$efcache = array();
		$efs = $this->tracker->getTrackerExtraFields();
		foreach ($efs as $ef) {
			$efcache[$ef->getTrackerExtraFieldId()] = $ef;
		}

		for ($i=0; $i<count($arr); $i++) {	
			$tracker_item = $arr[$i];

			if ( ($this->parent_tracker_item_id == 0) || 
			     ( $this->parent_tracker_item_id != 0 && !$tracker_item->hasSubitems()) ||
			     $this->show_all == true) {
				$tracker_item_id = $tracker_item->getTrackerItemId();

				$arr_nodes_path_aux[$level] = $tracker_item_id;

				$str_nodes_path = "";
				for($z=0; $z <= $level; $z++) {
					$str_nodes_path .= $arr_nodes_path_aux[$z].",";
				}
				$this->arr_nodes_path[$tracker_item->getTrackerItemId()] = $str_nodes_path;

				$trow = array();
				$tmod = array();

				$trow[]=(($this->isTrackerAdmin) ? '<input type="checkbox" name="tid[]" value="'.$arr[$i]->getTrackerItemId().'" />' : '' ).' '.$arr[$i]->getTrackerItemId();
				$tmod[]='style="min-width: 50px;"';

				// Text that will be used on the tooltip
				$tooltip = StringUtils::trimString($arr[$i]->getDetails(), 500);
				$tooltip = StringUtils::generateTooltip($tooltip);

				$str_image_blank = '<td style="width: 18px; margin: 0px; padding: 0px;">' . $this->theme->image('ic/tree_blank.gif', 0, 0, array()) . '</td>';
				$str_image_line = '<td style="width: 18px; margin: 0px; padding: 0px; background: url(\'' . $this->theme->getImgRoot(). '/ic/tree_line.gif' . '\') top left repeat-y;">' . $this->theme->image('ic/tree_line.gif', 0, 0, array()) . '</td>';
				$str_image_tee = '<td style="width: 18px; margin: 0px; padding: 0px; background: url(\'' . $this->theme->getImgRoot(). '/ic/tree_line.gif' . '\') top left repeat-y;">' . $this->theme->image('ic/tree_line.gif', 0, 0, array()) . '</td>';
				
				$text = '<table  border="0" cellspacing="0" cellpadding="0" width="100%"><tr>';

				if ($level > 0 || $this->parent_tracker_item_id != 0) {
					if ($this->parent_tracker_item_id != 0) {
						for ($z=0; $z < sizeof($this->arr_parent_node_icons)-1; $z++) {
							switch ($this->arr_parent_node_icons[$z]) {
								case "B":
									$text .= $str_image_blank;
								break;

								case "F":
									$text .= $str_image_blank;
								break;
								
								case "L":
									$text .= $str_image_line;
								break;
							}
							
						}
					}

					if (!isset($this->arr_node_icons[$tracker_item->getTrackerItemId()])) {
						$this->arr_node_icons[$tracker_item->getTrackerItemId()] = "";
					}

					if (!isset($this->arr_node_icons[$root_id])) {
						$this->arr_node_icons[$root_id] = "";
					}

					foreach ($arr_levels as $bol_level) {
						if (!$bol_level) {
							//$this->arr_node_icons[$tracker_item->getTrackerItemId()] = $this->arr_node_icons[$root_id] . "T,";
							$this->arr_node_icons[$tracker_item->getTrackerItemId()] .= "L,";
							$text .= $str_image_blank;
						}	else {
							$this->arr_node_icons[$tracker_item->getTrackerItemId()] .= "B,";
							$text .= $str_image_line;
						}				
					}
	
					//if it's the last element of the branch, put a terminator icon
					if ($i == (count($arr)-1)) {
						
							$this->arr_node_icons[$tracker_item->getTrackerItemId()] = $this->arr_node_icons[$root_id] . "F,";
							if ($this->parent_tracker_item_id != 0 && $this->bol_has_open_nodes == 1) {
								$str_line_background = 'background: url(\'' . $this->theme->getImgRoot().'/ic/tree_line.gif' . '\') repeat-y;';		
							} else {
								$str_line_background = '';
							}
							$text .= '<td valign="top" width="18px" style="margin: 0px; padding: 0px; ' . $str_line_background  . '">' . $str_image = $this->theme->image('ic/tree_end.gif', 0, 0, array()) . '</td>';

					} else {
						$this->arr_node_icons[$tracker_item->getTrackerItemId()] = $this->arr_node_icons[$root_id] . "L,";
						$text .= '<td valign="top" width="18px"  style="margin: 0px; padding: 0px; background: url(\'' . $this->theme->getImgRoot().'/ic/tree_line.gif' . '\') repeat-y;">' . $str_image = $this->theme->image('ic/tree_tee.gif', 0, 0, array()) . '</td>';
					}
				}
		
				$extras = array();
				$expand_new = $expand_list;	
				if ($tracker_item->hasSubItems()) {			
					$extras['id'] = 'nimg1' . $tracker_item->getTrackerItemId();
					$extras2 = array();
					$extras2['id'] = 'nimg2' . $tracker_item->getTrackerItemId();
					$extras2['nimg2'] = '-';
					if (in_array($tracker_item_id, $expand_list)) {
						// If we're showing the subitems, the icon and the plus sign must use javascript instead of links
						$extras['onClick'] = 'doExpand(\'tiid'.$tracker_item->getTrackerItemId().'\',' . $tracker_item->getTrackerItemId() . ')';
	
						$str_tree_plus = $this->theme->image('ic/tree_minus.gif', 0, 0, $extras);
						$text .= '<td id="td' . $tracker_item->getTrackerItemId() . '" valign="top" width="18px" style="margin: 0px; padding: 0px; background: url(\'' . $this->theme->getImgRoot().'/ic/tree_line.gif' . '\');"><a href="javascript:;">'. $str_tree_plus .'</a></td>' . '<td style="padding-top: 3px;" valign="top" width="18px">' . $this->theme->image('ic/ofolder16.png', 0, 0, $extras2) . '</td>';
					} else {
						$extras['onClick'] = 'doExpandNewNode(' . $tracker_item->getTrackerItemId() . ');';
						$str_tree_plus = $this->theme->image('ic/tree_plus.gif', 0, 0, $extras);
		
						if (!in_array($tracker_item_id, $expand_list)) {
							$expand_new[] = $tracker_item_id;
						}
						
						$str_url = ' <a href="javascript:;">'. $str_tree_plus .'</a>';
						$text .= '<td id="td' . $tracker_item->getTrackerItemId() . '" valign="top" width="18px" style="margin: 0px; padding: 0px;">' . $str_url . '</td>' . '<td style="padding-top: 3px;" valign="top" width="18px">' . $this->theme->image('ic/cfolder16.png', 0, 0, $extras2) . '</td>';
					}
				}

				// (Marcelo) Can't we do this using the trow[]/tmod[] mechanism?
				$text .= '<td style="line-height: 32px; min-width: 150px;" valign="top" width="100%" id=" ' . $tracker_item->getTrackerItemId() . '"><div class="jsTrackerItems moveHandle" style="line-height: 18px; padding-top: 4px; padding-bottom: 2px;" id="jsTrackerItemId_' . $tracker_item->getTrackerItemId() . '">&nbsp;&nbsp;';
				$str_tracker_edit_url = GFUrl::getUrl()->currentBaseUrl('TrackerItemEdit', array('tracker_item_id' => $arr[$i]->getTrackerItemID(), 'start' => $this->start));
				$text .= '<a href="javascript:;" onclick="doEditTrackerItem(\''. $str_tracker_edit_url .'\');" onmouseover="tooltip(\''.$tooltip.'\');" onmouseout="tooltipexit()">'. $arr[$i]->getSummary() .'</a>&nbsp;&nbsp;&nbsp;<img id="dragicon_' . $tracker_item->getTrackerItemId() . '" class="drag_area" onmouseover="tooltip(\''.$this->lang->getText('Tracker.DragDropTooltip').'.\'); setDraggingIcon(\'dragicon_' . $tracker_item->getTrackerItemId() . '\');" onmouseout="tooltipexit(); setDragIcon(\'dragicon_' . $tracker_item->getTrackerItemId() . '\');" src="/images/drag_arrow.png" /></div></td>';
	
				$text .= '</tr></table>';
				$trow[] = $text;
				$tmod[]='';
	
				if ($this->isTrackerAdmin) {
					$trow[]='<a href="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemDelete', array('tracker_item_id' => $arr[$i]->getTrackerItemID())).'">'. $this->lang->getText('Delete').'</a>';
					$tmod[]='';
				}
	
				if ($tq->showColumn('priority')) {
					$trow[]=$arr[$i]->getPriority();
					$tmod[]='bgcolor="'.$this->theme->getPriorityColor($arr[$i]->getPriority()).'"';
				}
				if ($tq->showColumn('assigned_to')) {
					$asses = $arr[$i]->getTrackerItemAssignees();
					$assignees = '';
					foreach ($asses as $ass) {
						$assignees .= $ass->getUser()->getUserLink().'<br />';
					}
					$trow[]=$assignees;
					$tmod[]='';
					unset($assignees);
				}
				if ($tq->showColumn('submitted_by')) {
					$trow[]=UserPeer::retrieveByPk($arr[$i]->getSubmittedBy())->getUserLink();
					$tmod[]='';
				}
				$colarray=array();
				$efdatas=$arr[$i]->getTrackerExtraFieldDatas();
	
				$colarray=array();
				$efdatas=$arr[$i]->getTrackerExtraFieldDatas();

				foreach($efdatas as $efdata) {
					if (is_object($efcache[$efdata->getTrackerExtraFieldId()])) {
						$colarray[$efdata->getTrackerExtraFieldId()][]=$efcache[$efdata->getTrackerExtraFieldId()]->translateFieldDataToName($efdata->getFieldData());
					}
				}
				reset($efs);
				foreach ($efs as $ef) {
					if ($ef->getUseInQuickBrowse()) {
						if (isset($colarray[$ef->getTrackerExtraFieldId()]) && count($colarray[$ef->getTrackerExtraFieldId()]) > 1) {
							$trow[] = implode('<br />',$colarray[$ef->getTrackerExtraFieldId()]);
							$tmod[]='';
						} else {
							if (isset($colarray[$ef->getTrackerExtraFieldId()])) {
								if($ef->getFieldType() == TrackerExtraField::TYPE_DATE){
									if ($colarray[$ef->getTrackerExtraFieldId()][0] != "") {
										$dt = date('Y-m-d',  strtotime($colarray[$ef->getTrackerExtraFieldId()][0]));
										$trow[] = $dt;
									} else {
										$trow[] = '--';
									}
								} else {
									$trow[] =  $colarray[$ef->getTrackerExtraFieldId()][0];
								}
									$tmod[]='';
							} else {
								$trow[] = '--';
								$tmod[]='';
							}
						}
					}
				}
				if ($tq->showColumn('open_date')) {
					$trow[]=$arr[$i]->getOpenDate('Y-m-d');
					$tmod[]='';
				}
				if ($tq->showColumn('close_date')) {
					$trow[]=(($arr[$i]->getStatusId()==Tracker::STATUS_CLOSED || $this->isTaskTracker) ? $arr[$i]->getCloseDate('Y-m-d') : '&nbsp;');
					$tmod[]='';
				}
				if ($tq->showColumn('last_modified_date')) {
					$trow[]=$arr[$i]->getLastModifiedDate('Y-m-d');
					$tmod[]='';
				}	

				if ($this->parent_tracker_item_id != 0) {		
					for($z=0; $z < sizeof($this->arr_parent_nodes_path)-2; $z++) {
						$special_attributes .= ' tiid'. $this->arr_parent_nodes_path[$z] . '="+"';
					}
					$special_attributes .= ' tiid'. $this->arr_parent_nodes_path[sizeof($this->arr_parent_nodes_path)-2] . '="-"';
				}

				$param_special_attributes = $special_attributes;
				if ($tracker_item->hasSubItems()) {				
					$param_special_attributes .= ' id="node_id_' . $tracker_item_id . '" tlevel="' . $level . '" tnode="' . $tracker_item->getTrackerItemId() . '"';
				}

				echo $this->theme->tableRow($trow,$tmod,false,$trmod,'', $param_special_attributes);
				if ($tracker_item->hasSubItems()) {
					echo '<!--tracker_item_row-' . $tracker_item_id . '-->';
				}

				$str_delimiter = ($this->parent_tracker_item_id != 0) ? ";" : ";";

				//Create draggable for this row
				$str_draggables_js .= "new Draggable('jsTrackerItemId_" . $tracker_item->getTrackerItemId() . "', {revert:true,
					onStart: function() {
					dropTrackerItemId = " . $tracker_item->getTrackerItemId()  . ";
					dropTrackerItemSummary = \"" . $tracker_item->getSummary()  . "\";					
				}
				})"  . $str_delimiter;
				
				$str_draggables_js .= "Droppables.add(
	     	'jsTrackerItemId_" . $tracker_item->getTrackerItemId() . "',
	   			{
	        	onDrop: function() {
	        		parentTrackerItemId = " . $tracker_item->getTrackerItemId()  . ";
	        		parentTrackerItemSummary = \"" . $tracker_item->getSummary()  . "\";
	        		addToParent();		
	        	}
	     		}
	  		)" . $str_delimiter;
/*
				// Show child tasks recursively
				if ($tracker_item->hasSubItems() && in_array($tracker_item_id, $expand_list)) {
					$arr_levels_aux = $arr_levels;
					if ($level > 0) {
						if ($i != (count($arr)-1) && $level > 0) {
							$arr_levels_aux[] = true;
						} else {
							$arr_levels_aux[] = false;
						}
					}
					$sub_special_attributes = str_replace('"-"', '"+"', $special_attributes);
					$sub_special_attributes .= ' tiid'. $tracker_item->getTrackerItemId() . '="-"';
					$subiq = $tq->getSubitemsQuery($tracker_item);
					$str_draggables_js .= $this->showTrackerItemsTree($subiq, $level+1, ($level == 0 ? $root_id : $tracker_item->getTrackerItemId()), $sub_special_attributes, $arr_levels_aux, $arr_nodes_path_aux);
				}
*/
				unset($trow);
				unset($tmod);
			}
		}

		//
		//	Pagination code
		//
		if ($level == 0 && $this->parent_tracker_item_id == 0) {
			echo $this->theme->tableBottom();
			$pages = $totalcount / $this->show;
			$currentpage = intval($this->start / $this->show);
			$skipped_pages=false;
			for ($j=0; $j<$pages; $j++) {
				if ($pages > 20) {
					if ((($j > 4) && ($j < ($currentpage-5))) || (($j > ($currentpage+5)) && ($j < ($pages-5)))) {
						if (!$skipped_pages) {
							$skipped_pages=true;
							echo "....&nbsp;";
						}
						continue;
					} else {
						$skipped_pages=false;
					}
				}
				if ($j == $currentpage) {
					echo '<strong>'.($j+1).'</strong>&nbsp;';
				} else {
					if (isset($_GET['tracker_query_id'])) {
						echo '<a href="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemBrowse', array()).'&amp;tracker_id='.$this->tracker->getTrackerId().'&amp;tracker_query_id='.$_GET['tracker_query_id'].'&amp;start='.($j*$this->show).'">'.($j+1).'</a>&nbsp;';
					} else {
						echo '<a href="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemBrowse', array()).'&amp;tracker_id='.$this->tracker->getTrackerId().'&amp;start='.($j*$this->show).'">'.($j+1).'</a>&nbsp;';
					}
				}
			}
		}

		return $str_draggables_js;
	}	

	private function showMassUpdate() {
		if ($this->isTrackerAdmin) {
			echo '<table width="100%" style="clear:left;">';
			$tefr = new TrackerExtraFieldRenderer($this->tracker);
			echo $tefr->renderFields('MASSUPDATE');
			echo '<tr><td>'.HTMLWidget::button("button",$this->lang->getText('Tracker.MassUpdate'),"browse","","doMassUpdate()").'</td></tr></table></form>';
		}
	}

} 
