<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';
 

// (on-demand) include_once 'core/Filesystem.php';
// (on-demand) include_once 'core/FilesystemPeer.php';

include_once 'plugins/tracker/lib/TrackerTransitionScriptPeer.php';

/**
 * Base class that represents a row from the 'tracker_transition_script' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerTransitionScript class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerTransitionScript extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerTransitionScriptPeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_transition_script_id field.
	 * @var int	  
	 */
	protected $tracker_transition_script_id;	

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the script_filesystem_id field.
	 * @var int	  
	 */
	protected $script_filesystem_id;	

	/**
	 * The value for the script_path field.
	 * @var string	  
	 */
	protected $script_path;	

	/**
	 * The value for the description field.
	 * @var string	  
	 */
	protected $description;	
  
	/**
	 * Get the TrackerTransitionScriptId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerTransitionScriptId()
	{
		return $this->tracker_transition_script_id;
	}


	/**
	 * Set the value of `tracker_transition_script_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerTransitionScriptId($v)
	{
		if ($this->tracker_transition_script_id !== $v) {
			$this->tracker_transition_script_id = $v;
			$this->modifiedColumns[] = TrackerTransitionScriptPeer::TRACKER_TRANSITION_SCRIPT_ID;
		}
			
		  // update associated TrackerEfeTransitionEnabledScript		  
		  if ($this->collTrackerEfeTransitionEnabledScripts !== null) {
			  for ($i=0,$size=count($this->collTrackerEfeTransitionEnabledScripts); $i < $size; $i++) {
				  $this->collTrackerEfeTransitionEnabledScripts[$i]->setTrackerTransitionScriptId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = TrackerTransitionScriptPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the ScriptFilesystemId column value.
	 *  
	 * @return int	  
	 */
	public function getScriptFilesystemId()
	{
		return $this->script_filesystem_id;
	}


	/**
	 * Set the value of `script_filesystem_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setScriptFilesystemId($v)
	{
		if ($this->script_filesystem_id !== $v) {
			$this->script_filesystem_id = $v;
			$this->modifiedColumns[] = TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID;
		}
			
		if ($this->aFilesystem !== null && $this->aFilesystem->getFilesystemId() !== $v) {
			$this->aFilesystem = null;
		}
			
	}

  
	/**
	 * Get the ScriptPath column value.
	 *  
	 * @return string	  
	 */
	public function getScriptPath()
	{
		return $this->script_path;
	}


	/**
	 * Set the value of `script_path` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setScriptPath($v)
	{
		if ($this->script_path !== $v) {
			$this->script_path = $v;
			$this->modifiedColumns[] = TrackerTransitionScriptPeer::SCRIPT_PATH;
		}
				
	}

  
	/**
	 * Get the Description column value.
	 *  
	 * @return string	  
	 */
	public function getDescription()
	{
		return $this->description;
	}


	/**
	 * Set the value of `description` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDescription($v)
	{
		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = TrackerTransitionScriptPeer::DESCRIPTION;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_transition_script_id = $rs->getInt($startcol + 0);					
			$this->project_id = $rs->getInt($startcol + 1);					
			$this->script_filesystem_id = $rs->getInt($startcol + 2);					
			$this->script_path = $rs->getString($startcol + 3);					
			$this->description = $rs->getString($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerTransitionScript object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerTransitionScriptPeer::DATABASE_NAME);
		$criteria->add(TrackerTransitionScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $this->tracker_transition_script_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerTransitionScriptPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerTransitionScriptPeer::TRACKER_TRANSITION_SCRIPT_ID)) $criteria->add(TrackerTransitionScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $this->tracker_transition_script_id);
		if ($this->isColumnModified(TrackerTransitionScriptPeer::PROJECT_ID)) $criteria->add(TrackerTransitionScriptPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID)) $criteria->add(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID, $this->script_filesystem_id);
		if ($this->isColumnModified(TrackerTransitionScriptPeer::SCRIPT_PATH)) $criteria->add(TrackerTransitionScriptPeer::SCRIPT_PATH, $this->script_path);
		if ($this->isColumnModified(TrackerTransitionScriptPeer::DESCRIPTION)) $criteria->add(TrackerTransitionScriptPeer::DESCRIPTION, $this->description);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addTrackerTransitionScripts($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * @var Filesystem	  
	 */
	protected $aFilesystem;

	/**
	 * Declares an association between this object and a Filesystem object
	 *
	 * @param Filesystem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setFilesystem($v)
	{
			
		if ($v === null) {
			$this->setScriptFilesystemId(NULL);
		} else {
			$this->setScriptFilesystemId($v->getFilesystemId());
		}
   
		$this->aFilesystem = $v;
	}


	/**
	 * Get the associated Filesystem object
	 *
	 * @param Connection Optional Connection object.
	 * @return Filesystem The associated Filesystem object.
	 * @throws PropelException
	 */
	public function getFilesystem($con = null)
	{
		// include the Peer class
		include_once 'core/FilesystemPeer.php';

		if ($this->aFilesystem === null && ($this->script_filesystem_id !== null)) {
	
			$this->aFilesystem = FilesystemPeer::retrieveByPK($this->script_filesystem_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = FilesystemPeer::retrieveByPK($this->script_filesystem_id, $con);
			   $obj->addTrackerTransitionScripts($this);
			 */
		}
		return $this->aFilesystem;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setFilesystemKey($key)
	{

		$this->setScriptFilesystemId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collTrackerEfeTransitionEnabledScripts	  
	 * @var array
	 */
	protected $collTrackerEfeTransitionEnabledScripts; 

	/**
	 * Temporary storage of collTrackerEfeTransitionEnabledScripts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerEfeTransitionEnabledScripts()
	{
		if ($this->collTrackerEfeTransitionEnabledScripts === null) {
			$this->collTrackerEfeTransitionEnabledScripts = array();
		}
	}

	/**
	 * Method called to associate a TrackerEfeTransitionEnabledScript object to this object
	 * through the TrackerEfeTransitionEnabledScript foreign key attribute
	 *
	 * @param TrackerEfeTransitionEnabledScript $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerEfeTransitionEnabledScript(TrackerEfeTransitionEnabledScript $l)
	{
		$this->collTrackerEfeTransitionEnabledScripts[] = $l;
		$l->setTrackerTransitionScript($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerEfeTransitionEnabledScripts.
	 * @var Criteria
	 */
	private $lastTrackerEfeTransitionEnabledScriptsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerTransitionScript has previously
	 * been saved, it will retrieve related TrackerEfeTransitionEnabledScripts from storage.
	 * If this TrackerTransitionScript is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerEfeTransitionEnabledScripts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionEnabledScriptPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerEfeTransitionEnabledScripts === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionEnabledScripts = array();
			} else {
	
				$criteria->add(TrackerEfeTransitionEnabledScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $this->getTrackerTransitionScriptId() );

				$this->collTrackerEfeTransitionEnabledScripts = TrackerEfeTransitionEnabledScriptPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerEfeTransitionEnabledScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $this->getTrackerTransitionScriptId());

				if (!isset($this->lastTrackerEfeTransitionEnabledScriptsCriteria) || !$this->lastTrackerEfeTransitionEnabledScriptsCriteria->equals($criteria)) {
					$this->collTrackerEfeTransitionEnabledScripts = TrackerEfeTransitionEnabledScriptPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerEfeTransitionEnabledScriptsCriteria = $criteria;

		return $this->collTrackerEfeTransitionEnabledScripts;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerTransitionScript is new, it will return
	 * an empty collection; or if this TrackerTransitionScript has previously
	 * been saved, it will retrieve related TrackerEfeTransitionEnabledScripts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerTransitionScript.
	 */
	public function getTrackerEfeTransitionEnabledScriptsJoinTrackerExtraFieldElementTransition($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionEnabledScriptPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionEnabledScripts === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionEnabledScripts = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionEnabledScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $this->getTrackerTransitionScriptId());
				$this->collTrackerEfeTransitionEnabledScripts = TrackerEfeTransitionEnabledScriptPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionEnabledScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $this->getTrackerTransitionScriptId());
			if (!isset($this->lastTrackerEfeTransitionEnabledScriptsCriteria) || !$this->lastTrackerEfeTransitionEnabledScriptsCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionEnabledScripts = TrackerEfeTransitionEnabledScriptPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionEnabledScriptsCriteria = $criteria;

		return $this->collTrackerEfeTransitionEnabledScripts;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerTransitionScript is new, it will return
	 * an empty collection; or if this TrackerTransitionScript has previously
	 * been saved, it will retrieve related TrackerEfeTransitionEnabledScripts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerTransitionScript.
	 */
	public function getTrackerEfeTransitionEnabledScriptsJoinTrackerTransitionScript($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionEnabledScriptPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionEnabledScripts === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionEnabledScripts = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionEnabledScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $this->getTrackerTransitionScriptId());
				$this->collTrackerEfeTransitionEnabledScripts = TrackerEfeTransitionEnabledScriptPeer::doSelectJoinTrackerTransitionScript($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionEnabledScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $this->getTrackerTransitionScriptId());
			if (!isset($this->lastTrackerEfeTransitionEnabledScriptsCriteria) || !$this->lastTrackerEfeTransitionEnabledScriptsCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionEnabledScripts = TrackerEfeTransitionEnabledScriptPeer::doSelectJoinTrackerTransitionScript($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionEnabledScriptsCriteria = $criteria;

		return $this->collTrackerEfeTransitionEnabledScripts;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_transition_script_id", "project_id", "script_filesystem_id", "script_path", "description", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerTransitionScriptPeer::TRACKER_TRANSITION_SCRIPT_ID:
				return $this->getTrackerTransitionScriptId();
				break;
		  
			case TrackerTransitionScriptPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID:
				return $this->getScriptFilesystemId();
				break;
		  
			case TrackerTransitionScriptPeer::SCRIPT_PATH:
				return $this->getScriptPath();
				break;
		  
			case TrackerTransitionScriptPeer::DESCRIPTION:
				return $this->getDescription();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerTransitionScriptId();
				break;
  
			case 1:
				return $this->getProjectId();
				break;
  
			case 2:
				return $this->getScriptFilesystemId();
				break;
  
			case 3:
				return $this->getScriptPath();
				break;
  
			case 4:
				return $this->getDescription();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerTransitionScriptPeer::TRACKER_TRANSITION_SCRIPT_ID, $arr)) $this->setTrackerTransitionScriptId($arr[TrackerTransitionScriptPeer::TRACKER_TRANSITION_SCRIPT_ID]);
  
		if (array_key_exists(TrackerTransitionScriptPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[TrackerTransitionScriptPeer::PROJECT_ID]);
  
		if (array_key_exists(TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID, $arr)) $this->setScriptFilesystemId($arr[TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID]);
  
		if (array_key_exists(TrackerTransitionScriptPeer::SCRIPT_PATH, $arr)) $this->setScriptPath($arr[TrackerTransitionScriptPeer::SCRIPT_PATH]);
  
		if (array_key_exists(TrackerTransitionScriptPeer::DESCRIPTION, $arr)) $this->setDescription($arr[TrackerTransitionScriptPeer::DESCRIPTION]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerTransitionScriptPeer::TRACKER_TRANSITION_SCRIPT_ID:
				$this->setTrackerTransitionScriptId($value);
				break;
	  
			case TrackerTransitionScriptPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case TrackerTransitionScriptPeer::SCRIPT_FILESYSTEM_ID:
				$this->setScriptFilesystemId($value);
				break;
	  
			case TrackerTransitionScriptPeer::SCRIPT_PATH:
				$this->setScriptPath($value);
				break;
	  
			case TrackerTransitionScriptPeer::DESCRIPTION:
				$this->setDescription($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerTransitionScriptId($value);
				break;
  
			case 1:
				$this->setProjectId($value);
				break;
  
			case 2:
				$this->setScriptFilesystemId($value);
				break;
  
			case 3:
				$this->setScriptPath($value);
				break;
  
			case 4:
				$this->setDescription($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerTransitionScriptPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerTransitionScriptPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerTransitionScriptPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}
 
			if ($this->aFilesystem !== null) {
				if ($this->aFilesystem->isModified()) $this->aFilesystem->save($con);
				$this->setFilesystem($this->aFilesystem);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerTransitionScriptPeer::doInsert($this, $con);
					$this->setTrackerTransitionScriptId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerTransitionScriptPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collTrackerEfeTransitionEnabledScripts !== null) {
				for ($i=0,$size=count($this->collTrackerEfeTransitionEnabledScripts); $i < $size; $i++) {
					$this->collTrackerEfeTransitionEnabledScripts[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerTransitionScriptPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aFilesystem !== null) {
				if (($retval = $this->aFilesystem->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerTransitionScriptPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collTrackerEfeTransitionEnabledScripts !== null) {
				for ($i=0,$size=count($this->collTrackerEfeTransitionEnabledScripts); $i < $size; $i++) {
					if (($retval = $this->collTrackerEfeTransitionEnabledScripts[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_transition_script_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerTransitionScriptId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerTransitionScriptId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerTransitionScript Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerTransitionScript();
		$copyObj->setProjectId($this->project_id);
		$copyObj->setScriptFilesystemId($this->script_filesystem_id);
		$copyObj->setScriptPath($this->script_path);
		$copyObj->setDescription($this->description);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getTrackerEfeTransitionEnabledScripts() as $relObj) {
				$copyObj->addTrackerEfeTransitionEnabledScript($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerTransitionScriptId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerTransitionScriptPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerTransitionScriptPeer();
		}
		return self::$peer;
	}

}
