<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/tracker/lib/Tracker.php');
require_once('plugins/tracker/lib/TrackerQuery.php');
require_once('lib/core/UserPreference.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('exceptions/NotLoggedInException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

//force login
$sess = Session::getSession();
if (!$sess->isLoggedIn()) {
	throw new NotLoggedInException();
}

// The query being added as a tickler
$tracker_query_id = Validator::sanitizeInt($_REQUEST['tracker_query_id']);
$tracker_id = Validator::sanitizeInt($_REQUEST['tracker_id']);

if ($tracker_query_id > 0) {
    $preference_prefix = "ti-tq-{$tracker_id}";

    $prefs = UserPreferencePeer::getUserPrefsByUserAndPrefix($sess->getUser()->getUserId(), $preference_prefix);

    foreach ($prefs as $pref) {
        if ($pref->getPreferenceValue() == $tracker_query_id) {
            $pref->delete();
            break;
        }
    }
}

$url = GFUrl::getUrl()->currentBaseURL('TrackerItemBrowse', array('tracker_id' => $tracker_id));
GFUrl::getUrl()->redirect($url);
