<?php
/**
 * Copyright (c) 2005-2013 GForge, LLC
 *
 * @author Hector Pizarro <hpizarro@gforgegroup.com>
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists TrackerExtraFieldElementTransition
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

$myGFUrl = GFUrl::getUrl();
$Project = $myGFUrl->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraFieldElementTransition.BrowsePageTitle')
		);
$theme->header($params);
$theader = array();
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.FieldName');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.FromElementIdName');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.ToElementIdName');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Roles');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Fields');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Notify');
echo $theme->tableTop($theader);

$data = TrackerPeer::getWorkflowRulesData($Tracker->getTrackerId());
if (count($data['nTEF']) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('TrackerExtraFieldElementTransition.NoneFound').'</span>');
} else {
	$prevField = '';
	$prevElement = '';
	foreach ($data['rows'] as $d) {
		$tdContent = array();// TD content
		$tdAttr = array();// TD attributes
		if ($d['tracker_extra_field_id'] != $prevField) {
			$nRows = $data['nTEF'][$d['tracker_extra_field_id']];
			$href = $myGFUrl->projectURL($Project, 'WorkflowMatrix',
				'tracker','admin',
				array('tracker_extra_field_id' => $d['tracker_extra_field_id'])
			);
			$tdContent[] = "<a href='{$href}'>{$d['field_name']}</a>";
			$tdAttr[]='rowspan="'. $nRows .'"';
			$prevField=$d['tracker_extra_field_id'];
		}
		if ($d['element_id'] != $prevElement) {
			$tdContent[]=$d['element_name'] . '<br />(' . (($d['alias'] !== '') ? $d['alias'] : 'alias not defined') . ')';
			$tdAttr[]='rowspan="'.$data['nElem'][$d['element_id']].'"';
			$prevElement=$d['element_id'];
		}
		$idTEFETI = 'tracker_extra_field_element_transition_id';
		$href = $myGFUrl->projectURL($Project, 
			'TrackerExtraFieldElementTransitionEdit','tracker','admin',
			array($idTEFETI => $d[$idTEFETI],
				'element_id' => $d['element_id'],
				'return_to' => 'rules'
			)
		);
		$tdContent[] = "<a href='{$href}'>{$d['to_value']}</a>";
		$tdAttr[]='';
		$tdContent[] = implode(',',$d['roles']);
		$tdAttr[]='';
		$tdContent[] = implode(',',$d['fields']);
		$tdAttr[]='';
		$tdContent[] = implode(',',$d['notifs']);
		$tdAttr[]='';
		echo $theme->tableRow($tdContent,$tdAttr);
	}
}

echo $theme->tableBottom();

$theme->footer($params);
