<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Tracker and saves it to the
// database
//
require_once('plugins/tracker/lib/Tracker.php');
require_once('plugins/tracker/lib/TrackerPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Project = GFUrl::getUrl()->getProject();
$perm = $Project->getPermission();
$tracker_id = isset($_REQUEST['tracker_id']) ? $_REQUEST['tracker_id'] : 0;
$str_tids_delete = isset($_REQUEST['tids_delete']) ? $_REQUEST['tids_delete'] : array();
if (isset($_POST['sure'])) {
	$tids_delete = explode(',', $str_tids_delete);

	if (count($tids_delete) == 0) {
		GFUrl::redirect($url->currentBaseUrl('TrackerItemBrowse'),array('tracker_id'=>$tracker_id,'feedback' => Language::getSessLang()->getText('TrackerItem.NoTrackerItemsSelected')));
	}

	$Tracker = TrackerPeer::retrieveByPk($tracker_id);
	if (!is_object($Tracker)) {
		throw new PermissionDeniedException();
	}

	$tracker_items = array();
	foreach ($tids_delete as $tracker_item_id) {
		$TrackerItem = TrackerItemPeer::retrieveByPk($tracker_item_id);
		if (is_object($TrackerItem) && $TrackerItem->userCanDelete()) {
			$TrackerItem->delete();

		} else {
			throw new PermissionDeniedException();
		}
	}

	$feedback = Language::getSessLang()->getText('TrackerDeleteForm.Deleted');
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('TrackerItemBrowse'), array('tracker_id' => $tracker_id, 'feedback' => $feedback));

} else {
	$feedback = Language::getSessLang()->getText('TrackerDeleteForm.DidntConfirm');
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('TrackerItemMassDelete'), array('tids_delete' => $str_tids_delete, 'tracker_id' => $tracker_id, 'feedback' => $feedback));
}

?>
