<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing TrackerItem
//
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('plugins/tracker/lib/html/TrackerExtraFieldRenderer.php');
require_once('plugins/frs/lib/FrsReleasePeer.php');
require_once('plugins/frs/lib/FrsRelease.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerItem = TrackerItemPeer::retrieveByPk($_REQUEST['tracker_item_id']);
if (!is_object($TrackerItem)) {
	throw new PermissionDeniedException();
}
$Tracker=$TrackerItem->getTracker();
$tracker_item_id = $TrackerItem->getTrackerItemId();
if (!is_object($TrackerItem) || !$TrackerItem->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$obj = $TrackerItem;

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'tracker_item' => $TrackerItem,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('TrackerItem.MergePageTitle')
		);

include('forms/TrackerItemMerge-tpl.php');

?>
