<?php
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('plugins/tracker/lib/TrackerSprint.php');
require_once('plugins/tracker/lib/TrackerSprintPeer.php');
require_once('plugins/tracker/lib/html/TrackerSprintTemplate.php');
require_once('plugins/tracker/lib/html/TrackerExtraFieldRenderer.php');
require_once ('lib/ProjectNotification.php');
require_once ('core/Notification.php');

if ($_SERVER['REQUEST_METHOD'] != 'GET') {
    throw new PermissionDeniedException();
}

//force login
$Session = Session::getSession();
if (!$Session->isLoggedIn()) {
    throw new NotLoggedInException();
}
$Lang = $Session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$sprint_id = $_REQUEST['sprint_id'];
$TrackerSprint = TrackerSprintPeer::retrieveByPk($sprint_id, $Project->getProjectId());

if (!$TrackerSprint) {
	throw new InvalidDataException('Invalid tracker sprint id: '.$sprint_id);
}

if (!$TrackerSprint->userIsAdmin()) {
	throw new PermissionDeniedException();
}

if ($TrackerSprint->getSprintStatus() == TrackerSprint::STATUS_IN_PROGRESS) {
  $TrackerSprint->setSprintStatus(TrackerSprint::STATUS_CLOSED);
  $TrackerSprint->save();
}

$message = $Lang->getText('TrackerSprint.CloseFeedback', array($TrackerSprint->getSprintTitleText()));
GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerSprintBrowse', array('feedback' => $message,'sprint_id'=>$TrackerSprint->getSprintId())));
?>
