<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Sprint and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerSprint.php');
require_once('plugins/tracker/lib/TrackerSprintPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Project = GFUrl::getUrl()->getProject();
$perm = $Project->getPermission();
$sprint_id = Validator::sanitizeInt($_REQUEST['sprint_id']);
if (isset($_POST['sure'])) {
	$TrackerSprint = TrackerSprintPeer::retrieveByPk($sprint_id, $Project->getProjectId());

	if (!is_object($TrackerSprint)) {
		throw new InvalidDataException('Invalid Id: '.$sprint_id);
	}

	if ($TrackerSprint->userIsAdmin()) {
        $name = $TrackerSprint->getName();
		$TrackerSprint->delete();
        $feedback = Language::getSessLang()->getText('TrackerSprint.Deleted', array($name));
		GFUrl::getUrl()->redirect(GFUrl::getUrl()->projectURL($Project, 'TrackerSprintBrowse', 'tracker','',array('feedback' => $feedback)));
	} else {
		throw new PermissionDeniedException();
	}
} else {
	$feedback = Language::getSessLang()->getText('TrackerSprintDeleteForm.DidntConfirm');
	// GFUrl::redirect($url->projectURL($Project, '','','sprint',array('feedback' => $feedback)));
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->projectURL($Project, 'TrackerSprintBrowse', 'tracker','',array('feedback' => $feedback)));

}