<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing TrackerCannedResponse
//
require_once('plugins/tracker/lib/TrackerCannedResponsePeer.php');
require_once('plugins/tracker/lib/TrackerCannedResponse.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerCannedResponse = TrackerCannedResponsePeer::retrieveByPk($_GET['tracker_canned_response_id']);
$Tracker=$TrackerCannedResponse->getTracker();
if (!is_object($Tracker) || !$Tracker->userIsAdmin()) {
	throw new PermissionDeniedException();
}
$obj = $TrackerCannedResponse;

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('TrackerCannedResponse.EditPageTitle')
		);

$tracker_id = $Tracker->getTrackerId();
$tracker_canned_response_id = $TrackerCannedResponse->getTrackerCannedResponseId();
$title = ( (isset($_POST) && isset($_POST['title'])) ? htmlspecialchars($_POST['title']) : $obj->getTitle() );
$body = ( (isset($_POST) && isset($_POST['body'])) ? htmlspecialchars($_POST['body']) : $obj->getBody() );

include ('forms/TrackerCannedResponseEdit-tpl.php');

?>