<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new TrackerExtraField and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerExtraField.php');
require_once('plugins/tracker/lib/TrackerExtraFieldPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$TrackerExtraField = TrackerExtraFieldPeer::retrieveByPk($_REQUEST['tracker_extra_field_id']);
if (!is_object($TrackerExtraField)) {
	throw new PermissionDeniedException();
}
$Tracker = $TrackerExtraField->getTracker();
if (is_object($Tracker) && $Tracker->userIsAdmin()) {
	if ($_POST['sure']) {
		$TrackerExtraField->delete();
		GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldBrowse'), array('feedback' => Language::getSessLang()->getText('TrackerExtraField.DeleteFeedback'), 'tracker_id'=>$Tracker->getTrackerId()));
	} else {
		$feedback = Language::getSessLang()->getText('TrackerExtraFieldDelete.DidntConfirm');
		GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldBrowse'), array('feedback' =>$feedback, 'tracker_id'=>$Tracker->getTrackerId()));
	}
} else {
	throw new PermissionDeniedException();
}

?>
