<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for TrackerExtraFieldElementTransition
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');
require_once('GFUrl.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$project = GFUrl::getUrl()->getProject();
$TrackerExtraFieldElement = TrackerExtraFieldElementPeer::retrieveByPk($_REQUEST['element_id']);
$Tracker = $TrackerExtraFieldElement->getTrackerExtraField()->getTracker();
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementTransitionBrowse').'&amp;element_id='.$_REQUEST['element_id'].'">'. $Lang->getText('TrackerExtraFieldElement.DefineRules') .'</a>');
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementBrowse').'&amp;tracker_extra_field_id='.$TrackerExtraFieldElement->getTrackerExtraField()->getId().'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraFieldElement.Edit') .'</a>');
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse').'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>');

$params = array(
		'project' => $project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($feedback) ? $feedback : '',
		'title' => $Lang->getText('TrackerExtraFieldElementTransition.AddNewPageTitle')
		);

$element_id=((isset($_POST['element_id'])) ? htmlspecialchars($_POST['element_id']) : '' );
$to_element_id=((isset($_POST['to_element_id'])) ? htmlspecialchars($_POST['to_element_id']) : '' );

$con = Propel::getConnection();
$stmt = $con->createStatement();
$tid=$TrackerExtraFieldElement->getTrackerExtraFieldId();
$sql="SELECT * FROM tracker_extra_field_element 
	WHERE tracker_extra_field_id='".$tid."'
	AND element_id != '".$TrackerExtraFieldElement->getElementId()."'
	AND element_id NOT IN (SELECT to_element_id FROM tracker_extra_field_element_transition WHERE element_id='".$TrackerExtraFieldElement->getElementId()."')";
$rs=$stmt->executeQuery($sql,ResultSet::FETCHMODE_NUM);
$toElements=TrackerExtraFieldElementPeer::populateObjects($rs);
//no other possible transitions - redirect back
if (count($toElements) < 1) {
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementTransitionBrowse'), array('element_id'=>$TrackerExtraFieldElement->getElementId(),'feedback' => $Lang->getText('TrackerExtraFieldElementTransition.AllDefined')));
}
$crit=new Criteria();
$crit->add(TrackerExtraFieldPeer::FIELD_TYPE,array(TrackerExtraField::TYPE_SELECT,TrackerExtraField::TYPE_RADIO,TrackerExtraField::TYPE_STATUS),Criteria::IN);
$fields=$Tracker->getTrackerExtraFields($crit);

include('forms/TrackerExtraFieldElementTransitionAdd-tpl.php');

?>
