<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists TrackerExtraFieldElementTransition
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerExtraFieldElement = TrackerExtraFieldElementPeer::retrieveByPk($_REQUEST['element_id']);
$Tracker = $TrackerExtraFieldElement->getTrackerExtraField()->getTracker();
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementBrowse').'&amp;tracker_extra_field_id='.$TrackerExtraFieldElement->getTrackerExtraField()->getId().'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraFieldElement.Edit') .'</a>');
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse').'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>');

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraFieldElementTransition.BrowsePageTitle')
		);
$theme->header($params);


$arr = $TrackerExtraFieldElement->getTrackerExtraFieldElementTransitionsRelatedByElementId();



echo "<strong>Transition rules allow you to specify which users can change this field. Add a rule 
for each value change that you wish to control.</strong><p>";


$theader = array();

$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.ToElementIdName');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Roles');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Fields');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Notify');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('TrackerExtraFieldElementTransition.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=TrackerExtraFieldElementPeer::retrieveByPk($item->getToElementId())->getElementName();
		$roles=$item->getTrackerExtraFieldElementTransitionRolesJoinRole();
		$rolearr=array();
		foreach ($roles as $role) {
			$rolearr[]=$role->getRole()->getRoleName();
		}
		$trow[]=implode(',',$rolearr);;
		$fields=$item->getTrackerExtraFieldElementTransitionFieldsJoinTrackerExtraField();
		$fieldarr=array();
		foreach ($fields as $field) {
			$fieldarr[]=$field->getTrackerExtraField()->getFieldName();
		}
		$trow[]=implode(',',$fieldarr);
		$roles=$item->getTrackerExtraFieldElementTransitionNotifys();
		$rolearr=array();
		foreach ($roles as $role) {
			$rolearr[]=$role->getName();
		}
		$trow[]=implode(',',$rolearr);;
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementTransitionEdit').'&amp;element_id='.$TrackerExtraFieldElement->getElementID().'&amp;tracker_extra_field_element_transition_id='.$item->getTrackerExtraFieldElementTransitionID() .'">'. $Lang->getText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementTransitionDelete').'&amp;tracker_extra_field_element_transition_id='.$item->getTrackerExtraFieldElementTransitionID() .'">'. $Lang->getText('Delete') .'</a>';

		echo $theme->tableRow($trow);
	}
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementTransitionAdd').'&amp;element_id='.$TrackerExtraFieldElement->getElementID() .'">'. $Lang->getText('TrackerExtraFieldElementTransition.AddNew') .'</a>'));

$theme->footer($params);

?>
