<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version	  $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This	file is	part of	GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This	code shows a form for TrackerExtraFieldElementTransition
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');
require_once('plugins/tracker/lib/TrackerEfeTransitionTrigger.php');
require_once('GFUrl.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
$Lang =	$session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$project = GFUrl::getUrl()->getProject();
$TrackerExtraFieldElement =	TrackerExtraFieldElementPeer::retrieveByPk($_REQUEST['element_id']);
if (!is_object($TrackerExtraFieldElement)) {
	throw new PermissionDeniedException();
}
$Tracker = $TrackerExtraFieldElement->getTrackerExtraField()->getTracker();
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementTransitionBrowse').'&amp;element_id='.$_REQUEST['element_id'].'">'.	$Lang->getText('TrackerExtraFieldElement.DefineRules') .'</a>');
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementBrowse').'&amp;tracker_extra_field_id='.$TrackerExtraFieldElement->getTrackerExtraField()->getId().'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraFieldElement.Edit') .'</a>');
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse').'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>');

$params	= array(
		'project' => $project,
		'tracker' => $Tracker,
		'action' =>	isset($action) ? $action : '',
		'feedback' => isset($feedback) ? $feedback : '',
		'title'	=> $Lang->getText('TrackerExtraFieldElementTransition.EditPageTitle')
		);

$element_id=((isset($_POST['element_id'])) ? htmlspecialchars($_POST['element_id'])	: '' );
$to_element_id=((isset($_POST['to_element_id'])) ? htmlspecialchars($_POST['to_element_id']) : '' );

$tracker_extra_field_element_transition_id=((isset($_REQUEST['tracker_extra_field_element_transition_id']))	? htmlspecialchars($_REQUEST['tracker_extra_field_element_transition_id']) : ''	);

//Get "nobody" role object
$c = new Criteria();
$c->add(RolePeer::PROJECT_ID, null);
$nobody_role = RolePeer::doSelectOne($c);

if (is_object($nobody_role)) {
	$nobody_role_id = $nobody_role->getRoleId();
	$nobody_role_name = $nobody_role->getRoleName();
} else {
	$nobody_role_id = -1;
	$nobody_role_name = '';
}

$con = Propel::getConnection();
$stmt =	$con->createStatement();
$tid=$TrackerExtraFieldElement->getTrackerExtraFieldId();
$sql="SELECT * FROM	tracker_extra_field_element	
	WHERE tracker_extra_field_id='".$tid."'
	AND	element_id != '".$TrackerExtraFieldElement->getElementId()."'";
	//"AND element_id NOT IN (SELECT to_element_id FROM	tracker_extra_field_element_transition WHERE element_id='".$TrackerExtraFieldElement->getElementId()."')";

$rs=$stmt->executeQuery($sql,ResultSet::FETCHMODE_NUM);
$toElements=TrackerExtraFieldElementPeer::populateObjects($rs);

$tracker_extra_field_element_transition	= TrackerExtraFieldElementTransitionPeer::retrieveByPK($tracker_extra_field_element_transition_id);

$roles = $tracker_extra_field_element_transition->getTrackerExtraFieldElementTransitionRolesJoinRole();
$rolearr=array();
foreach	($roles	as $role) {
	$rolearr[]=$role->getRole()->getRoleId();
}
$fields	= $tracker_extra_field_element_transition->getTrackerExtraFieldElementTransitionFieldsJoinTrackerExtraField();
$fieldarr=array();
foreach	($fields as	$field)	{
	$fieldarr[]=$field->getTrackerExtraField()->getTrackerExtraFieldId();
}

//List roles as well as "Member" EFs
$notify_arr = array();
//Roles first
foreach ($project->getRoles() as $role) {
  $notify_arr["role;" . $role->getRoleId()] = $role->getRoleName();
}
//Add Member's extra fields
$c = new Criteria();
$c->add(TrackerExtraFieldPeer::TRACKER_ID, $Tracker->getTrackerId());
$c->add(TrackerExtraFieldPeer::FIELD_TYPE, TrackerExtraField::TYPE_MEMBERS);
$efs = TrackerExtraFieldPeer::doSelect($c);
foreach ($efs as $ef) {
  $notify_arr["members;" . $ef->getTrackerExtraFieldId()] = "Member: " . $ef->getFieldName();
}


$notify_roles =	$tracker_extra_field_element_transition->getTrackerExtraFieldElementTransitionNotifys();
$notify_rolearr=array();
foreach	($notify_roles as $role) {
	$notify_rolearr[]=$role->getSection() . ';' . $role->getRefId();
}

$reassign_to_roles = $tracker_extra_field_element_transition->getTrackerEfeTransitionReassigns();
$reassign_to=array();
foreach	($reassign_to_roles	as $reassign_to_role) {
	$reassign_to[]=$reassign_to_role->getAssignToRoleId();
}

// Extra fields	to update
$available_extra_fields_to	= array();
$available_elements = array();
$c = new Criteria();
$c->add(TrackerExtraFieldPeer::TRACKER_ID, $Tracker->getTrackerId());
$extra_fields =	TrackerExtraFieldPeer::doSelect($c);
foreach	($extra_fields as $extra_field)	{
	switch ($extra_field->getFieldType()) {
	case TrackerExtraField::TYPE_SELECT:
	//case TrackerExtraField::TYPE_CHECKBOX:
	case TrackerExtraField::TYPE_RADIO:
	case TrackerExtraField::TYPE_STATUS:
		if ($extra_field->getTrackerExtraFieldId() == $TrackerExtraFieldElement->getTrackerExtraField()->getTrackerExtraFieldId()) {
			// don't show the current element
			break;
		}
		$available_extra_fields_to[] = $extra_field;
		// Get the values
		$available_elements[$extra_field->getTrackerExtraFieldId()] = $extra_field->getTrackerExtraFieldElements();
		break;
	default:
		break;
	}
}

// Get the default value to switch to
// NOTE: currently only one field is allowed to change
$c = new Criteria();
$c->add(TrackerEfeTransitionTriggerPeer::TRACKER_EXTRA_FIELD_ELEMENT_TRANSITION_ID, $tracker_extra_field_element_transition_id);
$trigger = TrackerEfeTransitionTriggerPeer::doSelectOne($c);
if (is_object($trigger)) {
	$default_change_extra_field_id = $trigger->getChangeTrackerExtraFieldId();
	$default_to_element_id = $trigger->getToElementId();
} else {
	$default_change_extra_field_id = 0;
	$default_to_element_id = 0;
}

// List of enabled and disabled scripts
$scripts = TrackerEfeTransitionEnabledScriptPeer::getEnabledAndDisabledScripts($tracker_extra_field_element_transition);

include('forms/TrackerExtraFieldElementTransitionEdit-tpl.php');

?>
