<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new TrackerExtraFieldElementTransition and saves it to the 
// database
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionRole.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionNotify.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionField.php');
require_once('plugins/tracker/lib/TrackerEfeTransitionReassign.php');
require_once('plugins/tracker/lib/TrackerEfeTransitionTrigger.php');
require_once('plugins/tracker/lib/TrackerEfeTransitionEnabledScript.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$session = Session::getSession();
$Lang = $session->getLanguage();
$project = GFUrl::getUrl()->getProject();
$TrackerExtraFieldElement = TrackerExtraFieldElementPeer::retrieveByPk($_REQUEST['element_id']);
$TrackerExtraField = $TrackerExtraFieldElement->getTrackerExtraField();
$Tracker = $TrackerExtraField->getTracker();
if (!is_object($Tracker) || !$Tracker->userIsAdmin()) {
	throw new PermissionDeniedException();
}

$TrackerExtraFieldElementTransition = TrackerExtraFieldElementTransitionPeer::retrieveByPK($_REQUEST['tracker_extra_field_element_transition_id']);

try {
	$TrackerExtraFieldElementTransition->setElementId( Validator::sanitizeInt($_POST['element_id']) );

	if (isset($_REQUEST['role_id']) && is_array($_REQUEST['role_id']) && count($_REQUEST['role_id']) > 0) {
		$tefetr=$TrackerExtraFieldElementTransition->getTrackerExtraFieldElementTransitionRolesJoinRole();
		foreach($tefetr as $tefetr_obj){
			$tefetr_obj->delete();
		}
		foreach ($_REQUEST['role_id'] as $role) {
			if ($role == '') {

			} else {
				$tefetr=new TrackerExtraFieldElementTransitionRole();
				$tefetr->setRoleId($role);
				$TrackerExtraFieldElementTransition->addTrackerExtraFieldElementTransitionRole($tefetr);
			}
		}
	}
	if (isset($_REQUEST['notify_role_id']) && is_array($_REQUEST['notify_role_id']) && count($_REQUEST['notify_role_id']) > 0) {
		$tefetr=$TrackerExtraFieldElementTransition->getTrackerExtraFieldElementTransitionNotifys();
		foreach($tefetr as $tefetr_obj){
			$tefetr_obj->delete();
		}
		foreach ($_REQUEST['notify_role_id'] as $v) {
      $vs   = explode(';', $v);
      $type = $vs[0];
      $id   = $vs[1];
			if ($v == '') {

			} else {
        if ($type == 'role') {
          $tefetr=new TrackerExtraFieldElementTransitionNotify();
          $tefetr->setRoleId($id);
          $TrackerExtraFieldElementTransition->addTrackerExtraFieldElementTransitionNotify($tefetr);
        } else if ($type == 'members') {
          
          $tefetr=new TrackerExtraFieldElementTransitionNotify();
          $tefetr->setSection("members");
          $tefetr->setRefId($id);
          $TrackerExtraFieldElementTransition->addTrackerExtraFieldElementTransitionNotify($tefetr);
        }
      }
		}
	} else {
		$tefetr=$TrackerExtraFieldElementTransition->getTrackerExtraFieldElementTransitionNotifys();
		foreach($tefetr as $tefetr_obj){
			$tefetr_obj->delete();
		}
	}
	if (isset($_REQUEST['reassign_to_role_id']) && is_array($_REQUEST['reassign_to_role_id']) && count($_REQUEST['reassign_to_role_id']) > 0) {
		$tefetr=$TrackerExtraFieldElementTransition->getTrackerEfeTransitionReassigns();
		foreach($tefetr as $tefetr_obj){
			$tefetr_obj->delete();
		}
		foreach ($_REQUEST['reassign_to_role_id'] as $role) {
			if ($role == '') {

			} else {

				$tefetr=new TrackerEfeTransitionReassign();
				$tefetr->setAssignToRoleId($role);
				$TrackerExtraFieldElementTransition->addTrackerEfeTransitionReassign($tefetr);
			}
		}
	} else {
		$tefetr=$TrackerExtraFieldElementTransition->getTrackerEfeTransitionReassigns();
		foreach($tefetr as $tefetr_obj){
			$tefetr_obj->delete();
		}
	}
	if (isset($_REQUEST['tracker_extra_field_id']) && is_array($_REQUEST['tracker_extra_field_id']) && count($_REQUEST['tracker_extra_field_id']) > 0) {
		$tefetr=$TrackerExtraFieldElementTransition->getTrackerExtraFieldElementTransitionFieldsJoinTrackerExtraField();
		foreach($tefetr as $tefetr_obj){
			$tefetr_obj->delete();
		}
		foreach ($_REQUEST['tracker_extra_field_id'] as $fieldid) {
			if ($fieldid == '') {

			} else {
				$tefetr=new TrackerExtraFieldElementTransitionField();
				$tefetr->setRequiredTrackerExtraFieldId($fieldid);
				$TrackerExtraFieldElementTransition->addTrackerExtraFieldElementTransitionField($tefetr);
			}
		}
	} else {
		$tefetr=$TrackerExtraFieldElementTransition->getTrackerExtraFieldElementTransitionFieldsJoinTrackerExtraField();
		foreach($tefetr as $tefetr_obj){
			$tefetr_obj->delete();
		}
	}
	$TrackerExtraFieldElementTransition->setNotificationMessage(Validator::sanitizeString($_REQUEST['notification_message']));
	$TrackerExtraFieldElementTransition->save();
	
	// Save the transition trigger (if any)
	$c = new Criteria();
	$c->add(TrackerEfeTransitionTriggerPeer::TRACKER_EXTRA_FIELD_ELEMENT_TRANSITION_ID, $TrackerExtraFieldElementTransition->getTrackerExtraFieldElementTransitionId());
	if (isset($_POST['change_tracker_extra_field_id']) && !empty($_POST['change_tracker_extra_field_id'])) {
		$trigger = TrackerEfeTransitionTriggerPeer::doSelectOne($c);
		if (empty($trigger)) {
			$trigger = new TrackerEfeTransitionTrigger();
			$trigger->setTrackerExtraFieldElementTransitionId($TrackerExtraFieldElementTransition->getTrackerExtraFieldElementTransitionId());
		}
		
		$trigger->setChangeTrackerExtraFieldId($_POST['change_tracker_extra_field_id']);
		$trigger->setToElementId($_POST['to_element_id']);
		$trigger->save();
	} else {
		TrackerEfeTransitionTriggerPeer::doDelete($c);
	}
	
	// Remove the old script associations
	$c = new Criteria();
	$c->add(TrackerEfeTransitionEnabledScriptPeer::TRACKER_EXTRA_FIELD_ELEMENT_TRANSITION_ID, $TrackerExtraFieldElementTransition->getPrimaryKey());
	TrackerEfeTransitionEnabledScriptPeer::doDelete($c);
	// Save the transition scripts
	if (!empty($_POST['workflow_scripts_ids'])) {
		$enabledScriptIds = explode(',', $_POST['workflow_scripts_ids']);
		$exec_order = 1;
		foreach ($enabledScriptIds as $enabledScriptId) {
			$trans = new TrackerEfeTransitionEnabledScript();
			$trans->setTrackerExtraFieldElementTransition($TrackerExtraFieldElementTransition);
			$trans->setTrackerTransitionScriptId($enabledScriptId);
			$trans->setExecOrder($exec_order++);
			$trans->save();
		}
	}
	

	if (isset($_REQUEST['return_to']) && $_REQUEST['return_to'] == 'matrix') {
		GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('WorkflowMatrix'), array('feedback' => $Lang->getText('TrackerExtraFieldElementTransition.EditFeedback'), 'tracker_extra_field_id'=>$TrackerExtraField->getTrackerExtraFieldId()));
	} else {
		GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementTransitionBrowse'), array('feedback' => $Lang->getText('TrackerExtraFieldElementTransition.EditFeedback'),'element_id'=>$_POST['element_id']));
	}
} catch (InvalidDataException $ex) {
	$errors = $ex->getErrors();		// attach object errors to validation errors
	$feedback = '* '.implode('<br />* ', $errors);
	
	include('TrackerExtraFieldElementTransitionEdit.php');

}
?>
