<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Tracker and saves it to the
// database
//
require_once('plugins/tracker/lib/Tracker.php');
require_once('plugins/tracker/lib/TrackerPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Project = GFUrl::getUrl()->getProject();
$perm = $Project->getPermission();
if (isset($_POST['sure'])) {
	$tids_to_delete = isset($_REQUEST['tid_delete']) ? $_REQUEST['tid_delete'] : array();
	$trackers = array();
	foreach ($tids_to_delete as $tracker_item_id => $value) {
		$TrackerItem = TrackerItemPeer::retrieveByPk($tracker_item_id);
		if (is_object($TrackerItem) && $TrackerItem->userIsAdmin()) {
			$TrackerItem->delete();
		} else {
			throw new PermissionDeniedException();
		}
	}

	if ($perm->check(TrackerPlugin::SECTION, 0, TrackerPlugin::ADMIN)) {
		GFUrl::redirect($url->currentBaseURL('TrackerBrowse'), array('feedback' => Language::getSessLang()->getText('TrackerItem.Deleted')));
	} else {
		GFUrl::redirect($url->projectURL($Project, '','','tracker',array('feedback' => Language::getSessLang()->getText('TrackerItem.Deleted'))));
	}

} else {
	$feedback = Language::getSessLang()->getText('TrackerItemDeleteForm.DidntConfirm');
	if ($perm->check(TrackerPlugin::SECTION, 0, TrackerPlugin::ADMIN)) {
		GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('TrackerBrowse'), array('feedback' => $feedback,'tracker_id'=>$_REQUEST['tracker_id']));
	} else {
		GFUrl::redirect($url->projectURL($Project, '','','tracker',array('feedback' => $feedback)));
	}
}

?>
