<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/tracker/lib/TrackerTransitionScript.php');

$session = Session::getSession();
$lang = $session->getLanguage();
$project = $url->getProject();

if (!GFConf::get('tracker.enableWorkflowScripts')) {
	throw new PermissionDeniedException();
}

if (is_null($project)) {
	include_once('lib/html/templates/SiteAdminTemplate.php');
	$theme = new SiteAdminTemplate();
} else {
	include_once('lib/html/templates/ProjectAdminTemplate.php');
	$theme = new ProjectAdminTemplate();
}

$params = array(
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $lang->getText('Tracker.DeletePageTitle')
		);
if (!is_null($project)) {
 	if (!$project->getEnableWorkflowScripts()) {
		throw new PermissionDeniedException();
	}
	$params['project'] = $project;
}

$script = TrackerTransitionScriptPeer::retrieveByPk($_REQUEST['tracker_transition_script_id']);
if (!is_object($script) || !$script->userCanDelete()) {
	throw new PermissionDeniedException();
}

$theme->header($params);
?>
<p>
	<h4><?php echo $lang->getText('Tracker.WorkflowScriptDelete') ?></h4>
</p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerTransitionScriptDeleteAction') ?>" method="post">
	<input type="hidden" name="tracker_transition_script_id" value="<?php echo $_REQUEST['tracker_transition_script_id'] ?>" />
	<table border="0">
	<tr>
		<td><strong><?php echo $lang->getText('Tracker.WorkflowScriptDeleteConfirm'); ?></strong>
		<input type="checkbox" name="sure" value="1">
		<?php 
			if ($script->getScriptType() == TrackerTransitionScript::SCRIPT_TYPE_LOCAL) {
				echo "<br />".$lang->getText("Tracker.WorkflowScriptNoFSRemove");
			}
		?>
		</td>
	</tr>
	<tr>
		<td colspan="2" align="center">
			<?php echo HTMLWidget::button("submit", $lang->getText('submit.delete'),"submit","","")?>
			<?php echo HTMLWidget::button("button", $lang->getText('submit.cancel'),"button","","javascript:history.back();")?>
		</td>
	</tr>
	</table>
</form>
<?php
$theme->footer($params);
?>
