<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
echo '<p><div class="infobox">'.$Lang->getText('Tracker.AddTrackerDescription').'</div></p>';
?>
<p>
<strong>Tracker Options</strong>
<ul>
<li><a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse'); ?>&amp;tracker_id=<?php echo Validator::sanitizeInt($_REQUEST['tracker_id']); ?>"><?php echo $Lang->getText('TrackerExtraField.Edit'); ?></a></li>
<?php /* Commit triggers only in AS */ if (GFConf::get('system.licenseType')=='advanced') { ?>
<li><a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerCommitEdit', array('tracker_id' => Validator::sanitizeInt($_REQUEST['tracker_id']))); ?>"><?php echo $Lang->getText('Tracker.TrackerCommitEdit'); ?></a></li>
<?php } ?>
<li><a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerDelete'); ?>&amp;tracker_id=<?php echo Validator::sanitizeInt($_REQUEST['tracker_id']); ?>"><?php echo $Lang->getText('Delete'); ?></a></li>
</ul>
</p>
<br />
<p>
<strong><?php echo $Lang->getText('Tracker.EditPageTitle'); ?></strong>
</p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerEditAction') ?>" method="post">
	<input type="hidden" name="tracker_id" value="<?php echo Validator::sanitizeInt($_REQUEST['tracker_id']); ?>" />
	<?php if (isset($_REQUEST['redirect_to'])) { ?>
	<input type="hidden" name="redirect_to" value="<?php echo Validator::sanitizeString($_REQUEST['redirect_to']); ?>" />
	<?php } ?>

	<table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.TrackerNameName'); ?>&nbsp;*</strong><br />
			<input type="text" name="tracker_name" value="<?php echo $tracker_name; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.DescriptionName'); ?>&nbsp;*</strong><br />
			<input type="text" name="description" value="<?php echo $description; ?>" size="40" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.IsPublicName'); ?></strong><br />
			<input type="checkbox" name="is_public" value="1" <?php echo (($is_public==1) ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.RestrictBrowseName'); ?></strong><br />
			<input type="checkbox" name="restrict_browse" value="1" <?php echo (($restrict_browse==1) ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.EmailAllUpdatesName'); ?></strong><br />
			<input type="checkbox" name="email_all_updates" value="1" <?php echo (($email_all_updates==1) ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.EmailAddressName'); ?></strong><br />
			<input type="text" name="email_address" value="<?php echo $email_address; ?>" /></td>
		</tr>
		<tr>
			<td>
				<br />
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.SenderEmailAddress'); ?></strong><br /></td>
		</tr>
		<tr>
			<td>
				<input type="text" name="email_alias" value="<?php echo $email_alias; ?>"  />@<?php echo GFConf::get('system.hostName'); ?>
			</td>
		</tr>
		<tr>
			<td>
				<br />
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.DuePeriodName'); ?></strong><br />
			<input type="text" name="due_period" value="<?php echo ($due_period/(60*60*24)); ?>" size="3" maxlength="3" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.SubmitInstructionsName'); ?></strong><br />
			<textarea name="submit_instructions" rows="10" cols="60"><?php echo $submit_instructions; ?></textarea></td>
		</tr>
		<?php
			$SubmitInstructions = new GFCKEditor();
			$SubmitInstructions->replace('submit_instructions');
		?>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.BrowseInstructionsName'); ?></strong><br />
			<textarea name="browse_instructions" rows="10" cols="60"><?php echo $browse_instructions; ?></textarea></td>
		</tr>
		<?php
			$BrowseInstructions = new GFCKEditor();
			$BrowseInstructions->replace('browse_instructions');
		?>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.AutoresponseInstructionsName'); ?></strong><br />
			<textarea name="autoresponse_instructions" rows="10" cols="60"><?php echo $autoresponse_instructions; ?></textarea></td>
		</tr>
		<tr>
			<td>
				<div class="infobox" style="margin-left: 0px;"><?php echo $Lang->getText('Tracker.NagEmailHelp'); ?></div>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowDependenciesTab'); ?></strong><br />
			<input type="checkbox" name="show_dependencies_tab" value="1" <?php echo ($show_dependencies_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowDuplicatesTab'); ?></strong><br />
			<input type="checkbox" name="show_duplicates_tab" value="1" <?php echo ($show_duplicates_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tabs.ShowAssociationsTab'); ?></strong><br />
			<input type="checkbox" name="show_associations_tab" value="1" <?php echo ($show_associations_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowTimeTrackingTab'); ?></strong><br />
			<input type="checkbox" name="show_time_tracking_tab" value="1" <?php echo ($show_time_tracking_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tabs.ShowTagsTab'); ?></strong><br />
			<input type="checkbox" name="show_tags_tab" value="1" <?php echo ($show_tags_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.SendAbbreviatedEmail'); ?></strong><br />
			<input type="checkbox" name="send_abbreviated_email" value="1" <?php echo ($send_abbreviated_email ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td>
				<br />
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.EnableNagAlerts'); ?></strong><br />
			<input type="checkbox" name="enable_nag_alerts" value="1" <?php echo ($enable_nag_alerts ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><br /><strong><?php echo $Lang->getText('Tracker.SettingsDetails'); ?></strong></td>
		</tr>
		<tr>
			<td>
				<table>
		<?php
			foreach($arr_status as $element_id => $status) {
		?>
			<tr>
				<td><strong><?php echo $status['element_name']; ?></strong></td>
				<td><input name="arr_status_nagtime[<?php echo $element_id; ?>]" size="4" value="<?php echo $status['nagtime']; ?>" /></td>
			</tr>
		<?php
			}
		?>
				</table>
			</td>
		</tr>
		<tr>
			<td><br /><strong><?php echo $Lang->getText('Tracker.StatusNagText'); ?></strong><br />
			<textarea name="tracker_status_nag_text" rows="10" cols="60"><?php echo $tracker_status_nag_text; ?></textarea></td>
		</tr>
		<tr>
			<td>
				<div class="infobox" style="margin-left: 0px;"><?php echo $Lang->getText('Tracker.NagEmailHelp'); ?></div>
			</td>
		</tr>
		<tr>
			<td>
				<br />
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.EnableCustomerNagAlerts'); ?></strong><br />
			<input type="checkbox" name="enable_customer_nag_alerts" value="1" <?php echo ($enable_customer_nag_alerts ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><br /><strong><?php echo $Lang->getText('Tracker.CustomerSettingsDetails'); ?></strong></td>
		</tr>
		<tr>
			<td>
				<table>
		<?php
			foreach($arr_customer_status as $element_id => $status) {
		?>
			<tr>
				<td><strong><?php echo $status['element_name']; ?></strong></td>
				<td><input name="arr_customer_status_nagtime[<?php echo $element_id; ?>]" size="4" value="<?php echo $status['nagtime']; ?>" /></td>
			</tr>
		<?php
			}
		?>
				</table>
			</td>
		</tr>
		<tr>
			<td><br /><strong><?php echo $Lang->getText('Tracker.CustomerStatusNagText'); ?></strong><br />
			<textarea name="tracker_customer_status_nag_text" rows="10" cols="60"><?php echo $tracker_customer_status_nag_text; ?></textarea></td>
		</tr>
		<tr>
			<td>
				<div class="infobox" style="margin-left: 0px;"><?php echo $Lang->getText('Tracker.NagEmailHelp'); ?></div>
			</td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.AutoCloseSettingsTitle'); ?></strong><br />
		</tr>
		<tr>
			<td>
				<input type="text" name="auto_close_interval" value="<?php echo $auto_close_setting; ?>" />&nbsp;<strong><?php echo $Lang->getText('Tracker.AutoCloseSettingInterval'); ?></strong>
			</td>
		</tr>
		<tr>
			<td>
				<?php if (sizeof($arr_closed_statuses) > 0) { ?>
				<?php echo HTMLWidget::select('auto_close_status', $arr_closed_statuses, $auto_close_status, null, false); ?>&nbsp;<strong><?php echo $Lang->getText('Tracker.AutoCloseStatusSet'); ?></strong>
				<?php } else { ?>
					<br /><span style="color: red;"><?php echo $Lang->getText('Tracker.AutoCloseNoClosedStatuses'); ?></span>
				<?php } ?>
			</td>
		</tr>
		<tr>
			<td>
				<br />
			</td>
		</tr>
		<tr>
			<td align="center">
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Cancel') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'TrackerEdit','tracker','admin',array('tracker_id' => $Tracker->getTrackerId())) . "'; ")?>
			</td>
		</tr>
	</table>
</form>
<?php
$theme->footer($params);
?>
