<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);

if ($TrackerExtraField->getFieldType() == TrackerExtraField::TYPE_STATUS) {
    echo '<p><div class="infobox">'.$Lang->getText('Common.templateUpdating').' By providing your status an alias you can change the status of a tracker item in a source code commit using the alias. For example if you had a status named Pull Request and gave it an alias of pull-request then you can move a tracker item into that status using something like: "[#1234,pull-request] Pushed changes to fix issue #1234".  This will move tracker item #1234 into the Pull Request status.</div></p>';
?>
<script type="text/javascript">
  $(document).ready(function() {
    $(".status-value").change(function() {
      updateDefaults();
    });
    function updateDefaults() {
      statuses = $(".status-value");
      defaults = $(".default-selected");
      for (i = 0; i < statuses.length; i++) {
        if (statuses[i].value == "1") {
          //open
          $(defaults[i]).removeAttr("disabled");
        } else {
          //closed
          $(defaults[i]).attr("disabled", "disabled");
          if ($(defaults[i]).attr("checked") != undefined) {
            $(defaults[i]).removeAttr("checked");
          }
        }
      }
    }
    updateDefaults();

  });
  </script>
<?php }else{
    echo '<p><div class="infobox">'.$Lang->getText('Common.templateUpdating').'</div></p>';
    } ?>
<?php if ($TrackerExtraField->getFieldType() == TrackerExtraField::TYPE_MEMBERS && $TrackerExtraField->memberFieldIsDataDefined()) { ?>
	<div id="dialog" >
		<p><?php echo $Lang->getText('TrackerExtraField.Members.ChangeTypeWarning'); ?></p>
		<p><?php echo  $Lang->getText('TrackerExtraField.Members.ChangeTypeWarningQuestion'); ?></p>
	</div>
	<script type="text/javascript" >
		$(document).ready(function() {
			var $el = $("[name='attribute1']");

			$el.focus(function(){
				var oldVal = $("[checked='checked']").val();
				$(this).data('oldVal',oldVal);
			})
			.change(function (){
				var $this = $(this);
				var oldVal = $this.data('oldVal');
				var newVal = $this.val();
				if ((oldVal == 1 && newVal == 2) ||
					(oldVal == 2 && newVal == 1) ||
					(oldVal == 3 && (newVal == 1 || newVal == 2))) {
					$("#dialog").dialog({
						modal: true,
						resizable: false,
						buttons: {
							<?php echo $Lang->getText('Common.Yes') ?>: function() {
								$(this).dialog("close"); },
							<?php echo $Lang->getText('Common.No') ?>: function() {
								$(this).prop('checked', false);
								$("input[name='attribute1'][value="+oldVal+"]").prop('checked',true);
							$(this).dialog("close");}
						}
					});
				}
		})
	})
	</script>
<?php } ?>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldEditAction') ?>" method="post">
	<input type="hidden" name="tracker_id" value="<?php echo $_REQUEST['tracker_id']; ?>" />
	<input type="hidden" name="tracker_extra_field_id" value="<?php echo $_REQUEST['tracker_extra_field_id']; ?>" />
	<?php if ($TrackerExtraField->getFieldType() != TrackerExtraField::TYPE_STATUS) { ?>
    <table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('TrackerExtraField.FieldNameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="field_name" value="<?php echo $field_name; ?>" /></td>
		</tr>
		<?php if ($field_type == TrackerExtraField::TYPE_TEXTAREA || $field_type == TrackerExtraField::TYPE_TEXT || $field_type == TrackerExtraField::TYPE_NUMERIC) { ?>
		<tr>
			<td><strong><?php echo $Lang->getText('TrackerExtraField.Attribute1Name'); ?></strong>
			<?php if ($field_type == TrackerExtraField::TYPE_TEXTAREA || $field_type == TrackerExtraField::TYPE_TEXT) { ?>
				<span class="required">*</span>
			<?php } ?>
			<br />
			<input type="text" name="attribute1" value="<?php echo $attribute1; ?>"  size="2" maxlength="3"/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('TrackerExtraField.Attribute2Name'); ?></strong>
			<?php if ($field_type == TrackerExtraField::TYPE_TEXTAREA || $field_type == TrackerExtraField::TYPE_TEXT) { ?>
				<span class="required">*</span>
			<?php } ?>
			<br />
			<input type="text" name="attribute2" value="<?php echo $attribute2; ?>"  size="2" maxlength="3"/></td>
		</tr>
		<?php } ?>

		<?php if ($field_type == TrackerExtraField::TYPE_MEMBERS) { ?>
			<tr>
				<td><strong><?php echo $Lang->getText('TrackerExtraField.MemberOptions'); ?></strong>
					<span class="required">*</span>
				<br />
				<?php echo HTMLWidget::radio('attribute1', $Lang->getText('TrackerExtraField.MemberGroups'), TrackerExtraField::MEMBER_GROUPS, $attribute1); ?><br />
				<?php echo HTMLWidget::radio('attribute1', $Lang->getText('TrackerExtraField.MemberUsers'), TrackerExtraField::MEMBER_USERS, $attribute1); ?><br />
				<?php echo HTMLWidget::radio('attribute1', $Lang->getText('TrackerExtraField.MemberUsersAndGroups'), TrackerExtraField::MEMBER_USERS + TrackerExtraField::MEMBER_GROUPS, $attribute1); ?>
			</tr>
		<?php } ?>

		<?php if ($field_type == TrackerExtraField::TYPE_NUMERIC || $field_type == TrackerExtraField::TYPE_TEXT) { ?>
		<tr>
			<td><strong><?php echo $Lang->getText('TrackerExtraField.DefaultValueName'); ?></strong><br />
			<input type="text" name="default_value" value="<?php echo $default_value; ?>"  /></td>
		</tr>
		<?php } ?>
		<?php if($field_type != TrackerExtraField::TYPE_SERIAL) { ?>
		<tr>
			<td><strong><?php echo $Lang->getText('TrackerExtraField.IsRequiredName'); ?></strong><br />
			<input type="checkbox" name="is_required" value="1"<?php echo (($is_required==1) ? ' checked' : ''); ?> /></td>
		</tr>
		<?php } ?>
		<tr>
			<td><strong><?php echo $Lang->getText('TrackerExtraField.FieldOrderName'); ?></strong><br />
			<input type="text" name="field_order" value="<?php echo $field_order; ?>"  size="2" maxlength="3"/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('TrackerExtraField.UseInQuickBrowseName'); ?></strong><br />
			<input type="checkbox" name="use_in_quick_browse" value="1"<?php echo (($use_in_quick_browse==1) ? ' checked' : ''); ?> /></td>
		</tr>
		<?php if($field_type != TrackerExtraField::TYPE_SERIAL) { ?>
		<tr>
			<td><strong><?php echo $Lang->getText('TrackerExtraField.ShowOnSubmitName'); ?></strong><br />
			<input type="checkbox" name="show_on_submit" value="1"<?php echo (($show_on_submit==1) ? ' checked' : ''); ?> /></td>
		</tr>
		<?php } ?>
	</table>
    <?php } ?>
<?php

$strtype="".$TrackerExtraField->getFieldType()."";
if (strpos(TrackerExtraField::EDITABLE_ELEMENT_TYPES,$strtype) !== false) {
    echo '<br /><h4>' . $Lang->getText('TrackerExtraField.EditElementValues') . ':</h4><br />';

    // Retrieve the objects array
    $crit = new Criteria();
    $crit->add(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $TrackerExtraField->getTrackerExtraFieldId());
    $crit->addAscendingOrderByColumn(TrackerExtraFieldElementPeer::SORT_ORDER);
    $arr = TrackerExtraFieldElementPeer::doSelect($crit);

    $theader = array();

    $theader[] = $Lang->getText('TrackerExtraFieldElement.ElementNameName');
    $theader[] = $Lang->getText('TrackerExtraFieldElement.ElementAliasName');
    if ($TrackerExtraField->getFieldType() == TrackerExtraField::TYPE_STATUS) {
        $theader[] = $Lang->getText('TrackerExtraFieldElement.StatusIdName');
    }
    if ($TrackerExtraField->getUseAutoAssign()) {
        $theader[] = $Lang->getText('TrackerExtraField.AutoAssignTo');
    }
    if ($TrackerExtraField->getUseWorkflow()) {
        $use_workflow=true;
        $theader[] = $Lang->getText('TrackerExtraFieldElement.Workflow');
    } else {
        $use_workflow=false;
    }
    if ($TrackerExtraField->getUseCommitRule()) {
        $use_commit_rule=true;
        $theader[] = $Lang->getText('TrackerExtraFieldElement.CanCommit');
    } else {
        $use_commit_rule=false;
    }
    $theader[] = $Lang->getText('TrackerExtraFieldElement.DefaultSelectedName');
    $theader[] = $Lang->getText('TrackerExtraFieldElement.SortOrderName');
    $theader[] = $Lang->getText('Delete');

        echo $theme->tableTop($theader,false,'class="jsSortTBL"');

        if (count($arr) < 1) {
            echo $theme->tableFullRow($Lang->getText('TrackerExtraFieldElement.NoneFound'));
        } else {
            $statuses=$Tracker->getStatuses();
            echo '<tbody id="jsExtraFieldElementList">';
            foreach ($arr as $item) {
                $trow = array();
                $tmod = array();
                $trow[]='<input type="text" name="element_name['.$item->getElementId().']" value="'.$item->getElementName().'" />';
                $tmod[]='class="moveHandle"';

                $trow[]='<input type="text" name="alias['.$item->getElementId().']" value="'.$item->getAlias().'" />';
                $tmod[]='class="moveHandle"';

                if ($TrackerExtraField->getFieldType() == TrackerExtraField::TYPE_STATUS) {
                    $s = "<select class='status-value' name='status[" . $item->getElementId() . "]'>";
                    foreach ($statuses as $id => $status) {
                      if ($id == $item->getStatusId()) {
                        $s .= "<option value='$id' selected>" . $status . "</option>";
                      } else {
                        $s .= "<option value='$id'>" . $status . "</option>";
                      }
                    } 
                    $s .= "</select>";
                    $trow[]= $s;
                    $tmod[]='';
                }
                if ($TrackerExtraField->getUseAutoAssign()) {
                    $trow[]=HTMLWidget::select('auto_assign_to['.$item->getElementId().']',$TrackerExtraField->getTracker()->getTechnicians(),$item->getAutoAssignTo(),100,true,'Unassigned',false,null);
                    $tmod[]='';
                }
                if ($use_workflow) {
                    $trow[]='<a href="'.GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementTransitionBrowse').'&amp;element_id='.$item->getElementId().'">'.$Lang->getText('TrackerExtraFieldElement.DefineRules').'</a>';
                    $tmod[]='';
                }
                if ($use_commit_rule) {
                    $trow[]='<input type="checkbox" name="can_commit['.$item->getElementId().']" value="1" '.($item->getCanCommit()=='1' ? ' checked' : '' ).' />';
                    $tmod[]='';
                }
                $trow[]='<input type="radio" class="default-selected" name="default_selected" value="'.$item->getElementId().'"'.($item->getDefaultSelected()=='1' ? ' checked' : '' ).' />';
                $tmod[]='';
                $trow[]='<input type="text" name="sort_order['.$item->getElementId().']" value="'.$item->getSortOrder().'"  id="EFEOrder'.$item->getElementID().'" size="3" maxlength="3"/>';
                $tmod[]='';
                $trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementDelete').'&amp;element_id='.$item->getElementID().'">'. $Lang->getText('Delete') .'</a>';
                $tmod[]='';

                echo $theme->tableRow($trow, $tmod, false, 'id="jsExtraFieldElementList_EFEOrder'.$item->getElementID().'"');
            }
            echo '</tbody>';

        }
        echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldElementAdd').'&amp;tracker_extra_field_id='.$TrackerExtraField->getTrackerExtraFieldId()=>$Lang->getText('TrackerExtraFieldElement.AddNew')));
        ?>

    <script type="text/javascript">
        var moveHandlers = document.body.getElementsByClassName("moveHandle");
        if(moveHandlers.length > 0)
        {
            function updateOrder() {
                arrayEF = Sortable.serialize('jsExtraFieldElementList').split('&');
                for (i=0;i<arrayEF.length;i++) {
                    efKeyVal = arrayEF[i].split('=');
                    obj = FindObject(efKeyVal[1]);
                    if (obj) obj.value = i;
                }
                return true;
            }

            Sortable.create("jsExtraFieldElementList", {
                    dropOnEmpty:true,
                    handle:'moveHandle',
                    containment:["jsExtraFieldElementList"],
                    constraint:false,
                    tag:'tr',
                    onUpdate:updateOrder
                }
            );
            //window.onload=updateOrder;
            window.onload=window.onload=function(){oldload();convertTrees();window.setTimeout('expandableExpandItem()',100);docmanExpandTree();updateOrder();}
        }
    </script>
<?php
}
?>
	<table border="0">
		<tr>
			<td align="center">
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Cancel') . " ","cancel","","window.location='".GFUrl::getUrl()->currentBaseURL('TrackerExtraFieldBrowse').'&amp;tracker_id='.$TrackerExtraField->getTracker()->getTrackerId()."';")?>
			</td>
		</tr>
	</table>
</form>
<?php
$theme->footer($params);
?>
