<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

echo $theme->header($params);
?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js"></script>

<style>
	.ui-dialog-titlebar { display: none; }
	.ui-dialog-content { background-color: transparent; }
</style>

<?php echo $uploadHandler->getJavascriptSetup(); ?>

<?php
//
//	Show the Submit instructions. 
//
if (strlen($Tracker->getSubmitInstructions())) {
	echo "<br />".$Tracker->getSubmitInstructions(false)."<br />";
}
?>

<p>
	<strong><?php echo $Lang->getText('TrackerItem.AddNew'); ?></strong>
</p>
<form class="use-jst" action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerItemAddAction') ?>" method="post" enctype="multipart/form-data" name="TrackerItemAdd">
	<input type="hidden" name="tracker_id" value="<?php echo $tracker_id; ?>"  />
  <?php if (is_object($Ts)) { ?>
	<input type="hidden" name="sprint_id" value="<?php echo $Ts->getSprintId(); ?>"  />
  <?php } ?>
	<table style="border: none; min-width: 640px;" >
		<?php if ($Tracker->getDatatype()==Tracker::DATATYPE_TASK) { ?>
		<tr>
            <?php if($intrinsic_fields[Tracker::TRACKER_FIELD_OPEN_DATE]['is_enabled']) { ?>
			<td><strong><?php echo $Lang->getText('TrackerItem.StartDate'); ?></strong><span class="required">*</span><br />
                        <input type="text" id="task_start" name="start_date" value="<?php echo $start_date; ?>" size="11" maxlength="11" /><a href="javascript:NewCal('task_start','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a>
            </td>
            <?php } ?>
            <?php if($intrinsic_fields[Tracker::TRACKER_FIELD_OPEN_DATE]['is_enabled']) { ?>
			<td><strong><?php echo $Lang->getText('TrackerItem.EndDate'); ?></strong><span class="required">*</span><br />
                        <input type="text" id="task_end" name="end_date" value="<?php echo $end_date; ?>" size="11" maxlength="11" /><a href="javascript:NewCal('task_end','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a>
            </td>
            <?php } ?>
		</tr>
		<?php } ?>
		<tr>
			<td colspan="2"><strong><?php echo $Lang->getText('TrackerItem.SummaryName'); ?></strong><span class="required">*</span><br />
				<input type="text" name="summary" value="<?php echo  htmlentities($summary, ENT_COMPAT, 'UTF-8'); ?>" size="80" maxlength="255" /></td>
		</tr>

	<?php
		$arr_post = $_POST;
		$arr_post['tracker_sprint'] = $sprint_id;
		echo $tefr->renderFields('SUBMIT', null, null, $arr_post); ?>
	<?php if ($intrinsic_fields[Tracker::TRACKER_FIELD_DETAILS]['is_enabled']) { ?>

		<tr>
			<td colspan="2"><strong><?php echo $Lang->getText('TrackerItem.DetailsName'); ?></strong><span class="required">*</span><br />
			<?php
			$CKEditor = new GFCKEditor();
			$CKEditor->config['width'] = 700;
			echo $CKEditor->editor("details", $details);
			?>
			</td>
		</tr>
		<?php } ?>
<?php
ActionManager::notify('TRACKER_ITEM_ADD_FORM');
?>
		<?php if ($Tracker->userHasMemberPermission()) {
				if ($groups_count > 1) {
		?>
		<tr>
			<td>
				<strong><?php echo $Lang->getText('TrackerItem.SelectMembersGroupForTi'); ?></strong>
			</td>
		</tr>
		<tr>
			<td>
			<?php echo HTMLWidget::select('extra_field['.$tef_members->getTrackerExtraFieldId().'][]', $member_groups, null, null, false); ?><br /><br />
			</td>
		</tr>
		<?php } else  { ?>
			<input type="hidden" name="extra_field[<?php echo $tef_members->getTrackerExtraFieldId(); ?>][0]" value="<?php echo $autoassign_group; ?>" />
		<?php }
			}
		?>

		<tr>
			<td colspan="2"><div class="upload_widget"></div></td>
		</tr>
		<tr>
			<td colspan="2">
				<br /><input type="checkbox" name="monitor" value="" <?php echo (($monitor === 'true') ? "checked" : "") ?>  /><strong><?php echo $Lang->getText('TrackerItem.ReceiveUpdates'); ?></strong><br /><br />
			</td>
		</tr>
		<tr>
			<td colspan="2">
				<?php echo HTMLWidget::button("submit", $Lang->getText('submit.add'), "submit", "", "")?>
				<?php echo HTMLWidget::button("button", $Lang->getText('Common.Cancel') , "cancel", "", "window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'TrackerItemBrowse','tracker','',array('tracker_id' => $tracker_id)) . "'; ")?>
			</td>
		</tr>
	</table>
</form>

<?php
if (GFConf::get('feature.jst', false) == true) {
	include('wwwlib/forms/jst.html');
}

echo $theme->footer($params);
?>
