<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Federico Tarantini	federico@gforgegroup.com 
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/tracker/lib/html/TrackerTemplate.php');


$session = Session::getSession();
$project = GFUrl::getUrl()->getProject();
$user = $session->getUser();

$template = new TrackerTemplate();

echo popupHeader($template, Language::getSessText('TrackerItemRelationPopup.Title'));

// get the user projects
$c = new Criteria();
$c->add(UserProjectPeer::USER_ID,$user->getPrimaryKey());
$c->addJoin(UserProjectPeer::PROJECT_ID, ProjectPeer::PROJECT_ID);
$c->add(ProjectPeer::STATUS, Project::STATUS_ACTIVE);
$user_projects = UserProjectPeer::doSelect($c);

$theader = array();
$theader[] = Language::getSessText('TrackerItemRelationPopup.Project');
$theader[] = Language::getSessText('TrackerItemRelationPopup.Tracker');
echo $template->tableTop($theader);

if (count($user_projects) > 0) {
	foreach ($user_projects as $user_project) {
		$Project = $user_project->getProject();

		//get trackers
		$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);
		$sql = 'SELECT t.tracker_id, t.tracker_name, count(ti.tracker_item_id) as total_items FROM tracker t, tracker_item ti WHERE t.project_id = '.$Project->getProjectId().' AND ti.tracker_id = t.tracker_id GROUP BY ti.tracker_id, t.tracker_id, t.tracker_name';
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);
		if ($rs->getRecordCount() > 0) {
			while ($rs->next()) {
				$cols = array();
				$cols[] = $Project->getProjectName();
				$cols[] = '<a href="'.GFUrl::getUrl()->projectURL($Project, 'TrackerItemList', 'tracker', '/popups', array('tracker_id' => $rs->getInt('tracker_id'))).'&amp;field='.$_GET['field'].'">'.$rs->getString('tracker_name').'</a>';
				echo $template->tableRow($cols);
			}
		} else {
			$cols = array();
			$cols[] = $Project->getProjectName();
			$cols[] = Language::getSessText('TrackerItemRelationPopup.NoTracker');
			echo $template->tableRow($cols);
		}
	}
} else {
	echo $template->tableFullRow(Language::getSessText('TrackerItemRelationPopup.NoProjects'));
}
echo $template->tableBottom();

echo popupFooter();

?>
