<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('html/UserTemplate.php');
require_once('lib/plugin/PluginResult.php');

class UserblogUserTemplate extends UserTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab']='userblog';
		$Lang = Session::getSession()->getLanguage();
		if (isset($params['title'])) {
			$params['title']=' '.$Lang->getText('Userblog.TabString').' > '.$params['title'];
		} else {
			Throw new exception('Missing title in blog template');
		}

		$this->addBreadCrumb('<a href="/gf/user/'.$params['user']->getUnixName().'/userblog/">'.$Lang->getText('Userblog.TabString').'</a>');

		return parent::header($params);
	}

	/**
	 *	getPluginNavElements - this overrides parent class and adds its own 
	 *	plugin listener
	 *	@return	PluginResultSet
	 */
	function getPluginNavElements($params) {

	}

	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 */
	function getTemplateNavElements($params) {
		$url = GFurl::getUrl();
		$lang = Session::getSession()->getLanguage();
		$loggedin = Session::getSession()->isLoggedIn();
		$user = $params['user'];
		
		$temp = new UserTemplate();
		$ret = $temp->getTemplateNavElements($params);
		

		if (isset($ret)) {
			return $ret;
		}
	}

}

?>