<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a News and saves it to the 
// database
//
require_once('plugins/userblog/lib/UserBlogPeer.php');
require_once('plugins/userblog/lib/UserBlog.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$Str = new StringUtils(StringUtils::FULL_HTML);

$UserBlog = UserBlogPeer::retrieveByPk($_POST['id']);
if (!is_object($UserBlog) || !$UserBlog->userCanUpdate()) {
	throw new PermissionDeniedException();
}
$errors = array();
$language = Language::getSessLang();
//update
if(isset($_POST['submit'])) {	
	if (strlen($_POST['subject'])==0) {
		$errors['invalid_subject'] = Language::getSessText('News.SummaryInvalid');
	}
	if (strlen($_POST['content'])==0) {
		$errors['invalid_subject'] = Language::getSessText('News.DetailsInvalid');
	}
	if (count($errors)==0) {
		$UserBlog->setSubject( Validator::sanitizeString($_POST['subject']) );
		$UserBlog->setContent( $Str->cleanHtml($_POST['content']) );
		try {
			$UserBlog->save();
		} catch (InvalidDataException $ex) {
			$errors = array_merge($errors, $ex->getErrors());		
		}
		if(count($errors) == 0) {
			GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), array('feedback' => $language->getText('News.EditFeedback')));
		} else {
			$feedback = implode('<br />', $errors);
			include('NewsEdit.php');
		}		
	} else {
		$feedback = implode('<br />', $errors);
		include('UserblogEdit.php');		
	}


}
//delete
if(isset($_POST['delete'])) {
	try {	
		$UserBlog->delete();
	} catch (InvalidDataException $ex) {
		$errors = array_merge($errors, $ex->getErrors());		
	}

	if(count($errors) == 0) {
		GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), array('feedback' => $language->getText('News.DeleteFeedback')));
	} else {
		$feedback = implode('<br />', $errors);
		include('UserblogEdit.php');
	}
}
?>