<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists News
//
require_once('plugins/userblog/lib/UserBlogPeer.php');
require_once('plugins/userblog/lib/UserBlog.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$user = $session->getUser();
$Lang = $session->getLanguage();

require_once('plugins/userblog/lib/html/UserblogMyAdminTemplate.php');
$theme = new UserblogMyAdminTemplate();

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}

$userBlog = new UserBlog();
if (!$userBlog->userCanCreate()) {
	throw new PermissionDeniedException();
}

if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];

$params = array(
		'user' => $user,
	//	'News' => $News,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($feedback) ? $feedback : '',
		'title' => $Lang->getText('News.BrowsePageTitle')
		);
$theme->header($params);

$columns = array(
	UserblogPeer::SUBJECT => $Lang->getText('Userblog.SubjectName'),
	UserblogPeer::CONTENT => $Lang->getText('Userblog.ContentName'),
	UserblogPeer::POST_DATE => $Lang->getText('Userblog.PostDateName'),
	$Lang->getText('Userblog.Edit'),
	$Lang->getText('Userblog.Delete')
	);
	
// Retrieve the objects array
$crit = new Criteria();
$crit->add(UserblogPeer::USER_ID, $user->getUserId());
$total = UserblogPeer::doCount($crit);
$paginator = new Paginator('userblogadm', -1, $total, UserblogPeer::POST_DATE, $columns);
$paginator->addPageClauses($crit);
//$crit->addDescendingOrderByColumn(NewsPeer::POST_DATE);
$arr = UserblogPeer::doSelect($crit);

/*$theader = array();
$theader[] = $Lang->getText('News.SummaryName');
$theader[] = $Lang->getText('News.DetailsName');
$theader[] = $Lang->getText('News.PostDateName');
$theader[] = $Lang->getText('News.Edit');
$theader[] = $Lang->getText('News.Delete');*/


$theader = $paginator->getSortableTableHeaders($theme);
//echo $paginator->showLimitOptions();

echo $theme->tableTop($theader);

if (count($arr) == 0) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Userblog.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getSubject();
		$trow[]= $item->getShortContent();
		$trow[]=$item->getPostDate();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UserblogEdit',array('id'=>$item->getUserBlogID())).'">'. $Lang->getText('Userblog.Edit').'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UserblogDelete',array('id'=>$item->getUserBlogID())).'">'. $Lang->getText('Userblog.Delete').'</a>';
		echo $theme->tableRow($trow);
	}
	//echo $theme->listPaginatorRow($paginator);
}
//echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('NewsAdd')=>$Lang->getText('News.AddNew')));
echo $theme->tableBottom(array(GFUrl::getURL()->currentBaseUrl('UserblogAdd',array('return_to' => 'admin'))=>$Lang->getText('Userblog.AddNew')),array(true));

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}

$theme->footer($params);
?>