<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists UserBlog
//
require_once('plugins/userblog/lib/UserBlogPeer.php');
require_once('plugins/userblog/lib/UserBlog.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);

if (in_array('my',$arr)) {
	require_once('plugins/userblog/lib/html/UserblogMyTemplate.php');
	$theme = new UserblogMyTemplate();
} else {
	require_once('plugins/userblog/lib/html/UserblogUserTemplate.php');
	$theme = new UserblogUserTemplate();
}

$user = GFUrl::getUrl()->getUser();

$columns = array(
	UserBlogPeer::POST_DATE => $Lang->getText('Userblog.PostDateName'), 
	$Lang->getText('Userblog.SummaryName'));

//Get params
$tag = isset($_REQUEST['tag']) ? Validator::sanitizeString($_REQUEST['tag']) : "";
$year = isset($_REQUEST['year']) ? Validator::sanitizeInt($_REQUEST['year']) : "";
$month = isset($_REQUEST['month']) ? Validator::sanitizeInt($_REQUEST['month']) : "";
$post_id = isset($_REQUEST['id']) ? Validator::sanitizeInt($_REQUEST['id']) : "";
$thread_id = isset($_REQUEST['thread_id']) ? Validator::sanitizeInt($_REQUEST['thread_id']) : 0;
$message_id = isset($_REQUEST['message_id']) ? Validator::sanitizeInt($_REQUEST['message_id']) : 0;
$forum_action = isset($_REQUEST['_forum_action']) ? Validator::sanitizeString($_REQUEST['_forum_action']) : "";

$con = Propel::getConnection(UserBlogPeer::DATABASE_NAME);

// Retrieve the objects array
$crit = new Criteria();
$crit->add(UserBlogPeer::USER_ID, $user->getUserId());
if ($tag != "") {
	$crit->addJoin(UserBlogPeer::USER_BLOG_ID, TagEntryPeer::REF_ID, Criteria::JOIN);
	$crit->add(TagEntryPeer::SECTION, UserBlog::SECTION);
	$crit->add(TagEntryPeer::TAG_NAME, $tag);
}
if ($year != 0 && $month != 0) {
	$start_date = $year."-".$month."-01";
	$last_day_month = date('t',strtotime($month."/1/".$year));
	$end_date = $year."-".$month."-".$last_day_month;
	
	$crit->add(UserBlogPeer::POST_DATE, $start_date, Criteria::GREATER_EQUAL);
	$crit->addAnd(UserBlogPeer::POST_DATE, $end_date, Criteria::LESS_EQUAL);
}
if ($post_id != 0) {
	$crit->add(UserBlogPeer::USER_BLOG_ID, $post_id);
}

$total = UserBlogPeer::doCount($crit);

$paginator = new Paginator('userblog', -1, $total, UserBlogPeer::POST_DATE, $columns);
$paginator->addPageClauses($crit);
$arr = UserBlogPeer::doSelect($crit);

/*$theader = array();
$theader[] = $Lang->getText('UserBlog.PostDateName');
$theader[] = $Lang->getText('UserBlog.SummaryName');*/
//$theader[] = $Lang->getText('UserBlog.DetailsName');

$theader = $paginator->getSortableTableHeaders($theme);
//echo $paginator->showLimitOptions();
//echo $theme->tableTop($theader);
/*
if (count($arr) == 0) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Userblog.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[0] = $item->getPostDate('Y-m-d');
		$trow[1] = 'Posted By: '.$item->getUser()->getUserLink().'<br />';
		$trow[1] .= '<a href="'. GFUrl::getUrl()->currentBaseUrl('UserBlogThreadView').'&amp;id='.$item->getUserBlogID() .'">'. $item->getSubject().'</a>';
		$trow[1] .= '<br /><br />';
		$trow[1] .= StringUtils::addHtmlLinks(nl2br($item->getContent()));
		$trow[1] .= '<br /><br />';
		//$trow[1] .= '<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'UserBlogThreadView','news','',array('id'=>$item->getUserBlogId())).'"><img src="/images/forum_icon.gif" alt="" border="0" height="16" width="16">&nbsp;'.Language::getSessText('Userblog.Discussions').'</a>';
		//echo $theme->tableRow($trow,array(),true);
	}
	//echo $theme->listPaginatorRow($paginator);
}
*/
//Get tags
$str_sql = "SELECT tag_name, count(*) as quantity FROM tag_entry t, user_blog u WHERE t.ref_id=u.user_blog_id AND  u.user_id = " . $user->getUserId() . " AND section='" . UserBlog::SECTION . "' GROUP BY tag_name";
$stmtCount = $con->createStatement();
$rs = $stmtCount->executeQuery($str_sql);

$arr_tagnames = array();
foreach ($rs as $row) {
	$arr_tagnames[ $row['tag_name'] ] = $row['quantity'];
}

//Set min and max font sizes
$min_font_size = 10; // min font size in pixels
$max_font_size = 18; // max font size in pixels

//Get min and max tag values
$min_tag_value = (sizeof(array_values($arr_tagnames)) > 0) ? min(array_values($arr_tagnames)) : 0;
$max_tag_value = (sizeof(array_values($arr_tagnames)) > 0) ? max(array_values($arr_tagnames)) : 0;

//Get the range of values
$spread = $max_tag_value - $min_tag_value;
if ($spread == 0) {
	$spread = 1;
}

//Set the font-size increment
$step = ($max_font_size - $min_font_size) / ($spread);

$arr_tags = array();     
//Loop through the tags array
foreach ($arr_tagnames as $key => $value) {
	$size = round($min_font_size + (($value - $min_tag_value) * $step));
	$arr_tags[ $key ] = $size;
}

//Get Archives
$str_sql = "SELECT date_part('month', post_date) as smonth, date_part('year', post_date) as syear 
						FROM user_blog
						WHERE user_id = " . $user->getUserId() . "
						GROUP BY syear, smonth
						ORDER BY syear, smonth DESC";

$stmtArchives = $con->createStatement();
$rs_archives = $stmtCount->executeQuery($str_sql);

$arr_archives = array();
$i=0;
foreach ($rs_archives as $row) {
	$arr_archives[$i]['month'] =  $row['smonth'];
	$arr_archives[$i]['year'] =  $row['syear'];
	$arr_archives[$i]['desc'] =  date("F", mktime(0, 0, 0, $row['smonth'])) . " " . $row['syear'];
	$i++;
}

if (is_object($session->getUser()) && $user->getUserId() == $session->getUser()->getUserId()) {
	$button_enabled = true;
} else {
	$button_enabled = false;
}

$form = "";

//If we are showing a post with the threads:
if ($post_id != 0) {
	$Post = UserBlogPeer::retrieveByPk($post_id);
	if (!is_object($Post)) {
		throw new PermissionDeniedException();
	}
	
	// Generate the forum page. This is done BEFORE outputting any text before this code could redirect.
	include_once('plugins/news/lib/html/NewsCommentsRenderer.php');
	$kept_vars = array();
	$renderer = new NewsCommentsRenderer(UserBlog::SECTION, UserblogPlugin::getFormPaths(), $Post->getPrimaryKey(), $theme, $Lang, $kept_vars);
	
	// Try to create a forum for this news on the fly
	$c = new Criteria();
	$c->add(ForumPeer::SECTION, UserBlog::SECTION);
	$c->add(ForumPeer::REF_ID, $Post->getPrimaryKey());
	$forum = ForumPeer::doSelectOne($c);
	if (is_null($forum)) {
		$forum = new Forum();
		$forum->setSection(UserBlog::SECTION);
		$forum->setRefId($Post->getPrimaryKey());
		$forum->setForumName($Post->getSubject());
		// We do this because we may be logged in as any user, so we must skip
		// permission checks
		$forum->forceSave();
		$forum->save();
	}
	

	//Process action
	if ($forum_action != "") {
		$form = $renderer->handleBrowse($forum, $Post->getSubject(), $thread_id, $message_id, $forum_action);
	}

	//Get the thread messages
	$forum_messages = "";
	if ($message_id != 0) {
		$forum_messages = $renderer->handleBrowse($forum, $Post->getSubject(), $thread_id, $message_id, 'ForumMessageBrowse');
	}
	
	//Get the threads
	$forum_page = $renderer->handleBrowse($forum, $Post->getSubject(), $thread_id, $message_id, '', $forum_messages);

	if ($renderer->hasErrors()) {
		$feedback = "*".implode('<br />*', $renderer->getErrors());
	}
	
} else {
	$forum_page = "";
}

$feedback = isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : '');

$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => $feedback,
		'title' => 'User Blog',
		'selectedbottomtab' => 'userblog'
		);

$theme->header($params);

require_once("forms/UserblogBrowse-tpl.php");

$str_paginator = '';
if(isset($paginator) && is_object($paginator)) {
	$str_paginator = '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}

?>
<?php
$theme->footer($params);
?>
