<?php

require_once('html/MyTemplate.php');
require_once('lib/plugin/PluginResult.php');

class UsercalendarMyTemplate extends MyTemplate{

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab'] = 'usercalendar' ;
		$Lang = Session::getSession()->getLanguage();
		if (isset($params['title'])) {
			$params['title']=' '.$Lang->getText('UserCalendar.TabString').' > '.$params['title'];
		} else {
			Throw new exception('Missing title in userfiles template');
		}
		
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->userUrl($params['user'],'','usercalendar/my').'">'.$Lang->getText('UserCalendar.TabString').'</a>');
		
		return parent::header($params);
	}

	/**
	 *	getPluginNavElements - this overrides parent class and adds its own 
	 *	plugin listener
	 *	@return	PluginResultSet
	 */
	function getPluginNavElements($params) {

	}

	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 */
	function getTemplateNavElements($params) {
		$url = GFurl::getUrl();
		$lang = Session::getSession()->getLanguage();
		$loggedin = Session::getSession()->isLoggedIn();
		$user = $params['user'];
		$ret = array();
		
		$elements = array(
			array('link'=>$url->userUrl($user, 'monthview', 'usercalendar', 'my', ''),
					'description'=>$lang->getText('UserCalendar.MonthView')),
			array('link'=>$url->userUrl($user, 'weekview', 'usercalendar', 'my', ''),
					'description'=>$lang->getText('UserCalendar.WeekView')),
			array('link'=>$url->userUrl($user, 'dayview', 'usercalendar', 'my', ''),
					'description'=>$lang->getText('UserCalendar.DayView'))
		);

		if($loggedin){
			if($user->getPrimaryKey() == Session::getSession()->getUser()->getPrimaryKey()){
				$elements[] = array(
					'link'=>$url->UserURL($user, 'index','usercalendar','my/admin',''),
					'description'=>$lang->getText('UserCalendar.Admin'),
				);
			}
		}

		$ret[] = array(
			'title' => $lang->getText('UserCalendar.MyCalendar'),
			'elements'=> $elements
		);

		return $ret;
	}

	function getExtraCSS(){
		return array('/themes/'.$this->getName().'/calendar.css');
	}

}

?>
