<?php
require_once('plugins/usercalendar/lib/html/UsercalendarRenderer.php');
require_once('plugins/calendar/lib/CalendarPeer.php');


$session = Session::getSession();
$lang = $session->getLanguage();

if(!$session->isLoggedIn()){
	throw new NotLoggedInException();
}

$user = GFUrl::getUrl()->getUser();

//Only the owner can access this page
if($user->getUserId() != $session->getUser()->getUserId()){
	throw new PermissionDeniedException();
}

$redirect_to = isset($_REQUEST['redirect_to']) ? Validator::sanitizeString($_REQUEST['redirect_to']) : ( isset($redirect_to) ? $redirect_to : 'monthview');
$from_date = isset($_GET['start_date']) ? $_GET['start_date'] : (isset($_POST['from_date']) ? strtotime($_POST['from_date']) : $from_date);
$to_date = isset($_POST['to_date']) ? strtotime($_POST['to_date']) : $from_date;
$subject = isset($_POST['subject']) ? htmlspecialchars($_POST['subject']) : ''; 
$description = isset($_POST['description']) ? htmlspecialchars($_POST['description']) : '';
$from_hour_hour = isset($_POST['from_hour_hour']) ? $_POST['from_hour_hour'] : strftime('%H');
$from_hour_minute = isset($_POST['from_hour_minute']) ? $_POST['from_hour_minute'] : '00';
$to_hour_hour = isset($_POST['to_hour_hour']) ? $_POST['to_hour_hour'] : strftime('%H', time() + 60 * 60);
$to_hour_minute = isset($_POST['to_hour_minute']) ? $_POST['to_hour_minute'] : '00';
$occurrence = isset($_POST['occurrence']) ? $_POST['occurrence'] : 0;
$occurrence_to = isset($_POST['occurrence_to']) && !is_null($_POST['occurrence_to']) ? strtotime($_POST['occurrence_to']) : null;
$is_public = isset($_POST['is_public']) ? $_POST['is_public'] : false;
$reminder = isset($_POST['reminder']) ? $_POST['reminder'] : 0;


//Get the calendar
$c = new Criteria();
$c->add(CalendarPeer::SECTION,'user');
$c->add(CalendarPeer::REF_ID, $user->getUserId());
$calendar = CalendarPeer::doSelectOne($c);

if(!is_object($calendar)){
	throw new InvalidDataException(array('Invalid calendar id'));
}

$params = array(
	'user'=> $user,
	'action'=> isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback :''),
	'title' => $lang->getText('UserCalendar.AddNewEvent'),
	'selectedbottomtab' => 'usercalendar'
);

$components = GFUrl::getUrl()->getURI();
$arr=explode('/',$components);
if (in_array('my', $arr)){
	require_once('plugins/usercalendar/lib/html/UsercalendarMyTemplate.php');
	$theme = new UsercalendarMyTemplate();
} else {
	require_once('plugins/usercalendar/lib/html/UsercalendarTemplate.php');
	$theme = new UsercalendarTemplate();
}
$theme->header($params);
include ('forms/UsercalendarEventAdd-tpl.php');

?>
