<?php

require_once('plugins/calendar/lib/CalendarEventPeer.php');
require_once('plugins/usercalendar/lib/html/UsercalendarMyTemplate.php');
require_once('Validator.php');

$session = Session::getSession();
$lang = $session->getLanguage();

if(!$session->isLoggedIn()){
	throw new NotLoggedInException();
}

$user = GFUrl::getUrl()->getUser();

if(isset($_GET['event_id'])){
	$event_id = Validator::sanitizeInt($_GET['event_id']);
} else {
	throw new InvalidDataException(array('calendar_event_id' => 'Missing event id'));
}

if(isset($_GET['redirect_to'])){
	$redirect_to = Validator::sanitizeString($_GET['redirect_to']);
}

if(isset($_GET['start_date'])){
	$start_date = Validator::sanitizeDate($_GET['start_date']);
} else {
	$start_date = time();
}

$c = new Criteria();
$c->add(CalendarEventPeer::CALENDAR_EVENT_ID, $event_id);
$event = CalendarEventPeer::doSelectOne($c);

if(!is_object($event) || !$event->userCanDelete()){
	throw new PermissionDeniedException();
}

$theme = new UsercalendarMyTemplate();

$params = array(
	'user'=> $user,
	'action'=> isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback :''),
	'title' => $lang->getText('UserCalendar.DeleteEvent'),
	'selectedbottomtab' => 'usercalendar'
);

$theme->header($params);

include('forms/UsercalendarEventDelete-tpl.php');

?>
