<?php
require_once('plugins/usercalendar/lib/html/UsercalendarRenderer.php');
require_once('plugins/calendar/lib/CalendarEventPeer.php');
require_once('plugins/calendar/lib/CalendarEventReminderPeer.php');

$session = Session::getSession();
$lang = $session->getLanguage();

if(!$session->isLoggedIn()){
	throw new NotLoggedInException();
}

$user = GFUrl::getUrl()->getUser();

if(isset($_REQUEST['event_id'])){
	$event_id = Validator::sanitizeInt($_REQUEST['event_id']);
} else {
	throw new PermissionDeniedException();
}

if(isset($_REQUEST['redirect_to'])){
	$redirect_to = Validator::sanitizeString($_REQUEST['redirect_to']);
} else {
	$redirect_to = 'monthview';
}

if(isset($_REQUEST['start_date'])){
	$start_date = Validator::sanitizeString($_REQUEST['start_date']);
} else {
	$start_date = time();
}

//Get the event
$c = new Criteria();
$c->add(CalendarEventPeer::CALENDAR_EVENT_ID, $event_id);
$event = CalendarEventPeer::doSelectOne($c);

if(!is_object($event) || !$event->userCanUpdate()){
	throw new PermissionDeniedException();
}
//TODO: add support for multiple reminders in the form
$reminders = $event->getCalendarEventReminders();
if(empty($reminders)){
	$reminder = 0;
} else {
	$reminder = $reminders[0]->getTimeUnit();
}

$from_date = isset($from_date) ? $from_date : $event->getFromDate("%b %d %Y");
$to_date = isset($to_date) ? $to_date: $event->getToDate("%b %d %Y");
$subject = isset($subject) ? $subject : htmlspecialchars($event->getSubject()); 
$description = isset($description) ? $description : htmlspecialchars($event->getDescription());
$from_hour_hour = isset($from_hour_hour) ? $from_hour_hour : $event->getFromDate("%H");
$from_hour_minute = isset($from_hour_minute) ? $from_hour_minute : $event->getFromDate("%M");
$to_hour_hour = isset($to_hour_hour) ? $to_hour_hour : $event->getToDate("%H");
$to_hour_minute = isset($to_hour_minute) ? $to_hour_minute : $event->getToDate("%M");
/* For now, recurrent events can only be created when the initial event is created */
/*
$occurrence = isset($occurrence) ? $occurrence  : $event->getOccurrence();
$occurrence_to = isset($occurrence_to) ? $occurrence_to : $event->getOccurrenceTo("%b %d %Y");
*/
$is_public = isset($is_public) ? $is_public : $event->getIsPublic();

include('plugins/usercalendar/lib/html/UsercalendarMyTemplate.php');
$params = array(
	'user'=> $user,
	'action'=> isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback :''),
	'title' => $lang->getText('UserCalendar.EventEdit'),
	'selectedbottomtab' => 'usercalendar'
);

$theme = new UserCalendarMyTemplate();

$theme->header($params);

include('forms/UsercalendarEventEdit-tpl.php');

?>
