<?php

require_once('plugins/calendar/lib/CalendarEventPeer.php');
require_once('Validator.php');

$session = Session::getSession();
$lang = $session->getLanguage();

if(!$session->isLoggedIn()){	
	throw new NotLoggedInException();
}

$user = GFUrl::getUrl()->getUser();

if(isset($_GET['event_id'])){
	$event_id = Validator::sanitizeInt($_GET['event_id']);
} else {
	throw new InvalidDataException(array('calendar_event_id' => 'Missing event id'));
}

//Get event 
$c = new Criteria();
$c->add(CalendarEventPeer::CALENDAR_EVENT_ID, $event_id);
$event = CalendarEventPeer::doSelectOne($c);
if(!is_object($event) || !$event->userCanRead()){
	throw new PermissionDeniedException();
}

$filename = 'event' . $event->getCalendarEventId();
header("Content-Type: text/calendar\n");
header("Expires: 0");
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
header("content-disposition: attachment;filename=$filename.ics");

echo $event->exportToICalendar();

?>
