<?php
require_once('plugins/usercalendar/lib/html/UsercalendarTemplate.php');
require_once('plugins/usercalendar/lib/html/UsercalendarMyTemplate.php');
require_once('plugins/calendar/lib/CalendarEventPeer.php');
require_once('Validator.php');

$session = Session::getSession();
$lang = $session->getLanguage();

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	if(!$session->isLoggedIn()){
		throw new NotLoggedInException();
	}
	$theme = new UsercalendarMyTemplate();
} else {
	$theme = new UsercalendarTemplate();
}


$user = GFUrl::getUrl()->getUser();

if(isset($_GET['event_id'])){
	$event_id = Validator::sanitizeInt($_GET['event_id']);
} else {
	throw new InvalidDataException(array('calendar_event_id' => 'Missing event id'));
}


if(isset($_GET['redirect_to'])){
	$redirect_to = Validator::sanitizeString($_GET['redirect_to']);
}

if(isset($_GET['start_date'])){
	$start_date = Validator::sanitizeInt($_GET['start_date']);
} else {
	$start_date = time();
}


//Get event 
$c = new Criteria();
$c->add(CalendarEventPeer::CALENDAR_EVENT_ID, $event_id);
$event = CalendarEventPeer::doSelectOne($c);
if(!is_object($event) || !$event->userCanRead()){
	throw new PermissionDeniedException();
}


$params = array(
	'user'=> $user,
	'action'=> isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback :''),
	'title' => $lang->getText('UserCalendar.EventView'),
	'selectedbottomtab' => 'usercalendar'
);

$components = GFUrl::getUrl()->getURI();
$arr=explode('/',$components);
if (in_array('my', $arr)){
	require_once('plugins/usercalendar/lib/html/UsercalendarMyTemplate.php');
	$theme = new UsercalendarMyTemplate();
} else {
	require_once('plugins/usercalendar/lib/html/UsercalendarTemplate.php');
	$theme = new UsercalendarTemplate();
}
$theme->header($params);

if($event->userCanUpdate()){
?>
<a href="<?php echo GFUrl::getUrl()->currentBaseUrl('UsercalendarEventDelete', array('event_id'=>$event->getCalendarEventId(), 'redirect_to'=>isset($redirect_to) ? $redirect_to : 'monthview', 'start_date'=>$start_date)) ?>"><?php echo $lang->getText('UserCalendar.Delete') ?></a> | 
<a href="<?php echo GFUrl::getUrl()->currentBaseUrl('UsercalendarEventExportAction', array('event_id'=>$event->getCalendarEventId())) ?>"><?php echo $lang->getText('UserCalendar.EventExport') ?></a>
<?php } ?>

<table border="0">
	<tr>
		<td><strong><?php echo 'Event #' . $event->getCalendarEventId() . ': ' . htmlspecialchars($event->getSubject()) ?></strong></td>
	</tr>
	<tr>
		<td><strong><?php echo $lang->getText('UserCalendar.EventFromDate') ?></strong><br />
		<?php echo $event->getFromDate("%Y-%m-%d %H:%M")?>
		</td>
	</tr>
	<tr>
		<td><strong><?php echo $lang->getText('UserCalendar.EventToDate') ?></strong><br />
		<?php echo $event->getToDate("%Y-%m-%d %H:%M")?>
		</td>
	</tr>
	<tr>
		<td><strong><?php echo $lang->getText('UserCalendar.EventDescription') ?></strong><br />
		<?php echo htmlspecialchars($event->getDescription()); ?>
		</td>
	</tr>
	<tr>
		<td><strong><?php echo $lang->getText('UserCalendar.EventIsPublic') ?></strong><br />
		<?php if($event->getIsPublic()) { echo $lang->getText('UserCalendar.Yes'); } else {echo $lang->getText('UserCalendar.No'); } ?>
		</td>
	<tr>
		<td>
		<?php echo HTMLWidget::button("button",$lang->getText('UserCalendar.EventEdit'),"edit","",
		"window.location = '" .GFUrl::getUrl()->currentBaseUrl('UsercalendarEventEdit', array('event_id'=>$event->getCalendarEventId(), 'redirect_to'=>isset($redirect_to) ? $redirect_to : 'monthview', 'start_date'=>$start_date)) . "'; ", 
		$event->userCanUpdate()) ?>
		<?php echo HTMLWidget::button("button","" .   $lang->getText('Common.Back') . " ","cancel","","history.back(1);")?>
		</td>
	</tr>
</table>

<?php echo $theme->footer($params); ?>


