<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('html/MyTemplate.php');
require_once('lib/plugin/PluginResult.php');

class UserfilesMyTemplate extends MyTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab'] = 'userfiles' ;
		$Lang = Session::getSession()->getLanguage();
		if (isset($params['title'])) {
			$params['title']=' '.$Lang->getText('Wiki.TabString').' > '.$params['title'];
		} else {
			Throw new exception('Missing title in userfiles template');
		}
		
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->userUrl($params['user'],'','userfiles/my').'">'.$Lang->getText('UserFiles.TabString').'</a>');
		
		return parent::header($params);
	}

	/**
	 *	getPluginNavElements - this overrides parent class and adds its own 
	 *	plugin listener
	 *	@return	PluginResultSet
	 */
	function getPluginNavElements($params) {

	}

	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 */
	function getTemplateNavElements($params) {
		$url = GFurl::getUrl();
		$lang = Session::getSession()->getLanguage();
		$loggedin = Session::getSession()->isLoggedIn();
		$user = $params['user'];
		
		$temp = new MyTemplate();
		$ret = $temp->getTemplateNavElements($params);
		
		$elements = array();
		
		if ($loggedin) {
			if ($user->getPrimaryKey() == Session::getSession()->getUser()->getPrimaryKey()) {
				$elements[] = array('link' => $url->userURL($user,'','userfiles','my/admin', ''),
					'description' => $lang->getText('Tabs.Admin'));
			}
		}
		
		if (count($elements) > 0) {
			$ret[] = array(
				'title' => $lang->getText('UserFiles.TabString'),
				'elements'=> $elements
			);
		}
		if (isset($ret)) {
			return $ret;
		}
	}

}

?>