<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for Snippet
//
require_once('GFUrl.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('html/HTMLWidget.php');
require_once('html/TroveRenderer.php');

$session = Session::getSession();
if (!$session->isLoggedIn()) {
	throw new PermissionDeniedException();
}
$Lang = $session->getLanguage();

$user = GFUrl::getUrl()->getUser();
$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('UserFiles.AddNewPageTitle'),
		'selectedbottomtab' => 'userfiles'
		);

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	require_once('plugins/userfiles/lib/html/UserfilesMyTemplate.php');
	$theme = new UserfilesMyTemplate();
} else {
	require_once('plugins/userfiles/lib/html/UserfilesUserTemplate.php');
	$theme = new UserfilesUserTemplate();
}

include('forms/UserfileAdd-tpl.php');

?>
