<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/userwiki/lib/html/WikiMyTemplate.php');
require_once('lib/plugin/PluginResult.php');

class WikiMyAdminTemplate extends WikiMyTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
		$params['selectedbottomtab']='userwiki';
		$Lang = Session::getSession()->getLanguage();

		if(!isset($params['user']) || !is_object($params['user'])) {
			Throw new exception('Missing user object in wiki template');
		} 
		if (!Session::getSession()->isLoggedIn()) {
			Throw new PermissionDeniedException();
		}		
		if(!($params['user']->getPrimaryKey() == Session::getSession()->getUser()->getPrimaryKey())) {
			Throw new PermissionDeniedException();
		}
		if (!isset($params['title'])) {
			Throw new exception('Missing title in wiki template');
		}
		$params['title']=$Lang->getText('Tabs.Admin').' > '.$params['title'];

		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->userUrl($params['user'],'','userwiki','admin').'">'.$Lang->getText('Tabs.Admin').'</a>');
		
		return parent::header($params);
	}

	/**
	 *	getPluginNavElements - this overrides parent class and adds its own 
	 *	plugin listener
	 *	@return	PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
	       	$tprs = ActionManager::Notify('GET_WIKI_NAV_ELEMENTS',$params);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}

	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 * /
	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		$ret = array();
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		if (isset($params['wiki']) && is_object($params['wiki'])) {
			$wiki = $params['wiki'];
			if (!isset($params['project'])) {
				echo 'missing project param';
			}
			$ret[] = array(
				'title'=>$wiki->getwikiName(). ' Admin',
				'elements'=> array(
				array('link'=>'/gf/project/'.$params['project']->getUnixName().'/wiki/admin/?wiki_id='.$wiki->getWikiId(),
					'description'=>'wiki')
					)
				);
		}
		return $ret;
	}*/
	
}

?>
