<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('plugins/userwiki/lib/Wiki.php');
require_once('plugins/userwiki/lib/html/WikiMyAdminTemplate.php');

$theme = new WikiMyAdminTemplate();
$user = GFUrl::getUrl()->getUser();
$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => 'Wiki Admin'
		);
$theme->header($params);


if (array_key_exists('lock',$_REQUEST)) {
	$lock = Validator::sanitizeInt($_REQUEST['lock']);
} else {
	$lock = null;
}
$section = User::SECTION; // This should be changed if we are in the user wiki wwwlib, for example
$ref_id = $user->getUserId(); // This should be changed if we are in the user wiki wwwlib, for example

$wiki = new UserWiki($section,$ref_id,$theme,$user);
$wiki->setAdmin();

if ($lock) {
	echo $wiki->lockPage($lock);
	GFUrl::redirect(GFUrl::getUrl()->userURL($user,'','userwiki','', array('pageid' => $lock,'feedback'=>'Page Locked')));
} else {
	echo 'ERROR - no page specified';
}



$theme->footer();
?>
