<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('plugins/userwiki/lib/Wiki.php');
require_once('plugins/userwiki/lib/html/WikiMyAdminTemplate.php');

$theme = new WikiMyAdminTemplate();
$user = GFUrl::getUrl()->getUser();
$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => 'Wiki Admin'
		);
$theme->header($params);


if (array_key_exists('remove',$_REQUEST)) {
	$remove = Validator::sanitizeInt($_REQUEST['remove']);
} else {
	$remove = null;
}
$section = User::SECTION; // This should be changed if were in the user wiki wwwlib, for example
$ref_id = $user->getUserId(); // This should be changed if were in the user wiki wwwlib, for example

if (array_key_exists('sure',$_POST)) {
	$sure = $_POST['sure'];
} else {
	$sure = null;
}

$wiki = new UserWiki($section,$ref_id,$theme,$user);
$wiki->setAdmin();

if ($sure) {
	if ($remove) {
		echo $wiki->removePage($remove);
	} else {
		echo $wiki->displayFrontPage('ERROR - no page specified');
	}
} else {
	echo $wiki->displayPageById($remove,null,'<font color="red">No Changes</font>');
}

$theme->footer();
?>
