<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

// The parent class
require_once 'plugins/wiki/lib/om/BaseWikiPagePeer.php';

// The object class
include_once 'plugins/wiki/lib/WikiPage.php';

/** 
 * The skeleton for this class was autogenerated by Propel  *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package plugins.wiki.lib 
 */
class WikiPagePeer extends BaseWikiPagePeer {
	private static $_pkCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	WikiPage
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, WikiPagePeer::$_pkCache)) {
			return WikiPagePeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			WikiPagePeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, WikiPagePeer::$_pkCache)) {
			unset(WikiPagePeer::$_pkCache[$pk]);
		}
	}

	public static function getWikiPageCount($project_id) {
		$total = 0;
		$c = new Criteria();
		$c->add(WikiPagePeer::REF_ID,$project_id);
		$c->addSelectColumn(WikiPagePeer::COUNT);
		$rs = WikiPagePeer::doSelectRS($c);  
  		if ($rs->next()) {
   			return $rs->getInt(1);
		}
		return 0;
	}

}
?>