<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('plugins/wiki/lib/Wiki.php');
require_once('plugins/wiki/lib/html/WikiTemplate.php');

$theme = new WikiTemplate();
$project = GFUrl::getUrl()->getProject();
		
$section = Project::SECTION;
$ref_id = $project->getProjectId();
$diff = (isset($_REQUEST['diff'])) ? Validator::sanitizeInt($_REQUEST['diff']) : null;
$from = (isset($_REQUEST['from'])) ? Validator::sanitizeInt($_REQUEST['from']) : null;
$to = (isset($_REQUEST['to'])) ? Validator::sanitizeInt($_REQUEST['to']) : null;
		
if ($diff != null && $to != null && $from != null) {
	$wiki = new Wiki($section,$ref_id,$theme,$project);
	$PageContent = $wiki->showDiffFromTo($diff, $from, $to);
} else if ($diff != null && $to != null) {
	$wiki = new Wiki($section,$ref_id,$theme,$project);
	$PageContent = $wiki->showDiffTo($diff, $to);
} else if ($diff != null) {
	$wiki = new Wiki($section,$ref_id,$theme,$project);
	$PageContent = $wiki->showDiff($diff);
} else {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => Language::getSessText('Wiki.ViewDiffTitle'),
		'wiki' => $wiki
		);

$theme->header($params);

echo $PageContent;

$theme->footer();

?>
