<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('plugins/wiki/lib/Wiki.php');
require_once('plugins/wiki/lib/html/WikiTemplate.php');

$theme = new WikiTemplate();
$project = GFUrl::getUrl()->getProject();

$pagename = (isset($_REQUEST['pagename'])) ? Validator::sanitizeString($_REQUEST['pagename']) : null;
$pagename = html_entity_decode($pagename);
$parent_page = (isset($_REQUEST['parent_page'])) ? Validator::sanitizeString($_REQUEST['parent_page']) : null;
$pageid = (isset($_REQUEST['pageid'])) ? Validator::sanitizeInt($_REQUEST['pageid']) : null;
$version = (isset($_REQUEST['version'])) ? Validator::sanitizeInt($_REQUEST['version']) : null;
$selectedtab = (isset($_REQUEST['selectedtab'])) ? Validator::sanitizeString($_REQUEST['selectedtab']) : null;
$section = Project::SECTION;
$ref_id = $project->getProjectId();
//This is a special case where instead of remembering the last user selection, we want to go straight to the edit screen
if ($selectedtab == 'edit') {
	setcookie('mainTabSettabberprojectwiki', 1, 0, '/');
}
$wiki = new Wiki($section,$ref_id,$theme,$project);

if ($pageid) {
	// display page or display create-page page
	if ($version) {
		$PageContent = $wiki->displayPageById($pageid,$version);
	} else {
		$PageContent = $wiki->displayPageById($pageid);
	}
} elseif ($pagename) {
	if (strlen($pagename) > 255) {
		throw new Exception(Language::getSessText('WikiPage.NameTooLong'));
	}
	
	// display page or display create-page page
	if ($version) {
		$PageContent = $wiki->displayPage($pagename,$version);
	} else {
		if ($parent_page) {
			$PageContent = $wiki->displayPage($pagename,null,null,$parent_page);
		} else {
			$PageContent = $wiki->displayPage($pagename);
		}
	}
} else {
	//if there is no FrontPage and the type is not set
	$wiki->retrievePageByName('FrontPage');
	$wikiType = $wiki->getWikiType(); 
	if( !is_object($wiki->getPage()) 	&& 
			$wikiType == WikiProjectSetting::UNKNOWN_TYPE	) {
			if (!$project->getPermission()->isAdmin()) {
				$PageContent = "
					<div class='infobox'>" .
						Language::getSessText('Wiki.Admin.WikiFirstTime') .
					"</div>";
			} else {
				GFUrl::redirect(GFUrl::getUrl()->projectURL($project,'','wiki','admin', array('action'=>'','feedback'=>'', 'firstTimeSetup' => 'yes')));			
			}
	} else {
		$PageContent = $wiki->displayFrontPage();
	}
}
$page = $wiki->getPage();

$params = array(
		'project' => $project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => Language::getSessText('Wiki.ViewPageTitle'),
		'wiki' => $wiki,
		'page' => $page,
		'enableUploads' => isset($page) ? $page->userCanUpdate() : false
		);

$tabbertabsetcookie='projectwiki';
$theme->header($params);

echo $PageContent;

$theme->footer($params);
?>
