<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-16
 *
 * SOAP plugin for GForge5.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
 

require_once('plugins/tracker/lib/TrackerPeer.php');
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('lib/core/Monitor.php');


$server->register(
	'getArtifactTechnicians',
	array('session_ser'=>'xsd:string','group_id'=>'xsd:int','group_artifact_id'=>'xsd:int'),
	array('getArtifactTechniciansResponse'=>'tns:ArrayOfUser'),
	$uri, $uri.'#getArtifactTechnicians','rpc','encoded'
);

//
//	getArtifactTechnicians
//
function getArtifactTechnicians($session_ser, $group_id, $group_artifact_id) {
	try {
		$session = continueSession($session_ser);
		
		// Retrieve the Tracker Item
		$c = new Criteria();
		$c->add(TrackerPeer::TRACKER_ID, $group_artifact_id);
		$c->add(TrackerPeer::PROJECT_ID, $group_id);
		$Tracker = TrackerPeer::doSelectOne($c);
	
		if (!$Tracker || !is_object($Tracker)) {
			return new soap_fault('', 'getArtifactTechnicians', 'No Such ArtifactType',
								'No Such ArtifactType');
		}
		
		$Technicians = $Tracker->getTechnicians();
		return usersToSoap($Technicians);
	} catch (Exception $ex) {
		return new soap_fault('', 'getArtifactTechnicians',
							'Could Not Get Artifact Technicians: '.$ex->getMessage(),
							'Could Not Get Artifact Technicians: '.$ex->getMessage());
	}
}

?>
