<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

// This code generates a SOAP API for handling logins and logouts


$SOAP_VERSION = '570';

/* ******************************************************************** */
/*                                 DATA TYPES                           */
/* ******************************************************************** */

$server->wsdl->addComplexType(
	'ArrayOfString',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array(
			'ref'=>'SOAP-ENC:arrayType',
			'wsdl:arrayType'=>'xsd:string[]'
		)
	),
	'xsd:string'
);

$server->wsdl->addComplexType(
	'ArrayOfInt',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array(
			'ref'=>'SOAP-ENC:arrayType',
			'wsdl:arrayType'=>'xsd:int[]'
		)
	),
	'xsd:int'
);


/* ******************************************************************** */
/*                                 METHODS                              */
/* ******************************************************************** */

$server->register(
	'getTimezones',
	array('sessionHash'	=> 'xsd:string'), 
	array('getTimezones' => 'tns:ArrayOfString'),
	$uri, 
	$uri.'#getTimezones',
	'rpc',
	'encoded'
);


/**
 * SOAP method to get the list of Timezones
 *
 * @return	Array of Timezones
 */

function getTimezones($sessionHash) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);
	require_once('lib/timezones.php');
	return $TZs;
}


$server->register(
	'getSOAPVersion',
	array('sessionHash'	=> 'xsd:string'), 
	array('getSOAPVersion' => 'xsd:int'),
	$uri, 
	$uri.'#getSOAPVersion',
	'rpc',
	'encoded'
);

/**
 * SOAP method to get the version number of the SOAP API
 *
 * @return	int
 */

function getSOAPVersion($sessionHash) {
	global $SOAP_VERSION;
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);
	return $SOAP_VERSION;
}


$server->register(
	'getServerTime',
	array('sessionHash'	=> 'xsd:string'), 
	array('getServerTime' => 'xsd:string'),
	$uri, 
	$uri.'#getServerTime',
	'rpc',
	'encoded'
);

/**
 * SOAP method to get the server time in the GMT time zone
 * 
 * @return	int
 */

function getServerTime($sessionHash) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);
	return gmdate("Y-m-d H:i:sO");
}

?>
