<?php
require_once('lib/core/TagEntry.php');

$server->wsdl->addComplexType(
	'ArrayOfString',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'xsd:string[]')),
	'xsd:string'
);


$server->register(
	'getTagEntries',
	array(
		'sessionHash'	=> 'xsd:string',
		'section' => 'xsd:string',
		'ref_id' => 'xsd:int'
	), 
	array('getTagEntries' => 'tns:ArrayOfString'),
	$uri, 
	$uri.'#getTagEntries',
	'rpc',
	'encoded'
);

function getTagEntries($sessionHash, $section, $ref_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);
	
	$c = new Criteria();
	$c->add(TagEntryPeer::SECTION, $section);
	$c->add(TagEntryPeer::REF_ID, $ref_id);
	$entries = TagEntryPeer::doSelect($c);
	
	$result = array();
	foreach ($entries as $entry) {
		$result[] = $entry->getTagName();
	}
	return $result;
	
}

$server->register(
	'deleteTagEntries',
	array(
		'sessionHash'	=> 'xsd:string',
		'section' => 'xsd:string',
		'ref_id' => 'xsd:int',
		'tags' => 'xsd:string',
	), 
	array('deleteTagEntries' => 'xsd:int'),
	$uri, 
	$uri.'#deleteTagEntries',
	'rpc',
	'encoded'
);

function deleteTagEntries($sessionHash, $section, $ref_id, $tags) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);
	
	TagEntryPeer::deleteTags($section, $ref_id, $tags);
	return 1;
}

$server->register(
	'addTagEntries',
	array(
		'sessionHash'	=> 'xsd:string',
		'section' => 'xsd:string',
		'ref_id' => 'xsd:int',
		'tags' => 'xsd:string',
	), 
	array('addTagEntries' => 'xsd:int'),
	$uri, 
	$uri.'#addTagEntries',
	'rpc',
	'encoded'
);

function addTagEntries($sessionHash, $section, $ref_id, $tags) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);
	
	TagEntryPeer::addTags($section, $ref_id, $tags);
	return 1;
}


?>
