<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @author		Marcelo Mottalli <marcelo@gforgegroup.com>
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/docman/lib/DocmanProjectSetting.php');

$server->wsdl->addComplexType(
	'DocmanProjectSetting',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'project_id' => array('name'=>'project_id', 'type' => 'xsd:int'),
		'show_associations_tab' => array('name'=>'show_associations_tab', 'type' => 'xsd:boolean'),
		'show_tags_tab' => array('name'=>'show_tags_tab', 'type' => 'xsd:boolean')
	)
);

$server->register(
	'setDocmanProjectSettings',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' 	=> 'xsd:int',
		'show_associations_tab'	=> 'xsd:boolean',
		'show_tags_tab'	=> 'xsd:boolean'
	), 
	array('setDocmanProjectSettings' => 'xsd:int'),
	$uri, 
	$uri.'#setDocmanProjectSettings',
	'rpc',
	'encoded'
);

function setDocmanProjectSettings($sessionHash, $project_id, $show_associations_tab, $show_tags_tab) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);
	
	$obj = DocmanProjectSettingPeer::retrieveByPk($project_id);
	if (!is_object($obj)) {
		$obj = new DocmanProjectSetting();
		$obj->setProjectId($project_id);
	}
	
	$obj->setShowAssociationsTab(Validator::sanitizeBool($show_associations_tab));
	$obj->setShowTagsTab(Validator::sanitizeBool($show_tags_tab));
	$obj->save();
	
	return 1;
}

$server->register(
	'getDocmanProjectSettings',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' 	=> 'xsd:int'
	), 
	array('getDocmanProjectSettings' => 'tns:DocmanProjectSetting'),
	$uri, 
	$uri.'#getDocmanProjectSettings',
	'rpc',
	'encoded'
);

function getDocmanProjectSettings($sessionHash, $project_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($ip, $sessionHash);
	
	$obj = DocmanProjectSettingPeer::retrieveByPk($project_id);
	if (!is_object($obj)) {
		$show_associations_tab = true;
		$show_tags_tab = true;
	} else {
		$show_associations_tab = $obj->getShowAssociationsTab();
		$show_tags_tab = $obj->getShowTagsTab();		
	}
	
	$ret = array();
	$ret['project_id'] = $project_id;
	$ret['show_associations_tab'] = $show_associations_tab;
	$ret['show_tags_tab'] = $show_tags_tab;
	
	return $ret;
}


?>
