<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author mtutty mtutty@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('initialize.php');

require_once('GFConf.php');
require_once('GFUrl.php');
require_once('session/Session.php');
require_once('core/Language.php');

// Initialize plugins
// Set up session
$session = Session::getSession();

// user may already be logged in
if (isset($_COOKIE['sessionHash'])) {
	$ip = $_SERVER['REMOTE_ADDR'];
	try {
		$session->setup($_COOKIE['sessionHash'], $ip);
	} catch (SessionException $ex) {
		// This means the cookie is invalid... we delete it
    setcookie("sessionHash", false, 0, "/", '', !empty($_SERVER['HTTPS']), true);
	}
}

// GAWD, I'm a haxxor
// Different templates used for the various sections of the 404 form
// require slightly different context variables.
$lang = $language = $session->getLanguage();

// User is not logged in, get the default theme
$defaultThemeName = GFConf::get('system.defaultTheme');
$theme = ThemeFactory::getTheme($defaultThemeName);

require_once('html/SiteTemplate.php');
$template = new SiteTemplate();

$params = array(
	'selectedtoptab' => '',
	'title' => 'Not Found',
	'feedback' => ''
);
$template->header($params);

$uri = 'http' . (isset($_SERVER['HTTPS']) ? 's' : null) . '://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
?>
<style>
	table.notfound {
		width: 75%; margin-left: 3em; margin-right: auto; display: block;
	}

	h2 {
		padding-left: 0;
	}

	table.notfound td {
		padding: .5em 2em .5em 2em;
		vertical-align: top;
	}

	table.notfound td.right-border {
		border-right: solid 2px darkgray;
	}
</style>

<h2>Not Found</h2><br />
<p>Sorry, the URL you requested <br /><div style="padding: .5em 0 .5em 3em; font-weight: bold;"><?php echo $uri ?></div><br /> does not exist on this site. This could be the result of an error in the system, or a mis-spelled item in the URL itself.</p>

<br />
<br />
<h2>What Now?</h2><br />
<p>Try one of the options below to find your way:</p><br />
<table class="notfound">
	<tr>
		<td class="right-border">
			<h2>Project Search</h2><br />
			<p>If you were looking for a specific Project, use this search to find it by words in the name and/or description:</p>
<?php
echo $template->tableTop(array('Project Search'));
echo '<tr><td>';
$hideNewProject = TRUE;
include('wwwlib/project/forms/ProjectSearch-tpl.php');
echo '</td></tr>';
echo $template->tableBottom();
?>
		</td>
			<?php
			if ($session->isLoggedIn()) {
				?>
			<td class="right-border">
				<h2>Site Search</h2><br />
				<p>If you were looking for a specific Tracker Item, Document or other Project item, use the Site Search to find it:</p>
	<?php
	$theader = array('Site Search');
	$words = '';
	include('wwwlib/search/SiteSearchForm.php');
	echo '</td>';  // end div from above
}
?>
		<td>
			<h2>GForge Help Reference</h2><br />
			<p>You can find information about basic and advanced GForge usage in our <a href="http://gforgegroup.com/es/help.php" title="GForge Help Reference">Help Pages</a></p>
<?php
echo $template->tableTop(array('GForge Help Reference'));
$trow = array(
	'<center>' . HTMLWidget::button("button", 'Go', "go_help", "", "window.location.href = 'http://gforgegroup.com/es/help.php';") . '</center>'
);
echo $template->tableRow($trow, array(), true);
echo $template->tableBottom();
?>
		</td>
	</tr>
</table>
<br />
<h2>No Joy?  Get Help From Us!</h2><br />
<p>Contact us at <a href="mailto:support@gforgegroup.com" title="E-mail GForge support">support@gforgegroup.com</a>, and we'll do our best to help out.</p>

<?php
$template->footer();
