 function discuss(elem, onSuccess) {
	if (log) console.log('Discuss enter');
	elem = $(elem).closest('a');  // in case image or other elem inside the link is clicked
	// Get values from clicked element
	var url = '/gf/chat/?action=ChatAdd';

	var thread_id = $(elem).attr('data-thread-id');
	var section = $(elem).attr('data-section');
	var refid = $(elem).attr('data-ref-id');
	var forum_id = $(elem).attr('data-forum-id');
	var forum_name = $(elem).attr('data-forum-name');

	// First, try to use a specific thread if specified
	if (thread_id && thread_id != '') {
		url += '&thread_id='+encodeURIComponent(thread_id.toString());
	// Next try to find or create a forum and thread based on section and refid
	} else if (section && refid && section != '' && refid != '') {
		url += '&section='+encodeURIComponent(section)+'&refid='+encodeURIComponent(refid)+"&name="+encodeURIComponent(forum_name);
	// Next, try to get the "discussion" thread for a specified forum
	} else if (forum_id && forum_id != '') {
		url += '&forum_id='+encodeURIComponent(forum_id);
	// If we got none of those, then tell the user.
	} else {
		alert("Sorry, someone marked this item as discussable but we can't figure out what to discuss!");
		return false;
	}
	if (log) console.log('Discuss, ChatAdd url is '+url);

	// AJAX call to set up forum/thread
	$.ajax({
		type: "GET",
		url: url,
		dataType: "json",
		cache: false,
		success: function(data) {
			if (log) console.log('Discuss, set up ajax success for '+url);
			if (log) console.log(data);
			if (undefined === data || null === data) {
				// Nothing came back?
				return;
			}

			if (data.success) {
				if (onSuccess != undefined && typeof(onSuccess) == 'function') {
					// Don't need the window, just the AJAX call and returned data.
					onSuccess(data);
				} else {
					openChatWindow();
				}
			} else {
				if (data.message !== "") {
					alert(data.message);
				}
			}

			if (log) console.log('Discuss, done');
		},
		statusCode: {
			401: function() {
				return chatErrorMsg('Log into GForge and try again.');
			},
			403: function() {
				return chatErrorMsg('The Discussion does not exist, or you are not allowed to view it.');
			},
			404: function() {
				return chatErrorMsg('The Discussion does not exist, or you are not allowed to view it.');
			},
			418: function() {
				return chatErrorMsg('Apparently, GForge is a teapot!');
			},
			500: function() {
				return chatErrorMsg('The GForge server had an internal error.');
			}
		}
	});
}

function openChatWindow() {
    var url = "/gf/chat/?action=Chat";
    //If this is the chat window, no action needed here, exit
    if (window.location.href.indexOf(url) > -1) {
        return;
    }
	var target = "_gfchat";
	var options = "fullscreen=no,menubar=no,resizable=yes,location=no,scrollbars=no,status=no,toolbar=no,width=800,height=600";

	var discussWindow = window.open("", target, options);
	if (discussWindow.location.href === "about:blank") {
		discussWindow = window.open(url, target, options);
	}
	discussWindow.focus();
}

function chatErrorMsg(specific) {
	alert('Sorry, could not open the Live Discussion you requested. '+specific);
	return false;
}

