/*==================================================
  Cookie functions
  ==================================================*/
function setCookie(name, value, expires, path, domain, secure) {
    document.cookie= name + "=" + escape(value) +
        ((expires) ? "; expires=" + expires.toGMTString() : "") +
        ((path) ? "; path=" + path : "") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
}

function getCookie(name) {
    var dc = document.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1) {
        begin = dc.indexOf(prefix);
        if (begin != 0) return null;
    } else {
        begin += 2;
    }
    var end = document.cookie.indexOf(";", begin);
    if (end == -1) {
        end = dc.length;
    }
    return decodeURI(dc.substring(begin + prefix.length, end));
}
function deleteCookie(name, path, domain) {
    if (getCookie(name)) {
        document.cookie = name + "=" +
            ((path) ? "; path=" + path : "") +
            ((domain) ? "; domain=" + domain : "") +
            "; expires=Thu, 01-Jan-70 00:00:01 GMT";
    }
}

$(document).ready(function() {
	//This is a workaround for the cookie-based tabber persistance on the wiki. 
	//We need to reset the cookie for the wiki plugin, except when loading wiki related urls
	var str_url = document.location;
	str_url = str_url.toString();
	if (str_url.indexOf('/wiki') == -1 && str_url.indexOf('TagAdd') == -1  && str_url.indexOf('Association') == -1) {
		setCookie('mainTabSettabberprojectwiki', 0, 0, '/');
	}

    //Activate syntax highlighting
    highlightCodeBlock();
});

var toasterDelaySeconds = 1;
var toaster_xhr = null;

function isPageVisible() {
	if (typeof document.hidden !== "undefined") { // Opera 12.10 and Firefox 18 and later support 
	    hidden = "hidden";
	} else if (typeof document.mozHidden !== "undefined") {
	    hidden = "mozHidden";
	} else if (typeof document.msHidden !== "undefined") {
	    hidden = "msHidden";
	} else if (typeof document.webkitHidden !== "undefined") {
	    hidden = "webkitHidden";
	}
	var isHidden = document[hidden];

	return (isHidden === false);
}

function cancelToaster() {
	if (toaster_xhr) {
		toaster_xhr.abort();
		toaster_xhr = null;
	}
}

function checkToasterMessages() {
	// AJAX call to set up forum/thread
	var url = '/gf/my/messagewall/?action=MessageWallUserNotice';
	var log = false;
	var keepPolling = window.flagPollActive;//defined in Layout.php
	var now = new Date();
	if (log) console.log('Toaster, entered checkToasterMessages at '+ now.toString());
	if (toaster_xhr) {
		if (log) console.log('Toaster, request in progress, quit');
		return;
	}
	if (! isPageVisible()) {
		if (log) console.log('Toaster, window is not visible, go to sleep');
		return;
	}
	if (!keepPolling) {
		if (log) {
			console.log('Toaster, polling is off');
		}
		return;
	}
	toaster_xhr = $.ajax({
		async: true,
		type: "GET",
		url: url,
		dataType: "json",
		cache: false,
		timeout: 30000,
		success: function(data) {
			if (log) console.log('Toaster, set up ajax success for '+url);

			if (data == undefined || data == null) {
				if (log) console.log("Received a null response from message wall ajax method!");
			} else {
				if (log) console.log(data);
				for (var i = 0; i < data.messages.length; i++) {
					var message = data.messages[i];
					var comment = message.comment;
					var avatar = '/images/stock_avatars/default.png';
					//var title = 'Wall Message';
					if (message.user != null) {
						//title = message.user.unix_name;
						if (message.user.avatar != '' && message.user.avatar != 0) {
							avatar = '/images/custom_avatars/'+message.user.avatar+'.jpg';
						}
					}
					$.meow({
						//title: title,
						message: comment,
						icon: avatar,
						sticky: log
					});
					playSystemSound('growl');
				}
				toasterDelaySeconds = 1;
			}
			keepPolling = window.flagPollActive;//defined in Layout.php
		},
		error: function(xhr, options, err) {
			if (log) console.log('Toaster, status returned was '+xhr.status.toString());
			if (log) console.log('Toaster, error was '+err.toString());

			if (err == 'abort') {
				keepPolling = false;
			} else {
				toasterDelaySeconds += toasterDelaySeconds;				
				if (toasterDelaySeconds > 32) {
					if (log) console.log('Toaster, we have reached the max toasterDelaySeconds!');
					//alert('Sorry, it seems like your GForge server is not available.  Notification polling will stop until you refresh or load a page from GForge.');
					keepPolling = false;
				}
			}
		},
		complete: function() {
			if (log) console.log('Toaster, entered complete function');
			toaster_xhr = null;

			if (keepPolling) {
				if (log) console.log('Toaster, starting next check with interval '+toasterDelaySeconds);
				setTimeout(checkToasterMessages, toasterDelaySeconds * 1000);
			}
		}
	});
}
function unescape(rawHtml) {
	if (rawHtml) {
    var div = document.createElement('div');
    div.innerHTML = rawHtml;
    return div.firstChild.nodeValue;
	} else {
		return '';
	}
}
if (log == undefined) var log = false;
if (typeof console === "undefined" || typeof console.log === "undefined") {
	console = {};
	console.log = function() {};
}

function addAutoComplete(elem) {
	var dataSourceUrl = $(elem).attr('data-autocomplete-src');
	if (dataSourceUrl && dataSourceUrl != '') {
		$.ajax({
			type: "GET",
			url: dataSourceUrl,
			dataType: "json",
			cache: false,
			success: function(data) {
				if (data && data.length > 0) {
			    $(elem).asuggest(data, {
						'endingSymbols': ' ',
						'stopSuggestionKeys': [$.asuggestKeys.RETURN],
						'minChunkSize': 2,
						'delimiters': ' '
			    });
			    return true;
				}
			}
		});
	}
}

function popup(url, width, height) {
	/* open popup window */
	popupwindow = window.open(url, 'popup', 'scrollbars=yes,resizable=yes,height='+height+',width='+width+'');
	/* set focus on it */
	if (window.focus) {
		popupwindow.focus()
	}
	return false;
}

function fixedPopup(url, width, height) {
	/* open popup window */
	popupwindow = window.open(url, 'popup', 'toolbar=no,directories=no,status=no,scrollbars=no,menubar=no,height='+height+',width='+width+'');
	/* set focus on it */
	if (window.focus) {
		popupwindow.focus()
	}
	return false;
}

function FindObject(n, d)
{ //v4.01
	var p, i, x;
	if (!d) d = document;
	if ((p=n.indexOf("?"))> 0 && parent.frames.length)
	{
		d = parent.frames[n.substring(p+1)].document;
		n = n.substring(0,p);
	}
	if(!(x=d[n])&&d.all) x=d.all[n];
	for (i=0;!x&&i<d.forms.length;i++) x = d.forms[i][n];
	for (i=0;!x&&d.layers&&i<d.layers.length;i++) x = FindObject(n,d.layers[i].document);
	if (!x && d.getElementById) x = d.getElementById(n);
	return x;
}

var btn = {
	init : function() {
		var ieVer=/*@cc_on function(){ switch(@_jscript_version){ case 1.0:return 3; case 3.0:return 4; case 5.0:return 5; case 5.1:return 5; case 5.5:return 5.5; case 5.6:return 6; case 5.7:return 7; }}()||@*/0;
		var i;
		if (!document.getElementById || !document.createElement || !document.appendChild) return false;
		as = btn.getElementsByClassName('button(.*)');
		for (i=0; i< as.length; i++) {
			//check if node is an input tag
			if ( as[i].tagName == "INPUT" && ( as[i].type.toLowerCase() == "submit" || as[i].type.toLowerCase() == "button" ) ) {
				//get input type
				var type = as[i].type.toLowerCase();
	            	
				if(ieVer != 6){
					var a1 = document.createElement("a");

					//set text to link
					as[i].style.display = "none";
					a1.appendChild(document.createTextNode(as[i].value));
					a1.className = as[i].className;
					a1.id = as[i].id;
					a1.onclick = as[i].onclick;
		                
					if(type == "submit"){
						as[i].parentNode.insertBefore(a1, as[i]);
					}
					else{
						as[i].parentNode.replaceChild(a1, as[i]);
					}

					as[i] = a1;
               
					if(type == "submit"){
						btn.addEvent(as[i],'click',function() {
							var form = btn.findForm(this);
							var submit = btn.findSubmitButton(form);
							submit.click();
						});
						if(ieVer == 7){
							document.onkeypress = function formSubmit() {
								// IE7
								if(window.event.keyCode == 13){
									var target = window.event.srcElement;
									var form = btn.findForm(target);
									var submit = btn.findSubmitButton(form);
									submit.click();
								}
								return true;
							}
						}
					}
					else if(type == "reset"){
						btn.addEvent(document.getElementById('reset_btn'),'click',function() {
							var form = btn.findForm(this);
							form.reset();
						});
					}
				}
				else{
					var s1 = document.createElement('span');
					var a1 =  as[i].cloneNode(false);
					//set text to link
					s1.appendChild(a1)
					s1.className = as[i].className;
					as[i].parentNode.replaceChild(s1, as[i]);
					as[i] = a1;
				}
	                
			}//if is not an input tag ask for a link
			else if (as[i].tagName == "A") {
				var tt = as[i].childNodes;
			}
	            
			if (as[i].tagName != "DEL" && ieVer != 6) {
				var s1 = document.createElement('span');
				while (as[i].firstChild) {
					s1.appendChild(as[i].firstChild);
				}
				as[i].appendChild(s1);
			}

		}

	       
		as = btn.getElementsByClassName('disabled_button(.*)');
	        
		for (i=0; i<as.length; i++) {
	        	
			if ( as[i].tagName == "INPUT" && ( as[i].type.toLowerCase() == "submit" || as[i].type.toLowerCase() == "button" ) ) {
				var type = as[i].type.toLowerCase();
				var a1 = document.createElement("a");
				a1.appendChild(document.createTextNode(as[i].value));
				a1.className = as[i].className;
				as[i].className = "";
				//a1.id = as[i].id;
				//a1.onclick = as[i].onclick;
				as[i] = as[i].parentNode.replaceChild(a1, as[i]);
				as[i] = a1;
	                               	                
			}
			else if (as[i].tagName == "A") {
				var tt = as[i].childNodes;
			}
			else if (as[i].tagName == "SPAN") {
	       	
				var del1 = document.createElement("del");
				var span1 = document.createElement("span");
				span1.appendChild(document.createTextNode(as[i].firstChild.data));
				del1.className = 'button';
				del1.appendChild(span1);
				//a1.id = as[i].id;
				//a1.onclick = as[i].onclick;
				as[i] = as[i].parentNode.replaceChild(del1, as[i]);
				as[i] = del1;
			}
		}
	        
		if (document.getElementById('reset_btn')) {
			btn.addEvent(document.getElementById('reset_btn'),'click',function() {
				var form = btn.findForm(this);
				form.reset();
			});
		}
	},
	findForm : function(f) {
		while(f.tagName != "FORM") {
			f = f.parentNode;
		}
		return f;
	},
	findSubmitButton: function(f) {
		var kids = f.childNodes;
		var button = null;
	        
		for(var i = 0; i < kids.length; i++){
			button = btn.findSubmitButton(kids[i]);
			if(kids[i].type == "submit")
				button = kids[i];
			if(button != null){
				break;
			}
		}
	        
		return button;
	}
	,
	addEvent : function(obj, type, fn) {
		if (obj.addEventListener) {
			obj.addEventListener(type, fn, false);
		}
		else if (obj.attachEvent) {
			obj["e"+type+fn] = fn;
			obj[type+fn] = function() {
				obj["e"+type+fn]( window.event );
			}
			obj.attachEvent("on"+type, obj[type+fn]);
		}
	},
	getElementsByClassName : function(className, tag, elm) {
		var testClass = new RegExp("(^|\s)" + className + "(\s|$)");
		var tag = tag || "*";
		var elm = elm || document;
		var elements = (tag == "*" && elm.all)? elm.all : elm.getElementsByTagName(tag);
		var returnElements = [];
		var current;
		var length = elements.length;
		for(var i=0; i<length; i++){
			current = elements[i];
			if(testClass.test(current.className)){
				returnElements.push(current);
			}
		}
		return returnElements;
	}
}


function setUserPreference(str_preference_name, str_preference_value) {
	var _url = '/gf/ajax/?action=UserSetPreferenceAjax&preference_name=' + str_preference_name + '&preference_value=' + str_preference_value;

	$.ajax({
		url: _url,
		type: "GET",
		dataType: 'html',
		success: function(json_string){
		},
		error: function(json_string) {
		}
	});   
}


function submitSystemSoundSetting(el) {
	var preferenceName = 'system-sound-setting';
	var preferenceValue = $(el).attr(preferenceName);
	if (preferenceValue == 'Y') {
		preferenceValue = 'N';
	} else {
		preferenceValue = 'Y';
	}
	
	var url = '/gf/ajax/?action=UserSetPreferenceAjax&preference_name=' + preferenceName + '&preference_value=' + preferenceValue;
	$.ajax({
		type: "GET",
		url: url,
		dataType: "html",
		cache: false,
		success: function(data) {
			$(el).attr('system-sound-setting', preferenceValue);
			var src_image = $(el).attr('src');
			if (preferenceValue == 'N') {
				src_image = src_image.replace("sound_on_white_small.png", "sound_off_white_small.png");
			} else {
				src_image = src_image.replace("sound_off_white_small.png", "sound_on_white_small.png");
			}
			$(el).attr('src', src_image);
			if (log) console.log('Submit Sound Setting: ' + threadId + ' success');
		},
		error: function(json_string) {
		}
	});
}


function playSystemSound(event) {	
	var sound_toggle = $(document).find('.sound-toggle');
	$("#systemsound_").remove()
	try {
		var preferenceValue = $(sound_toggle).attr('system-sound-setting');
		if (preferenceValue == 'Y') {
			$('body').append('<embed id="systemsound_" autostart="true" hidden="true" src="/themes/gforge5/sounds/growl/' + event + '.mp3" />');
		}
	} catch(err) {
	}
	
}


var pastNotifIndex = 0;


function updateNotificationsUi(data) {
	var notificationList = $("#jcapp-notificationssummary").find('.notificationlist');
	$.tmpl( "notificationtemplate", data ).appendTo( $(notificationList) );
}


function renderNotificationsUi() {
	$( "#notificationsAreaTemplate" ).template( "notificationsArea" );
	var data = {};
	$.tmpl( "notificationsArea", data ).appendTo( $('#notificationsarea') );
}


function getPastNotifications(restart) {
	if (restart == undefined) {
		restart = true;
	}
	
	if (restart) {
		$('.notificationlist').empty();
		pastNotifIndex = 0;
	}

	var url = '/gf/my/messagewall/?action=MessageWallUserNotice&since=' + pastNotifIndex + '&history=1';
	var log = true;
	$.ajax({
		async: true,
		type: "GET",
		url: url,
		dataType: "json",
		cache: false,
		timeout: 10000,
		success: function(data) {
			if (log) console.log(JSON.stringify(data));
			if (log) console.log('Notifications, set up ajax success for '+url);

			if (data == undefined || data == null) {
				if (log) console.log("Received a null response from message wall ajax method!");
			} else {
				if (log) console.log(data);
				pastNotifIndex = data.since;
				
				if (data.messages.length > 0) {
					$('#notifications-seemore').show();
				} else {
					if (restart) {
						var notificationList = $("#jcapp-notificationssummary").find('.notificationlist');
						data = {};
						$.tmpl( "nonotificationtemplate", data ).appendTo( $(notificationList) );
						$('#notifications-seeall').hide();
					}
					$('#notifications-seemore').hide();
				}
				
				for (var i = 0; i < data.messages.length; i++) {
					var message = data.messages[i];
					var post_date = message.post_date;
					var comment = message.comment;
					var avatar = '/images/stock_avatars/default.png';
					//var title = 'Wall Message';
					if (message.user != null) {
						//title = message.user.unix_name;
						if (message.user.avatar != '' && message.user.avatar != 0) {
							avatar = '/images/custom_avatars/'+message.user.avatar+'.jpg';
						}
					}

					//Render the notification
					comment = comment.replace(/<br \/>/i, '');
					var notification_data = {
						body : comment,
						avatar: avatar,
						post_date : post_date
					};
					updateNotificationsUi(notification_data);
				}
			}
		},
		statusCode: {
			401: function() {
				keepPolling = false;
			},
			403: function() {
				keepPolling = false;
			},
			404: function() {
				keepPolling = false;
			},
			500: function() {
				keepPolling = false;
			}
		}
	});
}


var BrowserDetect = {
	init: function () {
		this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
		this.version = this.searchVersion(navigator.userAgent)
			|| this.searchVersion(navigator.appVersion)
			|| "an unknown version";
		this.OS = this.searchString(this.dataOS) || "an unknown OS";
	},
	searchString: function (data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].string;
			var dataProp = data[i].prop;
			this.versionSearchString = data[i].versionSearch || data[i].identity;
			if (dataString) {
				if (dataString.indexOf(data[i].subString) != -1)
					return data[i].identity;
			}
			else if (dataProp)
				return data[i].identity;
		}
	},
	searchVersion: function (dataString) {
		var index = dataString.indexOf(this.versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	},
	dataBrowser: [
		{
			string: navigator.userAgent,
			subString: "Chrome",
			identity: "Chrome"
		},
		{ 	string: navigator.userAgent,
			subString: "OmniWeb",
			versionSearch: "OmniWeb/",
			identity: "OmniWeb"
		},
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: "Safari",
			versionSearch: "Version"
		},
		{
			prop: window.opera,
			identity: "Opera",
			versionSearch: "Version"
		},
		{
			string: navigator.vendor,
			subString: "iCab",
			identity: "iCab"
		},
		{
			string: navigator.vendor,
			subString: "KDE",
			identity: "Konqueror"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: "Firefox"
		},
		{
			string: navigator.vendor,
			subString: "Camino",
			identity: "Camino"
		},
		{		// for newer Netscapes (6+)
			string: navigator.userAgent,
			subString: "Netscape",
			identity: "Netscape"
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: "Explorer",
			versionSearch: "MSIE"
		},
		{
			string: navigator.userAgent,
			subString: "Gecko",
			identity: "Mozilla",
			versionSearch: "rv"
		},
		{ 		// for older Netscapes (4-)
			string: navigator.userAgent,
			subString: "Mozilla",
			identity: "Netscape",
			versionSearch: "Mozilla"
		}
	],
	dataOS : [
		{
			string: navigator.platform,
			subString: "Win",
			identity: "Windows"
		},
		{
			string: navigator.platform,
			subString: "Mac",
			identity: "Mac"
		},
		{
			   string: navigator.userAgent,
			   subString: "iPhone",
			   identity: "iPhone/iPod"
	    },
		{
			string: navigator.platform,
			subString: "Linux",
			identity: "Linux"
		}
	]

};
BrowserDetect.init();

//	btn.addEvent(window,'load', function() { btn.init();} );

function playSound(str_url) {
	var str_html = '<embed id="sound_" autostart="true" hidden="true" src="' + str_url + '" />';
	
	try {
		$('body').append(str_html);
	} catch(err) {
		if (log) console.log(err);
	}
}


function highlightCodeBlock() {
    var highlight_class = 'highlight';
    var show_spinner = true;

    //check if there are highlight elements in the screen
    //var highlight_count = $(document).find('.' + highlight_class).lenght();
    var highlight_count = $('.' + highlight_class).length;

    if (highlight_count == 0) {
        show_spinner = false;
    }

    var spinner;
    if (show_spinner) {
        spinner_opts = {
            lines: 16, // The number of lines to draw
            length: 10, // The length of each line
            width: 5, // The line thickness
            radius: 15, // The radius of the inner circle
            color: '#000', // #rgb or #rrggbb
            speed: 1, // Rounds per second
            trail: 79, // Afterglow percentage
            shadow: false, // Whether to render a shadow
            hwaccel: false, // Whether to use hardware acceleration
            className: 'spinner', // The CSS class to assign to the spinner
            zIndex: 2e9, // The z-index (defaults to 2000000000)
            top: 'auto', // Top position relative to parent in px
            left: 'auto' // Left position relative to parent in px
        };

        var area = document.getElementsByTagName("body")[0];
        spinner = new Spinner(spinner_opts).spin(area);
    }

    $.SyntaxHighlighter.init();
    setTimeout(function() {
        $("." + highlight_class).slideDown('slow');
    }, 1500);

    if (show_spinner) {
        setTimeout(function() {
            spinner.stop();
            spinner = null;
        }, 1000);
    }
}
