<?php
/**
 * GForge 5.0 theme
 *
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel Perez daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/Layout.php');
require_once('html/HTMLWidget.php');
require_once('session/Session.php');
require_once('SystemUtils.php');
require_once('GFUrl.php');

class GFTheme extends Layout {
	/** misc color definitions */
	const COLOR_ROW_EVEN = '#EAEAEA';
	const COLOR_ROW_ODD = '#E0E0E0';
	const COLOR_TITLE_ROW = '#BBB';
	
	function getQuickJumpWrapper() {
		return '';
		if (Session::getSession()->isLoggedIn()) {
			$lang = Session::getSession()->getLanguage();
			//$return = "<div id=\" \" class=\"quickJumpMenu\" style=\"visibility: hidden; position:absolute; z-index:2; max-height: 60%; overflow:auto;\">";
			$return = "<div id=\"quickJumpMenu\" class=\"quickJumpMenu\" style=\"visibility: hidden; position:absolute; z-index:2; overflow:auto;\">";
			$return .= '</div>';
			return $return;
		}
	}	
	
	/**
	 *	getQuickJump() - Local redefinition of the getQuickJump defined in the Layout class
	 *
	 */

	function getQuickJump() {
		if (Session::getSession()->isLoggedIn()) {
			$lang = Session::getSession()->getLanguage();
			$return = "<div id=\"quickJumpMenu\" class=\"quickJumpMenu\" style=\"visibility: hidden; position:absolute; z-index:2; max-height: 60%; overflow:auto;\">";
			$return .= 	"<table class='quickJumpMenu'>" . 
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/register/?action=ProjectAdd\">" . $lang->getText('QuickJump.AddProject') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/reports/\">" . $lang->getText('QuickJump.Reports') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/\">" . $lang->getText('QuickJump.MyStuff') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/dashboard/\">" . $lang->getText('QuickJump.Dashboard') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/activity/\">" . $lang->getText('QuickJump.Activity') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/gantt/\">" . $lang->getText('QuickJump.Gantt') . "</a></td></tr>" .
					"<tr><td class='quickJumpMenu'><a class='quickJumpMenu' href=\"/gf/my/?action=LatestForumMessages\">" . $lang->getText('QuickJump.Forums') . "</a></td></tr>";
			
			$ids=Session::getSession()->getUser()->getAllProjectIds();
			if (count($ids) > 0) {
				$sql="SELECT pr.unix_name,pr.project_name,pl.plugin_name 
				FROM project pr, project_plugin pp, plugin pl
				WHERE pr.project_id IN (".implode(',',$ids).")
				AND pr.project_id=pp.project_id AND
				pp.plugin_id=pl.plugin_id
				ORDER BY pr.unix_name";
				$con=Propel::getConnection();
				$stmt=$con->createStatement();
				$rs=$stmt->executeQuery($sql);
				$last_project='';
				while ($rs->next()) {
					$plugin_name = $rs->getString('plugin_name');
					// Ugly hack -- Jabber plugin shouldn't be shown since it doesn't have a main page
					if ($plugin_name == 'projectjabber') {
						continue;
					}
					$projname=$rs->getString('unix_name');
					if ($projname != $last_project) {
						$last_project=$projname;
						$return .= '<tr><td class=\'quickJumpMenu\'><a class=\'quickJumpMenu\' href="/gf/project/'.$projname.'/">'.$rs->getString('project_name').'</a></td></tr>';
					}
					$return .= '<tr><td class=\'quickJumpMenu\'><a class=\'quickJumpMenu\' href="/gf/project/'.$projname.'/'.$rs->getString('plugin_name').'/">&nbsp;&nbsp;'.ucwords($rs->getString('plugin_name')).'</a></td></tr>';
				}
			}
			$return .= '</table></div>';
			return $return;
		} else {
			return '';
		}
	}

	/**
	 *	header() - "steel theme" top of page
	 *
	 * @param	array	Header parameters array
	 */
	function header($params=array()) {
		if (isset($GLOBALS['headershown']) && $GLOBALS['headershown']) {
			return;
		} else {
			$GLOBALS['headershown']=true;
		}

		$session = Session::getSession();
		$User = $session->getUser();
		$language = $session->getLanguage();
		$this->headerStart($params);
		?>

<?php 
	//The following code is also used further down to select between div classes 'right' and 'rightnoleft'
	//If the criteria to choose between cases changes, the other code needs to be modified too.
	if (array_key_exists('project', $params) || array_key_exists('user', $params)) {?>
<body>
<?php } else { ?>
<body class='noleftbody' data-spy="scroll" data-target="#navbar">
<?php } ?>

<script>
	function getPos(obj, direction) {	/*		direction == 0 ---> Top		direction != 0 ---> Left	*/
		var cur = 0;
		if (obj.offsetParent) {
			do {
				if (direction == 0)
					cur += obj.offsetTop;
				else
					cur += obj.offsetLeft;
			} while (obj = obj.offsetParent);
		}
		return cur;
	}
<?php
if (Session::getSession()->isLoggedIn()) {
?>
<?php
}
?>
	function expandFloatingMenu(id, icon) {
		var menu = document.getElementById(id);
		var icon = document.getElementById(icon);		
		var t = getPos(icon, 0);
		var l = getPos(icon, 1);
		menu.style.top = ((t + parseInt(icon.height)) + "px");
		menu.style.left = (l + "px");
		if (menu.style.visibility == "visible")
			menu.style.visibility = "hidden";
		else
			menu.style.visibility = "visible";
	}
	
</script>

<?php echo $this->getQuickJumpWrapper(); ?>


<div id="header" style="min-width:803px;">
<script type="text/javascript">
	<?php
	//Hack, until we replace the myqueue drag and drop functionality, we will need
	// to use prototype
	if (Session::getSession()->isLoggedIn()) {
		if (isset($params['selectedbottomtab']) && $params['selectedbottomtab'] == 'my') { ?>
		//This is how you use jquery when you have other libs that also use the $ identifier
		//In My Page, we must use it this way to avoid conflicts with prototype and the draggable functionality
		//jQuery.noConflict();
		$(document).ready(function(){
			if ($('#quickJumpMenu').html() == ""){
				$("#quickJumpIcon").click(function(){
					$.get('/gf/ajax/handler.php?action=GetQuickJumpMenu',
						function(data){
							$('#quickJumpMenu').html(data);
							//quickJumpMenu();
						}
					);
				});
			} else {
				//quickJumpMenu();
			}
		});
		<?php } else { ?>
			$(document).ready(function(){
				if ($('#quickJumpMenu').html() == ""){
					$("#quickJumpIcon").click(function(){
						$.get('/gf/ajax/handler.php?action=GetQuickJumpMenu',
							function(data){
								$('#quickJumpMenu').html(data);
								//quickJumpMenu();
							}
						);
					});
				} else {
					//quickJumpMenu();
				}
			});
			
	<?php } // isset($params['selectedbottomtab']) && $params['selectedbottomtab'] == 'my' ?>
        $(document).ready(function() {
			$(document).on('click', '.discuss', function(e) {
				discuss(e.target);
				return false;
			});

			$(window).on('focus', function() {
				if (window.flagPollActive) {//defined in Layout.php
					setTimeout(checkToasterMessages, 250);
				}
			});

			$(window).on('blur', function() {
				cancelToaster();
			});

			// First-time try
			setTimeout(checkToasterMessages, 250);

			$('.auto-complete').each(function(index, elem) { addAutoComplete(elem); });
			
			$(document).on('click', '.sound-toggle', function(e) {
				submitSystemSoundSetting(this);	
				return false;
			});

			$(document).on('click', '.toggle-table', function(e) {
				var t = $(this).parent().nextAll('table.collapsible').first();
				if (t) {
					$(t).fadeToggle();
				}
			});
			
        });
	<?php } // Session::getSession()->isLoggedIn() ?>
	</script>

<script>
	$(document).ready(function(){
	 	$("#notificationssummary").jcfbtooltip({position:'bottom', 'width':'350px' ,method: getPastNotifications});
		$("#quickjumpmenupopup").jcfbtooltip({position:'bottom', 'width': '180px'});
		$("#searchmenuicon").jcfbtooltip({position:'bottom', 'width': '250px'});

		$( "#notificationsTemplate" ).template( "notificationtemplate" );
		$( "#nonotificationsTemplate" ).template( "nonotificationtemplate" );
		$( "#notificationsAreaTemplate" ).template( "tooltiptemplate" );
		$( "#quickJumpMenuTemplate" ).template( "jumpmenutemplate" );
		$( "#searchMenuTemplate" ).template( "searchmenutemplate" );

		var data = {};
		$.tmpl( "tooltiptemplate", data ).appendTo( $('#jcapp-notificationssummary') );
		$.tmpl( "jumpmenutemplate", data ).appendTo( $('#jcapp-quickjumpmenupopup') );
		$.tmpl( "searchmenutemplate", data ).appendTo( $('#jcapp-searchmenuicon') );
		

		$(document).on('click', '.sound-toggle', function(e) {
			submitSystemSoundSetting(this);	
			return false;
		});

		$(document).on('click', '.my-message-wall"', function(e) {
			window.location = '<?php echo GFUrl::getUrl()->baseURL('', 'my', 'messagewall', array()); ?>';
			return false;
		});

		$(':not(#jcapp-notificationssummary)').click(function(ev) {
			var str_class = '';
			if ($(this).attr("class")) {
				str_class = $(this).attr("class");
			}

			if ($(this).parents('#jcapp-notificationssummary').length == 0 && str_class.indexOf("notifications") == -1 && str_class.indexOf('sound-toggle') == -1) {
		    $('#jcapp-notificationssummary').hide();
		    $('#jcapp-notificationssummary').attr('visibility-status', 'hidden');
			}

			if ($(this).parents('#jcapp-notificationssummary').length > 0) {
				ev.stopPropagation();
				if (str_class.indexOf('sound-toggle') != -1) {
					submitSystemSoundSetting(this);
				}
			}
		});
	
	
		$(':not(#jcapp-quickjumpmenupopup)').click(function(ev) {
			var str_class = '';
			if ($(this).attr("class")) {
				str_class = $(this).attr("class");
			}

			if ($(this).parents('#jcapp-notificationssummary').length == 0 && str_class.indexOf("quickjumpmenuicon") == -1) {
		    $('#jcapp-quickjumpmenupopup').hide();
		    $('#jcapp-quickjumpmenupopup').attr('visibility-status', 'hidden');
			}

			if ($(this).parents('#jcapp-notificationssummary').length > 0) {
				ev.stopPropagation();
			}

		});


		$(':not(#jcapp-searchmenuicon)').click(function(ev) {
			var str_class = '';
			if ($(this).attr("class")) {
				str_class = $(this).attr("class");
			}

			if ($(this).parents('#jcapp-searchmenuicon').length == 0 && $(this).parents('.tooltip-content').length == 0 && str_class.indexOf("SearchByIDMenu") == -1) {
		    $('#jcapp-searchmenuicon').hide();
		    $('#jcapp-searchmenuicon').attr('visibility-status', 'hidden');
			}
			
			if ($(this).parents('#jcapp-searchmenuicon').length > 0) {
				ev.stopPropagation();
			}

		});
	
		
	});  
</script>

	
<?php

echo $this->topTabs($params);
$src_qj = $this->getImgUrl("blue/quickjump_off.gif");
$src_qj_mo = $this->getImgUrl("blue/quickjump_on.gif");
$src_sbyid = $this->getImgUrl("blue/searchbyid_off.gif");
$src_sbyid_mo = $this->getImgUrl("blue/searchbyid_on.gif");
$src_help = $this->getImgUrl("blue/help_off.gif");
$src_help_mo = $this->getImgUrl("blue/help_on.gif");

//quick jump menu
if (Session::getSession()->isLoggedIn()) {
?>
	<img class="quickjumpmenuicon" id="quickjumpmenupopup" onclick="$('#jcapp-quickjumpmenupopup').toggle();" title="QuickJump menu" alt="" class="quickJumpMenu" id="quickJumpIcon" src="<?php echo $this->getImgRoot() . '/blue/quickjump_off.gif' ?>" style="float:left;padding-right:10px; position:relative; top:0px; cursor: pointer;" onmouseover="this.src='<?php echo $src_qj_mo ?>';" onmouseout="this.src='<?php echo $src_qj ?>';" />
<?php
}

?>

<div id="quickjumpmenuarea" style="display: none;">
</div>


<script id="quickJumpMenuTemplate" type="text/x-jquery-tmpl">

	<div class="tooltip-title">
		<?php echo $language->getText('QuickJumpMenu.Title') ?>
	</div>
	
	<div class="tooltip-settings">
	</div>

	<div class="tooltip-content">
		<?php echo Layout::getQuickJump(true); ?>
	</div>

</script>


<script id="searchMenuTemplate" type="text/x-jquery-tmpl">

	<div class="tooltip-title">
		<?php echo $language->getText('SearchByIdMenu.Title') ?>
	</div>
	
	<div class="tooltip-settings">
	</div>

	<div class="tooltip-content">
			<form id="searchbyid" name="searchbyid" class="SearchByIDMenu" action=<?php	echo "\"" . GFUrl::getUrl()->baseURL('SearchById', '', 'search') . "\""; ?> method="POST">
			<table class="SearchByIDMenu" summary="" style="width: 100%">
				<tr>
					<td class="SearchByIDMenu">
						<select name="searchtype" class="SearchByIDMenu">
							<?php
								$res = ActionManager::notify('SEARCH_BY_ID_LIST');
								foreach ($res as $r) {
									$t = $r->getResult();
									foreach ($t as $key => $value)
									{
										if ($key == "trackeritem") // dirty hack to get the tracker item option selected by default
											echo "<option value=\"$key\" selected>$value</option>";
										else
											echo "<option value=\"$key\">$value</option>";
									}
								}
							?>
						</select>
					</td>
					<td class="SearchByIDMenu">
						<strong>Item Id:&nbsp;</strong><input type="text" size="4" name="searchid" id="quicksearchid" value="" />
					</td>
				</tr>
				<tr style="text-align: center;">
					<td colspan="2">
						<?php echo HTMLWidget::button("submit",$language->getText('Common.Search'),"searchbyidsubmit","searchbyidsubmit","")?>
					</td>
				</tr>
			</table>
			</form>
	</div>

</script>

<?php

//search by id menu
echo '<img title="Search by ID" alt="Search by ID" class="SearchByIDMenu" id="searchmenuicon" src="' . $src_sbyid . '" style="float:left; position:relative; top:0px;" onmouseover="this.src=\'' . $src_sbyid_mo . '\';" onmouseout="this.src=\'' . $src_sbyid . '\';" onclick="$(\'#jcapp-searchmenuicon\').toggle(); $(\'#quicksearchid\').focus(); window.scrollTo(0, 0);" />';

//Get user preference
	if ($session->isLoggedIn()) {
		$user = $session->getUser();
		$sound_setting = 'Y';
		$sound_icon = 'sound_on_white_small.png';
		if (is_object($user)) {
			$sound_preference = $user->getPreference('system-sound-setting');
			if ($sound_preference != 'Y') {
				$sound_setting = 'N';
				$sound_icon = 'sound_off_white_small.png';
			}
		}

		$notifications_off = $this->getImgUrl("notifications_off.png");
		$notifications_on = $this->getImgUrl("notifications_on.png");
?>
	 &nbsp;
	 <img class="notifications" id="notificationssummary" jccontent="notificationsarea" onclick="$('#jcapp-notificationssummary').toggle();" src="<?php echo $this->getImgRoot() . '/notifications_off.png' ?>" onMouseOver="tooltip('Show past notifications'); this.src='<?php echo $notifications_on; ?>';" onmouseout="tooltipexit(); this.src='<?php echo $notifications_off; ?>'" style="position:relative; top:0px;" /> 	
<?php
	//contextual help menu
	echo "<a href=\"http://gforgegroup.com/es/help.php?section=".$this->getHelpSection()."\" target=\"_blank\" style='top:0px;'><img title='Help' alt='Help' class='HelpMenu' id='helpIcon' src='$src_help' style='position:relative; top:0px;' onmouseover='this.src=\"$src_help_mo\";' onmouseout='this.src=\"$src_help\";'/></a>";
?>
<div id="notificationsarea" style="display: none;">
</div>

<script id="notificationsAreaTemplate" type="text/x-jquery-tmpl">

	<div class="tooltip-title">
		<table width="100%">
			<tr>
				<td width="50%">
					<?php echo $language->getText('Notifications.Title') ?>
				</td>
				<td align="right" width="50%">
						<img class="sound-toggle" src="<?php echo $this->getImgRoot() . '/chat/' . $sound_icon ?>" system-sound-setting="<?php echo $sound_setting; ?>" onMouseOver="tooltip('Toogle notification sound on/off')" onmouseout="tooltipexit()" />
				</td>
			</tr>
		</table>
	</div>
	
	<div class="tooltip-settings">
	</div>
	<div class="tooltip-content">
		<ul class="notificationlist">
		</ul>
	</div>
	<div id="notificationsseemore" class="notificationsseemore">
		<table style="width: 100%; padding: 2px; margin: 0px;">
			<tr>
				<td align="left" width="50%">
					<span id="notifications-seemore">
						<a href="javascript:;" onclick="getPastNotifications(false);">
							<?php echo $language->getText('Notifications.SeeMore') ?>
						</a>
					</span>
				</td>
				<td align="right" width="50%">
					<span id="notifications-seeall">
						<a href="javascript:;" onclick="window.location = '<?php echo GFUrl::getUrl()->baseURL('', 'my', 'messagewall', array()); ?>';">
							<?php echo $language->getText('Notifications.SeeAll') ?>
						</a>
					</span>
				</td>
			</tr>
		</table>
		&nbsp;
	</div>

</script>

<script id="notificationsTemplate" type="text/x-jquery-tmpl">
	<li>
		<table>
			<tr style="border-bottom: solid 1px black;">
				<td style="margin-right: 4px; padding: 2px" valign="top">
					<img style="width: 35px;" src="${avatar}" />
				</td>
				<td valign="top">{{html body}}<br/>${post_date}
				</td>
			</tr>
		</table>
		<hr class="notificationlistdivider"></hr>
	</li>
</script>

<script id="nonotificationsTemplate" type="text/x-jquery-tmpl">
	<li>
		<br />
		<span style="text-align: center;"><h3><?php echo $language->getText('Notifications.NoNotifications') ?></h3></span>
	</li>
</script>


<?php
	} else {
		//contextual help menu
		echo "<a href=\"http://gforgegroup.com/es/help.php?section=".$this->getHelpSection()."\" target=\"_blank\" style='float:left; position:relative; top:0px;'><img title='Help' alt='Help' class='HelpMenu' id='helpIcon' src='$src_help' style='float:left; position:relative; top:0px;' onmouseover='this.src=\"$src_help_mo\";' onmouseout='this.src=\"$src_help\";'/></a>";	
	}
?>


		<div id="login" nowrap="nowrap"><?php
			if ($session->isLoggedIn()) {
				echo $language->getText('Common.Loggedin') .': '. $User->getUnixName() .' | <a href="'. GFUrl::getUrl()->baseURL('Logout','','account') .'">'. $language->getText('Common.Logout') .'</a>';
			} else {
				$redirect = $_SERVER['REQUEST_URI'];
				// Small hack: if we're showing the user registration page, login shouldn't redirect here
				$noRedirectActions = array('UserAdd', 'PostUserRegistration', 'PostUserRegistrationTFA');
				foreach ($noRedirectActions as $noRedirectAction) {
					if (strpos($redirect, $noRedirectAction) !== false) {
						$redirect = '';
						break;
					}
				}

				$link = '<a href="'. GFUrl::getUrl()->baseURL('Login','','account',array('redirect' => $redirect)).'">'. $language->getText('Common.Login').'</a>'; 
				if( !GFConf::get('system.usesLdap')  || GFConf::get('ldap.dbLoginPrefered')){
					$link .= ' | <a href="'.GFUrl::getUrl()->baseURL('UserAdd','','account').'">'. $language->getText('Common.NewAccount').'</a>';
				}
				echo $link;
			}
			?>
		</div>
		
		<div class="clear"></div>		
</div>
<div id="container">
<?php 
//The following code is also used further up to select between the default body class and 'bodynoleft'
//If the criteria to choose between cases changes, the other code needs to be modified too.
if (array_key_exists('project', $params) || array_key_exists('user', $params)) {

	?>
	<div id="left">
		<?php
		echo $this->secondTabs($params);
		?>
		<div class="clear"></div>
	</div>
	<div id="right">
	<?php
} else {
	?>
	<div id="rightnoleft">
	<?php
}

?>
		<div class="contentNav">
			<p id="crumbs"><?php echo $this->breadCrumbs($params['title']); ?></p>
			<div class="clear"></div>
		</div>
		<div class="main">
			<?php if (array_key_exists('project', $params)) { ?>
			<h1 class="project-title"><?php echo $params['project']->getProjectName(); ?></h1>
        <?php } ?>
<?php
if (isset($params['feedback']) && !empty($params['feedback'])) {
    if (isset($params['keep_feedback_tags']) && $params['keep_feedback_tags']) {
      $fb = $params['feedback'];
    } else {
      $fb = strip_tags($params['feedback'], '<br><br/><br />');
    }
	$plugin = GFUrl::getUrl()->getPlugin();
    if (is_object($plugin) && $plugin->getName() == TrackerPlugin::SECTION && preg_match('/\[#\d*[0-9]\]/', $fb, $itemExpMatch) == 1){
        preg_match('/\d*[0-9]/', $fb, $itemIdMatch);
        $linkUrl = GFUrl::getUrl()->currentBaseURL('TrackerItemEdit', array('tracker_item_id'=>$itemIdMatch[0]));
        $link = "<a href='$linkUrl' title='Edit this tracker item'>".$itemExpMatch[0]."</a>";
        $fb = preg_replace('/\[#\d*[0-9]\]/', $link, $fb);
    }
    echo '<span class="feedback">'. $fb . '</span><br />';
}
	}

	function footer($params=array()) {
		if (Session::getSession()->isSiteAdmin()) {
			// Show the GForge version only to the site administrators
			$version = 'v'.SystemUtils::getGForgeVersion();
		} else {
			$version = '';
		}

	?>
	<center>
		<br /><br /><a href="http://gforgegroup.com/"><img src="/themes/<?php echo $this->getName(); ?>/images/gforge-as-logo-large.png" height="43" width="130" title="Powered By GForge&reg; Collaborative Development Environment <?php echo $version ?>" border="0" /></a><br /><br />
	</center>
		</div>
		<div class="clear"></div>
	</div>
<?php
	$this->footerEnd($params);

	}


	public function getVersionString() {
		if (Session::getSession()->isSiteAdmin()) {
			// Show the GForge version only to the site administrators
			return 'v'.SystemUtils::getGForgeVersion();
		}
		return '';
	}

	public function getGFASLogoSrc() {
		$name = $this->getName();
		return "/themes/$name/images/gforge-as-logo-large.png";
	}

	public function getGFASLogo2() {
		$name = $this->getName();
		return "/themes/$name/images/logo.png";
	}

	public function getGFASLogoGrey() {
		$name = $this->getName();
		return "/themes/$name/images/logo_grey.gif";
	}

	public function getPoweredByLogo() {
		$name = $this->getName();
		return "/themes/$name/images/pow-gforge.png";
	}

	function renderLocalNavElements($params) {
		$arr = $this->getTemplateNavElements($params);
		if (count($arr) == 0) {
			return '';
		}
		
		$nav = '<ul>';
		$first_li=true;
		foreach ($arr as $res) {
		/*	$nav .= '
		<	<ul>
		<!--	<li><a class="group" href="#">'.$res['title'].'</a></li> -->'; */
			$expandable='';
			$expandable_counter=0;
			
			foreach ($res['elements'] as $el) {
				$liclass='';
				if(isset($el['expandables']) && count($el['expandables'])>0) {
					$expandable = 'class="menuitem expandable"';
				}
				else {
					if($expandable == '' && $first_li) {
						$liclass='class="first_li"';
						$first_li=false;
					}
					$expandable='';
				}
				
				$nav .= '
				<li '.$liclass.'><a '.$expandable.' href="'.$el['link'].'"';
				if (isset($el['target']) && !empty($el['target'])) $nav .= ' target="'.$el['target'].'"';
				$nav .= '>'.$el['description'].'</a></li>';
				
				if(isset($el['expandables'])) {
					if($el['expanded']) {
						$nav = "<script>function expandableExpandItem() {ddaccordion.expandone('expandable',$expandable_counter);}</script>$nav";
					}
					$nav.= "\n<div class='submenu'><ul>";
					$ele_count = count ($el['expandables']);
					for($elec=0;$elec<$ele_count;$elec++) {
						$elexp = $el['expandables'][$elec];
						if($elec==$ele_count-1) {
							$ele_class='class="finalitem"';
						}
						else $ele_class='';
						
						$nav .= '
						<li><a '. $ele_class .' href="'.$elexp['link'].'"';
						if (isset($elexp['target']) && !empty($elexp['target'])) $nav .= ' target="'.$elexp['target'].'"';
						$nav .= '>'.$elexp['description'].'</a></li>';
					}
					$nav.="</ul></div>\n";
					$expandable_counter++;
					
				}
				
				
		
			}
		/*	$nav .= '
			</ul>';*/
		}
		return $nav.'</ul>';
	}

	/**
	 * infoTableTop() - Top HTML box
	 *
	 * @param   string  Box title
	 * @param   bool	Whether to echo or return the results
	 * @param   string  The box background color
	 */
	function infoTableTop($title) {
		return '
		<!-- Box Top Start -->
<table width="100%" class="tabular" cellpadding="5" cellspacing="1" summary="">
                        <tr class="th">
                                <th nowrap="nowrap">'.$title.'</th>
			</tr>
			<tr class="d">
				<td>
		<!-- Box Top end -->
		';

	}

	/**
	 * infoTableMiddle() - Middle HTML box
	 *
	 * @param   string  Box title
	 * @param   string  The box background color
	 */
	function infoTableMiddle($title) {
		return '
		<!-- Box Middle Start -->
				</td>
			</tr>
			<tr class="th">
				<th nowrap="nowrap">'.$title.'</th>
			</tr>
			<tr class="d">
				<td>

		<!-- Box Middle end -->
		';
	}

	/**
	 * infoTableBottom() - Bottom HTML box
	 *
	 * @param   bool	Whether to echo or return the results
	 */
	function infoTableBottom() {
		return '
		<!-- Box Bottom Start -->
				</td>
			</tr>
		</table>
		<!-- Box Bottom End -->';
	}

	function getTableRowClass($i) {
		if ($i % 2 == 0) {
			return 'l';
		} else {
			return 'd';
		}
	}

	function tableTop ($title_arr,$links_arr=false,$mod='', $tclass='tabular', $row_id="", $enclose_paragraph=true, $widgets_left=array(), $widgets_right=array()) {
		$this->tableColCount=count($title_arr);
		if ($row_id != "") {
			$str_row_id = 'id="'. $row_id .'"';
		} else {
			$str_row_id = "";
		}
		if ($tclass == 'thierarchical') {
			$str_padding_spacing = 'cellpadding="0" cellspacing="0"';
		} else {
			$str_padding_spacing = 'cellpadding="5" cellspacing="1"';
		}
		$return = '';
		if ($enclose_paragraph) {
			$return = '<p>';
		}
		$return .= '
			<table width="100%" class="'.$tclass.'" summary="" ' . $str_padding_spacing . ' '.$mod.'>';
		
		
		if (sizeof($widgets_left) > 0 || sizeof($widgets_right) > 0) {
			$return .= '<tr ' . $str_row_id. ' style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0"><tr><td class="header" colspan="'.sizeof($title_arr).'">';
			$return .= '<table width="100%"><tr>';
			
			$return .= '<td style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0" class="tFooter" valign="top" colspan="'.$this->tableColCount.'" align="left">';
			$return .= '<div class="buttonLinkLeft">';
			foreach ($widgets_left as $widget) {
				$return .= $widget;
			}			
			$return .= '</div></td>'; 
				
			$return .= '<td style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0" class="tFooter" valign="top" colspan="'.$this->tableColCount.'" align="right">';
			$return .= '<div class="buttonLink">';
			foreach ($widgets_right as $widget) {
				$return .= $widget;
			}			
			$return .= '</div></td>';
			
			$return .= '</tr></table>';

			//$return = preg_replace('/ \\| $/', '', $return);
			$return .= '</td></tr>';
		}
		
		
		$return .= '<tr class="th" ' . $str_row_id. ' >';
		
		$count=count($title_arr);
		if ($links_arr) {
			for ($i=0; $i<$count; $i++) {
				$return .= '
				<th nowrap="nowrap"><a href="'.$links_arr[$i].'">'.$title_arr[$i].'</a></th>';
			}
		} else {
			for ($i=0; $i<$count; $i++) {
				$return .= '
				<th nowrap="nowrap">'.$title_arr[$i].'</th>';
			}
		}
		return $return.'</tr>';
	}
	
	/**
	 * Builds a row that spans the entire table
	 */
	function tableFullRow($text, $style="") {
		$class = $this->getTableRowClass($this->tableRowCounter++);
		if ($style != "") {
			$style = 'style="'.$style.'"';
		}
		$return = '
			<tr class="'.$class.'">';
		$return .= '
				<td colspan="'.$this->tableColCount.'"'.$style.'>'.$text.'</td>';
		$return .= '
			</tr>';
		return $return;
	}
	
	/**
	 * Display a row on the top of the table with buttons.
	 * @param	array	Button array
	 */
	public function tableTopButtons($buttons) {
		$return = '';
		$class = $this->getTableRowClass(0);
		if (count($buttons) == 0) return;
		
		$return .= '<table width="100%" summary="" cellpadding="0" cellspacing="0">';
		$return .= '<tr style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0">';
		$return .= '<td style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0" valign="top" align="right">';
		$return .= '<div class="buttonLink">';
		
		foreach ($buttons as $href => $text) {
			$text = trim($text);
			$return .= HTMLWidget::button("button", $text , "", "", "window.location = '".$href."'", true, "button");
		}
		
		$return .= '</div>';
		$return .= '</td></tr></table>';
		
		return $return;
	}



	function tableBottom($button=array(), $button_enabled=array(), $row_id="", $dialog=false, $enclose_paragraph=true, $left = false, $button_is_link=array()) {
		$return = '';
		$class = $this->getTableRowClass($this->tableRowCounter++);

		if ($row_id != "") {
			$str_row_id = 'id="'. $row_id .'"';
		} else {
			$str_row_id = "";
		}
		if (count($button) < 1) {
			$return .= '<tr ' . $str_row_id. ' style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0"><td style="margin-top:0; margin-bottom:0; padding-top:0; padding-bottom:0" class="tFooter" valign="top" colspan="'.$this->tableColCount.'" align="right">&nbsp;</td></tr>';
		} else {
			$return .= '<tr ' . $str_row_id. ' >';
			$return .= '<td class="footer" colspan="'.$this->tableColCount.'" >';

			if ($left) {
				$return .= '<div class="buttonLinkLeft">';
			} else {
				$return .= '<div class="buttonLink">';
			}

			$i = 0;
			foreach ($button as $href => $text) {
				$text = trim($text);
				// Small hack that fixes an inconsistence (some buttons have the link inside the text)
				if (strpos($text, '<a ') === 0) {
					$data = StringUtils::extractDataFromLink($text);
					$href = $data['href'];
					$text = $data['text'];
				}

				if (isset($button_enabled[$i])) {
					$enabled = $button_enabled[$i];
				} else {
					$enabled = true;
				}

				if ($dialog) {
					$return .= HTMLWidget::button("button", $text , "", "", $href, $enabled, "button", "", true);
					error_log($return);
				} else {
					if (!isset($button_is_link[$i]) || (isset($button_is_link[$i]) && $button_is_link[$i])) {
						$return .= HTMLWidget::button("button", $text , "", "", "window.location = '" . $href . "'", $enabled, "button");
					} else {
						$return .= HTMLWidget::button("button", $text , "", "", $href, $enabled, "button");
					}
				}

				/*
				if (isset($button_enabled[$i])) {
						$button_class = 'button';
						//$return .= '<span class="button"><a href="'. $href.'">'.$text.'</a></span>';
						$return .= '<a class="button" href="'. $href.'"><span>'.$text.'</span></a>'; //For styled buttons
					} else {
						$button_class = 'disabled_button';
						//$return .= '<span class="disabled_button">'.$text.'</span>';
						$return .= '<del class="button"><span>'.$text.'</span></del>'; //For styled buttons
					}
				} else {
					//$return .= '<span class="button"><a href="'. $href.'">'.$text.'</a></span>';
					$return .= '<a  class="button" href="'. $href.'"><span>'.$text.'</span></a>';
					$button_class = 'button';
				}	
				*/
				$i++;
			}
			$return = preg_replace('/ \\| $/', '', $return);
			$return .= '</div>';
			$return .= '</td></tr>';
		}
		$return .= '</table>';
		if ($enclose_paragraph) {
			$return .= '</p>';
		}

		return $return;
	}
	
	/**
	 * tableRow build a <tr><td> set for this array
	 * @param	array	
	 */
	function tableRow($array,$array2=array(),$suppress_highlight=true,$trMod='',$additionalClasses='', $special_attributes='') {
		$class = $this->getTableRowClass($this->tableRowCounter++);

		if ($suppress_highlight) {
			$highlight='';
		} else {
			$highlight = ' onmouseover="this.className=\'over\'" onmouseout="this.className=\''.$class.'\'"';
		}
		$return = '
			<tr class="'.$class.' '.$additionalClasses.'" '.$highlight.' '.$trMod.' '.$special_attributes.'>';
		for ($i=0; $i<count($array); $i++) {
			if (isset($array2[$i])) {
				$str=$array2[$i];
			} else {
				$str='';
			}
			//$return .= '<td '.$str.' valign="top">'.$array[$i].'</td>';
			$return .= '<td '.$str.' valign="middle">'.$array[$i].'</td>';
		}
		$return .= '
			</tr>';
		return $return;
	}

	public function getName() {
		return 'gforge5';
	}

	/**
	* @param array $tabs
	* @param $selectedTab
	* @param $nested
	* @param $params
	* @return string
	*/
	protected function renderTabs($tabs, $selectedTab, $nested, $params) {

		$count = count($tabs);
		$return = '';

		//top row of tabs
		if (!$nested) {
			//hack to select class="selected" on the outer UL
			if ($tabs[0]['id']==$selectedTab) {
				$logoclass=' class="selected"';
			} else {
				$logoclass='';
			}
			if ($tabs[$count-1]['id']==$selectedTab) {
				$ulclass=' class="selected"';
			} else {
				$ulclass='';
			}
			$return .= '
			<h1 id="logo"'.$logoclass.'><a href="/">MyGforge Home</a></h1>
			<ul id="mainNav"'.$ulclass.'>';
			$return .= '<li class="start"></li>';
			for ($i=0; $i < $count; $i++) {
				$tab = $tabs[$i];
				$issel = ($selectedTab && $tab['id'] == $selectedTab);
				if ($i==0 && !$issel) {
					$liclass='';
				} elseif ($i==$count-1 && !$issel) {
					$liclass=' class="end"';
				} elseif ($issel) {
					$liclass=' class="selected"';
				} else {
					$liclass='';
				}
				$return .= '
				<li'.$liclass.'><a '.(($issel) ? 'class="selected"' : '').' href="'.$tab['action'].'">'.$tab['text'].'</a></li>';
				if ($issel && $i!=$count-1) {
					$return .= '<li class="selectedBar"><img src="/themes/'.$this->getName().'/images/clear.png" width="1" height="1" alt="clear" /></li>';
				}
			}
			$return .= '</ul>';
		//side tabs, like for projects or user navigation
		} else {
			if (isset($params['project'])) {
				$project = $params['project'];
                $lang = Session::getSession()->getLanguage();
				$local = $lang->getText('Project.Menu');
				$project_chat = HTMLWidget::projectChat($project);
				$return .= "\n<h1 class='navLabel'>$local $project_chat</h1>\n<div class='expandableMenu' >";
			} elseif ( isset($params['user']) ) {
				$local= $params['user']->getUnixName();
				$return .= "\n<h1 class='navLabel'>$local</h1>\n<div class='expandableMenu' >";
			} else {
				$local= '&nbsp;';
				$return .= "\n<h1 class='navLabel'>$local</h1>\n<div class='expandableMenu' >";
			}

			for ($i=0; $i < $count; $i++) {
				$tab = $tabs[$i];
				
				if (!isset($tab['id'])) {
					// Empty tab, for some reason
					continue;
				}
				
				$issel = ($selectedTab && $tab['id'] == $selectedTab);
				//$return .= '<li><a '.(($issel) ? 'class="selected"' : '').' href="'.$tab['action'].'">'.$tab['text'].'</a>';
				//$expandable = '';
				if ($issel) {
					$localNavElements = $this->renderLocalNavElements($params);
				}

				if(isset($tab['item_count'])){
					$item_count = $tab['item_count'];
				}
				
				$return .= '<a '.($issel ? 'class="menuitem selected"' : 'class="menuitem regular"'). (($issel && $localNavElements!='') ? ' style="margin-bottom:0px;" ':' ') . ' href="'.$tab['action'].'">'.$tab['text'].((isset($tab['item_count']) && $tab['item_count'] > -1) ? ' ('.$item_count.')': '')."</a>\n";
				
				if(isset($item_count)){
					unset($item_count);
				}


				if ($issel) {
					$return .= $localNavElements;
				}
				//$return .= '</li>';
			}
			//$return .= '</ul>';
			$return .= '<h1 class="navLabel_bottom">&nbsp;</h1></div>';
		}
		return $return;
	}


	public function createGraphicDropDown($id, $title, $arr_options, $var_name) {     
		$str_result = '
		<div id="'.$id.'" class="ddsmoothmenu">
			<ul>
				<li><a href="#">'.$title.'</a>
    			<ul>';

		foreach($arr_options as $opkey => $arr_option) {
			$str_result .= '<li><a href="'.$arr_option['action'].'">'.$arr_option['title'].'</a></li>';
		}
			
		$str_result .= '
				</ul>
			</li>
		</ul>
		</div>';
		
		return $str_result;
	}


	public function popupHeader($params) {
		echo $this->headerStart($params);
		echo '<body class="popup">';
	}


	public function popupFooter() {
		$Lang = Session::getSession()->getLanguage();

		ob_start();
		require_once('templates/PopupFooter-tpl.php');
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

}


	function popupHeader($theme, $title) {
		ob_start();
		require_once('templates/PopupHeader-tpl.php');
		$html = ob_get_contents();
		ob_end_clean();

		return $html;
	}


	function popupFooter() {
	    $Lang = Session::getSession()->getLanguage();

		ob_start();
		require_once('templates/PopupFooter-tpl.php');
		$html = ob_get_contents();
		ob_end_clean();
	    return $html;
	}


?>
