<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing User
//
require_once('core/UserPeer.php');
require_once('core/User.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('lib/timezones.php');
require_once('lib/html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/MyTemplate.php');
$theme = new MyTemplate();

//must be logged in
if (!$session->isLoggedIn()) {
      throw new NotLoggedInException();
}

$User = $session->getUser();
$obj = $User;

$params = array(
		'user' => $User,
		'selectedbottomtab' => 'myaccount',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('User.EditPageTitle')
		);

$unix_name = ( (isset($_POST) && isset($_POST['unix_name'])) ? htmlspecialchars($_POST['unix_name']) : $obj->getUnixName() );
$timezone = ( (isset($_POST) && isset($_POST['timezone'])) ? htmlspecialchars($_POST['timezone']) : $obj->getTimezone() );
$date_format = ( (isset($_POST) && isset($_POST['date_format'])) ? htmlspecialchars($_POST['date_format']) : $obj->getDateFormat() );
$address = ( (isset($_POST) && isset($_POST['address'])) ? htmlspecialchars($_POST['address']) : $obj->getAddress() );
$address2 = ( (isset($_POST) && isset($_POST['address2'])) ? htmlspecialchars($_POST['address2']) : $obj->getAddress2() );
$phone = ( (isset($_POST) && isset($_POST['phone'])) ? htmlspecialchars($_POST['phone']) : $obj->getPhone() );
$cell = ( (isset($_POST) && isset($_POST['cell'])) ? htmlspecialchars($_POST['cell']) : $obj->getCell() );
$fax = ( (isset($_POST) && isset($_POST['fax'])) ? htmlspecialchars($_POST['fax']) : $obj->getFax() );
$title = ( (isset($_POST) && isset($_POST['title'])) ? htmlspecialchars($_POST['title']) : $obj->getTitle() );
$firstname = ( (isset($_POST) && isset($_POST['firstname'])) ? htmlspecialchars($_POST['firstname']) : $obj->getFirstname() );
$lastname = ( (isset($_POST) && isset($_POST['lastname'])) ? htmlspecialchars($_POST['lastname']) : $obj->getLastname() );
$ccode = ( (isset($_POST) && isset($_POST['ccode'])) ? htmlspecialchars($_POST['ccode']) : $obj->getCcode() );
$language_id = ( (isset($_POST) && isset($_POST['language_id'])) ? htmlspecialchars($_POST['language_id']) : $obj->getLanguageId() );
$theme_id = ( (isset($_POST) && isset($_POST['theme_id'])) ? htmlspecialchars($_POST['theme_id']) : $obj->getThemeId() );
$email = ( (isset($_POST) && isset($_POST['email'])) ? htmlspecialchars($_POST['email']) : $obj->getEmail() );
$avatar_id = ( (isset($_POST) && isset($_POST['avatar_id'])) ? htmlspecialchars($_POST['avatar_id']) : $obj->getAvatarId() );

$avatar_url = $User->getAvatarUrl();
$avatar_type = $User->getAvatarType();

include ('forms/UserEdit-tpl.php');

?>
