<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing User
//
require_once('core/UserPeer.php');
require_once('core/User.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('html/SiteTemplate.php');
require_once('Validator.php');
require_once('StringUtils.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/MyTemplate.php');

$password_expired = isset($_REQUEST['password_expired']) ? validator::sanitizeBool($_REQUEST['password_expired']) : false;
$username = isset($_REQUEST['username']) ? Validator::sanitizeString($_REQUEST['username']) : '';
$redirect = isset($_REQUEST['redirect']) ? StringUtils::stripHtmlTags($_REQUEST['redirect']) : '';

//If not logged in and not in password expired context, then throw exception
if (!$session->isLoggedIn() && !($password_expired == true && $username != '')) {
	throw new NotLoggedInException();
}

if(GFConf::get('system.usesLdap') && !GFConf::get('ldap.dbLoginPrefered')){
	throw new PermissionDeniedException();
}

if ($password_expired) {
	//If in password expired context, get user from DB
	$c = new Criteria();
	$c->add(UserPeer::UNIX_NAME, $username);
	$User = UserPeer::doSelectOne($c);
	if (!is_object($User)) {
		throw new PermissionDeniedException();
	}
	$theme = new SiteTemplate();
} else {
	//If in session user password edit context, get user from session
	$User = $session->getUser();
	$theme = new MyTemplate();
}

$obj = $User;

//Build the appropiate theme params object based on context
if ($password_expired) {
	$params = array(
			'title' => Language::getSessText('Common.Login'),
			'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		);
} else {	
	$params = array(
			'user' => $User,
			'selectedbottomtab' => 'myaccount',
			'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
			'action' => isset($action) ? $action : '',
			'title' => $Lang->getText('User.EditPageTitle')
			);
}
include ('forms/UserPasswordEdit-tpl.php');
?>
