<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a UserUnix and saves it to the 
// database
//
require_once('core/UserUnix.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$User = $session->getUser();

$errors = array();
$language = Language::getSessLang();

//
// TODO Validate the values passed by $_POST. Store the errors in $error like
// $errors["field_name"] = error_description
//

if (count($errors) == 0) {
	$UserUnix->setUnixShellId( Validator::sanitizeInt($_POST['unix_shell_id']) );
	$UserUnix->setAuthorizedKeys( Validator::sanitizeString($_POST['authorized_keys']) );
	
	$UserUnix->save();
	$url = GFUrl::getUrl();
	GFUrl::redirect($url->currentBaseURL(''), array('feedback' => $language->getText('UserUnix.EditFeedback')));
} else {
	$feedback = implode('<br />', $errors);
	include('UserUnixEdit.php');
}

?>