<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
?>
<script type="text/javascript">

window.onload = function () {
	REDIPS.dialog.init();
}

function setDefaultAvatar() {
	document.getElementById('imgavatar').src = '<?php echo '/themes/'.$theme->getName().'/images/avatar_default.png'; ?>';
	document.getElementById('selected_avatar_3').checked = true;
	document.getElementById('avatar_id').value = 0;
}

</script>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('UserEditAction') ?>" method="POST" enctype="multipart/form-data">
	<table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('User.UnixNameName'); ?>: <?php echo $unix_name; ?></strong><br /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.TitleName'); ?></strong><br />
			<input type="text" name="title" value="<?php echo $title; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.FirstnameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="firstname" value="<?php echo $firstname; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.LastnameName'); ?></strong><span class="required">*</span><br />
			<input type="text" name="lastname" value="<?php echo $lastname; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.TimezoneName'); ?></strong><br />
			<?php echo HTMLWidget::selectBoxFromArrays($TZs,$TZs,'timezone',$timezone,false); ?></td>
		</tr>
		<input type="hidden" name="date_format" value="Y-M-D"/>
<!--		<tr>
			<td><strong><?php echo $Lang->getText('User.DateFormatName'); ?></strong><br />
			<input type="text" name="date_format" value="<?php echo $date_format; ?>" /></td>
		</tr> -->
		<tr>
			<td><strong><?php echo $Lang->getText('User.EmailName'); ?></strong><br />
			<?php  
				echo $email; 
				$email_link = '<a href="' . GFUrl::getUrl()->baseURL('UserEmailEdit','','my') . '">' . Language::getSessText('My.ChangeEmail') . '</a>';

				if(!GFConf::get('system.usesLdap') || GFConf::get('ldap.dbLoginPrefered')){
					echo '&nbsp;&nbsp;' . $email_link;				
				}
			?>
			</td>
		</tr>

		<?php if (GFConf::get('system.displayAvatar')) { ?>
		<tr>
			<td>
				<strong><?php echo Language::getSessText('User.Avatar'); ?>:</strong>
			</td>
		</tr>
		<tr>
			<td>
				<table>
					<tr>
						<td>
							<img id="imgavatar" style="max-height:50px;max-width:60px" src="<?php echo $avatar_url; ?>" alt="avatar" />
						</td>
						<td valign="top">
							<table>
								<tr>
									<td>
										<input type="radio" id="selected_avatar_1" name="selected_avatar" value="1"<?php if ($avatar_type == "c"): echo ' checked'; endif; ?> />
									</td>
									<td>
										<strong><?php echo Language::getSessText('User.AvatarUpload'); ?>:</strong><br />
										<input type="file" name="avatar" onclick="document.getElementById('selected_avatar_1').checked=true;"><br />
									</td>
								</tr>
								<tr>
									<td>
										<input type="radio" id="selected_avatar_3" name="selected_avatar" value="3" onclick="setDefaultAvatar();"<?php if ($avatar_type == "d"): echo ' checked'; endif; ?> />
									</td>
									<td>
										<strong>None (use default avatar)</strong><br />
									</td>
								</tr>							
							</table>
						</td>
					</tr>
				</table>
			</td>
		</tr>
		<?php } ?>
		<tr>
			<td><strong><?php echo $Lang->getText('User.AddressName'); ?></strong><br />
			<input type="text" name="address" value="<?php echo $address; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.Address2Name'); ?></strong><br />
			<input type="text" name="address2" value="<?php echo $address2; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.PhoneName'); ?></strong><br />
			<input type="text" name="phone" value="<?php echo $phone; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.CellName'); ?></strong>
			<?php /*if (GFConf::get('system.useTFA')) : ?>
				<span class="required">*</span>
				<br />
				<emph><?php echo $Lang->getText('User.CellDescription'); ?></emph>
			<?php endif;*/ ?>
			<br />
			<input type="text" name="cell" value="<?php echo $cell; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.FaxName'); ?></strong><br />
			<input type="text" name="fax" value="<?php echo $fax; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.CcodeName'); ?></strong><br />
			<?php
			$countries = CountryCodePeer::getOrderedCountryList();
			echo HTMLWidget::select('ccode',$countries,$ccode,HTMLWidget::OPTION_NONE,false);
			?></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.LanguageIdName'); ?></strong><br />
			<?php
			$languages = LanguagePeer::doSelect(new Criteria());
			echo HTMLWidget::select('language_id',$languages,$language_id,HTMLWidget::OPTION_NONE,false);
			?></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('User.ThemeIdName'); ?></strong><br />
			<?php
			$themes = ThemePeer::doSelect(new Criteria());
			echo HTMLWidget::select('theme_id',$themes,$theme_id,HTMLWidget::OPTION_NONE,false);
			?></td>
		</tr>
		<tr>
			<td align="center">
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->baseURL('','','my') . "'; ")?>
			</td>
		</tr>
	</table>
</form>
<?php
$theme->footer($params);
?>
