<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing Project
//
require_once('core/ProjectPeer.php');
require_once('core/Project.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('lib/html/HTMLWidget.php');
require_once('plugins/scm/lib/SCMRepositoryFactory.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$Project = ProjectPeer::retrieveByPk($_GET['id']);
if (!is_object($Project) || !$Project->userCanUpdate()) {
	throw new PermissionDeniedException();
}
if ($Project->getStatus()==Project::STATUS_PENDING) {
	throw new Exception( '<p><h3>Cannot Edit Pending Project - approve it first</h3></p>' );
}

$obj = $Project;
$params = array(
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Project.Edit')
		);
		
// Get the SCM configuration for this project (if any)
$repos = ScmRepositoryFactory::getRepository($Project);
if ($repos) {
	$ProjectScm = $repos->getScmConfiguration();
} else {
	$ProjectScm = null;
}

$project_name = ( (isset($_POST) && isset($_POST['project_name'])) ? htmlspecialchars($_POST['project_name']) : $obj->getProjectName() );
$unix_name = ( (isset($_POST) && isset($_POST['unix_name'])) ? htmlspecialchars($_POST['unix_name']) : $obj->getUnixName() );
$homepage_url = ( (isset($_POST) && isset($_POST['homepage_url'])) ? htmlspecialchars($_POST['homepage_url']) : $obj->getHomepageUrl() );
$is_public = ( (isset($_POST) && isset($_POST['is_public'])) ? htmlspecialchars($_POST['is_public']) : $obj->getIsPublic() );
$status = ( (isset($_POST) && isset($_POST['status'])) ? htmlspecialchars($_POST['status']) : $obj->getStatus() );
$description = ( (isset($_POST) && isset($_POST['description'])) ? htmlspecialchars($_POST['description']) : $obj->getDescription() );
$register_purpose = ( (isset($_POST) && isset($_POST['register_purpose'])) ? htmlspecialchars($_POST['register_purpose']) : $obj->getRegisterPurpose() );
//$register_license_other = ( (isset($_POST) && isset($_POST['register_license_other'])) ? htmlspecialchars($_POST['register_license_other']) : $obj->getRegisterLicenseOther() );
$create_date = ( (isset($_POST) && isset($_POST['create_date'])) ? htmlspecialchars($_POST['create_date']) : $obj->getCreateDate() );
$template_project_id = ( (isset($_POST) && isset($_POST['template_project_id'])) ? htmlspecialchars($_POST['template_project_id']) : $obj->getTemplateProjectId() );

include ('forms/ProjectEdit-tpl.php');

?>
