<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists ScmCommitFilter
//
require_once('plugins/scm/lib/ScmCommitFilterPeer.php');
require_once('plugins/scm/lib/ScmCommitFilter.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

//$Project = GFUrl::getUrl()->getProject();
//$ScmCommitFilter = $ScmCommitFilterPeer::retrieveByPk($_GET['id']);

$params = array(
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('ScmCommitFilter.BrowsePageTitle')
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->addJoin(ScmCommitFilterPeer::PLUGIN_ID, PluginPeer::PLUGIN_ID);
$crit->addAscendingOrderByColumn(PluginPeer::PLUGIN_NAME);
/** @var ScmCommitFilter[] $arr */
$arr = ScmCommitFilterPeer::doSelectJoinPlugin($crit);


$theader = array();

$theader[] = $Lang->getText('ScmCommitFilter.ScmCommitFilterIdName');
$theader[] = $Lang->getText('ScmCommitFilter.PluginIdName');
$theader[] = $Lang->getText('ScmCommitFilter.FilterTypeName');
$theader[] = $Lang->getText('ScmCommitFilter.FilterDescriptionName');
$theader[] = $Lang->getText('ScmCommitFilter.FilterStringName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('ScmCommitFilter.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getScmCommitFilterId();
		$trow[]=$item->getPlugin()->getPluginName();
		$trow[]= $item->getHRFilterType();
		$trow[]=$item->getFilterDescription();
		$trow[]=$item->getFilterString();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmCommitFilterEdit').'&amp;id='.$item->getScmCommitFilterId() .'">'. $Lang->getText('Edit') .'</a>';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmCommitFilterDelete').'&amp;id='.$item->getScmCommitFilterId() .'">'. $Lang->getText('Delete') .'</a>';

		echo $theme->tableRow($trow, array(), false);
	}
}

$buttons_array = array();
$buttons_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmCommitFilterAdd').'">'. $Lang->getText('ScmCommitFilter.AddNew') .'</a>';
$buttons_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('').'">'. $Lang->getText('Common.Back') .'</a>';
echo $theme->tableBottom($buttons_array,array(true, true));

$theme->footer($params);

?>