<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing ScmCommitFilter
//
require_once('plugins/scm/lib/ScmCommitFilterPeer.php');
require_once('plugins/scm/lib/ScmCommitFilter.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

//$Project = GFUrl::getUrl()->getProject();
$ScmCommitFilter = ScmCommitFilterPeer::retrieveByPk($_REQUEST['id']);
if (!is_object($ScmCommitFilter) || !$ScmCommitFilter->userCanUpdate()) {
	throw new PermissionDeniedException();
}
$obj = $ScmCommitFilter;

$params = array(
	//	'project' => $Project,
	//	'ScmTemplate' => $ScmTemplate,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('ScmCommitFilter.EditPageTitle')
		);

$filter_description = ( (isset($_POST) && isset($_POST['filter_description'])) ? htmlspecialchars($_POST['filter_description']) : $obj->getFilterDescription() );
$plugin_id = ( (isset($_POST) && isset($_POST['plugin_id'])) ? htmlspecialchars($_POST['plugin_id']) : $obj->getPluginId() );
$filter_string = ( (isset($_POST) && isset($_POST['filter_string'])) ? htmlspecialchars($_POST['filter_string']) : $obj->getFilterString() );
$filter_type = ( (isset($_POST) && isset($_POST['filter_string'])) ? Validator::sanitizeInt($_POST['filter_type']) : $obj->getFilterType() );

include ('forms/ScmCommitFilterEdit-tpl.php');

?>