<?php

// Allow POST only
if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

// db conn
$con = Propel::getConnection(TroveCategoryPeer::DATABASE_NAME);

// language
$Language = Session::getSession()->getLanguage();

$trove_id = Validator::sanitizeInt($_POST['id']);

$response = array();

if ($trove_id > 0) {
    $trove_cat = TroveCategoryPeer::retrieveByPk($trove_id);
    if ($trove_cat && is_object($trove_cat)) {
        $enabled = $trove_cat->toggleEnabled();
        if ($enabled !== NULL) {
            $response['id'] = $trove_id;
            $response['next_action'] = $enabled ? $Language->getText('TroveToggle.Disable') : $Language->getText('TroveToggle.Enable');
			$response['message'] = $Language->getSessText($enabled ? 'TroveToggle.EnableSuccess' : 'TroveToggle.DisableSuccess', array($trove_cat->getName()));
            $response['success'] = TRUE;
        } else {
            $response['success'] = FALSE;
            $response['error'] = $Language->getText('TroveToggle.Error');
        }
    } else {
        $response['success'] = FALSE;
        $response['error'] = $Language->getText('TroveToggle.Error');
    }
} else {
    $response['success'] = FALSE;
    $response['error'] = $Language->getText('TroveToggle.Error');
}

echo json_encode($response);