<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for $OBJECT deletion
//
require_once('core/UserPeer.php');
require_once('core/User.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

$theme->addBreadCrumb('<a href="'.GFUrl::getUrl()->currentBaseUrl('UsergroupBrowse').'">'.$Lang->getText('Usergroup.ManageGroups').'</a>');

$group_id = Validator::sanitizeInt($_GET['id']);

$Group = UserPeer::retrieveByPk($group_id);
if (!is_object($Group) || ($Group->getIsGroup() != true) || !$session->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

$params = array(
	//	'SiteTemplate' => $SiteTemplate,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Usergroup.DeletePageTitle')
		);

include('forms/UsergroupDelete-tpl.php');

?>
