<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/User.php');
require_once('core/UserPeer.php');
require_once('core/UsergroupUserPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();

$group_id = (isset($_GET['id'])) ? Validator::sanitizeInt($_GET['id']) : false;

if ($group_id) {
	$Group = UserPeer::retrieveByPk($group_id);
	if (!is_object($Group) || !Session::getSession()->isSiteAdmin()) {
		throw new PermissionDeniedException();
	}
	if ($Group->getIsGroup() != true) {
		throw new PermissionDeniedException();
	}
	
	$Group->setStatus(User::STATUS_ACTIVE);
	$Group->save();

	GFUrl::redirect($url->currentBaseURL('UsergroupBrowse'), array('feedback' => $Lang->getText('Usergroup.UndeleteFeedback')));
} else {
	GFUrl::redirect($url->currentBaseURL('UsergroupBrowse'), array('feedback' => $Lang->getText('Usergroup.MissingGroupId')));
}

?>
