<?php

/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/news/lib/NewsPeer.php');
require_once('lib/core/ProjectPeer.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$count=0;
foreach ($all_news as $news) {
	if($news->getProject()->isPublic()){ //Only news from public projects can be approved
		$contents = array();
		if ($news->getIsApproved()) {
			$checked1 = 'checked';
			$checked2 = '';
		} else {
			$checked1 = '';
			$checked2 = 'checked';
		}
		$aux = '<input type="radio" '.$checked1.' value="1" name="news['. $news->getPrimaryKey().']"/>' . $lang->getText('Common.Yes')."\n";
		$aux .= '<input type="radio" '.$checked2.' value="0" name="news['. $news->getPrimaryKey().']"/>' . $lang->getText('Common.No');
		$contents[0] = $aux;
		$project = ProjectPeer::retrieveByPk($news->getProjectId());
		if (is_object($project)) {
			$contents[1] = $project->getUnixName();
		} else {
			$contents[1] = '';
		}
		$contents[2] = '<strong>'.$news->getSummary().'</strong><br /><br />'.StringUtils::addHtmlLinks(nl2br($news->getDetails()));
		$count++;
		echo $template->tableRow($contents, array(), false);
	}
}
if ($count < 1) {
	echo $template->tableFullRow($lang->getText('News.NoneFound'));
}

echo $template->tableBottom();

echo '<br /><div align="right">';
echo HTMLWidget::button("submit", "Update", "submit");
echo HTMLWidget::button("button",$Lang->getText('Common.Back'),"cancel","","window.location = \'" . GFUrl::getUrl()->currentBaseUrl('') . "\';");
echo '</div>';
echo '</form>';

?>
