<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
if(!isset($_GET['id'])) {
        throw new PermissionDeniedException();
}

$Group = UserPeer::retrieveByPk(Validator::sanitizeInt($_GET['id']));
if (is_object($Group) && $Group->getIsGroup() != true) {
        throw new PermissionDeniedException();
}

// Retrieve the objects array
$arr = $Group->getUsergroupUsersRelatedByUsergroupid();


$theader = array();

$theader[] = $Lang->getText('Usergroup.MemberUserIdName');
$theader[] = $Lang->getText('UsergroupUser.MemberUserIdName');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
        echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('UsergroupUser.NoneFound').'</span>');
} else {
        foreach ($arr as $item) {
		$User = UserPeer::retrieveByPk($item->getMemberUserId());
                $trow = array();
                $trow[]=$Group->getFirstName();
                $trow[]=$User->getUserLink();
                $trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupUserDelete').'&amp;id='.$item->getUsergroupId() .'&amp;remove_id='.$item->getMemberUserId().'">'. $Lang->getText('Delete') .'</a>';

                echo $theme->tableRow($trow);
        }
}

//echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupUserAdd').'&amp;id='.$Group->getId() .'">'. $Lang->getText('UsergroupUser.AddNew') .'</a>'));
$buttons_array = array();
$buttons_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupUserAdd').'&amp;id='.$Group->getId() .'">'. $Lang->getText('UsergroupUser.AddNew') .'</a>';
$buttons_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupBrowse').'">'. $Lang->getText('Common.Back') .'</a>';
echo $theme->tableBottom($buttons_array, array(true, true));


if (GFConf::varExists('system.enableUdfEdit') 
      && (GFConf::get('system.enableUdfEdit') == 'groups' || GFConf::get('system.enableUdfEdit') == 'on')) {
  $udf1Name = GFConf::get('system.udf1Name', $Lang->getText("User.Udf1Name"));
  $udf2Name = GFConf::get('system.udf2Name', $Lang->getText("User.Udf2Name"));
  $udf3Name = GFConf::get('system.udf3Name', $Lang->getText("User.Udf3Name"));
  $udf4Name = GFConf::get('system.udf4Name', $Lang->getText("User.Udf4Name"));
  $udf5Name = GFConf::get('system.udf5Name', $Lang->getText("User.Udf5Name"));
  $udf6Name = GFConf::get('system.udf6Name', $Lang->getText("User.Udf6Name"));


?>
<p>
  <strong><?php echo $Lang->getText("Usergroup.EditUdf") ?></strong>
</p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('UsergroupUdfEditAction') ?>" method="POST">
  <input type="hidden" name="group_id" value="<?php echo $_REQUEST['id']; ?>" />
  <table border="0">
    <tr>
      <td><strong><?php echo $udf1Name ?></strong><br />
      <input type="text" name="udf1" value="<?php echo $udf1; ?>"/></td>
    </tr>
    <tr>
      <td><strong><?php echo $udf2Name ?></strong><br />
      <input type="text" name="udf2" value="<?php echo $udf2; ?>"/></td>
    </tr>
    <tr>
      <td><strong><?php echo $udf3Name ?></strong><br />
      <input type="text" name="udf3" value="<?php echo $udf3; ?>"/></td>
    </tr>
    <tr>
      <td><strong><?php echo $udf4Name ?></strong><br />
      <input type="text" name="udf4" value="<?php echo $udf4; ?>"/></td>
    </tr>
    <tr>
      <td><strong><?php echo $udf5Name ?></strong><br />
      <input type="text" name="udf5" value="<?php echo $udf5; ?>"/></td>
    </tr>
    <tr>
      <td><strong><?php echo $udf6Name ?></strong><br />
      <input type="text" name="udf6" value="<?php echo $udf6; ?>"/></td>
    </tr>
    <tr>
      <td>
        <?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submit","","")?>
      </td>
    </tr>
  </table>
</form>
<?php
}
$theme->footer($params);
?>
