<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/templates/SiteAdminTemplate.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/UserPeer.php');

$template = new SiteAdminTemplate();
$params = array(
		'title'	=> 'Project List');
$template->header($params);

$con = Propel::getConnection(UserPeer::DATABASE_NAME);

if (array_key_exists('sortorder',$_REQUEST)) {
	$sortorder = Validator::sanitizeString($_REQUEST['sortorder']);
} else {
	$sortorder = null;
}

if (array_key_exists('project_name_search',$_REQUEST)) {
	$project_name_search = Validator::sanitizeString($_REQUEST['project_name_search']);
} else {
	$project_name_search = '';
}

if (array_key_exists('status',$_REQUEST)) {
	$status = Validator::sanitizeString($_REQUEST['status']);
} else {
	$status = null;
}


if ($sortorder == null) {
	$sortorder = "project_name";
}
echo "<p>".Language::getSessText('SiteAdmin.ProjectList.ProjectFor').' ';
echo "<strong></strong></p>\n";
	
// TODO -> when license table is added to schema, fetch the data from the db an display it
$sql = "SELECT project.project_name,project.create_date,project.unix_name,project.project_id,"
	. "project.is_public,"
	//. "licenses.license_name,"
	. "project.status, "
	. "COUNT(user_project.project_id) AS members "
	. "FROM project LEFT JOIN user_project ON user_project.project_id=project.project_id "
	. "WHERE unix_name ILIKE ?"
//	. "WHERE group_category.category_id=".$form_catroot." AND "
	//. "licenses.license_id=project.license "
	. "GROUP BY project_name,create_date,unix_name,project.project_id,is_public,status "
	. "ORDER BY " . pg_escape_string($sortorder);
	
	$stmt = $con->prepareStatement($sql);
	$stmt->setString(1, "%$project_name_search%");
	$rs = $stmt->executeQuery(ResultSet::FETCHMODE_ASSOC);		


$headers = array(
	Language::getSessText('SiteAdmin.ProjectList.ProjectName'),
	Language::getSessText('Project.CreateDateName'),
	Language::getSessText('Project.UnixNameTitle'),
	Language::getSessText('SiteAdmin.Search.Status'),
	Language::getSessText('SiteAdmin.ProjectList.IsPublic'),
	Language::getSessText('SiteAdmin.ProjectList.Members')
);

$headerLinks = array(
	'?action=projectlist&sortorder=project_name',
	'?action=projectlist&sortorder=create_date',
	'?action=projectlist&sortorder=unix_name',
	'?action=projectlist&sortorder=status',
	'?action=projectlist&sortorder=is_public',
	'?action=projectlist&sortorder=members'
);

echo $template->tableTop($headers, $headerLinks);

$i = 0;
while ($rs->next()) {
	$time_display = date($rs->getDate('create_date'));
	$project_name = $rs->getString('project_name');
	echo '<tr '.$template->getTableRowStyle($i).'>';
	echo '<td><a href="'. GFUrl::getUrl()->currentBaseURL('projectedit',array('project_id'=>$rs->getInt('project_id'))). '">'.$project_name.'</a></td>';
	echo '<td>'.$time_display.'</td>';
	echo '<td>'.$rs->getString('unix_name').'</td>';
	echo '<td>'.Project::getStatusName($rs->getInt('status')).'</td>';
	echo '<td>'.$rs->getBoolean('is_public').'</td>';
	echo '<td>'.$rs->getInt('members').'</td>';
	echo '</tr>';
	$i++;
}

echo $template->tableBottom();

$template->footer();

?>