<?php

header('Access-Control-Allow-Origin: *', true);

/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('core/UserPreference.php');
require_once('plugins/forum/lib/ForumThreadPeer.php');
require_once('plugins/forum/lib/ForumPeer.php');

$session = Session::getSession();
$CHAT_ROOM_PREFIX = 'chat-room-';

$thread = null;

if (array_key_exists('thread_id', $_REQUEST)) {
	//error_log("ChatLeave, thread_id is in request, raw value is ".$_REQUEST['thread_id']);
    $thread_id = Validator::sanitizeInt($_REQUEST['thread_id']);
	if ($thread_id > 0) {
		$thread = ForumThreadPeer::retrieveByPk($thread_id);
	} else {
		//error_log("ChatLeave, thread_id is NOT > 0!");
	}
} else {
	//error_log("ChatLeave, thread_id is NOT in request!");
}

if (is_null($thread)) {
	//error_log("ChatLeave, no thread_id was provided, returning 404");
    header("HTTP/1.0 404 Not Found", true, '404');
    return;
}

ForumPeer::logChatEvent($thread, ForumPeer::CHAT_EVENT_USER_LEAVE, $session->getUser());

UserPreferencePeer::setUserPref(
	$session->getUser()->getUserId(),
	$CHAT_ROOM_PREFIX.$thread->getForumThreadId(),
	'N');

echo json_encode(array('result' => 'success'));
