<?php

header('Access-Control-Allow-Origin: *', true);

/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/forum/lib/ForumMessagePeer.php');

$session = Session::getSession();

if ($session == null || $session->getUser() == null) {
	header("HTTP/1.0 401 Authentication Required", true, '401');
	return;
}

$msg = null;

if (array_key_exists('message_id', $_REQUEST)) {
	//error_log("ChatLeave, thread_id is in request, raw value is ".$_REQUEST['thread_id']);
    $message_id = Validator::sanitizeInt($_REQUEST['message_id']);
	if ($message_id > 0) {
		$msg = ForumMessagePeer::retrieveByPk($message_id);
	} else {
		error_log("ChatMessageDelete, message_id is NOT > 0!");
	}
} else {
	error_log("ChatMessageDelete, message_id is NOT in request!");
}

if (is_null($msg)) {
	error_log("ChatMessageDelete, message_id $message_id not found in the database, returning 404");
    header("HTTP/1.0 404 Not Found", true, '404');
    return;
}

if (! $msg->userCanDelete()) {
	error_log("ChatMessageDelete, user is not authorized to delete this message, returning 403");
    header("HTTP/1.0 403 Not Allowed", true, '403');
    return;
}

$msg->delete();

echo json_encode(array('result' => 'success'));
