<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
//require_once('lib/core/UserProjectPeer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportTracker.php');
require_once('lib/core/MyReportTrackerPeer.php');

$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Lang = $session->getLanguage();
$template = new MyTemplate();
$user = Session::getSession()->getUser();

if(isset($_REQUEST['feedback'])) $feedback = StringUtils::stripHTMLTags($_REQUEST['feedback']);
if(isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
	// Fetch report data
	if($report_id != 0) {
		$report = MyReportPeer::retrieveByPK($report_id);
		if(!is_object($report)) {
			$is_new = true;
			$report_id = 0;
		}
		else {
			$is_new = false;
			if($report->getUserId() != $user->getUserId()) {
				$parms = array ('feedback'=>$Lang->getText('Report.NotOwner'));
				GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
				exit();
			}
		}
	}
	else {
		$is_new = true;
	}
}
else {
	$is_new = true;
	$report_id = 0;
}


if(!isset($_REQUEST['projects_selected']) || !is_array($_REQUEST['projects_selected']) || count($_REQUEST['projects_selected'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoProjectsSelected');
	include('ReportEditStep1.php');
	exit();
}

$params = array(
	'title' => $is_new ? Language::getSessText('Report.AddNew'):Language::getSessText('Report.Edit'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'myreports',
	'user' => $user
	);
$template->header($params);

echo '<p><div class="infobox">' . $Lang->getText('Report.Step2Description') . '</div></p><br>';

$params['theme'] = $template;

$projects_selected = array();
$trackers_arr = array();

// From the selected projects, select those that appear in all projects.

foreach($_REQUEST['projects_selected'] as $ps) {
	$ps = Validator::sanitizeInt($ps);
	$project = ProjectPeer::retrieveByPK($ps);
	if(is_object($project) && $project->userCanRead())
	{
		$projects_selected[$ps] = $project;
		
		$projectTrackers = $project->getTrackers();
		
		foreach($projectTrackers as $pt) {
			if ($pt->userCanRead()) {
				$trackers_arr[$pt->getTrackerName()] = $pt->getTrackerName();
			}
		}
	}
}

$trackers_selected = array();

if(!$is_new) {
	// Fetch selected trackers from the report	
	$crit = new Criteria();
	$crit->add(MyReportTrackerPeer::MY_REPORT_ID, $report_id);
	$crit->addJoin(TrackerPeer::TRACKER_ID, MyReportTrackerPeer::TRACKER_ID);
	$crit->addSelectColumn(TrackerPeer::TRACKER_NAME);
	$crit->setDistinct();
	$rs = TrackerPeer::doSelectRS($crit);
	while($rs->next())
	{
		$trackers_selected[] = $rs->getString(1);
	}
}

include('forms/ReportEditStep2-tpl.php');

$template->footer();
?>
