<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
//require_once('lib/core/UserProjectPeer.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportUser.php');
require_once('lib/core/MyReportUserPeer.php');
require_once('lib/core/MyReportFieldFilter.php');
require_once('lib/core/MyReportFieldDisplay.php');
require_once('lib/core/MyReportFieldFilterPeer.php');
require_once('lib/core/MyReportFieldDisplayPeer.php');
require_once('lib/core/MyReportTracker.php');
require_once('lib/core/MyReportTrackerPeer.php');
require_once('lib/core/MyReportProject.php');
require_once('lib/core/MyReportProjectPeer.php');
require_once('lib/core/MyReportFieldValue.php');
require_once('lib/core/MyReportFieldValuePeer.php');

$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Lang = $session->getLanguage();
$user = Session::getSession()->getUser();

if(isset($_REQUEST['feedback'])) $feedback = StringUtils::stripHTMLTags($_REQUEST['feedback']);
if(isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
	// Fetch report data
	if($report_id != 0) {
		$report = MyReportPeer::retrieveByPK($report_id);
		if(!is_object($report)) {
			$is_new = true;
		}
		else {
			$is_new = false;
			if($report->getUserId() != $user->getUserId()) {
				$parms = array ('feedback'=>$Lang->getText('Report.NotOwner'));
				GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
				exit();
			}
		}
	}
	else {
		$is_new = true;
	}
}
else {
	$is_new = true;
	$report_id = 0;
}


if(!isset($_REQUEST['projects_selected']) || !is_array($_REQUEST['projects_selected']) || count($_REQUEST['projects_selected'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoProjectsSelected');
	include('ReportEditStep1.php');
	exit();
}

if(!isset($_REQUEST['trackers_selected']) || !is_array($_REQUEST['trackers_selected']) || count($_REQUEST['trackers_selected'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoTrackersSelected');
	include('ReportEditStep2.php');
	exit();
}

if(!isset($_REQUEST['extrafields_filter']) || !is_array($_REQUEST['extrafields_filter']) || count($_REQUEST['extrafields_filter'])==0) {
	$_REQUEST['extrafields_filter'] = array();
	/*$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoExtraFieldsSelected');
	include('ReportEditStep3.php');
	exit();*/
}

if(!isset($_REQUEST['extrafields_display']) || !is_array($_REQUEST['extrafields_display']) || count($_REQUEST['extrafields_display'])==0) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoExtraFieldsSelected');
	include('ReportEditStep3.php');
	exit();
}

if(!isset($_REQUEST['report_name']) || trim($_REQUEST['report_name'])=='') {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorNoReportNameSupplied');
	include('ReportEditStep4.php');
	exit();
}
else {
	$report_name = Validator::sanitizeString($_REQUEST['report_name']);
}

if(!isset($_REQUEST['open_date_start'])) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorInvalidDate');
	include('ReportEditStep4.php');
	exit();
}
else {
	$open_date_start = Validator::sanitizeDate($_REQUEST['open_date_start']);
}

if(!isset($_REQUEST['open_date_end'])) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorInvalidDate');
	include('ReportEditStep4.php');
	exit();
}
else {
	$open_date_end = Validator::sanitizeDate($_REQUEST['open_date_end']);
}


if(!isset($_REQUEST['close_date_start'])) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorInvalidDate');
	include('ReportEditStep4.php');
	exit();
}
else {
	$close_date_start = Validator::sanitizeDate($_REQUEST['close_date_start']);
}

if(!isset($_REQUEST['close_date_end'])) {
	$_REQUEST['feedback'] = $Lang->getText('Report.ErrorInvalidDate');
	include('ReportEditStep4.php');
	exit();
}
else {
	$close_date_end = Validator::sanitizeDate($_REQUEST['close_date_end']);
}

if(!isset($_REQUEST['row_sort_column'])) {
	$rowSortColumn = '';
}
else {
	$rowSortColumn = Validator::sanitizeString($_REQUEST['row_sort_column']);
}

if(!isset($_REQUEST['row_sort_ascdesc'])) {
	$rowSortOrder = true;
}
else {
	if (strtolower(Validator::sanitizeString($_REQUEST['row_sort_ascdesc']))=='asc') {
		$rowSortOrder = true;
	}
	else $rowSortOrder = false;
}

if(isset($_REQUEST['report_shared'])) {
	$report_shared = true;
}
else {
	$report_shared = false;
}

$selectedUserIds = array();// array with userId of valid selected users
if(isset($_REQUEST['share_users']) && !empty($_REQUEST['share_users'])) {
	$usersarr = explode(',', $_REQUEST['share_users']);
	$count = count($usersarr);
	for($i = 0; $i < $count; $i++) {
		$usersarr[$i] = Validator::sanitizeString($usersarr[$i]);
	}
	$users = UserPeer::retrieveByUnixNames($usersarr);//array User objects
	$valid_users = array(); // array unix_name
	foreach ($users as $user) {
		$selectedUserIds[] = $user->getUserId();
		$valid_users[] = $user->getUnixName();
	}
	$invalid_users = array_diff($usersarr, $valid_users);
	if(count($invalid_users)) {
		$_REQUEST['feedback'] = implode(',', $invalid_users) .
			$Lang->getText('Report.ErrorInvalidUser', '');
		include('ReportEditStep4.php');
		exit();
	}
}

$projects_selected = array();
$trackers_selected = array();
$extrafields_filter = array();
$extrafields_display = array();
$extrafields_values = array();

// Sanitize project, trackers, extrafields and extrafields values
foreach($_REQUEST['projects_selected'] as $ps) {
	$ps = Validator::sanitizeInt($ps);
	$project = ProjectPeer::retrieveByPK($ps);
	if(is_object($project) && $project->userCanRead())
	{
		$projects_selected[$ps] = $project;
		$projectTrackers = $project->getTrackers();
		foreach($projectTrackers as $pt) {
			if ($pt->userCanRead()) {
				foreach($_REQUEST['trackers_selected'] as $ts) {
					if($ts==$pt->getTrackerName()) {
						$trackers_selected[] = $pt;
						if(!isset($tefs)) {
							//This part only is run for the first tracker, all trackers are supposed
							//to have the same extrafields and same extrafield types.
							
							
							// Process and remove the fixed fields first from the filter fields, and copy the values
							$tmp_filters = array();
							foreach($_REQUEST['extrafields_filter'] as $efs) {
								$efs = Validator::sanitizeString($efs);
								$copyValues = false;
								switch($efs) {
									case TrackerItemPeer::SUMMARY:
										$extrafields_filter[] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_SUMMARY);								
										$copyValues = true;
										break;
									case TrackerItemPeer::DETAILS:
										$extrafields_filter[] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_DETAILS);								
										$copyValues = true;
										break;
									case TrackerItemPeer::PRIORITY:
										$extrafields_filter[] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_PRIORITY);								
										$copyValues = true;
										break;
									case TrackerItemAssigneePeer::TABLE_NAME:	
										$extrafields_filter[] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_ASSIGNEES);								
										$copyValues = true;
										break;
									default:
										// Array that holds the real extra fields.
										$tmp_filters[] = $efs;
										break;
								}
								
								if($copyValues) {
									$extrafields_values[$efs] = array();
									if(isset($_REQUEST['extrafields_values_selected'][$efs])) {
										foreach($_REQUEST['extrafields_values_selected'][$efs] as $kefvs => $efvs) {										
											$extrafields_values[$efs][$kefvs] = str_replace('"','', str_replace("'",'', Validator::sanitizeString($efvs)));
										}
									}
								}
							}
							// Copy the arrays that contain the real extra fields for later processing,
							// thus removing the fake static ones.
							$_REQUEST['extrafields_filter'] = $tmp_filters;
							
							// Process and remove the fixed fields first from the display fields
							$tmp_filters = array();
							$efd_count = count($_REQUEST['extrafields_display']);
							for($efd_counter=0; $efd_counter< $efd_count; $efd_counter++) {
								$efs = Validator::sanitizeString($_REQUEST['extrafields_display'][$efd_counter]);
								$copyValues = false;
								switch($efs) {
									case TrackerItemPeer::SUMMARY:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_SUMMARY);
										$copyValues = true;
										break;
									case TrackerItemPeer::DETAILS:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_DETAILS);
										$copyValues = true;
										break;
									case TrackerItemPeer::PRIORITY:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_PRIORITY);
										$copyValues = true;
										break;
									case TrackerItemAssigneePeer::TABLE_NAME:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_ASSIGNEES);
										$copyValues = true;
										break;
									case TrackerItemPeer::OPEN_DATE:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_OPENDATE);
										$copyValues = true;
										break;
									case TrackerItemPeer::CLOSE_DATE:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_CLOSEDATE);
										$copyValues = true;
										break;
									case TrackerItemPeer::LAST_MODIFIED_DATE:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_LASTMODIFIEDDATE);
										$copyValues = true;
										break;
									case TrackerPeer::TRACKER_NAME:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_TRACKERNAME);
										$copyValues = true;
										break;
									case ProjectPeer::PROJECT_NAME:
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => MyReport::FIELDTYPE_PROJECTNAME);
										$copyValues = true;
										break;
									default:
										// Array that holds the real extra fields.
										$tmp_filters[$efd_counter] = $efs;
										break;
								}
							}
							// Copy the arrays that contain the real extra fields for later processing,
							// thus removing the fake static ones.
							$_REQUEST['extrafields_display'] = $tmp_filters;
							
							
							// Now we process the real extra fields, the fake static ones have already been taken care of.
							
							$tefs = $pt->getTrackerExtraFields();
							foreach($tefs as $tef) {
								foreach($_REQUEST['extrafields_filter'] as $efs) {
									$efs = Validator::sanitizeString($efs);
									if($tef->getFieldName()==$efs) {
										$extrafields_filter[] = array('name' => $efs, 'type' => $tef->getFieldType());
										switch($tef->getFieldType()) {
											case TrackerExtraField::TYPE_MEMBERS:
											case TrackerExtraField::TYPE_SELECT:
												// Multiselect field
											case TrackerExtraField::TYPE_CHECKBOX:
												// Checkbox
											case TrackerExtraField::TYPE_RADIO:
												// Radio
											case TrackerExtraField::TYPE_MULTISELECT:
												// Multiselect
											case TrackerExtraField::TYPE_STATUS:
												// Status field
											case TrackerExtraField::TYPE_RELEASE:
												// Release field
											case TrackerExtraField::TYPE_TEXT:
												// Text box
											case TrackerExtraField::TYPE_TEXTAREA:
												// Text Area
												$extrafields_values[$efs] = array();
												if(isset($_REQUEST['extrafields_values_selected'][$efs])) {
													foreach($_REQUEST['extrafields_values_selected'][$efs] as $kefvs => $efvs) {
														$extrafields_values[$efs][$kefvs] = str_replace('"','', str_replace("'",'', Validator::sanitizeString($efvs)));
													}
												}
												break;

											case TrackerExtraField::TYPE_DATE:
												try {
													if (isset($_REQUEST['extrafields_values_selected'][$efs]['min']) && isset($_REQUEST['extrafields_values_selected'][$efs]['max']) ) {
														$minDate = strftime('%b %d %Y', strtotime($_REQUEST['extrafields_values_selected'][$efs]['min']));
														$maxDate = strftime('%b %d %Y', strtotime($_REQUEST['extrafields_values_selected'][$efs]['max']));
														if ($minDate!==false && $maxDate!==false) {
															$extrafields_values[$efs] = array('min' => $minDate, 'max' => $maxDate);
														}
													}
													
												} catch (Exception $e) {}
												break;
											
											case TrackerExtraField::TYPE_SERIAL:
											case TrackerExtraField::TYPE_NUMERIC:
												try {
													if (isset($_REQUEST['extrafields_values_selected'][$efs]['min']) && isset($_REQUEST['extrafields_values_selected'][$efs]['max']) 
													&& is_numeric($_REQUEST['extrafields_values_selected'][$efs]['min']) 
													&& is_numeric($_REQUEST['extrafields_values_selected'][$efs]['max'])) {
														if ($minDate!==false && $maxDate!==false) {
															$extrafields_values[$efs] = array('min' => floatval($_REQUEST['extrafields_values_selected'][$efs]['min']),
																							 'max' => floatval($_REQUEST['extrafields_values_selected'][$efs]['max']));
														}
													}
													
												} catch (Exception $e) {}
												break;

											default:
												break;
										}
										break;
									}
								}
								foreach($_REQUEST['extrafields_display'] as $efd_counter => $efs) {
									$efs = Validator::sanitizeString($efs);
									if($tef->getFieldName()==$efs) {
										$extrafields_display[$efd_counter] = array('name' => $efs, 'type' => $tef->getFieldType());
										break;
									}
								}
							}
						}
						break;		
					}
				}
			}
		}
	}
}

// Save Data
if($is_new) {
	$report = new MyReport();
	$report->setReportType(MyReport::REPORTTYPE_TRACKER );
	$report->setUser($session->getUser());
}

$report->setReportName($report_name);
$report->setOpenDateStart($open_date_start);
$report->setOpenDateEnd($open_date_end);
$report->setCloseDateStart($close_date_start);
$report->setCloseDateEnd($close_date_end);
$report->setIsShared($report_shared);

$report->save();
$report_id = $report->getMyReportId();

// Save Projects (delete them and re add them)
$crit = new Criteria();
$crit->add(MyReportProjectPeer::MY_REPORT_ID, $report_id);
MyReportProjectPeer::doDelete($crit);

foreach($projects_selected as $p) {
	$mrp = new MyReportProject();
	$mrp->setMyReportId($report_id);
	$mrp->setProjectId($p->getProjectId());
	$mrp->save();
}

// Save Users (delete them and re add them)
$crit = new Criteria();
$crit->add(MyReportUserPeer::MY_REPORT_ID, $report_id);
MyReportUserPeer::doDelete($crit);

if($report_shared) {
	foreach($selectedUserIds as $userId) {
		$mru = new MyReportUser();
		$mru->setMyReportId($report_id);
		$mru->setUserId($userId);
		$mru->save();
	}
}

// Save Trackers (delete them and re add them)
$crit = new Criteria();
$crit->add(MyReportTrackerPeer::MY_REPORT_ID, $report_id);
MyReportTrackerPeer::doDelete($crit);

foreach($trackers_selected as $tracker) {
	$mrt = new MyReportTracker();
	$mrt->setMyReportId($report_id);
	$mrt->setTracker($tracker);
	$mrt->save();
}

// Save Display Fields
$crit = new Criteria();
$crit->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $report_id);
$fields = MyReportFieldDisplayPeer::doSelect($crit);

// Delete unused fields
foreach($fields as $field) {
	$delField = true;
	foreach($extrafields_display as $ef) {
		if($field->getFieldName()==$ef['name']) {
			$delField=false;
			break;
		}
	}
	if($delField) {
		$field->delete();
	}
}

// Save new fields, modify old ones if type changed.

foreach($extrafields_display as $efd_order => $ef) {
	$addField = true;
	foreach($fields as $field) {
		if($field->getFieldName()==$ef['name']) {			
			$field->setType($ef['type']);
			$field->setColumnOrder($efd_order);
			if($field->getFieldName()==$rowSortColumn) {
				$field->setOrderPriority(1);
				$field->setOrderAsc($rowSortOrder);
			}
			else {
				$field->setOrderPriority(0);
			}
			$field->save();
			$addField=false;
			break;
		}
	}
	
	if($addField) {
		$field = new MyReportFieldDisplay();
		$field->setFieldName($ef['name']);
		$field->setType($ef['type']);
		$field->setMyReportId($report_id);
		$field->setColumnOrder($efd_order);
		if($field->getFieldName()==$rowSortColumn) {
			$field->setOrderPriority(1);
			$field->setOrderAsc($rowSortOrder);
		}
		else {
			$field->setOrderPriority(0);
		}
		$field->save();
	}
	
}


// Save Filter Fields
$crit = new Criteria();
$crit->add(MyReportFieldFilterPeer::MY_REPORT_ID, $report_id);
$fields = MyReportFieldFilterPeer::doSelect($crit);

// Delete unused fields
foreach($fields as $field) {
	$delField = true;
	foreach($extrafields_filter as $ef) {
		if($field->getFieldName()==$ef['name'] && isset($extrafields_values[$ef['name']])) {
			$delField=false;
			break;
		}
	}
	if($delField) {
		$field->delete();
	}
}

// Save new fields, modify old ones if type changed.
foreach($extrafields_filter as $ef) {
	if (isset($extrafields_values[$ef['name']])) {
		$addField = true;
		foreach($fields as $field) {
			if($field->getFieldName()==$ef['name'] ) {
				if($field->getType() != $ef['type']) {
					$field->setType($ef['type']);
					$field->save();
				}
				$addField=false;
				break;
			}
		}
		if($addField) {
			$field = new MyReportFieldFilter();
			$field->setFieldName($ef['name']);
			$field->setType($ef['type']);
			$field->setMyReportId($report_id);
			$field->save();
		}

		// Save filter fields values.
	
		$ef_values = $extrafields_values[$ef['name']];
		$crit = new Criteria();
		$crit->add(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID, $field->getMyReportFieldFilterId());

		switch($field->getType()) {
			case MyReport::FIELDTYPE_ASSIGNEES:
			case MyReport::FIELDTYPE_PRIORITY:
			case TrackerExtraField::TYPE_MEMBERS:
			case TrackerExtraField::TYPE_SELECT:
				// Multiselect field
			case TrackerExtraField::TYPE_CHECKBOX:
				// Checkbox
			case TrackerExtraField::TYPE_RADIO:
				// Radio
			case TrackerExtraField::TYPE_MULTISELECT:
				// Multiselect
			case TrackerExtraField::TYPE_STATUS:
				// Status field
			case TrackerExtraField::TYPE_RELEASE:
				$values = MyReportFieldValuePeer::doSelect($crit);
				// Delete unused values
				foreach($values as $value) {
					$delValue = true;
					foreach($ef_values as $ef_value) {
						if($value->getFieldValue()==$ef_value)	{
							$delValue = false;
							break;
						}
					}
					if($delValue) {
						$value->delete();
					}
				}

				//Add new values
				foreach($ef_values as $ef_value) {
					$addValue = true;
					foreach($values as $value) {
						if($value->getFieldValue()==$ef_value)	{
							$addValue = false;
							break;
						}
					}
					if($addValue) {
						$value = new MyReportFieldValue();
						$value->setMyReportFieldFilter($field);
						$value->setFieldValue($ef_value);
						$value->setFieldRangeStart('');
						$value->setFieldRangeEnd('');
						$value->save();
					}
				}
				break;

			case MyReport::FIELDTYPE_DETAILS:
			case MyReport::FIELDTYPE_SUMMARY:
			case TrackerExtraField::TYPE_TEXT:
				// Text box
			case TrackerExtraField::TYPE_TEXTAREA:
				// Text Area
				$value = MyReportFieldValuePeer::doSelectOne($crit);
				if(!is_object($value)) {
					$value = new MyReportFieldValue();
					$value->setMyReportFieldFilter($field);
				}
				$value->setFieldValue($ef_values['value']);
				$value->setFieldRangeStart('');
				$value->setFieldRangeEnd('');
				$value->save();
				break;

			case TrackerExtraField::TYPE_SERIAL:
			case TrackerExtraField::TYPE_DATE:
			case TrackerExtraField::TYPE_NUMERIC:
				$value = MyReportFieldValuePeer::doSelectOne($crit);
				if(!is_object($value)) {
					$value = new MyReportFieldValue();
					$value->setMyReportFieldFilter($field);
				}
				$value->setFieldValue('');
				$value->setFieldRangeStart($ef_values['min']);
				$value->setFieldRangeEnd($ef_values['max']);
				$value->save();
				break;

			default:
				break;
		}
	}

}

GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), array('feedback' => $Lang->getText('Report.ReportSaved')));
exit();

?>
