<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
//require_once('lib/core/UserProjectPeer.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportUser.php');
require_once('lib/core/MyReportUserPeer.php');

$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$template = new MyTemplate();
$user = Session::getSession()->getUser();

if(isset($_REQUEST['feedback'])) $feedback = StringUtils::stripHTMLTags($_REQUEST['feedback']);
$params = array(
	'title' => Language::getSessText('Tabs.MyReports'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'myreports',
	'user' => $user
	);
$template->header($params);

$params['theme'] = $template;

// Fetch My Reports
$crit = new Criteria();
$crit->add(MyReportPeer::REPORT_TYPE, MyReport::REPORTTYPE_TRACKER);
$crit->addJoin(MyReportPeer::MY_REPORT_ID,MyReportUserPeer::MY_REPORT_ID, "LEFT JOIN");
$crit->setDistinct();
$ct1 = $crit->getNewCriterion(MyReportPeer::USER_ID, $session->getUser()->getUserId());
$ct2 = $crit->getNewCriterion(MyReportUserPeer::USER_ID, $session->getUser()->getUserId());
$ct3 = $crit->getNewCriterion(MyReportUserPeer::USER_ID, MyReportUserPeer::USER_ID .' IN (SELECT usergroup_id FROM usergroup_user WHERE member_user_id=' . $session->getUser()->getUserId() . ')', Criteria::CUSTOM);
$ct2->addOr($ct3);
$ct1->addOr($ct2);
$crit->addOr($ct1);

$reports = MyReportPeer::doSelect($crit);

$tmod = array();
$tmod[] = 'width="50%"';

$theader[] = Language::getSessText('Tabs.MyReports');
$theader[] = Language::getSessText('Report.Owner');
$theader[] = Language::getSessText('Report.ExportOptions');
$theader[] = Language::getSessText('Report.Delete');
echo $theme->tableTop($theader);

if(count($reports)>0)
{
	foreach($reports as $report) {
		$trow = array();
		// Only allow owners to edit their reports
		if($report->getUserId()==$session->getUser()->getUserId()) {
			$trow[]='<a href="'. GFUrl::getUrl()->baseURL('ReportEdit','my','reports', array('report_id' => $report->getMyReportId())) .'">'.  $report->getReportName() .'</a>';
		}
		else {
			$trow[] = $report->getReportName();
		}
		$trow[]=UserPeer::retrieveByPk($report->getUserId())->getFullName();
		$trow[]='<a href="'. GFUrl::getUrl()->baseURL('ReportView','my','reports', array('report_id' => $report->getMyReportId())) .'">'.  Language::getSessText('Report.View') .'</a> ' .
				'<a href="'. GFUrl::getUrl()->baseURL('ReportCSV','my','reports', array('report_id' => $report->getMyReportId())) .'">'.  Language::getSessText('Report.ViewCSV') .'</a> ' .
				'<a href="'. GFUrl::getUrl()->baseURL('ReportXML','my','reports', array('report_id' => $report->getMyReportId())) .'">'.  Language::getSessText('Report.ViewXML') .'</a> ' .
				'<a href="'. GFUrl::getUrl()->baseURL('ReportExcel','my','reports', array('report_id' => $report->getMyReportId())) .'">'.  Language::getSessText('Report.ViewExcel') .'</a> ' /*.
				'<a href="'. GFUrl::getUrl()->baseURL('ReportPDF','my','reports', array('report_id' => $report->getMyReportId())) .'">'.  Language::getSessText('Report.ViewPDF') .'</a>'*/;
		if($report->getUserId()==$session->getUser()->getUserId()) {
			$trow[]='<a href="'. GFUrl::getUrl()->baseURL('ReportDelete','my','reports', array('report_id' => $report->getMyReportId())) .'">'.  Language::getSessText('Report.Delete') .'</a>';
		}
		else {
			$trow[] = '&nbsp;';
		}
		echo $theme->tableRow($trow, $tmod, false);
	}	
}
else {
	echo $theme->tableFullRow(Language::getSessText('Report.NoReportsFound'));
}

$buttons = array();
$buttons[] = '<a href="'. GFUrl::getUrl()->baseURL('ReportAdd','my','reports') .'">'.  Language::getSessText('Report.AddNew') .'</a>';
echo $theme->tableBottom($buttons);

$template->footer();
?>
