<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for ProjectJoinRequest
//
require_once('core/ProjectJoinRequestPeer.php');
require_once('core/ProjectJoinRequest.php');
require_once('GFUrl.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
if (!Session::getSession()->isLoggedIn() || GFConf::get('system.allowProjectJoinRequests') == false) {
	throw new PermissionDeniedException();
}

require_once('html/ProjectTemplate.php');
$theme = new ProjectTemplate();

$project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('ProjectJoinRequest.AddNewPageTitle')
		);

$comments=((isset($_POST['comments'])) ? htmlspecialchars($_POST['comments']) : '' );

$user = Session::getSession()->getUser();
if ($user->isProjectMember($project)) {
	// If it's a member, just show a warning
	throw new Exception($Lang->getText('ProjectJoinRequestException.AlreadyMember'));
} 

include('forms/ProjectJoinRequestAdd-tpl.php');

?>
