<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez daniel@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('html/ProjectTemplate.php');
require_once('external/fckeditor/fckeditor.php');
require_once('lib/Validator.php');

$project = GFUrl::getUrl()->getProject();
$project_name = $project->getUnixName();
if (!$project->userIsAdmin()) {
	// Only project admins can change member information
	throw new PermissionDeniedException();
}

$feedback = 'No change';
$errors = array();

if (isset($_POST['submit'])) {
	$contents = stripslashes($_POST['content']);
	$contents = Validator::sanitizeHtml($contents);
	$project->setDescription($contents);
	try {
		$project->save();
		$feedback = Language::getSessText('ProjectAdmin.DescriptionUpdated');
	} catch (InvalidDataException $ex){
		$errors = array_merge($errors, $ex->getErrors());
		$feedback = '* '.implode('<br />* ', $errors);
	}
}

$template = new ProjectTemplate();
$params = array(
		'selectedbottomtab'	=> 'project_admin','project' => $project, 'feedback' => $feedback,'title'=>Language::getSessText('ProjectAdmin.EditDescription')
	);

if(count($errors) > 0){
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('EditDescription',array('feedback'=>$feedback)));
} else {
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('',array('feedback'=>$feedback)));
}

?>