<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/ProjectPeer.php');
require_once('session/Session.php');
require_once('core/RolePeer.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$project = GFUrl::getUrl()->getProject();
$project_id = $project->getProjectId();
$Lang = $session->getLanguage();

if (!$project->userIsAdmin()) {
  require_once('exceptions/PermissionDeniedException.php');
  throw new PermissionDeniedException();
}


require_once('html/templates/ProjectAdminTemplate.php');
$template = new ProjectAdminTemplate();

if (!isset($feedback)) {
  $feedback = isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : '';
}

$params = array(
		'selectedbottomtab'	=> 'project_admin',
		'project' => $project,
		'title' => Language::getSessText('ProjectAdmin.Invite.Title'),
		'pagename' => Language::getSessText('ProjectAdmin.Invite.Title'),
		'feedback' => $feedback
	);
$template->header($params);

$crit = new Criteria();
$crit->add(RolePeer::PROJECT_ID, $project->getProjectId());
$crit->addAscendingOrderByColumn(RolePeer::ROLE_NAME);
$roles = RolePeer::doSelect($crit);

?>

<p>
<h3><?php echo $Lang->getText("ProjectAdmin.Invite.Heading"); ?></h3>
  <?php echo $Lang->getText("ProjectAdmin.Invite.Subheading"); ?>
</p>
<p>
  <form method="post" action="<?php echo GFUrl::getUrl()->currentBaseUrl("ProjectInviteAction") ?>">
    <input type="hidden" name="project_id" value="<?php echo $project_id ?>"> 
    <strong><?php echo $Lang->getText("ProjectAdmin.Invite.Emails"); ?></strong></br>
    <textarea name="emails" rows="10" cols="50"><?php echo $emails ?></textarea></br></br>
    <strong><?php echo $Lang->getText("ProjectAdmin.Invite.UserRole"); ?></strong></br>
    <?php echo HTMLWidget::select("role", $roles, $role_id, null, false)?></br></br>
    <?php echo HTMLWidget::button("submit", 
                              $Lang->getText('Common.Submit'), 
                              "submit",
                              "", "")?>
	  <?php echo HTMLWidget::button("button",$Lang->getText('Common.Back'),"cancel","","javascript:history.go(-1);")?>
  </form>
</p>

		
<?php
$template->footer();
?>
