<?php

// Allow POST only
if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

// db conn
$con = Propel::getConnection(TroveCategoryPeer::DATABASE_NAME);

// language
$Language = Session::getSession()->getLanguage();

$project = GFUrl::getUrl()->getProject();

$response = array();

if (GFConf::get('system.projAdminCanCreateTemplate', FALSE)) {
	if ($project) {
		try {
			$project->setIsTemplate(TRUE);
			$project->save();
			$response['message'] = $Language->getText('Project.MarkAsTemplate.Success');
			$response['success'] = TRUE;
		} catch (InvalidDataException $e) {
			$response['success'] = FALSE;
			$response['error'] = $Language->getText('Project.MarkAsTemplate.Error');
		}    
	} else {
		$response['success'] = FALSE;
		$response['error'] = $Language->getText('Project.MarkAsTemplate.Error');
	}
} else {
	$response['success'] = FALSE;
	$response['error'] = $Language->getText('Project.MarkAsTemplate.Error.NotAllowed');
}

echo json_encode($response);