<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Role
//
require_once('core/RolePeer.php');
require_once('core/Role.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/ProjectAdminTemplate.php');
$theme = new ProjectAdminTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Role.BrowsePageTitle'),
		'selectedbottomtab'	=> 'project_admin',
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->add(RolePeer::PROJECT_ID, $Project->getProjectId());
$crit->addAscendingOrderByColumn(RolePeer::ROLE_NAME);
$arr = RolePeer::doSelect($crit);


$theader = array();

$theader[] = $Lang->getText('Role.RoleNameName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Role.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[] = $item->getRoleName();
		$trow[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('RoleEdit').'&amp;role_id='.$item->getID() .'">'. $Lang->getText('Edit') .'</a>';
		if ($item->hasUsers()) {
			$trow[] = $Lang->getText('ProjectAdmin.Role.RemoveFirst');
		} else {
			$trow[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('RoleDelete').'&amp;role_id='.$item->getID() .'">'. $Lang->getText('Delete') .'</a>';
		}

		echo $theme->tableRow($trow, array(), false);
	}
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('RoleAdd').'">'. $Lang->getText('Role.AddNew') .'</a>'));

$theme->footer($params);

?>
