<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
?>
<p><h3><?php echo $lang->getText('ProjectAdmin.Role.Observer'); ?></h3></p>
<p><div class="infobox"><?php echo $lang->getText('ProjectAdmin.Role.ObserverIntro'); ?></div></p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('ObserverEditAction') ?>" method="POST">
<script  type="text/javascript">
	function toggleObsSelects() {
		var wideObserverSelect = $('select.[name="data[projectstatus][0]"]');
		if (wideObserverSelect != null && wideObserverSelect.val() == 0) {
			$('.observer_settings').css('display', 'none');
		} else {
			$('.observer_settings').css('display', '');
		}



	}

	$('document').ready( function() {
		var wideObserverSelect = $('select.[name="data[projectstatus][0]"]');
		toggleObsSelects();
		wideObserverSelect.change( function () {
				toggleObsSelects();
		})
	})
</script>

<?php

$titles[] = Language::getSessText('ProjectAdmin.Role.Section');
$titles[] = Language::getSessText('ProjectAdmin.Role.Subsection');
$titles[] = Language::getSessText('ProjectAdmin.Role.Setting');
$titles[] = Language::getSessText('ProjectAdmin.Role.Description');

echo $theme->tableTop($titles);

/* Show project-wide options */
// Observer only has public/private setting

// Check if this project is public or private
$checked = ($project->getIsPublic()) ? 1 : 0;
$cols = array();
$mods = array();
$cols[] = '<strong>'.Language::getSessText('ProjectAdmin.Observer.ProjectWide').'</strong>';
$mods[]='width="20%"';
$cols[] = '-';
$mods[]='width="10%"';
$cols[] = HTMLWidget::SelectBoxFromArrays(array(0,1),
						array(Language::getSessText('Project.IsPrivateName'),
							Language::getSessText('Project.IsPublicName')),
						"data[projectstatus][0]", $checked, false);
$mods[]='width="10%"';
$cols[] = Language::getSessText('ProjectAdmin.Role.ObserverDescription');		// Description
$mods[]='width="40%"';

echo $theme->tableRow($cols,$mods);
	

/* Retrieve settings from plugins */
$params = array('project' => $project);
$prs = ActionManager::notify('GET_OBSERVER_ROLE_CHOICES', $params);

$txt='';
$lastid = null;
$lastplugin = null;
$previous_row = false;
$trow = array();
$tmod = array();

foreach ($prs as $pluginResult) {
	$plugin = $pluginResult->getPlugin();
	$roles = $pluginResult->getResult();

	if (!is_array($roles)) {	// Some plugins don't give us role choices
		continue;
	}
	
	// Layout hack: group the sections in the same rowspan
	$section_count = array();
	foreach ($roles as $roleitem) {
		$section_name = $roleitem['section'];
		$ref_id = $roleitem['ref_id'];
		if (!array_key_exists($section_name, $section_count)) {
			$section_count[$section_name] = array();
			$section_count[$section_name][$ref_id] = 1;
		} elseif (!array_key_exists($ref_id, $section_count[$section_name])) {
			$section_count[$section_name][$ref_id] = 1;
		} else {
			$section_count[$section_name][$ref_id]++;
		}
	}
	
	// now calculate the rowspans
	$rowspans = array();
	foreach ($section_count as $section_name => $refs) {
		$rowspans[$section_name] = count($refs);
	}
	$shown_sections = array();
	
	foreach ($roles as $roleitem) {
		$section = array_shift($roleitem['settings']);	// Retrieve the section for this item
		$checked = $plugin->getObserverSetting($roleitem['ref_id'],$section);
		
		$selectbox =  HTMLWidget::SelectBoxFromArrays($roleitem['settings'][0][1],
								$roleitem['settings'][0][0],
								"data[".$section."][".$roleitem['ref_id']."]",
								$checked, false);
		// Changed plugin
		if ( ($lastid != $roleitem['ref_id']) || !$lastid || ( ($lastplugin) && ($plugin->getName()!=$lastplugin)) ) {
			if ($previous_row) {
				// parse previous row
				echo $theme->tableRow($trow, $tmod, true, '', 'observer_settings');
				$trow = array();
				$tmod = array();
			} else {
				$previous_row = true;
			}
			
			// PLEASE NOTE: this assumes that the sections are grouped in the $result array, this
			// allows us to parse it sequentially.

			$section_name = $roleitem['section'];
			if (!in_array($section_name, $shown_sections)) {
				$trow[] = '<strong>'.$section_name.'</strong>';
				$mod = 'rowspan="'.$rowspans[$section_name].'"';
				if ($rowspans[$section_name] > 1) {
					$mod .= ' bgcolor="#ffffff"';
				}
				$tmod[] = $mod;
				$shown_sections[] = $section_name;
			}
			$trow[] = $roleitem['subsection'];
			$tmod[] = '';
			$trow[] = $selectbox;
			$tmod[] = '';
			
			if (array_key_exists('description', $roleitem)) {
				$trow[] = $roleitem['description'];
			} else {
				$trow[] = '';
			}
			$tmod[] = '';
		} else {
			$trow[count($trow)-1] .= "&nbsp;&nbsp;".$selectbox;
		}

		// saving setting for next iteration
		$lastid = $roleitem['ref_id'];
		$lastplugin = $plugin->getName();		
	}
}

if ($previous_row) {
	echo $theme->tableRow($trow, $tmod,true, '', 'observer_settings');
}



echo $theme->tableBottom();

?>
<br />

<?php echo HTMLWidget::button("submit","" .   $lang->getText('submit.edit') . " ","submit","","")?>
<?php echo HTMLWidget::button("button","" .   $lang->getText('Common.Back') . " ","cancel","","javascript:history.go(-1);")?>
</form>

<?php
$theme->footer($params);
?>
