<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
?>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('RoleAddAction') ?>" method="POST">
<strong><?php echo $Lang->getText('Role.RoleNameName'); ?></strong><br />
<input type="text" name="role_name" value="<?php echo $role_name; ?>" />
<br />
<br />
	
<?php

$titles[] = Language::getSessText('ProjectAdmin.Role.Section');
$titles[] = Language::getSessText('ProjectAdmin.Role.Subsection');
$titles[] = Language::getSessText('ProjectAdmin.Role.Setting');
$titles[] = Language::getSessText('ProjectAdmin.Role.Description');

echo $theme->tableTop($titles);

/* Show project admin */
$checked = 0;

$cols = array();
$cols[] = '<strong>'.Language::getSessText('ProjectAdmin.Role.ProjectAdmin').'</strong>';
$cols[] = '-';
$cols[] = HTMLWidget::SelectBoxFromArrays(array(0,1), 
							array(Language::getSessText('Options.None'), 
								Language::getSessText('ProjectAdmin.Role.ProjectAdmin')), 
							"data[projectadmin][0]", $checked, false);
$cols[] = Language::getSessText('ProjectAdmin.Role.ProjectAdminDescription');		// Description
echo $theme->tableRow($cols);

/* Retrieve roles from plugins */
$params = array('project' => $project);
$prs = ActionManager::notify('GET_ROLE_CHOICES', $params);

/* Roles for plugins */
$txt='';
$lastid = null;
$lastplugin = null;
foreach ($prs as $pluginResult) {
	$plugin = $pluginResult->getPlugin();
	$roles = $pluginResult->getResult();

	if (!is_array($roles)) {	// Some plugins don't give us role choices
		continue;
	}
	
	// Layout hack: group the sections in the same rowspan
	$section_count = array();
	foreach ($roles as $roleitem) {
		$section_name = $roleitem['section'];
		if (!array_key_exists($section_name, $section_count)) {
			$section_count[$section_name] = 1;
		} else {
			$section_count[$section_name]++;
		}
	}
	$shown_sections = array();

	
	foreach ($roles as $roleitem) {
		$section = array_shift($roleitem['settings']);	// Retrieve the section for this item
		
		$checked = '';
		$selectbox =  HTMLWidget::SelectBoxFromArrays($roleitem['settings'][0][1],
								$roleitem['settings'][0][0],
								"data[".$section."][".$roleitem['ref_id']."]",
								$checked, false);
		// Changed plugin
		if ( ($lastid != $roleitem['ref_id']) || !$lastid || ( ($lastplugin) && ($plugin->getName()!=$lastplugin)) ) {
			$trow = array();
			$tmod = array();
			
			// PLEASE NOTE: this assumes that the sections are grouped in the $result array, this
			// allows us to parse it sequentially.

			$section_name = $roleitem['section'];
			if (!in_array($section_name, $shown_sections)) {
				$trow[] = '<strong>'.$section_name.'</strong>';
				$mod = 'rowspan="'.$section_count[$section_name].'"';
				if ($section_count[$section_name] > 1) {
					$mod .= ' bgcolor="#ffffff"';
				}
				$tmod[] = $mod;
				$shown_sections[] = $section_name;
			}
			$trow[] = $roleitem['subsection'];
			$tmod[] = '';
			$trow[] = $selectbox;
			$tmod[] = '';
			
			if (array_key_exists('description', $roleitem)) {
				$trow[] = $roleitem['description'];
			} else {
				$trow[] = '';
			}
			$tmod[] = '';

			echo $theme->tableRow($trow, $tmod);
		} else {
			//$trow[2] .= "&nbsp;&nbsp;".$selectbox;
		}

		// saving setting for next iteration
		$lastid = $roleitem['ref_id'];
		$lastplugin = $plugin->getName();		
	}
}


echo $theme->tableBottom();

?>
<br />

<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submit","","")?>
<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Cancel') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->currentBaseURL('RoleBrowse',array()) . "'; ")?>
</form>

<?php
$theme->footer($params);
?>
