<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Association and saves it to the 
// database
//
require_once('core/Association.php');
require_once('core/AssociationPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('lib/html/association.php');
require_once('plugins/docman/lib/FastJSON.php');

$Lang = Language::getSessLang();

$return_to = $_POST['return_to'];
$return_to = preg_replace("/&feedback=.*$/", "", $return_to);
$ajax_call = isset($_POST['ajax']) ? $_POST['ajax'] : false;

if (strpos($_POST['return_to'],'?') === false) {
	$q='?';
} else {
	$q='';
}
if (isset($_POST['sure'])) {
	$crit= new Criteria();
	$vals = explode('|',$_POST['key']);
	$crit->add( AssociationPeer::SECTION,$vals[0] );
	$crit->add( AssociationPeer::REF_ID,$vals[1] );
	$crit->add( AssociationPeer::TO_SECTION,$vals[2] );
	$crit->add( AssociationPeer::TO_REF_ID,$vals[3] );
	$Association = AssociationPeer::doSelectOne($crit);
	if (is_object($Association) && $Association->userCanDelete()) {
		$Association->delete();
	}
	
	if ($ajax_call) {
		header('HTTP/1.1 200');
		$theme = Session::getSession()->getTheme();
		$from_element_name = isset($_POST['from_element_name']) ? Validator::sanitizeString($_POST['from_element_name']) : '';
		$project = GFUrl::getUrl()->getProject();
		$html = renderAssociationList($vals[0],$vals[1],true,$theme,$project,true, "docmanFile.addAssociation(" . $vals[1] . ", '" . $from_element_name . "')");
		$arr_feedback = array();
		$arr_feedback["html"] = $html;
		echo FastJSON::encode($arr_feedback);
		exit;
	} else {
		header("Location: ".$return_to.$q.'&feedback='.urlencode($Lang->getText('Association.DeleteFeedback')));
	}
} else {
	if ($ajax_call) {
		header('HTTP/1.1 401');
		$theme = Session::getSession()->getTheme();
		$arr_feedback = array();
		$arr_feedback["error"] = '';
		echo FastJSON::encode($arr_feedback);
		exit;
	} else {
	header("Location: ".$return_to.$q.'&feedback='.urlencode($Lang->getText('AssociationDeleteForm.DidntConfirm')));
	} 
}

?>
