<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once ("lib/external/jpgraph/jpgraph.php");
require_once ("lib/external/jpgraph/jpgraph_bar.php");

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();

$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);
$stmt = $con->createStatement();

//AND date_part('year', ti.close_date) = '2005'
$sql = "SELECT date_part('month', ti.close_date) AS month,
extract(epoch from reltime(avg(ti.close_date-ti.open_date))) as avg
FROM tracker_item ti, tracker t
WHERE ti.status_id=2 AND ti.tracker_id = t.tracker_id
AND ti.status_id=2 AND ti.tracker_id = t.tracker_id
AND t.project_id=".$project_id." AND ti.close_date > 'Jan 1, 1990'::timestamp
GROUP BY month ORDER BY month;";

$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$months = array('Jan','Feb','Mar','Apr','May','Jun',
					'Jul','Aug','Sep','Oct','Nov','Dec');

$data = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
$lastYear=0;
$i = -1;
if ($rs != null && $rs->getRecordCount() > 0) {
	while($rs->next()) {
		$month = $rs->getInt('month');
		$avg = ($rs->getFloat('avg') / (60*60));
		$data[$month-1] = $avg;
	}
}

$font = $Lang->getFontProperties(FF_FONT1, FS_NORMAL, 12);
// Create the graph. These two calls are always required
$graph = new Graph(400, 250);
$graph->title->Set("Age Of Items Throughout The Year");
$graph->title->SetFont($font[0], $font[1], $font[2]);
$graph->SetScale("textlin");
$graph->setBox(false);
$graph->setFrame(false);
$graph->img->SetMargin(40,20,30,40);
$graph->yaxis->scale->SetGrace(0);
$graph->yaxis->SetLabelMargin(1);
$graph->yaxis->SetTitle('Hours', 'low');
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->SetTitleMargin(30);
$graph->xaxis->SetTickLabels($months);
$graph->xaxis->SetFont(FF_FONT1,FS_BOLD);


$b = new BarPlot($data);
$b->value->Show();
$b->value->SetFormat('%d');
$b->SetAbsWidth(15);
$b->SetWidth(1);

$graph->Add($b);

if (ob_get_level()) ob_end_clean();
$graph->Stroke();
 