<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/Tracker.php');
require_once('lib/GraphicPie.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();

$Priorities = Tracker::getPriorities();

$sql = "select ti.priority, count(*) as count from tracker t, project p, tracker_item ti
where ti.tracker_id = t.tracker_id and t.project_id = p.project_id
and p.project_id = '$project_id'
and ti.status_id=".Tracker::STATUS_OPEN." group by ti.priority order by count desc";

$gp = new GraphicPie($Lang->getText('ProjectReporting.ByPriority'), 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields('priority', 'count');
$gp->setAuxValue1($Priorities);
$gp->setLegendFormat('$legend = $this->auxvalue1[intval($key)]. \': \'.$val;');

if (ob_get_level()) ob_end_clean();
$gp->showPie();
