<?php
require_once('plugins/tracker/lib/TrackerExtraField.php');

if (!isset($_REQUEST['release_id'])) {
	throw new Exception('Missing release_id');
}

$release_id = Validator::sanitizeInt($_REQUEST['release_id']);
$project = $project = GFUrl::getUrl()->getProject();

$sql = "SELECT frsp.package_name, frsp.frs_package_id,
frsr.release_name,frsr.frs_release_id, t.tracker_name,t.tracker_id,
tef.tracker_extra_field_id,tef.field_name,ti.tracker_item_id,
ti.priority,ti.summary,ti.status_id,frsp.project_id
FROM frs_package frsp, 
frs_release frsr,
tracker_extra_field tef,
tracker_extra_field_data tefd,
tracker t,
tracker_item ti
WHERE frsr.frs_package_id=frsp.frs_package_id
AND frsp.project_id='".$project->getProjectId()."'
AND frsr.frs_release_id=tefd.field_data
AND tefd.tracker_extra_field_id=tef.tracker_extra_field_id
AND tefd.tracker_item_id=ti.tracker_item_id
AND ti.tracker_id=t.tracker_id
AND tef.field_type='".TrackerExtraField::TYPE_RELEASE."'
AND frsr.frs_release_id = '".$release_id."'
ORDER BY frsp.package_name,frsr.release_name,t.tracker_id,tef.field_name,ti.tracker_item_id";

// Get connection
$con = Propel::getConnection(UserPeer::DATABASE_NAME);
$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql);

header('Content-type: text/csv');
header('Content-disposition: attachment; filename="release_roadmap.csv"');

echo '"PACKAGE NAME";"RELEASE NAME";"TRACKER NAME";"FIELD NAME";"TRACKER ITEM ID";"ITEM";"STATUS"'."\n";
while ($rs->next()) {
	echo '"'.$rs->getString('package_name').'";';
	echo '"'.$rs->getString('release_name').'";';
	echo '"'.$rs->getString('tracker_name').'";';
	echo '"'.$rs->getString('field_name').'";';
	echo $rs->getInt('tracker_item_id').';';
	echo '"'.$rs->getString('summary').'";';
	echo '"'.$rs->getString('status_id').'";';
	echo "\n";
}

die();
?>
