<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. P�rez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('wwwlib/search/commonsearch.php');
require_once('html/ProjectTemplate.php');
$project = GFUrl::getUrl()->getProject();
$lang = Session::getSession()->getLanguage();
$template = new ProjectTemplate();

if (isset($_REQUEST['do_search'])) {
	$search=(isset($_REQUEST['search']) ? $_REQUEST['search'] : array());
	$words =(isset($_REQUEST['words']) ? StringUtils::getPlainUTF8FromHtml($_REQUEST['words']) : '');
	$search_params['template'] = $template;
	$search_params['project'] = $project;
	$search_params['search']= $search;
	$search_params['words'] = $words;
	$search_params['search_by'] = isset($_REQUEST['search_by']) && $_REQUEST['search_by'] == 'tags' ? 'tags' : 'keywords';
	if (isset($_REQUEST['startdate']) && isset($_REQUEST['enddate'])) {
		$search_params['startdate'] = Validator::sanitizeDate($_REQUEST['startdate']);
		$search_params['enddate'] = Validator::sanitizeDate($_REQUEST['enddate']);
	} else {
		if (isset($_REQUEST['startdate']) || isset($_REQUEST['enddate'])) {
			$feedback = 'Date Range Must Include Both Dates';
		}
		$search_params['startdate'] = null;
		$search_params['enddate'] = null;
	}
	$search_params['search_attach'] = (isset($_REQUEST['search_attach']) ? Validator::sanitizeBool($_REQUEST['search_attach']) : false);
	if(Session::getSession()->isLoggedIn()) {
		$user = Session::getSession()->getUser();
		UserPreferencePeer::setUserPref($user->getUserId(),'project_search', setSearchParams($search_params));
	} else {
		$_SESSION['project_search'] = setSearchParams($search_params);
	}
} else {
	$words = '';
	$search = array();
}

$params = array(
	'selectedbottomtab'=>'search',
	'project' => $project,
	'title'=>'Search',
	'feedback'=>isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : '')
);	
$template->header($params);

if ($session->isLoggedIn()) {
	$search_prefs = UserPreferencePeer::getUserPreferenceValue($session->getUser()->getId()
		,'project_search');
	$search_prefs = unserialize($search_prefs);
} else {
	$search_prefs = isset($_SESSION['_search']) ? unserialize($_SESSION['project_search']) : array();
}

$theader = array('Search Criteria');

echo '<script language="javascript" type="text/javascript" src="/datetimepicker.js"></script>';
echo $template->tableTop($theader);
$trow = array();
echo '<form style="display: inline;" action="/gf/project/' . $project->getUnixName() . '/search/" method="GET">';
$trow[0] = '<strong>'.$lang->getText('Search.Keywords').':</strong><br /> <input type="text" size="25" name="words" value="'.$words.'" autofocus="autofocus" /><p>';
$trow[0] .= '<strong>'.$lang->getText('Search.In').':</strong><br /> <select multiple name="search[]">';

$prs = ActionManager::notify('BUILD_SEARCH_COMBO',$params);
$default_selected = false;
foreach ($prs as $result) {
	$options = $result->getResult();
	foreach ($options as $option) {
		if (!isset($search_prefs['search']) && !$default_selected) {
			$checked = " selected ";
			$default_selected = true;
		} else if (array_search($option['value'],$search_prefs['search']) !== false) {
			$checked = " selected ";
		} else {
			$checked = " ";
		}
		$trow[0] .= '<option' . $checked . 'value="' . $option['value'] . '">' . $option['display'] . '</option>';
	}
}

$trow[0] .= '</select> <br />';
$trow[0] .= '<p><strong>Search By</strong><br />';

//Search By radio
$searchByKeywords = !isset($search_prefs['search_by']) || $search_prefs['search_by'] == 'keywords';
$searchByTags = isset($search_prefs) && $search_prefs['search_by'] == 'tags';
$trow[0] .= '<input type="radio" name="search_by" value="keywords" ' .
	($searchByKeywords ? 'checked' : '' ). '/>' .
	$lang->getText('Search.Keywords') . '<br />';
$trow[0] .= '<input type="radio" name="search_by" value="tags" ' .
	($searchByTags ? 'checked' : ''). ' />' .
	$lang->getText('Tag.TabHeader') .'</p>';


//Search attach checkbox
$trow[0] .= '<p><strong>Search Attached Files:</strong><br /><input type="checkbox" name="search_attach" value="1" '.
	(isset($search_prefs['search_attach']) ? 'checked="checked"' : '').'/>';

//Date Range
$start_date  = isset($search_prefs['startdate']) ?  $search_prefs['startdate'] : '';
$end_date = isset($search_prefs['enddate']) ? $search_prefs['enddate'] : '';

if (!$start_date) {
	$start_date = '';
}

if (!$end_date) {
	$end_date = '';
}
$trow[0] .= '<p><strong>Date Range:</strong><br />'.
	//Start Date
	'<input id="startdate" type="text" size="11" maxlength="11" name="startdate" value="'.
	$start_date .
	'"/><a href="javascript:NewCal(\'startdate\',\'MMMddyyyy\')"><img src="/themes/gforge5/images/cal.gif"
	alt="Pick a date" border="0" height="16" width="16"></a>&nbsp;&nbsp;&nbsp;'.
	//End Date
	'<input id="enddate" type="text" size="11" maxlength="11" name="enddate" value="'.
	$end_date.'"/>'.
	'<a href="javascript:NewCal(\'enddate\',\'MMMddyyyy\')"><img src="/themes/gforge5/images/cal.gif"'.
	' alt="Pick a date" border="0" height="16" width="16"></a>';
$trow[0] .= '<p>' . HTMLWidget::button("submit",$language->getSessText('SearchBox.search'),"do_search","","") . '</form>';
echo $template->tableRow($trow,array(),true);
echo $template->tableBottom();

echo '<br /><br />';

try {
	if (array_key_exists('do_search', $_REQUEST)) {
		if (strlen($_REQUEST['words']) > 0) {
			$searchByTags = (isset($_REQUEST['search_by']) && $_REQUEST['search_by'] == 'tags');

			if ($searchByTags) {
				if (!count($search_params['search'])) {
					echo "<p><h3>".Language::getSessText('Tag.EmptySearch')."</h3></p>";
				} else {
					echo searchTags($search_params);
				}
			} else {
				$searchAction  = 'DO_SEARCH';

				echo '<h3>'.$language->getSessText('Search.SearchResultsTitle').'</h3>';
				$results = ActionManager::notify($searchAction, $search_params);

				if ($searchByTags) {

				} else {
					echo '<div class="tabber">';
					foreach ($results as $result) {
						$result = $result->getResult();
						if (!is_array($result)) {
							continue;
						}

						$title = $result['title'];
						$content = $result['content'];

						echo '<div class="tabbertab" title="'.$title.'">';
						echo $content;
						echo '</div>';
					}
					echo '</div>';
				}
			}

		} else {
			echo "<p><h3>Empty Search</h3></p>";
		}
	}
} catch (SQLException $e) {
	// SQL exception here means that there was a syntax error on the search terms
	echo '<span class="feedback">'.$lang->getText('Search.InvalidSearch').'</span>';
	echo "<!-- ".$e->getMessage()." -->";
}

$template->footer();
?>
