<?php


require_once('core/TagEntry.php');
require_once('Validator.php');

$Lang = Language::getSessLang();

if($_SERVER['REQUEST_METHOD'] != 'POST'){
	throw new PermissionDeniedException();
}

$errors = array();

if(isset($_REQUEST['ref_id'])  && isset($_REQUEST['section']) && isset($_REQUEST['return_to'])){
	$ref_id = Validator::sanitizeInt($_REQUEST['ref_id']);
	$section = Validator::sanitizeString($_REQUEST['section']);
	$return_to = Validator::sanitizeString($_REQUEST['return_to']);
	} else {
	throw new InvalidDataException(array('Invalid section or ref_id'));
}

if (!TagEntryPeer::userCanUpdate($section,$ref_id)){
	throw new PermissionDeniedException();
}
	

$tags = isset($_REQUEST['tags']) ? trim(Validator::sanitizeString($_REQUEST['tags'])) : '';

if ($tags != '') {
	TagEntryPeer::addTags($section, $ref_id, $tags);
} else {
	$errors[] = "Empty input";
	//throw new InvalidDataException(array('Invalid tags'));
}

//Remove feedback param from return url
$return_to = preg_replace("/&feedback=.+$/", "", $return_to);

if (count($errors) > 0){
	$feedback = implode($errors);
	GFUrl::redirect(GFUrl::getUrl()->currentBaseUrl('TagAdd',array('ref_id'=>$ref_id, 'section'=>$section,'return_to'=>$return_to,'feedback'=>$feedback)));
} else {
	GFUrl::redirect($return_to, array('feedback' => $Lang->getText('Tag.AddFeedback')));
}
		
?>
