<?php
require_once('lib/html/HTMLWidget.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('plugins/forum/lib/ForumMessage.php');

?>
<p>
	<strong><?php echo $Lang->getText('Tag.AddPageTitle'); ?></strong>
</p>
<p> 
<?php
	switch($section){
		case TrackerItem::SECTION:
			$section_name = $Lang->getText('Tag.TrackerItem');
			$message = '[#'.$item->getId().']: ' . $item->getSummary();
			break;
		case DocmanFile::SECTION: 
			$section_name = $Lang->getText('Tag.DocmanFile');
			$message = '[#'.$item->getDocmanFileId().']: ' . $item->getLatestVersion()->getFile()->getFileName() ;
			break;
		case ForumMessage::SECTION:
			$section_name = $Lang->getText('Tag.ForumMessage');
			$message = '[#'.$item->getForumMessageId() . ']: ' . $item->getSubject();
			break;
		case FrsRelease::SECTION:
			$section_name = $Lang->getText('Tag.FrsReleaseMessage');
			$message = '[#'.$item->getFrsReleaseId() .']: ' . $item->getReleaseName();
			break;
		case WikiPage::SECTION:
			$section_name = $Lang->getText('Tag.WikiPageMessage'); 
			$message = '[#'.$item->getWikiPageId() . ']: ' . $item->getPagename();
			break;
		case ScmCommit::SECTION:
			$section_name = $Lang->getText('Tag.ScmCommitMessage');
			$message = '[#'.$item->getScmCommitId() . ']: ' . $item->getMessageLog();
			break;
		case News::SECTION:
			$section_name = $Lang->getText('Tag.UserBlogMessage');
			$message = '[#'.$item->getNewsId() .'] : ' . $item->getSummary();
			break;
	}

?>
<form action="<?php echo GFUrl::getUrl()->currentBaseUrl('TagAddAction') ?>" method="POST">
	<input type="hidden" name="ref_id" value="<?php echo $ref_id?>" />
	<input type="hidden" name="section" value="<?php echo $section?>" />
	<input type="hidden" name="return_to" value="<?php echo $return_to?>" />
	<table border="0">
		<tr>
			<td>
			<strong><?php echo $Lang->getText('Tag.AddTagFor')?></strong> <br />
			<?php echo $section_name . ' ' . $message?>
			</td>
		</tr>

		<tr>
			<td>
			<strong><?php echo $Lang->getText('Tag.EnterTags'); ?></strong>
			<br />
			<textarea name="tags" cols="40" rows="4" value="<?php echo $tags ?>"></textarea>
			</td>
		<tr>
			<td align="center">
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.add') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Cancel') . " ","cancel","","javascript:history.go(-1);")?>
			</td>
		</tr>
	</table>
</form>

<?php echo $theme->footer($params);?>
