<?php
/**
 * Copyright (c) 2005-2011 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


$theme->header($params);
//Choose the template with git by default
foreach($templates as $template) {
	/** var Project $template */
	if($template->usesPlugin('scmgit')) {
		$template_project_id = $template->getProjectId();
	}
}
?>

<!-- Jquery.chosen support -->
<?php echo $trove_renderer->renderChosenJavascript(); ?>
<!-- -->

<script>
$(document).ready(function() {
	$('#project_name').focus();
	$('select[name="template_project_id"]').css('width', '50%').chosen();
});
<?php if (GFConf::get('system.troveEnabled') == 1) { ?>
function toggleTrove(animate) {
  animate = typeof animate !== 'undefined' ? animate : true;
  if (animate) {
    effect = 'blind';
  } else {
    effect = false;
  }
  $('#trove_container').toggle(effect);
  $('#trove_title').find(".arrow-up, .arrow-down").toggle();
}
$(document).ready(function() {
  $('#trove_title').click(function() {
    toggleTrove(); 
  });
  $('#trove_container').hide();
  $('.arrow-up').hide();
});
<?php } ?>
</script> 

<form action="<?php echo GFUrl::getUrl()->currentBaseURL('ProjectAddAction') ?>" method="POST">
	<input type="hidden" name="redirect" value="<?php echo $redirect; ?>" />
	<input type="hidden" name="action" value="ProjectAddAction" />
	<p>
		<?php echo $Lang->getText('Project.AddNewDescription'); ?>
	</p>
	<p>
		<h3><?php echo $Lang->getText('Project.ProjectNameTitle'); ?>&nbsp*</h3>
		<?php echo $Lang->getText('Project.ProjectNameDescription'); ?>
		<br />
		<br />
		<?php echo $Lang->getText('Project.ProjectNameName') ?>:
		<br />
		<input type="text" id="project_name" name="project_name" maxlength="40" size="35" value="<?php echo $project_name; ?>"  />
	</p>
	
	<p>
		<h3><?php echo $Lang->getText('Project.RegisterPurposeTitle'); ?></h3>
		<?php echo $Lang->getText('Project.RegisterPurposeDescription'); ?>
		<br />
		<br />
		<textarea name="register_purpose" rows="3" cols="40" /><?php echo $register_purpose; ?></textarea>
	</p>

	<p>
		<h3><?php echo $Lang->getText('Project.DescriptionTitle'); ?>&nbsp;*</h3>
		<?php echo $Lang->getText('Project.DescriptionDescription'); ?>
		<br />
		<br />
		<textarea name="description" rows="3" cols="40" /><?php echo $description; ?></textarea>
	</p>

	<p>
		<h3><?php echo $Lang->getText('Project.UnixNameTitle'); ?>&nbsp;*</h3>
		<?php echo $Lang->getText('Project.UnixNameDescription'); ?>
		<br />
		<input type="text" name="unix_name" maxlength="15" value="<?php echo $unix_name; ?>"  />
	</p>

	<p>
		<h3><?php echo $Lang->getText('Project.HomepageUrlTitle'); ?></h3>
		<?php echo $Lang->getText('Project.HomepageUrlDescription', array(GFConf::get('system.name'))); ?>:
		<br />
		<input type="text" name="homepage_url" value="<?php echo $homepage_url; ?>" size="35" />
	</p>

	<p>
		<h3><?php echo $Lang->getText('Project.TemplateProject'); ?></h3>
		<?php echo $Lang->getText('Project.TemplateProjectDescription'); ?>
		<br />
		<select name="template_project_id"><?php echo $template_project_options; ?></select>
	</p>
	
  <?php if (GFConf::get('system.troveEnabled') == 99) { ?>
	<p>
		<h3><?php echo $Lang->getText('Project.TroveCategorization'); ?></h3>
		<?php echo $Lang->getText('Project.TroveDescription'); ?>
	</p>
	<br />
  <?php
  	$trove_renderer->showTroveForm();
  } else if (GFConf::get('system.troveEnabled') == 1) { ?>
  <p>
    <h3 id="trove_title">
      <span class="arrow-up">&#9650;</span>
      <span class="arrow-down">&#9660;</span>
<?php echo $Lang->getText('Project.TroveCategorization'); ?>
    </h3>
  </p>
  <div id="trove_container">
  <?php $trove_renderer->showTroveForm() ?>
  </div>
  <?php } ?>
	
<?php if (GFConf::get('system.projectRegClickLicense')) { ?>
	<p>
<pre>
<?php echo file_get_contents(GFConf::get('system.etcDir').'/PROJECT_LICENSE'); ?>
</pre>
	</p>
	<p>
	<input type="checkbox" name="iagree" value="t" />&nbsp;<?php echo $Lang->getText('License.IHaveReadAndAgree'); ?>
	</p>
<?php } ?>
	<p>
		<?php echo HTMLWidget::button("submit","" .   $Lang->getText('ProjectAddForm.submit') . " ","submit","","")?>
		<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Cancel') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->baseURL('','project','') . "'; ")?>
	</p>
</form>

<?php
$theme->footer($params);
?>
