<?php

require_once('lib/external/jpgraph/jpgraph.php');
require_once('lib/external/jpgraph/jpgraph_line.php');

$Lang = $session->getLanguage();

$con = Propel::getConnection(TrackerPeer::DATABASE_NAME);
$stmt = $con->createStatement();

if (isset($_GET['year']) && isset($_GET['month'])) {
	$time = mktime(1, 1, 1, intval($_GET['month']), 1, intval($_GET['year']));
} else {
	$time = time();
}

// Get year-month and number of days
list($sqldate, $days) = explode('|', date('Y-m|t', $time));

if (isset($_GET['project_id'])) {
	$project_id = intval($_GET['project_id']);
	$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );
	if ($subprojects == 1) {
		$sql_projects = "AND (pack.project_id = $project_id
		 OR pack.project_id IN (SELECT project_id FROM project WHERE parent_project_id='$project_id')) ";
	} else {
		$sql_projects = "AND pack.project_id = $project_id";
	}
	$sql = "SELECT COUNT(down.*) AS downloads, 
			date_part('day', down.download_date)::text AS day
			FROM filesystem_download down, filesystem fs, frs_release rel, frs_package pack
			WHERE down.filesystem_id = fs.filesystem_id
			AND fs.section = 'frsrelease'
			AND fs.ref_id = rel.frs_release_id
			AND pack.frs_package_id = rel.frs_package_id
			$sql_projects
			AND (down.download_date BETWEEN '$sqldate-01' AND '$sqldate-$days')
			GROUP BY day";

} else {
	$project_id = 0;
	$sql = "SELECT COUNT(*) AS downloads, 
			date_part('day', download_date)::text AS day
			FROM filesystem_download
			WHERE (download_date BETWEEN '$sqldate-01' AND '$sqldate-$days')
			GROUP BY day";
}

$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$ydata  = array();

for ($i=0;$i<$days;$i++) {
	$ydata[] = 0;
}

if ($rs != null && $rs->getRecordCount() > 0) {
	while($rs->next()) {
		if (isset($ydata[$rs->getInt('day')])) {
			$ydata[$rs->getInt('day')] = $ydata[$rs->getInt('day')] + $rs->getInt('downloads');
		} else {
			$ydata[$rs->getInt('day')] = $rs->getInt('downloads');
		}
	}
}

$font = $Lang->getFontProperties(FF_FONT1, FS_NORMAL, 12);
// Create the graph.
$graph = new Graph(400, 250);
$graph->SetScale('textlin');
$graph->img->SetMargin(40, 15, 15, 40);
$graph->title->Set($Lang->getText('ProjectReporting.DownloadsPerDay')); 
$graph->title->SetFont($font[0], $font[1], $font[2]);
$graph->setBox(false);
$graph->setFrame(false);

$font = $Lang->getFontProperties(FF_FONT1, FS_BOLD, 8);
$graph->xaxis->SetTitle($Lang->getText('Common.Day'));
$graph->xaxis->SetTitleMargin(9);
$graph->xaxis->title->SetFont($font[0], $font[1], $font[2]);
$graph->xaxis->SetLabelAngle(90);

$graph->yaxis->SetTitle($Lang->getText('ProjectReporting.Downloads'), 'low'); 
$graph->yaxis->SetTitleMargin(25);
$graph->yaxis->title->SetFont($font[0], $font[1], $font[2]);
$graph->yaxis->scale->SetGrace(0);
$graph->yaxis->SetLabelMargin(1);

$lineplot = new LinePlot($ydata);
$lineplot->SetColor('blue');
$graph->Add($lineplot);

if (ob_get_level()) ob_end_clean();
$graph->Stroke();
